<p align="center">
<picture>
  <source media="(prefers-color-scheme: dark)" srcset="./docs/src/assets/logo-dark.svg">
  <img alt="HDF5.jl" src="./docs/src/assets/logo.svg" width=350 height=125>
</picture>
</p>

_HDF5 interface for the Julia language_
-


[HDF5](https://www.hdfgroup.org/solutions/hdf5/) is a file format and library for storing and
accessing data, commonly used for scientific data. HDF5 files can be created and read by numerous
[programming languages](https://en.wikipedia.org/wiki/Hierarchical_Data_Format#Interfaces). This
package provides an interface to the HDF5 library for the Julia language.


[![Stable](https://img.shields.io/badge/documentation-blue.svg)](https://JuliaIO.github.io/HDF5.jl/stable)
[![Build Status](https://github.com/JuliaIO/HDF5.jl/workflows/CI/badge.svg?branch=master)](https://github.com/JuliaIO/HDF5.jl/actions)
[![Coverage](https://codecov.io/gh/JuliaIO/HDF5.jl/branch/master/graph/badge.svg)](https://codecov.io/gh/JuliaIO/HDF5.jl)
<!-- [![Coverage](https://coveralls.io/repos/github/JuliaIO/HDF5.jl/badge.svg?branch=master)](https://coveralls.io/github/JuliaIO/HDF5.jl?branch=master) -->


### Changelog

Please see [HISTORY.md](HISTORY.md) and the [release notes](https://github.com/JuliaIO/HDF5.jl/releases). Most changes have deprecation warnings and may not be listed in the [HISTORY.md](HISTORY.md) file.

### Installation

```julia
julia>]
pkg> add HDF5
```
For custom build instructions please refer to the [documentation](https://juliaio.github.io/HDF5.jl/stable/#Using-custom-or-system-provided-HDF5-binaries).

### Quickstart


```julia
using HDF5
```

To read and write a variable to a file, one approach is to use the filename:
```julia
A = collect(reshape(1:120, 15, 8))
h5write("/tmp/test2.h5", "mygroup2/A", A)
data = h5read("/tmp/test2.h5", "mygroup2/A", (2:3:15, 3:5))
```
where the last line reads back just `A[2:3:15, 3:5]` from the dataset.

More fine-grained control can be obtained using functional syntax:

```julia
h5open("mydata.h5", "w") do file
    write(file, "A", A)  # alternatively, say "@write file A"
end

c = h5open("mydata.h5", "r") do file
    read(file, "A")
end
```
This allows you to add variables as they are generated to an open HDF5 file.
You don't have to use the `do` syntax (`file = h5open("mydata.h5", "w")` works
just fine), but an advantage is that it will automatically close the file (`close(file)`)
for you, even in cases of error.

Julia's high-level wrapper, providing a dictionary-like interface, may
also be of interest:

```julia
using HDF5

h5open("test.h5", "w") do file
    g = create_group(file, "mygroup") # create a group
    g["dset1"] = 3.2                  # create a scalar dataset inside the group
    attributes(g)["Description"] = "This group contains only a single dataset" # an attribute
end
```

Convenience functions for attributes attached to datasets are also provided:

```julia
A = Vector{Int}(1:10)
h5write("bar.h5", "foo", A)
h5writeattr("bar.h5", "foo", Dict("c"=>"value for metadata parameter c","d"=>"metadata d"))
h5readattr("bar.h5", "foo")
```

# JuliaFormatterTool

## Purpose

The purpose is this tool to aid in formatting the repository with JuliaFormatter.
Rather than starting a fresh Julia session each time you want to format, this will
run the formatter in a loop. Everytime you press enter, it will format the repository.
This avoids the initial delay when starting and loading the JuliaFormatter package.

The intended use of this program is to run in a separate terminal or be suspended
(e.g. via Control-Z) while you edit the repository. Resume the program (e.g. `fg`)
and press enter to format the repository before committing.

## Invocation

The format.jl script is meant to be executed directly.

On POSIX systems that understand shebang lines the format.jl can be invoked as follows.
```
./contrib/format/format.jl
```

Supplying the file as an argument to `julia` also works.

```
julia contrib/format/format.jl
```

The script will automatically install itself by resolving and instantiating its environment.
To bypass this install step, specify the project environment:

```
julia --project=contrib/format contrib/format.jl
```

## Example Usage

```
$ julia contrib/format/format.jl
  Activating project at `~/.julia/dev/HDF5/contrib/format`
  No Changes to `~/.julia/dev/HDF5/contrib/format/Project.toml`
  No Changes to `~/.julia/dev/HDF5/contrib/format/Manifest.toml`

Welcome to Julia Formatter Tool!
--------------------------------

Press enter to format the directory ~/.julia/dev/HDF5 or `q[enter]` to quit
format.jl>
Applying JuliaFormatter...
┌ Info: Is the current directory formatted?
│   target_dir = "~/.julia/dev/HDF5"
└   format(target_dir) = true

Press enter to format the directory ~/.julia/dev/HDF5 or `q[enter]` to quit
format.jl>
Applying JuliaFormatter...
┌ Info: Is the current directory formatted?
│   target_dir = "~/.julia/dev/HDF5"
└   format(target_dir) = true
```

using HDF5
using Test

@testset "Raw Chunk I/O" begin
    fn = tempname()

    # Direct chunk write is no longer dependent on HL library
    # Test direct chunk writing Cartesian index
    h5open(fn, "w") do f
        d = create_dataset(f, "dataset", datatype(Int), dataspace(4, 5); chunk=(2, 2))
        HDF5.API.h5d_extend(d, HDF5.API.hsize_t[3, 3]) # should do nothing (deprecated call)
        HDF5.API.h5d_extend(d, HDF5.API.hsize_t[4, 4]) # should do nothing (deprecated call)
        raw = HDF5.ChunkStorage(d)
        raw[1, 1] = 0, collect(reinterpret(UInt8, [1, 2, 5, 6]))
        raw[3, 1] = 0, collect(reinterpret(UInt8, [3, 4, 7, 8]))
        raw[1, 3] = 0, collect(reinterpret(UInt8, [9, 10, 13, 14]))
        raw[3, 3] = 0, collect(reinterpret(UInt8, [11, 12, 15, 16]))
        raw[1, 5] = 0, collect(reinterpret(UInt8, [17, 18, 21, 22]))
        raw[3, 5] = 0, collect(reinterpret(UInt8, [19, 20, 23, 24]))
    end

    # Test read back
    @test h5open(fn, "r") do f
        vec(f["dataset"][:, :])
    end == collect(1:20)

    # Test reading direct chunks via linear indexing
    h5open(fn, "r") do f
        d = f["dataset"]
        raw = HDF5.ChunkStorage{IndexLinear}(d)
        @test size(raw) == (6,)
        @test length(raw) == 6
        @test axes(raw) == (Base.OneTo(6),)
        @test prod(HDF5.get_num_chunks_per_dim(d)) == HDF5.get_num_chunks(d)
        if v"1.10.5" ≤ HDF5.API._libhdf5_build_ver
            @test HDF5.get_chunk_length(d) == HDF5.API.h5d_get_chunk_info(d, 1)[:size]
        end
        @test reinterpret(Int, raw[1][2]) == [1, 2, 5, 6]
        @test reinterpret(Int, raw[2][2]) == [3, 4, 7, 8]
        @test reinterpret(Int, raw[3][2]) == [9, 10, 13, 14]
        @test reinterpret(Int, raw[4][2]) == [11, 12, 15, 16]
        @test reinterpret(Int, raw[5][2])[1:2] == [17, 18]
        @test reinterpret(Int, raw[6][2])[1:2] == [19, 20]
        # Test 0-based indexed API
        @test HDF5.get_chunk_offset(d, 0) == (0, 0)
        @test HDF5.get_chunk_offset(d, 1) == (2, 0)
        @test HDF5.get_chunk_offset(d, 2) == (0, 2)
        @test HDF5.get_chunk_offset(d, 3) == (2, 2)
        @test HDF5.get_chunk_offset(d, 4) == (0, 4)
        @test HDF5.get_chunk_offset(d, 5) == (2, 4)
        # Test reverse look up of index from coords
        @test HDF5.get_chunk_index(d, (0, 0)) == 0
        @test HDF5.get_chunk_index(d, (2, 0)) == 1
        @test HDF5.get_chunk_index(d, (0, 2)) == 2
        @test HDF5.get_chunk_index(d, (2, 2)) == 3
        @test HDF5.get_chunk_index(d, (0, 4)) == 4
        @test HDF5.get_chunk_index(d, (2, 4)) == 5
        # Test internal coordinates
        @test HDF5.get_chunk_index(d, (0, 1)) == 0
        @test HDF5.get_chunk_index(d, (1, 0)) == 0
        @test HDF5.get_chunk_index(d, (1, 1)) == 0
        @test HDF5.get_chunk_index(d, (3, 1)) == 1
        @test HDF5.get_chunk_index(d, (1, 3)) == 2
        @test HDF5.get_chunk_index(d, (3, 3)) == 3
        @test HDF5.get_chunk_index(d, (1, 5)) == 4
        @test HDF5.get_chunk_index(d, (2, 5)) == 5
        @test HDF5.get_chunk_index(d, (3, 4)) == 5
        @test HDF5.get_chunk_index(d, (3, 5)) == 5
        # Test chunk iter
        if v"1.12.3" ≤ HDF5.API._libhdf5_build_ver
            infos = HDF5.get_chunk_info_all(d)
            offsets = [info.offset for info in infos]
            addrs = [info.addr for info in infos]
            filter_masks = [info.filter_mask for info in infos]
            sizes = [info.size for info in infos]
            @test isempty(
                setdiff(offsets, [(0, 0), (2, 0), (0, 2), (2, 2), (0, 4), (2, 4)])
            )
            @test length(unique(addrs)) == 6
            @test only(unique(filter_masks)) === UInt32(0)
            @test only(unique(sizes)) == 4 * sizeof(Int)
        end
    end

    # Test direct write chunk writing via linear indexing
    h5open(fn, "w") do f
        d = create_dataset(f, "dataset", datatype(Int64), dataspace(4, 5); chunk=(2, 3))
        raw = HDF5.ChunkStorage{IndexLinear}(d)
        raw[1] = 0, collect(reinterpret(UInt8, Int64[1, 2, 5, 6, 9, 10]))
        raw[2] = 0, collect(reinterpret(UInt8, Int64[3, 4, 7, 8, 11, 12]))
        raw[3] = 0, collect(reinterpret(UInt8, Int64[13, 14, 17, 18, 21, 22]))
        raw[4] = 0, collect(reinterpret(UInt8, Int64[15, 16, 19, 20, 23, 24]))
    end

    @test h5open(fn, "r") do f
        f["dataset"][:, :]
    end == reshape(1:20, 4, 5)

    h5open(fn, "r") do f
        d = f["dataset"]
        raw = HDF5.ChunkStorage(d)
        chunk = HDF5.get_chunk(d)
        extent = HDF5.get_extent_dims(d)[1]

        @test chunk == (2, 3)
        @test extent == (4, 5)
        @test size(raw) == (2, 2)
        @test length(raw) == 4
        @test axes(raw) == (1:2:4, 1:3:5)
        @test prod(HDF5.get_num_chunks_per_dim(d)) == HDF5.get_num_chunks(d)

        # Test 0-based indexed API
        @test HDF5.get_chunk_offset(d, 0) == (0, 0)
        @test HDF5.get_chunk_offset(d, 1) == (2, 0)
        @test HDF5.get_chunk_offset(d, 2) == (0, 3)
        @test HDF5.get_chunk_offset(d, 3) == (2, 3)
        # Test reverse look up of index from coords
        @test HDF5.get_chunk_index(d, (0, 0)) == 0
        @test HDF5.get_chunk_index(d, (2, 0)) == 1
        @test HDF5.get_chunk_index(d, (0, 3)) == 2
        @test HDF5.get_chunk_index(d, (2, 3)) == 3
        # Test internal coordinates
        @test HDF5.get_chunk_index(d, (0, 1)) == 0
        @test HDF5.get_chunk_index(d, (0, 2)) == 0
        @test HDF5.get_chunk_index(d, (1, 0)) == 0
        @test HDF5.get_chunk_index(d, (1, 1)) == 0
        @test HDF5.get_chunk_index(d, (1, 2)) == 0
        @test HDF5.get_chunk_index(d, (3, 1)) == 1
        @test HDF5.get_chunk_index(d, (1, 4)) == 2
        @test HDF5.get_chunk_index(d, (2, 4)) == 3
        @test HDF5.get_chunk_index(d, (2, 5)) == 3
        @test HDF5.get_chunk_index(d, (3, 3)) == 3
        @test HDF5.get_chunk_index(d, (3, 4)) == 3
        @test HDF5.get_chunk_index(d, (3, 5)) == 3

        if v"1.10.5" ≤ HDF5.API._libhdf5_build_ver
            chunk_length = HDF5.get_chunk_length(d)
            origin = HDF5.API.h5d_get_chunk_info(d, 0)
            @test chunk_length == origin[:size]
            chunk_info = HDF5.API.h5d_get_chunk_info_by_coord(d, HDF5.API.hsize_t[0, 1])
            @test chunk_info[:filter_mask] == 0
            @test chunk_info[:size] == chunk_length

            # Test HDF5.get_chunk_offset equivalence to h5d_get_chunk_info information
            @test all(
                reverse(HDF5.API.h5d_get_chunk_info(d, 3)[:offset]) .==
                HDF5.get_chunk_offset(d, 3)
            )

            # Test HDF5.get_chunk_index equivalence to h5d_get_chunk_info_by_coord information
            offset = HDF5.API.hsize_t[2, 3]
            chunk_info = HDF5.API.h5d_get_chunk_info_by_coord(d, reverse(offset))
            @test HDF5.get_chunk_index(d, offset) ==
                fld(chunk_info[:addr] - origin[:addr], chunk_info[:size])

            @test HDF5.API.h5d_get_chunk_storage_size(d, HDF5.API.hsize_t[0, 1]) ==
                chunk_length
            @test HDF5.API.h5d_get_storage_size(d) == sizeof(Int64) * 24
            if v"1.12.2" ≤ HDF5.API._libhdf5_build_ver
                @test HDF5.API.h5d_get_space_status(d) ==
                    HDF5.API.H5D_SPACE_STATUS_ALLOCATED
            else
                @test HDF5.API.h5d_get_space_status(d) ==
                    HDF5.API.H5D_SPACE_STATUS_PART_ALLOCATED
            end
        end

        # Manually reconstruct matrix
        A = Matrix{Int}(undef, extent)
        for (r1, c1) in Iterators.product(axes(raw)...)
            r2 = min(extent[1], r1 + chunk[1] - 1)
            c2 = min(extent[2], c1 + chunk[2] - 1)
            dims = (r2 - r1 + 1, c2 - c1 + 1)
            bytes = 8 * prod(dims)
            A[r1:r2, c1:c2] .= reshape(reinterpret(Int64, raw[r1, c1][2][1:bytes]), dims)
        end
        @test A == reshape(1:20, extent)
    end

    @static if VERSION >= v"1.6"
        # CartesianIndices does not accept StepRange

        h5open(fn, "w") do f
            d = create_dataset(f, "dataset", datatype(Int), dataspace(4, 5); chunk=(2, 3))
            raw = HDF5.ChunkStorage(d)
            data = permutedims(reshape(1:24, 2, 2, 3, 2), (1, 3, 2, 4))
            ci = CartesianIndices(raw)
            for ind in eachindex(ci)
                raw[ci[ind]] = data[:, :, ind]
            end
        end

        @test h5open(fn, "r") do f
            f["dataset"][:, :]
        end == reshape(1:20, 4, 5)
    end

    # Test direct write chunk writing via linear indexing, using views and without filter flag
    h5open(fn, "w") do f
        d = create_dataset(f, "dataset", datatype(Int), dataspace(4, 5); chunk=(2, 3))
        raw = HDF5.ChunkStorage{IndexLinear}(d)
        data = permutedims(reshape(1:24, 2, 2, 3, 2), (1, 3, 2, 4))
        chunks = Iterators.partition(data, 6)
        i = 1
        for c in chunks
            raw[i] = c
            i += 1
        end
    end

    @test h5open(fn, "r") do f
        f["dataset"][:, :]
    end == reshape(1:20, 4, 5)

    # Test chunk info retrieval method performance
    h5open(fn, "w") do f
        d = create_dataset(
            f,
            "dataset",
            datatype(UInt8),
            dataspace(256, 256);
            chunk=(16, 16),
            alloc_time=:early
        )
        if v"1.10.5" ≤ HDF5.API._libhdf5_build_ver
            HDF5._get_chunk_info_all_by_index(d)
            index_time = @elapsed infos_by_index = HDF5._get_chunk_info_all_by_index(d)
            @test length(infos_by_index) == 256
            iob = IOBuffer()
            show(iob, MIME"text/plain"(), infos_by_index)
            seekstart(iob)
            @test length(readlines(iob)) == 259
            if v"1.12.3" ≤ HDF5.API._libhdf5_build_ver
                HDF5._get_chunk_info_all_by_iter(d)
                iter_time = @elapsed infos_by_iter = HDF5._get_chunk_info_all_by_iter(d)
                @test infos_by_iter == infos_by_index
                @test iter_time < index_time
            end
        end
    end
    rm(fn)
end # testset "Raw Chunk I/O"

using Random, Test, HDF5

@testset "BlockRange" begin
    br = HDF5.BlockRange(2)
    @test length(br) == 1
    @test range(br) === 2:2
    @test convert(AbstractRange, br) === 2:2
    @test convert(UnitRange, br) === 2:2
    @test convert(StepRange, br) === 2:1:2
    @test repr(br) == "HDF5.BlockRange(2)"
    @test repr(br; context=:compact => true) == "2"

    br = HDF5.BlockRange(Base.OneTo(3))
    @test length(br) == 3
    @test range(br) == 1:3
    @test convert(AbstractRange, br) === 1:3
    @test convert(UnitRange, br) === 1:3
    @test convert(StepRange, br) === 1:1:3
    @test repr(br) == "HDF5.BlockRange(1:3)"
    @test repr(br; context=:compact => true) == "1:3"

    br = HDF5.BlockRange(2:7)
    @test length(br) == 6
    @test range(br) == 2:7
    @test convert(AbstractRange, br) === 2:7
    @test convert(UnitRange, br) === 2:7
    @test convert(StepRange, br) === 2:1:7
    @test repr(br) == "HDF5.BlockRange(2:7)"
    @test repr(br; context=:compact => true) == "2:7"

    br = HDF5.BlockRange(1:2:7)
    @test length(br) == 4
    @test range(br) == 1:2:7
    @test convert(AbstractRange, br) === 1:2:7
    @test_throws Exception convert(UnitRange, br)
    @test convert(StepRange, br) === 1:2:7
    @test repr(br) == "HDF5.BlockRange(1:2:7)"
    @test repr(br; context=:compact => true) == "1:2:7"

    br = HDF5.BlockRange(; start=2, stride=8, count=3, block=2)
    @test length(br) == 6
    @test_throws Exception range(br)
    @test_throws Exception convert(AbstractRange, br)
    @test_throws Exception convert(UnitRange, br)
    @test_throws Exception convert(StepRange, br)
    @test repr(br) == "HDF5.BlockRange(start=2, stride=8, count=3, block=2)"
    @test repr(br; context=:compact => true) ==
        "BlockRange(start=2, stride=8, count=3, block=2)"
end

@testset "hyperslab" begin
    N = 10
    v = [randstring(rand(5:10)) for i in 1:N, j in 1:N]

    fn = tempname()
    h5open(fn, "w") do f
        f["data"] = v
    end

    h5open(fn, "r") do f
        dset = f["data"]
        indices = (1, 1)
        @test dset[indices...] == v[indices...]

        indices = (1:10, 1)
        @test dset[indices...] == v[indices...]

        indices = (1, 1:10)
        @test dset[indices...] == v[indices...]

        indices = (1:2:10, 1:3:10)
        @test dset[indices...] == v[indices...]

        indices = (
            HDF5.BlockRange(1:2; stride=4, count=2), HDF5.BlockRange(1; stride=5, count=2)
        )
        @test dset[indices...] == vcat(v[1:2, 1:5:6], v[5:6, 1:5:6])
    end
end

@testset "read 0-length arrays: issue #859" begin
    fname = tempname()
    dsetname = "foo"

    h5open(fname, "w") do fid
        create_dataset(fid, dsetname, datatype(Float32), ((0,), (-1,)); chunk=(100,))
    end

    h5open(fname, "r") do fid
        fid[dsetname][:]
    end
end

using HDF5
using Test

@testset "extend" begin
    fn = tempname()

    fid = h5open(fn, "w")
    g = create_group(fid, "shoe")
    d = create_dataset(g, "foo", datatype(Float64), ((10, 20), (100, 200)); chunk=(1, 1))
    #println("d is size current $(map(int,HDF5.get_extent_dims(d)[1])) max $(map(int,HDF5.get_extent_dims(d)[2]))")
    dims, max_dims = HDF5.get_extent_dims(d)
    @test dims == (UInt64(10), UInt64(20))
    @test max_dims == (UInt64(100), UInt64(200))
    HDF5.set_extent_dims(d, (100, 150))
    dims, max_dims = HDF5.get_extent_dims(d)
    @test dims == (UInt64(100), UInt64(150))
    @test max_dims == (UInt64(100), UInt64(200))
    d[1, 1:5] = [1.1231, 1.313, 5.123, 2.231, 4.1231]
    HDF5.set_extent_dims(d, (1, 5))
    @test size(d) == (1, 5)

    # Indexing returns correct array dimensions
    @test d[1, end] ≈ 4.1231
    @test d[:, end] ≈ [4.1231]
    @test d[end, :] == [1.1231, 1.313, 5.123, 2.231, 4.1231]
    @test d[:, :] == [1.1231 1.313 5.123 2.231 4.1231]

    if VERSION >= v"1.4"
        include("extend_test_begin.jl")
        extend_test_begin(d)
    end

    # Test all integer types work
    @test d[UInt8(1), UInt16(1)] == 1.1231
    @test d[UInt32(1), UInt128(1)] == 1.1231
    @test d[Int8(1), Int16(1)] == 1.1231
    @test d[Int32(1), Int128(1)] == 1.1231

    # Test ranges work with steps
    @test d[1, 1:2:5] == [1.1231, 5.123, 4.1231]
    @test d[1:1, 2:2:4] == [1.313 2.231]

    # Test Array constructor
    Array(d) == [1.1231 1.313 5.123 2.231 4.1231]

    #println("d is size current $(map(int,HDF5.get_extent_dims(d)[1])) max $(map(int,HDF5.get_extent_dims(d)[2]))")
    b = create_dataset(fid, "b", Int, ((1000,), (-1,)); chunk=(100,)) #-1 is equivalent to typemax(hsize_t) as far as I can tell
    #println("b is size current $(map(int,HDF5.get_extent_dims(b)[1])) max $(map(int,HDF5.get_extent_dims(b)[2]))")
    b[1:200] = ones(200)
    dims, max_dims = HDF5.get_extent_dims(b)
    @test dims == (UInt64(1000),)
    @test max_dims == (HDF5.API.H5S_UNLIMITED % Int,)
    HDF5.set_extent_dims(b, (10000,))
    dims, max_dims = HDF5.get_extent_dims(b)
    @test dims == (UInt64(10000),)
    @test max_dims == (HDF5.API.H5S_UNLIMITED % Int,)
    #println("b is size current $(map(int,HDF5.get_extent_dims(b)[1])) max $(map(int,HDF5.get_extent_dims(b)[2]))")
    # b[:] = [1:10000] # gave error no method lastindex(HDF5.Dataset{PlainHDF5File},),
    # so I defined lastindex(dset::HDF5.Dataset) = length(dset), and exported lastindex
    # but that didn't fix the error, despite the lastindex function working
    # d[1] produces error ERROR: Wrong number of indices supplied, should datasets support linear indexing?
    b[1:10000] = [1:10000;]
    #println(b[1:100])

    close(fid)

    fid = h5open(fn, "r")
    d_again = fid["shoe/foo"]
    dims, max_dims = HDF5.get_extent_dims(d_again)
    @test dims == (UInt64(1), UInt64(5))
    @test max_dims == (UInt64(100), UInt64(200))
    @test (sum(d_again[1, 1:5]) - sum([1.1231, 1.313, 5.123, 2.231, 4.1231])) == 0
    #println("d is size current $(map(int,HDF5.get_extent_dims(re_d)[1])) max $(map(int,HDF5.get_extent_dims(re_d)[2]))")
    @test fid["b"][1:10000] == [1:10000;]
    b_again = fid["b"]
    dims, max_dims = HDF5.get_extent_dims(b_again)
    @test dims == (UInt64(10000),)
    @test max_dims == (HDF5.API.H5S_UNLIMITED % Int,)
    #println("b is size current $(map(int,HDF5.get_extent_dims(b)[1])) max $(map(int,HDF5.get_extent_dims(b)[2]))")

    close(fid)
    rm(fn)
end # testset extend_test

"""
    module FilterTestUtils

This module contains utilities for evaluating and debugging HDF5 Filters.
"""
module FilterTestUtils

import HDF5.API
import H5Zlz4: H5Z_filter_lz4
import H5Zzstd: H5Z_filter_zstd
import H5Zbzip2: H5Z_filter_bzip2
using Test

export test_filter

function test_filter_init(; cd_values=Cuint[], data=ones(UInt8, 1024))
    flags = Cuint(0)
    nbytes = sizeof(data)
    buf_size = Ref(Csize_t(sizeof(data)))
    databuf = Libc.malloc(sizeof(data))
    data = reinterpret(UInt8, data)
    unsafe_copyto!(Ptr{UInt8}(databuf), pointer(data), sizeof(data))
    buf = Ref(Ptr{Cvoid}(databuf))
    return flags, cd_values, nbytes, buf_size, buf
end

function test_filter_compress!(
    filter_func,
    flags::Cuint,
    cd_values::Vector{Cuint},
    nbytes::Integer,
    buf_size::Ref{Csize_t},
    buf::Ref{Ptr{Cvoid}}
)
    nbytes = Csize_t(nbytes)
    cd_nelmts = Csize_t(length(cd_values))
    GC.@preserve flags cd_nelmts cd_values nbytes buf_size buf begin
        ret_code = filter_func(
            flags,
            cd_nelmts,
            pointer(cd_values),
            Csize_t(nbytes),
            Base.unsafe_convert(Ptr{Csize_t}, buf_size),
            Base.unsafe_convert(Ptr{Ptr{Cvoid}}, buf)
        )
        @debug "Compression:" ret_code buf_size[]
        if ret_code <= 0
            error("Test compression failed: $ret_code.")
        end
    end
    return ret_code
end

function test_filter_decompress!(
    filter_func,
    flags::Cuint,
    cd_values::Vector{Cuint},
    nbytes::Integer,
    buf_size::Ref{Csize_t},
    buf::Ref{Ptr{Cvoid}}
)
    nbytes = Csize_t(nbytes)
    cd_nelmts = Csize_t(length(cd_values))
    flags |= UInt32(API.H5Z_FLAG_REVERSE)
    GC.@preserve flags cd_nelmts cd_values nbytes buf_size buf begin
        ret_code = filter_func(
            flags,
            cd_nelmts,
            pointer(cd_values),
            Csize_t(nbytes),
            Base.unsafe_convert(Ptr{Csize_t}, buf_size),
            Base.unsafe_convert(Ptr{Ptr{Cvoid}}, buf)
        )
        @debug "Decompression:" ret_code buf_size[]
    end
    return ret_code
end

function test_filter_cleanup!(buf::Ref{Ptr{Cvoid}})
    Libc.free(buf[])
end

function test_filter(filter_func; cd_values::Vector{Cuint}=Cuint[], data=ones(UInt8, 1024))
    flags, cd_values, nbytes, buf_size, buf = test_filter_init(;
        cd_values=cd_values, data=data
    )
    nbytes_compressed, nbytes_decompressed = 0, 0
    try
        nbytes_compressed = test_filter_compress!(
            filter_func, flags, cd_values, nbytes, buf_size, buf
        )
        nbytes_decompressed = test_filter_decompress!(
            filter_func, flags, cd_values, nbytes_compressed, buf_size, buf
        )
        if nbytes_decompressed > 0
            # ret_code is the number of bytes out
            round_trip_data = unsafe_wrap(Array, Ptr{UInt8}(buf[]), nbytes_decompressed)
            @debug "Is the data the same after a roundtrip?" data == round_trip_data
        end
    catch err
        rethrow(err)
    finally
        test_filter_cleanup!(buf)
    end
    @debug "Compression Ratio" nbytes_compressed / nbytes_decompressed
    return nbytes_compressed, nbytes_decompressed
end

function test_bzip2_filter(data=ones(UInt8, 1024))
    cd_values = Cuint[8]
    test_filter(H5Z_filter_bzip2; cd_values=cd_values, data=data)
end

function test_lz4_filter(data=ones(UInt8, 1024))
    cd_values = Cuint[1024]
    test_filter(H5Z_filter_lz4; cd_values=cd_values, data=data)
end

function test_zstd_filter(data=ones(UInt8, 1024))
    cd_values = Cuint[3] # aggression
    test_filter(H5Z_filter_zstd; cd_values=cd_values, data=data)
end

function __init__()
    @testset "Compression Filter Unit Tests" begin
        @test argmin(test_bzip2_filter()) == 1
        @test argmin(test_lz4_filter()) == 1
        @test argmin(test_zstd_filter()) == 1
        str = codeunits(repeat("foobar", 1000))
        @test argmin(test_bzip2_filter(str)) == 1
        @test argmin(test_lz4_filter(str)) == 1
        @test argmin(test_zstd_filter(str)) == 1
    end
end

end

### High-level interface ###

function h5write(filename, name::AbstractString, data; pv...)
    file = h5open(filename, "cw"; pv...)
    try
        write(file, name, data)
    finally
        close(file)
    end
end

function h5read(filename, name::AbstractString; pv...)
    local dat, file
    fapl = FileAccessProperties(; fclose_degree=:strong)
    pv = setproperties!(fapl; pv...)
    try
        file = h5open(filename, "r", fapl)
    finally
        close(fapl)
    end
    try
        obj = getindex(file, name; pv...)
        dat = read(obj)
        close(obj)
    finally
        close(file)
    end
    dat
end

function h5read(filename, name_type_pair::Pair{<:AbstractString,DataType}; pv...)
    local dat, file
    fapl = FileAccessProperties(; fclose_degree=:strong)
    pv = setproperties!(fapl; pv...)
    try
        file = h5open(filename, "r", fapl)
    finally
        close(fapl)
    end
    try
        obj = getindex(file, name_type_pair[1]; pv...)
        dat = read(obj, name_type_pair[2])
        close(obj)
    finally
        close(file)
    end
    dat
end

function h5read(
    filename,
    name::AbstractString,
    indices::Tuple{Vararg{Union{AbstractRange{Int},Int,Colon}}};
    pv...
)
    local dat, file
    fapl = FileAccessProperties(; fclose_degree=:strong)
    pv = setproperties!(fapl; pv...)
    try
        file = h5open(filename, "r", fapl)
    finally
        close(fapl)
    end
    try
        dset = getindex(file, name; pv...)
        dat = dset[indices...]
        close(dset)
    finally
        close(file)
    end
    dat
end

function Base.getindex(parent::Union{File,Group}, path::AbstractString; pv...)
    haskey(parent, path) || throw(KeyError(path))
    # Faster than below if defaults are OK
    isempty(pv) && return open_object(parent, path)
    obj_type = gettype(parent, path)
    if obj_type == API.H5I_DATASET
        return open_dataset(parent, path; pv...)
    elseif obj_type == API.H5I_GROUP
        return open_group(parent, path; pv...)
    else#if obj_type == API.H5I_DATATYPE # only remaining choice
        return open_datatype(parent, path; pv...)
    end
end

# Assign syntax: obj[path] = value
# Create a dataset with properties: obj[path, prop = val, ...] = val
function Base.setindex!(
    parent::Union{File,Group}, val, path::Union{AbstractString,Nothing}; pv...
)
    need_chunks = any(k in keys(chunked_props) for k in keys(pv))
    have_chunks = any(k == :chunk for k in keys(pv))

    chunk = need_chunks ? heuristic_chunk(val) : Int[]

    # ignore chunked_props (== compression) for empty datasets (issue #246):
    discard_chunks = need_chunks && isempty(chunk)
    if discard_chunks
        pv = pairs(Base.structdiff((; pv...), chunked_props))
    else
        if need_chunks && !have_chunks
            pv = pairs((; chunk=chunk, pv...))
        end
    end
    write(parent, path, val; pv...)
end

### Property manipulation ###
get_access_properties(d::Dataset)   = DatasetAccessProperties(API.h5d_get_access_plist(d))
get_access_properties(f::File)      = FileAccessProperties(API.h5f_get_access_plist(f))
get_create_properties(d::Dataset)   = DatasetCreateProperties(API.h5d_get_create_plist(d))
get_create_properties(g::Group)     = GroupCreateProperties(API.h5g_get_create_plist(g))
get_create_properties(f::File)      = FileCreateProperties(API.h5f_get_create_plist(f))
get_create_properties(a::Attribute) = AttributeCreateProperties(API.h5a_get_create_plist(a))

## C types
const Ctime_t = Int

## HDF5 types and constants
const haddr_t  = UInt64
const hbool_t  = Bool
const herr_t   = Cint
const hid_t    = Int64
const hsize_t  = UInt64
const hssize_t = Int64
const htri_t   = Cint   # pseudo-boolean (negative if error)
@static if Sys.iswindows()
    const off_t = Int
else
    const off_t = Int64
end
# Introduced in HDF5 v2.0
const H5Doff_t = Int64

const H5Z_filter_t = Cint

# For VLEN
struct hvl_t
    len::Csize_t
    p::Ptr{Cvoid}
end
const HVL_SIZE = sizeof(hvl_t)

# Reference types
struct hobj_ref_t
    buf::UInt64 # H5R_OBJ_REF_BUF_SIZE bytes
end
struct hdset_reg_ref_t
    buf::NTuple{12,UInt8} # H5R_DSET_REG_REF_BUF_SIZE bytes
end
const HOBJ_REF_T_NULL = hobj_ref_t(0x0)
const HDSET_REG_REF_T_NULL = hdset_reg_ref_t(ntuple(_ -> 0x0, Val(12)))

#= TODO: when upgraded to using newer HDF5 v1.12 reference API, can replace both with:
struct H5R_ref_t
    # Element type of UInt64 and not UInt8 to get 8-byte alignment
    buf::NTuple{8,UInt64} # H5R_REF_BUF_SIZE bytes
end
const H5R_REF_T_NULL = H5R_ref_t(ntuple(_ -> 0x0, Val(64)))
=#

# For attribute information
struct H5A_info_t
    corder_valid::hbool_t
    corder::UInt32 # typedef uint32_t H5O_msg_crt_idx_t
    cset::Cint
    data_size::hsize_t
end

# For group information
struct H5G_info_t
    storage_type::Cint # enum H5G_storage_type_t
    nlinks::hsize_t
    max_corder::Int64
    mounted::hbool_t
end

# For objects
@enum H5_index_t::Cint begin
    H5_INDEX_UNKNOWN = -1
    H5_INDEX_NAME = 0
    H5_INDEX_CRT_ORDER = 1
    H5_INDEX_N = 2
end
@enum H5_iter_order_t::Cint begin
    H5_ITER_UNKNOWN = -1
    H5_ITER_INC = 0
    H5_ITER_DEC = 1
    H5_ITER_NATIVE = 2
    H5_ITER_N = 3
end
@enum H5_iter_t::Cint begin
    H5_ITER_CONT  = 0
    H5_ITER_ERROR = -1
    H5_ITER_STOP  = 1
end
Base.convert(::Type{H5_iter_t}, x::Integer) = H5_iter_t(x)

const H5O_iterate1_t = Ptr{Cvoid}
const H5O_iterate2_t = Ptr{Cvoid}

struct _H5O_hdr_info_t_space
    total::hsize_t
    meta::hsize_t
    mesg::hsize_t
    free::hsize_t
end

struct _H5O_hdr_info_t_mesg
    present::UInt64
    shared::UInt64
end

struct H5O_hdr_info_t
    version::Cuint
    nmesgs::Cuint
    nchunks::Cuint
    flags::Cuint
    space::_H5O_hdr_info_t_space
    mesg::_H5O_hdr_info_t_mesg
end

struct H5_ih_info_t
    index_size::hsize_t
    heap_size::hsize_t
end

struct _H5O_native_info_t_meta_size
    obj::H5_ih_info_t
    attr::H5_ih_info_t
end

struct H5O_native_info_t
    hdr::H5O_hdr_info_t
    meta_size::_H5O_native_info_t_meta_size
end

const H5O_NATIVE_INFO_HDR = 0x0008
const H5O_NATIVE_INFO_META_SIZE = 0x0010
const H5O_NATIVE_INFO_ALL = H5O_NATIVE_INFO_HDR | H5O_NATIVE_INFO_META_SIZE

struct H5O_token_t
    __data::NTuple{16,UInt8}
end
@enum H5O_type_t::Cint begin
    H5O_TYPE_UNKNOWN = -1
    H5O_TYPE_GROUP = 0
    H5O_TYPE_DATASET = 1
    H5O_TYPE_NAMED_DATATYPE = 2
    H5O_TYPE_MAP = 3
    H5O_TYPE_NTYPES = 4
end

struct H5O_info1_t # version 1 type H5O_info1_t
    fileno::Culong
    addr::haddr_t
    otype::H5O_type_t # enum H5O_type_t
    rc::Cuint
    atime::Ctime_t
    mtime::Ctime_t
    ctime::Ctime_t
    btime::Ctime_t
    num_attrs::hsize_t
    #{ inlined struct H5O_hdr_info_t named type
    version::Cuint
    nmesgs::Cuint
    nchunks::Cuint
    flags::Cuint
    total::hsize_t
    meta::hsize_t
    mesg::hsize_t
    free::hsize_t
    present::UInt64
    shared::UInt64
    #}
    #{ inlined anonymous struct named meta_size
    meta_obj::H5_ih_info_t
    meta_attr::H5_ih_info_t
    #}
end
const H5O_info_t = H5O_info1_t

# The field "otype" is originally "type"
# Alias "otype" as "type" for compat with H5O_info2_t
Base.getproperty(oinfo::H5O_info1_t, field::Symbol) =
    field == :type ? getfield(oinfo, :otype) : getfield(oinfo, field)

struct H5O_info2_t
    fileno::Culong
    token::H5O_token_t
    type::H5O_type_t
    rc::Cuint
    atime::Ctime_t
    mtime::Ctime_t
    ctime::Ctime_t
    btime::Ctime_t
    num_attrs::hsize_t
end

# For links
struct H5L_info_t
    linktype::Cint
    corder_valid::hbool_t
    corder::Int64
    cset::Cint # enum H5T_cset_t
    u::haddr_t # union { haddr_t address, size_t val_size }
end

# For registering filters
struct H5Z_class_t # version 2 type H5Z_class2_t
    version::Cint # = H5Z_CLASS_T_VERS
    id::H5Z_filter_t # Filter ID number
    encoder_present::Cuint # Does this filter have an encoder?
    decoder_present::Cuint # Does this filter have a decoder?
    name::Ptr{UInt8} # Comment for debugging
    can_apply::Ptr{Cvoid} # The "can apply" callback
    set_local::Ptr{Cvoid} # The "set local" callback
    filter::Ptr{Cvoid} # The filter callback
end

# Information about an error; element of error stack.
# See https://github.com/HDFGroup/hdf5/blob/hdf5-1_12_0/src/H5Epublic.h#L36-L44
struct H5E_error2_t
    cls_id::hid_t # class ID"
    maj_num::hid_t # major error ID
    min_num::hid_t # minor error number
    line::Cuint # line in file where the error occurs
    func_name::Cstring # function where the error occurred
    file_name::Cstring # file in which the error occurred
    desc::Cstring # optional supplied description
end

# HDFS Drivers
struct H5FD_hdfs_fapl_t
    version::Int32
    namenode_name::NTuple{129,Cchar}
    namenode_port::Int32
    user_name::NTuple{129,Cchar}
    kerberos_ticket_cache::NTuple{129,Cchar}
    stream_buffer_size::Int32
end

const H5FD_ROS3_MAX_REGION_LEN = 32
const H5FD_ROS3_MAX_SECRET_ID_LEN = 128
const H5FD_ROS3_MAX_SECRET_KEY_LEN = 128

struct H5FD_ros3_fapl_t
    version::Int32
    authenticate::hbool_t
    aws_region::NTuple{H5FD_ROS3_MAX_REGION_LEN + 1,Cchar}
    secret_id::NTuple{H5FD_ROS3_MAX_SECRET_ID_LEN + 1,Cchar}
    secret_key::NTuple{H5FD_ROS3_MAX_SECRET_KEY_LEN + 1,Cchar}
end

struct H5FD_splitter_vfd_config_t
    magic::Int32
    version::Cuint
    rw_fapl_id::hid_t
    wo_fapl_id::hid_t
    wo_path::NTuple{4097,Cchar}
    log_file_path::NTuple{4097,Cchar}
    ignore_wo_errs::hbool_t
end

# Private function to extract exported global library constants.
# Need to call H5open to ensure library is initalized before reading these constants.
# Although these are runtime initalized constants, in practice their values are stable, so
# we can precompile for improved latency.
const libhdf5handle = Ref(dlopen(libhdf5))
ccall(dlsym(libhdf5handle[], :H5open), herr_t, ())
_read_const(sym::Symbol) = unsafe_load(cglobal(dlsym(libhdf5handle[], sym), hid_t))
_has_symbol(sym::Symbol) = dlsym(libhdf5handle[], sym; throw_error=false) !== nothing

# iteration order constants
# Moved to H5_iter_order_t enum
#const H5_ITER_UNKNOWN = -1
#const H5_ITER_INC     = 0
#const H5_ITER_DEC     = 1
#const H5_ITER_NATIVE  = 2
#const H5_ITER_N       = 3

# indexing type constants
# Moved to H5_index_t enum
#const H5_INDEX_UNKNOWN   = -1
#const H5_INDEX_NAME      = 0
#const H5_INDEX_CRT_ORDER = 1
#const H5_INDEX_N = 2

# dataset constants
const H5D_COMPACT    = 0
const H5D_CONTIGUOUS = 1
const H5D_CHUNKED    = 2
const H5D_VIRTUAL    = 3

# allocation times (C enum H5D_alloc_time_t)
const H5D_ALLOC_TIME_ERROR = -1
const H5D_ALLOC_TIME_DEFAULT = 0
const H5D_ALLOC_TIME_EARLY = 1
const H5D_ALLOC_TIME_LATE = 2
const H5D_ALLOC_TIME_INCR = 3

# used to "unset" chunk cache configuration parameters
const H5D_CHUNK_CACHE_NSLOTS_DEFAULT = -1 % Csize_t
const H5D_CHUNK_CACHE_NBYTES_DEFAULT = -1 % Csize_t
const H5D_CHUNK_CACHE_W0_DEFAULT = Cdouble(-1)

# space status
const H5D_SPACE_STATUS_ERROR = Cint(-1)
const H5D_SPACE_STATUS_NOT_ALLOCATED = Cint(0)
const H5D_SPACE_STATUS_PART_ALLOCATED = Cint(1)
const H5D_SPACE_STATUS_ALLOCATED = Cint(2)
const H5D_space_status_t = Cint

# error-related constants
const H5E_DEFAULT       = 0
const H5E_WALK_UPWARD   = 0
const H5E_WALK_DOWNWARD = 1

# file access modes
const H5F_ACC_RDONLY     = 0x0000
const H5F_ACC_RDWR       = 0x0001
const H5F_ACC_TRUNC      = 0x0002
const H5F_ACC_EXCL       = 0x0004
const H5F_ACC_DEBUG      = 0x0008
const H5F_ACC_CREAT      = 0x0010
const H5F_ACC_SWMR_WRITE = 0x0020
const H5F_ACC_SWMR_READ  = 0x0040

# Library versions
@enum H5F_libver_t::Int32 begin
    H5F_LIBVER_ERROR = -1
    H5F_LIBVER_EARLIEST = 0
    H5F_LIBVER_V18 = 1
    H5F_LIBVER_V110 = 2
    H5F_LIBVER_V112 = 3
    H5F_LIBVER_V114 = 4
    H5F_LIBVER_V200 = 5
    H5F_LIBVER_NBOUNDS = 6
end
# H5F_LIBVER_LATEST defined in helpers.jl

# object types
const H5F_OBJ_FILE     = 0x0001
const H5F_OBJ_DATASET  = 0x0002
const H5F_OBJ_GROUP    = 0x0004
const H5F_OBJ_DATATYPE = 0x0008
const H5F_OBJ_ATTR     = 0x0010
const H5F_OBJ_ALL      = (H5F_OBJ_FILE | H5F_OBJ_DATASET | H5F_OBJ_GROUP | H5F_OBJ_DATATYPE | H5F_OBJ_ATTR)
const H5F_OBJ_LOCAL    = 0x0020

# other file constants
const H5F_SCOPE_LOCAL   = 0
const H5F_SCOPE_GLOBAL  = 1
const H5F_CLOSE_DEFAULT = 0
const H5F_CLOSE_WEAK    = 1
const H5F_CLOSE_SEMI    = 2
const H5F_CLOSE_STRONG  = 3

# file driver constants
const H5FD_MPIO_INDEPENDENT    = 0
const H5FD_MPIO_COLLECTIVE     = 1
const H5FD_MPIO_CHUNK_DEFAULT  = 0
const H5FD_MPIO_CHUNK_ONE_IO   = 1
const H5FD_MPIO_CHUNK_MULTI_IO = 2
const H5FD_MPIO_COLLECTIVE_IO  = 0
const H5FD_MPIO_INDIVIDUAL_IO  = 1

# object types (C enum H5Itype_t)
const H5I_FILE      = 1
const H5I_GROUP     = 2
const H5I_DATATYPE  = 3
const H5I_DATASPACE = 4
const H5I_DATASET   = 5
const H5I_ATTR      = 6
const H5I_REFERENCE = 7
const H5I_VFL       = 8

# Link constants
const H5L_TYPE_HARD     = 0
const H5L_TYPE_SOFT     = 1
const H5L_TYPE_EXTERNAL = 2

# H5O_INFO constants
const H5O_INFO_BASIC = Cuint(0x0001)
const H5O_INFO_TIME = Cuint(0x0002)
const H5O_INFO_NUM_ATTRS = Cuint(0x0004)
const H5O_INFO_HDR = Cuint(0x0008)
const H5O_INFO_META_SIZE = Cuint(0x0010)
const H5O_INFO_ALL =
    H5O_INFO_BASIC | H5O_INFO_TIME | H5O_INFO_NUM_ATTRS | H5O_INFO_HDR | H5O_INFO_META_SIZE

# Object constants
# Moved to H5O_type_t enum
#const H5O_TYPE_GROUP   = 0
#const H5O_TYPE_DATASET = 1
#const H5O_TYPE_NAMED_DATATYPE = 2

# Property constants
const H5P_DEFAULT          = hid_t(0)
const H5P_OBJECT_CREATE    = _read_const(:H5P_CLS_OBJECT_CREATE_ID_g)
const H5P_FILE_CREATE      = _read_const(:H5P_CLS_FILE_CREATE_ID_g)
const H5P_FILE_ACCESS      = _read_const(:H5P_CLS_FILE_ACCESS_ID_g)
const H5P_DATASET_CREATE   = _read_const(:H5P_CLS_DATASET_CREATE_ID_g)
const H5P_DATASET_ACCESS   = _read_const(:H5P_CLS_DATASET_ACCESS_ID_g)
const H5P_DATASET_XFER     = _read_const(:H5P_CLS_DATASET_XFER_ID_g)
const H5P_FILE_MOUNT       = _read_const(:H5P_CLS_FILE_MOUNT_ID_g)
const H5P_GROUP_CREATE     = _read_const(:H5P_CLS_GROUP_CREATE_ID_g)
const H5P_GROUP_ACCESS     = _read_const(:H5P_CLS_GROUP_ACCESS_ID_g)
const H5P_DATATYPE_CREATE  = _read_const(:H5P_CLS_DATATYPE_CREATE_ID_g)
const H5P_DATATYPE_ACCESS  = _read_const(:H5P_CLS_DATATYPE_ACCESS_ID_g)
const H5P_STRING_CREATE    = _read_const(:H5P_CLS_STRING_CREATE_ID_g)
const H5P_ATTRIBUTE_ACCESS = _read_const(:H5P_CLS_ATTRIBUTE_ACCESS_ID_g)
const H5P_ATTRIBUTE_CREATE = _read_const(:H5P_CLS_ATTRIBUTE_CREATE_ID_g)
const H5P_OBJECT_COPY      = _read_const(:H5P_CLS_OBJECT_COPY_ID_g)
const H5P_LINK_CREATE      = _read_const(:H5P_CLS_LINK_CREATE_ID_g)
const H5P_LINK_ACCESS      = _read_const(:H5P_CLS_LINK_ACCESS_ID_g)

# Plugin constants, H5PL_type_t
const H5PL_TYPE_ERROR = -1
const H5PL_TYPE_FILTER = 0
const H5PL_TYPE_VOL = 1
const H5PL_TYPE_NONE = 2

const H5P_CRT_ORDER_TRACKED = 1
const H5P_CRT_ORDER_INDEXED = 2

# Reference constants
const H5R_OBJECT                = 0
const H5R_DATASET_REGION        = 1
const H5R_OBJ_REF_BUF_SIZE      = 8  # == sizeof(hobj_ref_t)
const H5R_DSET_REG_REF_BUF_SIZE = 12 # == sizeof(hdset_reg_ref_t)

# Dataspace constants
const H5S_ALL       = hid_t(0)
const H5S_UNLIMITED = typemax(hsize_t)

# Dataspace classes (C enum H5S_class_t)
@enum H5S_class_t::Cint begin
    H5S_NO_CLASS = -1
    H5S_SCALAR = 0
    H5S_SIMPLE = 1
    H5S_NULL = 2
end

# Dataspace selection constants (C enum H5S_seloper_t)
@enum H5S_seloper_t::Cint begin
    H5S_SELECT_NOOP = -1
    H5S_SELECT_SET = 0
    H5S_SELECT_OR = 1
    H5S_SELECT_AND = 2
    H5S_SELECT_XOR = 3
    H5S_SELECT_NOTB = 4
    H5S_SELECT_NOTA = 5
    H5S_SELECT_APPEND = 6
    H5S_SELECT_PREPEND = 7
    H5S_SELECT_INVALID = 8
end

# Dataspace selection types (C enum H5S_sel_type)
@enum H5S_sel_type::Cint begin
    H5S_SEL_ERROR = -1
    H5S_SEL_NONE = 0
    H5S_SEL_POINTS = 1
    H5S_SEL_HYPERSLABS = 2
    H5S_SEL_ALL = 3
    H5S_SEL_N = 4
end

# type classes (C enum H5T_class_t)
const H5T_NO_CLASS  = hid_t(-1)
const H5T_INTEGER   = hid_t(0)
const H5T_FLOAT     = hid_t(1)
const H5T_TIME      = hid_t(2)  # not supported by HDF5 library
const H5T_STRING    = hid_t(3)
const H5T_BITFIELD  = hid_t(4)
const H5T_OPAQUE    = hid_t(5)
const H5T_COMPOUND  = hid_t(6)
const H5T_REFERENCE = hid_t(7)
const H5T_ENUM      = hid_t(8)
const H5T_VLEN      = hid_t(9)
const H5T_ARRAY     = hid_t(10)

# Byte orders (C enum H5T_order_t)
const H5T_ORDER_ERROR = -1 # error
const H5T_ORDER_LE    = 0  # little endian
const H5T_ORDER_BE    = 1  # bit endian
const H5T_ORDER_VAX   = 2  # VAX mixed endian
const H5T_ORDER_MIXED = 3  # Compound type with mixed member orders
const H5T_ORDER_NONE  = 4  # no particular order (strings, bits,..)

# Floating-point normalization schemes (C enum H5T_norm_t)
const H5T_NORM_ERROR   = -1 # error
const H5T_NORM_IMPLIED = 0  # msb of mantissa isn't stored, always 1
const H5T_NORM_MSBSET  = 1  # msb of mantissa is always 1
const H5T_NORM_NONE    = 2   # not normalized

# Character types
const H5T_CSET_ASCII = 0
const H5T_CSET_UTF8  = 1

# Sign types (C enum H5T_sign_t)
const H5T_SGN_ERROR = Cint(-1) # error
const H5T_SGN_NONE  = Cint(0)  # unsigned
const H5T_SGN_2     = Cint(1)  # 2's complement
const H5T_NSGN      = Cint(2)  # sentinel: this must be last!

# Search directions
const H5T_DIR_ASCEND  = 1
const H5T_DIR_DESCEND = 2

# String padding modes
const H5T_STR_NULLTERM = 0
const H5T_STR_NULLPAD  = 1
const H5T_STR_SPACEPAD = 2

# Type_id constants (LE = little endian, I16 = Int16, etc)
const H5T_STD_I8LE        = _read_const(:H5T_STD_I8LE_g)
const H5T_STD_I8BE        = _read_const(:H5T_STD_I8BE_g)
const H5T_STD_U8LE        = _read_const(:H5T_STD_U8LE_g)
const H5T_STD_U8BE        = _read_const(:H5T_STD_U8BE_g)
const H5T_STD_I16LE       = _read_const(:H5T_STD_I16LE_g)
const H5T_STD_I16BE       = _read_const(:H5T_STD_I16BE_g)
const H5T_STD_U16LE       = _read_const(:H5T_STD_U16LE_g)
const H5T_STD_U16BE       = _read_const(:H5T_STD_U16BE_g)
const H5T_STD_I32LE       = _read_const(:H5T_STD_I32LE_g)
const H5T_STD_I32BE       = _read_const(:H5T_STD_I32BE_g)
const H5T_STD_U32LE       = _read_const(:H5T_STD_U32LE_g)
const H5T_STD_U32BE       = _read_const(:H5T_STD_U32BE_g)
const H5T_STD_I64LE       = _read_const(:H5T_STD_I64LE_g)
const H5T_STD_I64BE       = _read_const(:H5T_STD_I64BE_g)
const H5T_STD_U64LE       = _read_const(:H5T_STD_U64LE_g)
const H5T_STD_U64BE       = _read_const(:H5T_STD_U64BE_g)
const H5T_IEEE_F32LE      = _read_const(:H5T_IEEE_F32LE_g)
const H5T_IEEE_F32BE      = _read_const(:H5T_IEEE_F32BE_g)
const H5T_IEEE_F64LE      = _read_const(:H5T_IEEE_F64LE_g)
const H5T_IEEE_F64BE      = _read_const(:H5T_IEEE_F64BE_g)
const H5T_C_S1            = _read_const(:H5T_C_S1_g)
const H5T_STD_REF_OBJ     = _read_const(:H5T_STD_REF_OBJ_g)
const H5T_STD_REF_DSETREG = _read_const(:H5T_STD_REF_DSETREG_g)
# Native types
const H5T_NATIVE_B8     = _read_const(:H5T_NATIVE_B8_g)
const H5T_NATIVE_INT8   = _read_const(:H5T_NATIVE_INT8_g)
const H5T_NATIVE_UINT8  = _read_const(:H5T_NATIVE_UINT8_g)
const H5T_NATIVE_INT16  = _read_const(:H5T_NATIVE_INT16_g)
const H5T_NATIVE_UINT16 = _read_const(:H5T_NATIVE_UINT16_g)
const H5T_NATIVE_INT32  = _read_const(:H5T_NATIVE_INT32_g)
const H5T_NATIVE_UINT32 = _read_const(:H5T_NATIVE_UINT32_g)
const H5T_NATIVE_INT64  = _read_const(:H5T_NATIVE_INT64_g)
const H5T_NATIVE_UINT64 = _read_const(:H5T_NATIVE_UINT64_g)
const H5T_NATIVE_FLOAT  = _read_const(:H5T_NATIVE_FLOAT_g)
const H5T_NATIVE_DOUBLE = _read_const(:H5T_NATIVE_DOUBLE_g)
# Other type constants
const H5T_VARIABLE = reinterpret(UInt, -1)

# Filter constants
const H5Z_FLAG_MANDATORY = 0x0000
const H5Z_FLAG_OPTIONAL = 0x0001
const H5Z_FLAG_REVERSE = 0x0100
const H5Z_CLASS_T_VERS = 1

# predefined filters
const H5Z_FILTER_ALL = H5Z_filter_t(0)
const H5Z_FILTER_NONE = H5Z_filter_t(0)
const H5Z_FILTER_DEFLATE = H5Z_filter_t(1)
const H5Z_FILTER_SHUFFLE = H5Z_filter_t(2)
const H5Z_FILTER_FLETCHER32 = H5Z_filter_t(3)
const H5Z_FILTER_SZIP = H5Z_filter_t(4)
const H5Z_FILTER_NBIT = H5Z_filter_t(5)
const H5Z_FILTER_SCALEOFFSET = H5Z_filter_t(6)

const H5_SZIP_EC_OPTION_MASK = Cuint(4)
const H5_SZIP_NN_OPTION_MASK = Cuint(32)
const H5_SZIP_MAX_PIXELS_PER_BLOCK = Cuint(32)

const H5Z_FILTER_CONFIG_ENCODE_ENABLED = 0x0001
const H5Z_FILTER_CONFIG_DECODE_ENABLED = 0x0002

# fill time
@enum H5D_fill_time_t::Int32 begin
    H5D_FILL_TIME_ERROR = -1
    H5D_FILL_TIME_ALLOC = 0
    H5D_FILL_TIME_NEVER = 1
    H5D_FILL_TIME_IFSET = 2
end

@enum H5F_mem_t::Int32 begin
    H5FD_MEM_NOLIST = -1
    H5FD_MEM_DEFAULT = 0
    H5FD_MEM_SUPER = 1
    H5FD_MEM_BTREE = 2
    H5FD_MEM_DRAW = 3
    H5FD_MEM_GHEAP = 4
    H5FD_MEM_LHEAP = 5
    H5FD_MEM_OHDR = 6
    H5FD_MEM_NTYPES = 7
end

const H5FD_mem_t = H5F_mem_t

struct H5FD_file_image_callbacks_t
    image_malloc::Ptr{Cvoid}
    image_memcpy::Ptr{Cvoid}
    image_realloc::Ptr{Cvoid}
    image_free::Ptr{Cvoid}
    udata_copy::Ptr{Cvoid}
    udata_free::Ptr{Cvoid}
    udata::Ptr{Cvoid}
end

struct H5F_sect_info_t
    addr::haddr_t
    size::hsize_t
end

@enum H5F_fspace_strategy_t::UInt32 begin
    H5F_FSPACE_STRATEGY_FSM_AGGR = 0
    H5F_FSPACE_STRATEGY_PAGE = 1
    H5F_FSPACE_STRATEGY_AGGR = 2
    H5F_FSPACE_STRATEGY_NONE = 3
    H5F_FSPACE_STRATEGY_NTYPES = 4
end

@enum H5F_file_space_type_t::UInt32 begin
    H5F_FILE_SPACE_DEFAULT = 0
    H5F_FILE_SPACE_ALL_PERSIST = 1
    H5F_FILE_SPACE_ALL = 2
    H5F_FILE_SPACE_AGGR_VFD = 3
    H5F_FILE_SPACE_VFD = 4
    H5F_FILE_SPACE_NTYPES = 5
end

@enum H5Z_EDC_t::Int32 begin
    H5Z_ERROR_EDC = -1
    H5Z_DISABLE_EDC = 0
    H5Z_ENABLE_EDC = 1
    H5Z_NO_EDC = 2
end

# Callbacks
# typedef herr_t ( * H5P_prp_cb1_t ) ( const char * name , size_t size , void * value )
const H5P_prp_cb1_t = Ptr{Cvoid}
const H5P_prp_copy_func_t = H5P_prp_cb1_t
# typedef int ( * H5P_prp_compare_func_t ) ( const void * value1 , const void * value2 , size_t size )
const H5P_prp_compare_func_t = Ptr{Cvoid}
const H5P_prp_close_func_t = H5P_prp_cb1_t
const H5P_prp_create_func_t = H5P_prp_cb1_t
const H5P_prp_cb2_t = Ptr{Cvoid}
const H5P_prp_set_func_t = H5P_prp_cb2_t
const H5P_prp_get_func_t = H5P_prp_cb2_t
const H5P_prp_delete_func_t = H5P_prp_cb2_t
const H5P_cls_create_func_t = Ptr{Cvoid}
const H5P_cls_copy_func_t = Ptr{Cvoid}
const H5P_cls_close_func_t = Ptr{Cvoid}
const H5P_iterate_t = Ptr{Cvoid}
const H5D_append_cb_t = Ptr{Cvoid}
const H5L_elink_traverse_t = Ptr{Cvoid}
# typedef herr_t ( * H5F_flush_cb_t ) ( hid_t object_id , void * udata )
const H5F_flush_cb_t = Ptr{Cvoid}
# typedef H5O_mcdt_search_ret_t ( * H5O_mcdt_search_cb_t ) ( void * op_data )
const H5O_mcdt_search_cb_t = Ptr{Cvoid}
# typedef herr_t ( * H5T_conv_t ) ( hid_t src_id , hid_t dst_id , H5T_cdata_t * cdata , size_t nelmts , size_t buf_stride , size_t bkg_stride , void * buf , void * bkg , hid_t dset_xfer_plist )
const H5T_conv_t = Ptr{Cvoid}
# typedef H5T_conv_ret_t ( * H5T_conv_except_func_t ) ( H5T_conv_except_t except_type , hid_t src_id , hid_t dst_id , void * src_buf , void * dst_buf , void * user_data )
const H5T_conv_except_func_t = Ptr{Cvoid}
# typedef herr_t ( * H5M_iterate_t ) ( hid_t map_id , const void * key , void * op_data )
const H5M_iterate_t = Ptr{Cvoid}
# typedef void * ( * H5MM_allocate_t ) ( size_t size , void * alloc_info )
const H5MM_allocate_t = Ptr{Cvoid}
# typedef void ( * H5MM_free_t ) ( void * mem , void * free_info )
const H5MM_free_t = Ptr{Cvoid}
# typedef H5Z_cb_return_t ( * H5Z_filter_func_t ) ( H5Z_filter_t filter , void * buf , size_t buf_size , void * op_data )
const H5Z_filter_func_t = Ptr{Cvoid}

struct H5Z_cb_t
    func::H5Z_filter_func_t
    op_data::Ptr{Cvoid}
end

@enum H5C_cache_incr_mode::UInt32 begin
    H5C_incr__off = 0
    H5C_incr__threshold = 1
end

@enum H5C_cache_flash_incr_mode::UInt32 begin
    H5C_flash_incr__off = 0
    H5C_flash_incr__add_space = 1
end

@enum H5C_cache_decr_mode::UInt32 begin
    H5C_decr__off = 0
    H5C_decr__threshold = 1
    H5C_decr__age_out = 2
    H5C_decr__age_out_with_threshold = 3
end

struct H5AC_cache_config_t
    version::Cint
    rpt_fcn_enabled::hbool_t
    open_trace_file::hbool_t
    close_trace_file::hbool_t
    trace_file_name::NTuple{1025,Cchar}
    evictions_enabled::hbool_t
    set_initial_size::hbool_t
    initial_size::Csize_t
    min_clean_fraction::Cdouble
    max_size::Csize_t
    min_size::Csize_t
    epoch_length::Clong
    incr_mode::H5C_cache_incr_mode
    lower_hr_threshold::Cdouble
    increment::Cdouble
    apply_max_increment::hbool_t
    max_increment::Csize_t
    flash_incr_mode::H5C_cache_flash_incr_mode
    flash_multiple::Cdouble
    flash_threshold::Cdouble
    decr_mode::H5C_cache_decr_mode
    upper_hr_threshold::Cdouble
    decrement::Cdouble
    apply_max_decrement::hbool_t
    max_decrement::Csize_t
    epochs_before_eviction::Cint
    apply_empty_reserve::hbool_t
    empty_reserve::Cdouble
    dirty_bytes_threshold::Csize_t
    metadata_write_strategy::Cint
end

struct H5AC_cache_image_config_t
    version::Cint
    generate_image::hbool_t
    save_resize_status::hbool_t
    entry_ageout::Cint
end

@enum H5D_vds_view_t::Int32 begin
    H5D_VDS_ERROR = -1
    H5D_VDS_FIRST_MISSING = 0
    H5D_VDS_LAST_AVAILABLE = 1
end

@enum H5D_fill_value_t::Int32 begin
    H5D_FILL_VALUE_ERROR = -1
    H5D_FILL_VALUE_UNDEFINED = 0
    H5D_FILL_VALUE_DEFAULT = 1
    H5D_FILL_VALUE_USER_DEFINED = 2
end

struct H5F_info2_super
    version::Cuint
    super_size::hsize_t
    super_ext_size::hsize_t
end

struct H5F_info2_free
    version::Cuint
    meta_size::hsize_t
    tot_space::hsize_t
end

struct H5F_info2_sohm
    version::Cuint
    hdr_size::hsize_t
    msgs_info::H5_ih_info_t
end

struct H5F_info2_t
    super::H5F_info2_super
    free::H5F_info2_free
    sohm::H5F_info2_sohm
end

struct H5F_retry_info_t
    nbins::Cuint
    retries::NTuple{21,Ptr{UInt32}}
end

using HDF5
using Test

function create_h5_uint24()
    dt = HDF5.API.h5t_copy(HDF5.API.H5T_STD_U32LE)
    HDF5.API.h5t_set_size(dt, 3)
    HDF5.API.h5t_set_precision(dt, 24)
    return HDF5.Datatype(dt)
end

@testset "Datatypes" begin
    DT = create_h5_uint24()
    @test HDF5.API.h5t_get_size(DT) == 3
    @test HDF5.API.h5t_get_precision(DT) == 24
    @test HDF5.API.h5t_get_offset(DT) == 0
    @test HDF5.API.h5t_get_order(DT) == HDF5.API.H5T_ORDER_LE

    HDF5.API.h5t_set_precision(DT, 12)
    @test HDF5.API.h5t_get_precision(DT) == 12
    @test HDF5.API.h5t_get_offset(DT) == 0

    HDF5.API.h5t_set_offset(DT, 12)
    @test HDF5.API.h5t_get_precision(DT) == 12
    @test HDF5.API.h5t_get_offset(DT) == 12

    io = IOBuffer()
    show(io, DT)
    str = String(take!(io))
    @test match(r"undefined integer", str) !== nothing
    @test match(r"size: 3 bytes", str) !== nothing
    @test match(r"precision: 12 bits", str) !== nothing
    @test match(r"offset: 12 bits", str) !== nothing
    @test match(r"order: little endian byte order", str) !== nothing

    HDF5.API.h5t_set_order(DT, HDF5.API.H5T_ORDER_BE)
    @test HDF5.API.h5t_get_order(DT) == HDF5.API.H5T_ORDER_BE
    show(io, DT)
    str = String(take!(io))
    @test match(r"order: big endian byte order", str) !== nothing
end

module HDF5

using Base: unsafe_convert
using Requires: @require
using Mmap: Mmap
# needed for filter(f, tuple) in julia 1.3
using Compat
using UUIDs: uuid4
using Printf: @sprintf

### PUBLIC API ###

export @read,
    @write,
    h5open,
    h5read,
    h5write,
    h5rewrite,
    h5writeattr,
    h5readattr,
    create_attribute,
    open_attribute,
    read_attribute,
    write_attribute,
    delete_attribute,
    rename_attribute,
    attributes,
    attrs,
    create_dataset,
    open_dataset,
    read_dataset,
    write_dataset,
    create_group,
    open_group,
    copy_object,
    open_object,
    delete_object,
    move_link,
    create_datatype,
    commit_datatype,
    open_datatype,
    create_property,
    group_info,
    object_info,
    dataspace,
    datatype,
    Filters,
    Drivers

### The following require module scoping ###

# file, filename, name,
# get_chunk, get_datasets,
# get_access_properties, get_create_properties,
# root, readmmap,
# iscontiguous, iscompact, ischunked,
# ishdf5, ismmappable,
# refresh
# start_swmr_write
# create_external, create_external_dataset

### Types
# H5DataStore, Attribute, File, Group, Dataset, Datatype, Opaque,
# Dataspace, Object, Properties, VLen, ChunkStorage, Reference

h5doc(name) = "[`$name`](https://portal.hdfgroup.org/display/HDF5/$(name))"

include("api/api.jl")
include("properties.jl")
include("context.jl")
include("types.jl")
include("file.jl")
include("objects.jl")
include("groups.jl")
include("datatypes.jl")
include("typeconversions.jl")
include("dataspaces.jl")
include("virtual.jl")
include("datasets.jl")
include("attributes.jl")
include("readwrite.jl")
include("references.jl")
include("show.jl")
include("api_midlevel.jl")
include("highlevel.jl")

# Functions that require special handling

const libversion = API.h5_get_libversion()
const HAS_PARALLEL = Ref(false)
const HAS_ROS3 = Ref(false)

"""
    has_parallel()

Returns `true` if the HDF5 libraries were compiled with MPI parallel support via the [`Drivers.MPIO`](@ref) driver.

See [Parallel HDF5](@ref) for more details.
"""
has_parallel() = HAS_PARALLEL[]

"""
    has_ros3()

Returns `true` if the HDF5 libraries were compiled with ros3 support
"""
has_ros3() = HAS_ROS3[]

function __init__()
    # HDF5.API.__init__() is run first
    #
    # initialize default properties
    ASCII_LINK_PROPERTIES.char_encoding = :ascii
    ASCII_LINK_PROPERTIES.create_intermediate_group = true
    UTF8_LINK_PROPERTIES.char_encoding = :utf8
    UTF8_LINK_PROPERTIES.create_intermediate_group = true
    ASCII_ATTRIBUTE_PROPERTIES.char_encoding = :ascii
    UTF8_ATTRIBUTE_PROPERTIES.char_encoding = :utf8

    @require FileIO = "5789e2e9-d7fb-5bc7-8068-2c6fae9b9549" include("fileio.jl")

    @require H5Zblosc = "c8ec2601-a99c-407f-b158-e79c03c2f5f7" begin
        set_blosc!(p::Properties, val::Bool) =
            val && push!(Filters.FilterPipeline(p), H5Zblosc.BloscFilter())
        set_blosc!(p::Properties, level::Integer) =
            push!(Filters.FilterPipeline(p), H5Zblosc.BloscFilter(; level=level))
    end

    return nothing
end

include("deprecated.jl")

end  # module

using Random, Test, HDF5

import HDF5.datatype
import Base.convert
import Base.unsafe_convert

struct foo
    a::Float64
    b::String
    c::String
    d::Array{ComplexF64,2}
    e::Array{Int64,1}
end

struct foo_hdf5
    a::Float64
    b::Cstring
    c::NTuple{20,UInt8}
    d::NTuple{9,ComplexF64}
    e::HDF5.API.hvl_t
end

function unsafe_convert(::Type{foo_hdf5}, x::foo)
    foo_hdf5(
        x.a,
        Base.unsafe_convert(Cstring, x.b),
        ntuple(i -> i <= ncodeunits(x.c) ? codeunit(x.c, i) : '\0', 20),
        ntuple(i -> x.d[i], length(x.d)),
        HDF5.API.hvl_t(length(x.e), pointer(x.e))
    )
end

function datatype(::Type{foo_hdf5})
    dtype = HDF5.API.h5t_create(HDF5.API.H5T_COMPOUND, sizeof(foo_hdf5))
    HDF5.API.h5t_insert(dtype, "a", fieldoffset(foo_hdf5, 1), datatype(Float64))

    vlenstr_dtype = HDF5.API.h5t_copy(HDF5.API.H5T_C_S1)
    HDF5.API.h5t_set_size(vlenstr_dtype, HDF5.API.H5T_VARIABLE)
    HDF5.API.h5t_set_cset(vlenstr_dtype, HDF5.API.H5T_CSET_UTF8)
    HDF5.API.h5t_insert(dtype, "b", fieldoffset(foo_hdf5, 2), vlenstr_dtype)

    fixedstr_dtype = HDF5.API.h5t_copy(HDF5.API.H5T_C_S1)
    HDF5.API.h5t_set_size(fixedstr_dtype, 20 * sizeof(UInt8))
    HDF5.API.h5t_set_cset(fixedstr_dtype, HDF5.API.H5T_CSET_UTF8)
    HDF5.API.h5t_set_strpad(fixedstr_dtype, HDF5.API.H5T_STR_NULLPAD)
    HDF5.API.h5t_insert(dtype, "c", fieldoffset(foo_hdf5, 3), fixedstr_dtype)

    hsz = HDF5.API.hsize_t[3, 3]
    array_dtype = HDF5.API.h5t_array_create(datatype(ComplexF64), 2, hsz)
    HDF5.API.h5t_insert(dtype, "d", fieldoffset(foo_hdf5, 4), array_dtype)

    vlen_dtype = HDF5.API.h5t_vlen_create(datatype(Int64))
    HDF5.API.h5t_insert(dtype, "e", fieldoffset(foo_hdf5, 5), vlen_dtype)

    HDF5.Datatype(dtype)
end

struct bar
    a::Vector{String}
end

struct bar_hdf5
    a::NTuple{2,NTuple{20,UInt8}}
end

function datatype(::Type{bar_hdf5})
    dtype = HDF5.API.h5t_create(HDF5.API.H5T_COMPOUND, sizeof(bar_hdf5))

    fixedstr_dtype = HDF5.API.h5t_copy(HDF5.API.H5T_C_S1)
    HDF5.API.h5t_set_size(fixedstr_dtype, 20 * sizeof(UInt8))
    HDF5.API.h5t_set_cset(fixedstr_dtype, HDF5.API.H5T_CSET_UTF8)

    hsz = HDF5.API.hsize_t[2]
    array_dtype = HDF5.API.h5t_array_create(fixedstr_dtype, 1, hsz)

    HDF5.API.h5t_insert(dtype, "a", fieldoffset(bar_hdf5, 1), array_dtype)

    HDF5.Datatype(dtype)
end

function convert(::Type{bar_hdf5}, x::bar)
    bar_hdf5(
        ntuple(
            i -> ntuple(j -> j <= ncodeunits(x.a[i]) ? codeunit(x.a[i], j) : '\0', 20), 2
        )
    )
end

@testset "compound" begin
    N = 10
    v = [
        foo(
            rand(),
            randstring(rand(10:100)),
            randstring(10),
            rand(ComplexF64, 3, 3),
            rand(1:10, rand(10:100))
        ) for _ in 1:N
    ]

    v[1] = foo(1.0, "uniçº∂e", "uniçº∂e", rand(ComplexF64, 3, 3), rand(1:10, rand(10:100)))

    v_write = unsafe_convert.(foo_hdf5, v)

    w = [bar(["uniçº∂e", "hello"])]
    w_write = convert.(bar_hdf5, w)

    fn = tempname()
    h5open(fn, "w") do h5f
        foo_dtype = datatype(foo_hdf5)
        foo_space = dataspace(v_write)
        foo_dset = create_dataset(h5f, "foo", foo_dtype, foo_space)
        write_dataset(foo_dset, foo_dtype, v_write)

        bar_dtype = datatype(bar_hdf5)
        bar_space = dataspace(w_write)
        bar_dset = create_dataset(h5f, "bar", bar_dtype, bar_space)
        write_dataset(bar_dset, bar_dtype, w_write)
    end

    v_read = h5read(fn, "foo")
    for field in (:a, :b, :c, :d, :e)
        f = x -> getfield(x, field)
        @test f.(v) == f.(v_read)
    end

    w_read = h5read(fn, "bar")
    for field in (:a,)
        f = x -> getfield(x, field)
        @test f.(w) == f.(w_read)
    end

    T = NamedTuple{(:a, :b, :c, :d, :e, :f),Tuple{Int,Int,Int,Int,Int,Cstring}}
    TT = NamedTuple{(:a, :b, :c, :d, :e, :f),Tuple{Int,Int,Int,Int,Int,T}}
    TTT = NamedTuple{(:a, :b, :c, :d, :e, :f),Tuple{Int,Int,Int,Int,Int,TT}}
    TTTT = NamedTuple{(:a, :b, :c, :d, :e, :f),Tuple{Int,Int,Int,Int,Int,TTT}}

    @test HDF5.do_reclaim(TTTT) == true
    @test HDF5.do_normalize(TTTT) == true

    T = NamedTuple{(:a, :b, :c, :d, :e, :f),Tuple{Int,Int,Int,Int,Int,HDF5.FixedArray}}
    TT = NamedTuple{(:a, :b, :c, :d, :e, :f),Tuple{Int,Int,Int,Int,Int,T}}
    TTT = NamedTuple{(:a, :b, :c, :d, :e, :f),Tuple{Int,Int,Int,Int,Int,TT}}
    TTTT = NamedTuple{(:a, :b, :c, :d, :e, :f),Tuple{Int,Int,Int,Int,Int,TTT}}

    @test HDF5.do_reclaim(TTTT) == false
    @test HDF5.do_normalize(TTTT) == true
end

struct Bar
    a::Int32
    b::Float64
    c::Bool
end

mutable struct MutableBar
    x::Int64
end

@testset "create_dataset (compound)" begin
    bars = [Bar(1, 2, true), Bar(3, 4, false), Bar(5, 6, true), Bar(7, 8, false)]
    fn = tempname()
    h5open(fn, "w") do h5f
        d = create_dataset(h5f, "the/bars", Bar, ((2,), (-1,)); chunk=(100,))
        d[1:2] = bars[1:2]
    end

    h5open(fn, "cw") do h5f
        d = h5f["the/bars"]
        HDF5.set_extent_dims(d, (4,))
        d[3:4] = bars[3:4]
    end

    thebars = h5open(fn, "r") do h5f
        read(h5f, "the/bars")
    end

    @test 4 == length(thebars)
    @test 1 == thebars[1].a
    @test true == thebars[3].c
    @test 8 == thebars[4].b
end

@testset "write_compound" begin
    bars = [
        [Bar(1, 1.1, true) Bar(2, 2.1, false) Bar(3, 3.1, true)]
        [Bar(4, 4.1, false) Bar(5, 5.1, true) Bar(6, 6.1, false)]
    ]

    namedtuples = [(a=1, b=2.3), (a=4, b=5.6)]

    tuples = [(1, namedtuples[1], (0.1,)), (2, namedtuples[2], (1.0,))]

    fn = tempname()
    h5open(fn, "w") do h5f
        write_dataset(h5f, "the/bars", bars)
        write_dataset(h5f, "the/namedtuples", namedtuples)
        write_dataset(h5f, "the/tuples", tuples)
    end

    thebars = h5open(fn, "r") do h5f
        read(h5f, "the/bars")
    end

    @test (2, 3) == size(thebars)
    @test thebars[1, 2].b ≈ 2.1
    @test thebars[2, 1].a == 4
    @test thebars[1, 3].c

    thebars_r = reinterpret(Bar, thebars)
    @test (2, 3) == size(thebars_r)
    @test thebars_r[1, 2].b ≈ 2.1
    @test thebars_r[2, 1].a == 4
    @test thebars_r[1, 3].c

    thenamedtuples = h5open(fn, "r") do h5f
        read(h5f, "the/namedtuples")
    end

    @test (2,) == size(thenamedtuples)
    @test thenamedtuples[1].a == 1
    @test thenamedtuples[1].b ≈ 2.3
    @test thenamedtuples[2].a == 4
    @test thenamedtuples[2].b ≈ 5.6

    thetuples = h5open(fn, "r") do h5f
        read(h5f, "the/tuples")
    end

    @test (2,) == size(thetuples)
    @test thetuples[1][1] == 1
    @test thetuples[1][2].a == 1
    @test thetuples[1][2].b ≈ 2.3
    @test thetuples[1][3][1] ≈ 0.1
    @test thetuples[2][1] == 2
    @test thetuples[2][2].a == 4
    @test thetuples[2][2].b ≈ 5.6
    @test thetuples[2][3][1] ≈ 1.0

    mutable_bars = [MutableBar(1), MutableBar(2), MutableBar(3)]

    fn = tempname()
    @test_throws ArgumentError begin
        h5open(fn, "w") do h5f
            write_dataset(h5f, "the/mutable_bars", mutable_bars)
        end
    end

    Base.convert(::Type{NamedTuple{(:x,),Tuple{Int64}}}, mb::MutableBar) = (x=mb.x,)
    Base.unsafe_convert(::Type{Ptr{Nothing}}, mb::MutableBar) = pointer_from_objref(mb)

    h5open(fn, "w") do h5f
        write_dataset(h5f, "the/mutable_bars", mutable_bars)
        write_dataset(h5f, "the/mutable_bar", first(mutable_bars))
    end

    h5open(fn, "r") do h5f
        @test [1, 2, 3] == [b.x for b in read(h5f, "the/mutable_bars")]
        @test 1 == read(h5f, "the/mutable_bar").x
    end

    h5open(fn, "w") do h5f
        write_attribute(h5f, "mutable_bars", mutable_bars)
        write_attribute(h5f, "mutable_bar", first(mutable_bars))
    end

    h5open(fn, "r") do h5f
        @test [1, 2, 3] == [b.x for b in attrs(h5f)["mutable_bars"]]
        @test 1 == attrs(h5f)["mutable_bar"].x
    end
end

"""
    ROS3()
    ROS3(aws_region::String, secret_id::String, secret_key::String)
    ROS3(version::Int32, authenticate::Bool, aws_region::String, secret_id::String, secret_key::String)

This is the read-only virtual driver that enables access to HDF5 objects stored in AWS S3
"""
struct ROS3 <: Driver
    version::Int32
    authenticate::Bool
    aws_region::String
    secret_id::String
    secret_key::String
    function ROS3(version, authenticate, aws_region, secret_id, secret_key)
        length(aws_region) <= API.H5FD_ROS3_MAX_REGION_LEN ||
            "length(aws_region), $(length(aws_region)), must be less than or equal to $(API.H5FD_ROS3_MAX_REGION_LEN)"
        length(secret_id) <= API.H5FD_ROS3_MAX_SECRET_ID_LEN ||
            "length(secret_id), $(length(secret_id)), must be less than or equal to $(API.H5FD_ROS3_MAX_SECRET_ID_LEN)"
        length(secret_key) <= API.H5FD_ROS3_MAX_SECRET_KEY_LEN ||
            "length(secret_key), $(length(secret_key)), must be less than or equal to $(API.H5FD_ROS3_MAX_SECRET_KEY_LEN)"
        new(version, authenticate, aws_region, secret_id, secret_key)
    end
end

ROS3() = ROS3(1, false, "", "", "")

ROS3(region::AbstractString, id::AbstractString, key::AbstractString) =
    ROS3(1, true, region, id, key)

function ROS3(driver::API.H5FD_ros3_fapl_t)
    aws_region = _ntuple_to_string(driver.aws_region)
    secret_id = _ntuple_to_string(driver.secret_id)
    secret_key = _ntuple_to_string(driver.secret_key)
    ROS3(driver.version, driver.authenticate, aws_region, secret_id, secret_key)
end
_ntuple_to_string(x) = unsafe_string(Ptr{Cchar}(pointer_from_objref(Ref(x))), length(x))

function Base.convert(::Type{API.H5FD_ros3_fapl_t}, driver::ROS3)
    aws_region = ntuple(
        i -> i <= length(driver.aws_region) ? Cchar(driver.aws_region[i]) : Cchar(0x0),
        API.H5FD_ROS3_MAX_REGION_LEN + 1
    )
    secret_id = ntuple(
        i -> i <= length(driver.secret_id) ? Cchar(driver.secret_id[i]) : Cchar(0x0),
        API.H5FD_ROS3_MAX_SECRET_ID_LEN + 1
    )
    secret_key = ntuple(
        i -> i <= length(driver.secret_key) ? Cchar(driver.secret_key[i]) : Cchar(0x0),
        API.H5FD_ROS3_MAX_SECRET_KEY_LEN + 1
    )
    s = API.H5FD_ros3_fapl_t(
        driver.version, driver.authenticate, aws_region, secret_id, secret_key,
    )
end

function get_driver(fapl::Properties, ::Type{ROS3})
    r_fa = Ref{API.H5FD_ros3_fapl_t}()
    API.h5p_get_fapl_ros3(fapl, r_fa)
    return ROS3(r_fa[])
end

function set_driver!(fapl::Properties, driver::ROS3)
    HDF5.has_ros3() || error(
        "HDF5.jl has no ros3 support." *
        " Make sure that you're using ROS3-enabled HDF5 libraries"
    )
    HDF5.init!(fapl)
    API.h5p_set_fapl_ros3(fapl, Ref{API.H5FD_ros3_fapl_t}(driver))
    DRIVERS[API.h5p_get_driver(fapl)] = ROS3
    return nothing
end

abstract type Properties end

include("filters/filters.jl")
include("drivers/drivers.jl")

Base.cconvert(::Type{API.hid_t}, obj::Properties) = obj
Base.unsafe_convert(::Type{API.hid_t}, obj::Properties) = obj.id

function Base.close(obj::Properties)
    if obj.id != -1
        if isvalid(obj)
            API.h5p_close(obj)
        end
        obj.id = -1
    end
    nothing
end

Base.isvalid(obj::Properties) = obj.id != -1 && API.h5i_is_valid(obj)
Base.copy(obj::P) where {P<:Properties} = P(HDF5.API.h5p_copy(obj.id))

# By default, properties objects are only initialized lazily
function init!(prop::P) where {P<:Properties}
    if !isvalid(prop)
        prop.id = API.h5p_create(classid(P))
    end
    return prop
end

function (::Type{P})(; kwargs...) where {P<:Properties}
    obj = P(API.H5P_DEFAULT)
    for (k, v) in kwargs
        setproperty!(obj, k, v)
    end
    return obj
end
# Properties() do syntax
function (::Type{P})(func::Function; kwargs...) where {P<:Properties}
    p = P(; kwargs...)
    # Eagerly initialize when using do syntax
    # This allows for use low-level API calls
    init!(p)
    try
        func(p)
    finally
        close(p)
    end
end

function Base.getproperty(p::P, name::Symbol) where {P<:Properties}
    name === :id ? getfield(p, :id) : class_getproperty(P, init!(p), name)
end

function Base.setproperty!(p::P, name::Symbol, val) where {P<:Properties}
    if name === :id
        return setfield!(p, :id, API.hid_t(val))
    end
    init!(p)
    class_setproperty!(P, p, name, val)
end

Base.propertynames(p::P) where {P<:Properties} = (all_propertynames(P)..., :id)
all_propertynames(::Type{P}) where {P<:Properties} =
    (class_propertynames(P)..., all_propertynames(superclass(P))...,)

# defaults: refer to super class
class_getproperty(::Type{P}, props, name) where {P<:Properties} =
    class_getproperty(superclass(P), props, name)
class_setproperty!(::Type{P}, p, name, val) where {P<:Properties} =
    class_setproperty!(superclass(P), p, name, val)
class_propertynames(::Type{P}) where {P<:Properties} = ()

"""
    @propertyclass P classid

Define a new subtype of `P <: Properties` corresponding to a HDF5 property list
with class identifier `classid`.

Once defined, the following interfaces can be defined:

    superclass(::Type{P})

This should return the type from which `P` inherits. If not defined, it will
inherit from `GenericProperties`.

    class_propertynames(::Type{P})

This should return a `Tuple` of `Symbol`s, being the names of the properties
associated with `P`.

    class_getproperty(::Type{P}, p::Properties, name::Symbol)

If `name` is an associated property of type `P`, this should return the value of
the property, otherwise call `class_getproperty(superclass(P), p, name)`.

    class_setproperty!(::Type{P}, p::Properties, name::Symbol, val)

If `name` is an associated property of type `P`, this should set the value of
the property, otherwise call `class_setproperty!(superclass(P), p, name, val)`.
"""
macro propertyclass(name, classid)
    expr = quote
        Core.@__doc__ mutable struct $name <: Properties
            id::API.hid_t
            function $name(id::API.hid_t)
                obj = new(id)
                finalizer(API.try_close_finalizer, obj)
                obj
            end
        end
        classid(::Type{$name}) = $classid
    end
    return esc(expr)
end

@propertyclass GenericProperties API.H5P_DEFAULT

superclass(::Type{P}) where {P<:Properties} = GenericProperties

class_getproperty(::Type{GenericProperties}, props, name) =
    error("$(typeof(props)) has no property $name")
class_setproperty!(::Type{GenericProperties}, props, name, val) =
    error("$(typeof(props)) has no property $name")
all_propertynames(::Type{GenericProperties}) = ()

# for initializing multiple Properties from a set of keyword arguments
"""
    setproperties!(props::Properties...; kwargs...)

For each `(key, value)` pair in `kwargs`, set the corresponding properties in
each `Properties` object in `props`. Returns a `Dict` of any pairs which didn't
match properties in `props`.
"""
function setproperties!(props::Properties...; kwargs...)
    filter(kwargs) do (k, v)
        found = false
        for prop in props
            if k in all_propertynames(typeof(prop))
                setproperty!(prop, k, v)
                found = true
            end
        end
        return !found
    end
end

###
### Convenience macros for defining getter/setter functions
###

"""
    @tuple_property(name)
"""
macro tuple_property(property)
    get_property = Symbol(:get_, property)
    set_property! = Symbol(:set_, property, :!)
    api_get_property = :(API.$(Symbol(:h5p_get_, property)))
    api_set_property = :(API.$(Symbol(:h5p_set_, property)))
    quote
        function $(esc(get_property))(p::Properties)
            return $api_get_property(p)
        end
        function $(esc(set_property!))(p::Properties, val::Tuple)
            return $api_set_property(p, val...)
        end
    end
end

"""
    @enum_property(name, sym1 => enumvalue1, sym2 => enumvalue2, ...)

Wrap property getter/setter API functions that use enum values to use symbol instead.
"""
macro enum_property(property, pairs...)
    get_property = Symbol(:get_, property)
    set_property! = Symbol(:set_, property, :!)
    api_get_property = :(API.$(Symbol(:h5p_get_, property)))
    api_set_property = :(API.$(Symbol(:h5p_set_, property)))

    get_expr = :(error("Unknown $property value $enum"))
    set_expr = :(throw(ArgumentError("Invalid $property $val")))

    for pair in reverse(pairs)
        @assert pair isa Expr && pair.head == :call && pair.args[1] == :(=>)
        _, val, enum = pair.args
        get_expr = :(enum == $enum ? $val : $get_expr)
        set_expr = :(val == $val ? $enum : $set_expr)
    end
    quote
        function $(esc(get_property))(p::Properties)
            property = $(QuoteNode(property))
            enum = $api_get_property(p)
            return $get_expr
        end
        function $(esc(set_property!))(p::Properties, val)
            property = $(QuoteNode(property))
            enum = $set_expr
            return $api_set_property(p, enum)
        end
        function $(esc(set_property!))(p::Properties, enum::Integer)
            # deprecate?
            return $api_set_property(p, enum)
        end
    end
end

"""
    @bool_property(name)

Wrap property getter/setter API functions that use `0`/`1` to use `Bool` values
"""
macro bool_property(property)
    get_property = Symbol(:get_, property)
    set_property! = Symbol(:set_, property, :!)
    api_get_property = :(API.$(Symbol(:h5p_get_, property)))
    api_set_property = :(API.$(Symbol(:h5p_set_, property)))
    quote
        function $(esc(get_property))(p::Properties)
            return $api_get_property(p) != 0
        end
        function $(esc(set_property!))(p::Properties, val)
            return $api_set_property(p, val)
        end
    end
end

###
### Define Properties types
###

#! format: off

"""
    ObjectCreateProperties(;kws...)
    ObjectCreateProperties(f::Function; kws...)

Properties used when creating a new object. Available options:

- `obj_track_times :: Bool`: governs the recording of times associated with an
  object. If set to `true`, time data will be recorded. See
  $(h5doc("H5P_SET_OBJ_TRACK_TIMES")).

A function argument passed via `do` will be given an initialized property list
that will be closed.
"""
@propertyclass ObjectCreateProperties API.H5P_OBJECT_CREATE

@bool_property(obj_track_times)

class_propertynames(::Type{ObjectCreateProperties}) = (
    :obj_track_times,
    :track_times,
    )
function class_getproperty(::Type{ObjectCreateProperties}, p::Properties, name::Symbol)
    name === :obj_track_times ? get_obj_track_times(p) :
    # deprecated
    name === :track_times ? (depwarn("`track_times` property is deprecated, use `obj_track_times` instead",:track_times); get_obj_track_times(p)) :
    class_getproperty(superclass(ObjectCreateProperties), p, name)
end
function class_setproperty!(::Type{ObjectCreateProperties}, p::Properties, name::Symbol, val)
    name === :obj_track_times ? set_obj_track_times!(p, val) :
    # deprecated
    name === :track_times ? (depwarn("`track_times=$val` keyword option is deprecated, use `obj_track_times=$val` instead",:track_times); set_obj_track_times!(p, val)) :
    class_setproperty!(superclass(ObjectCreateProperties), p, name, val)
end

get_track_order(p::Properties) = API.h5p_get_link_creation_order(p) != 0 && API.h5p_get_attr_creation_order(p) != 0

function set_track_order!(p::Properties, val::Bool)
    crt_order_flags = val ? (API.H5P_CRT_ORDER_TRACKED | API.H5P_CRT_ORDER_INDEXED) : 0
    API.h5p_set_link_creation_order(p, crt_order_flags)
    API.h5p_set_attr_creation_order(p, crt_order_flags)
    nothing
end

"""
    GroupCreateProperties(;kws...)
    GroupCreateProperties(f::Function; kws...)

Properties used when creating a new `Group`. Inherits from
[`ObjectCreateProperties`](@ref), with additional options:

- `local_heap_size_hint :: Integer`: the anticipated maximum local heap size in
  bytes. See $(h5doc("H5P_SET_LOCAL_HEAP_SIZE_HINT")).
- `track_order :: Bool`: tracks the group creation order.

A function argument passed via `do` will be given an initialized property list
that will be closed.
"""
@propertyclass GroupCreateProperties API.H5P_GROUP_CREATE
superclass(::Type{GroupCreateProperties}) = ObjectCreateProperties

class_propertynames(::Type{GroupCreateProperties}) = (
    :local_heap_size_hint,
    :track_order,
    )
function class_getproperty(::Type{GroupCreateProperties}, p::Properties, name::Symbol)
    name === :local_heap_size_hint ? API.h5p_get_local_heap_size_hint(p) :
    name === :track_order ? get_track_order(p) :
    class_getproperty(superclass(GroupCreateProperties), p, name)
end
function class_setproperty!(::Type{GroupCreateProperties}, p::Properties, name::Symbol, val)
    name === :local_heap_size_hint ? API.h5p_set_local_heap_size_hint(p, val) :
    name === :track_order ? set_track_order!(p, val) :
    class_setproperty!(superclass(GroupCreateProperties), p, name, val)
end

"""
    FileCreateProperties(;kws...)
    FileCreateProperties(f::Function; kws...)

Properties used when creating a new `File`. Inherits from
[`ObjectCreateProperties`](@ref),  with additional properties:

- `userblock :: Integer`: user block size in bytes. The default user block size
  is 0; it may be set to any power of 2 equal to 512 or greater (512, 1024,
  2048, etc.). See $(h5doc("H5P_SET_USERBLOCK")).
- `track_order :: Bool`: tracks the file creation order.

A function argument passed via `do` will be given an initialized property list
that will be closed.
"""
@propertyclass FileCreateProperties API.H5P_FILE_CREATE
superclass(::Type{FileCreateProperties}) = ObjectCreateProperties


class_propertynames(::Type{FileCreateProperties}) = (
    :userblock,
    :track_order,
    :strategy,
    :persist,
    :threshold,
    :file_space_page_size
    )

const FSPACE_STRATEGY_SYMBOLS = Dict(
    :fsm_aggr => API.H5F_FSPACE_STRATEGY_FSM_AGGR,
    :page => API.H5F_FSPACE_STRATEGY_PAGE,
    :aggr => API.H5F_FSPACE_STRATEGY_AGGR,
    :none => API.H5F_FSPACE_STRATEGY_NONE,
    :ntypes => API.H5F_FSPACE_STRATEGY_NTYPES
)

set_strategy!(p::FileCreateProperties, val) = API.h5p_set_file_space_strategy(p, strategy = val)
set_strategy!(p::FileCreateProperties, val::Symbol) = API.h5p_set_file_space_strategy(p, strategy = FSPACE_STRATEGY_SYMBOLS[val])
function get_strategy(p::FileCreateProperties)
    strategy = API.h5p_get_file_space_strategy(p)[:strategy]
    for (k, v) in FSPACE_STRATEGY_SYMBOLS
        if v == strategy
            return k
        end
    end
    return :unknown
end

function class_getproperty(::Type{FileCreateProperties}, p::Properties, name::Symbol)
    name === :userblock   ? API.h5p_get_userblock(p) :
    name === :track_order ? get_track_order(p) :
    name === :strategy    ? get_strategy(p) :
    name === :persist     ? API.h5p_get_file_space_strategy(p)[:persist] :
    name === :threshold   ? API.h5p_get_file_space_strategy(p)[:threshold] :
    name === :file_space_page_size ? API.h5p_get_file_space_page_size(p) :
    class_getproperty(superclass(FileCreateProperties), p, name)
end
function class_setproperty!(::Type{FileCreateProperties}, p::Properties, name::Symbol, val)
    name === :userblock   ? API.h5p_set_userblock(p, val) :
    name === :track_order ? set_track_order!(p, val) :
    name === :strategy ? set_strategy!(p, val) :
    name === :persist ? API.h5p_set_file_space_strategy(p, persist = val) :
    name === :threshold ? API.h5p_set_file_space_strategy(p, threshold = val) :
    name === :file_space_page_size ? API.h5p_set_file_space_page_size(p, val) :
    class_setproperty!(superclass(FileCreateProperties), p, name, val)
end


"""
    DatatypeCreateProperties(;kws...)
    DatatypeCreateProperties(f::Function; kws...)

A function argument passed via `do` will be given an initialized property list
that will be closed.
"""
@propertyclass DatatypeCreateProperties API.H5P_DATATYPE_CREATE
superclass(::Type{DatatypeCreateProperties}) = ObjectCreateProperties

"""
    DatasetCreateProperties(;kws...)
    DatasetCreateProperties(f::Function; kws...)

Properties used when creating a new `Dataset`. Inherits from
[`ObjectCreateProperties`](@ref), with additional properties:

- `alloc_time`: the timing for the allocation of storage space for a dataset's
  raw data; one of:
   - `:default`

   - `:early`: allocate all space when the dataset is created

   - `:incremental`: Allocate space incrementally, as data is  written to the
     dataset

   - `:late`: Allocate all space when data is first written to the dataset.

  See $(h5doc("H5P_SET_ALLOC_TIME")).

- `fill_time`: the timing of when the dataset should be filled; one of:
   - `:alloc`: Fill when allocated
   - `:never`: Never fill
   - `:ifset`: Fill if a value is set

- `fill_value`: the fill value for a dataset. See $(h5doc("H5P_SET_FILL_VALUE")).

- `chunk`: a tuple containing the size of the chunks to store each dimension.
  See $(h5doc("H5P_SET_CHUNK")) (note that this uses Julia's column-major
  ordering).

- `external`: A tuple of `(name,offset,size)`, See $(h5doc("H5P_SET_EXTERNAL")).

- `filters` (only valid when `layout=:chunked`): a filter or vector of filters
  that are applied to applied to each chunk of a dataset, see [Filters](@ref).
  When accessed, will return a [`Filters.FilterPipeline`](@ref) object that can
  be modified in-place.

- `layout`: the type of storage used to store the raw data for a dataset. Can be
  one of:

   - `:compact`: Store raw data in the dataset object header in file. This
     should only be used for datasets with small amounts of raw data.

   - `:contiguous`: Store raw data separately from the object header in one
     large chunk in the file.

   - `:chunked`: Store raw data separately from the object header as chunks of
     data in separate locations in the file.

   - `:virtual`:  Draw raw data from multiple datasets in different files. See
     the `virtual` property below.

  See $(h5doc("H5P_SET_LAYOUT")).

- `no_attrs_hint`: Minimize the space for dataset metadata by hinting that no
   attributes will be added if set to `true`. Attributes can still be added but
   may exist elsewhere within the file. See
   $(h5doc("H5P_SET_DSET_NO_ATTRS_HINT")).

- `virtual`: when specified, creates a virtual dataset (VDS). The argument
  should be a "virtuala collection of [`VirtualMapping`](@ref) objects for
  describing the mapping from the dataset to the source datasets. When accessed,
  returns a [`VirtualLayout`](@ref) object.

The following options are shortcuts for the various filters, and are set-only.
They will be appended to the filter pipeline in the order in which they appear

- `blosc = true | level`: set the [`H5Zblosc.BloscFilter`](@ref) compression
  filter; argument can be either `true`, or the compression level.

- `deflate = true | level`: set the [`Filters.Deflate`](@ref) compression
  filter; argument can be either `true`, or the compression level.

- `fletcher32 = true`: set the [`Filters.Fletcher32`](@ref) checksum filter.

- `shuffle = true`: set the [`Filters.Shuffle`](@ref) filter.

A function argument passed via `do` will be given an initialized property list
that will be closed.
"""
@propertyclass DatasetCreateProperties API.H5P_DATASET_CREATE
superclass(::Type{DatasetCreateProperties}) = ObjectCreateProperties

@enum_property(alloc_time,
    :default     => API.H5D_ALLOC_TIME_DEFAULT,
    :early       => API.H5D_ALLOC_TIME_EARLY,
    :incremental => API.H5D_ALLOC_TIME_INCR,
    :late        => API.H5D_ALLOC_TIME_LATE)

# reverse indices
function get_chunk(p::Properties)
    dims, N = API.h5p_get_chunk(p)
    ntuple(i -> Int(dims[N-i+1]), N)
end
set_chunk!(p::Properties, dims) = API.h5p_set_chunk(p, length(dims), API.hsize_t[reverse(dims)...])

@enum_property(layout,
    :compact    => API.H5D_COMPACT,
    :contiguous => API.H5D_CONTIGUOUS,
    :chunked    => API.H5D_CHUNKED,
    :virtual    => API.H5D_VIRTUAL)

# See https://portal.hdfgroup.org/display/HDF5/H5P_SET_FILL_TIME
@enum_property(fill_time,
    :alloc => API.H5D_FILL_TIME_ALLOC,
    :never => API.H5D_FILL_TIME_NEVER,
    :ifset => API.H5D_FILL_TIME_IFSET
)

# filters getters/setters
get_filters(p::Properties) = Filters.FilterPipeline(p)
set_filters!(p::Properties, val::Filters.Filter) = push!(empty!(Filters.FilterPipeline(p)), val)
set_filters!(p::Properties, vals::Union{Tuple, AbstractVector}) = append!(empty!(Filters.FilterPipeline(p)), vals)

# convenience
set_deflate!(p::Properties, val::Bool) = val && push!(Filters.FilterPipeline(p), Filters.Deflate())
set_deflate!(p::Properties, level::Integer) = push!(Filters.FilterPipeline(p), Filters.Deflate(level=level))
set_shuffle!(p::Properties, val::Bool) = val && push!(Filters.FilterPipeline(p), Filters.Shuffle())
set_fletcher32!(p::Properties, val::Bool) = val && push!(Filters.FilterPipeline(p), Filters.Fletcher32())
set_blosc!(p::Properties, val) = error("The Blosc filter now requires the H5Zblosc package be loaded")

get_virtual(p::Properties) = VirtualLayout(p)
set_virtual!(p::Properties, vmaps) = append!(VirtualLayout(p), vmaps)


class_propertynames(::Type{DatasetCreateProperties}) = (
    :alloc_time,
    :fill_time,
    :fill_value,
    :chunk,
    :external,
    :filters,
    :layout,
    :no_attrs_hint,
    :virtual,
    # convenience
    :blosc,
    :deflate,
    :fletcher32,
    :shuffle,
    # deprecated
    :compress,
    :filter
    )


function class_getproperty(::Type{DatasetCreateProperties}, p::Properties, name::Symbol)
    name === :alloc_time  ? get_alloc_time(p) :
    name === :fill_time   ? get_fill_time(p) :
    name === :fill_value  ? get_fill_value(p) :
    name === :chunk       ? get_chunk(p) :
    name === :external    ? API.h5p_get_external(p) :
    name === :filters     ? get_filters(p) :
    name === :layout      ? get_layout(p) :
    name === :no_attrs_hint ?
        @static(API.h5_get_libversion() < v"1.10.5" ?
            false :
            API.h5p_get_dset_no_attrs_hint(p)
        ) :
    name === :virtual     ? get_virtual(p) :
    # deprecated
    name === :filter      ? (depwarn("`filter` property name is deprecated, use `filters` instead",:class_getproperty); get_filters(p)) :
    class_getproperty(superclass(DatasetCreateProperties), p, name)
end
function class_setproperty!(::Type{DatasetCreateProperties}, p::Properties, name::Symbol, val)
    name === :alloc_time  ? set_alloc_time!(p, val) :
    name === :fill_time   ? set_fill_time!(p, val) :
    name === :fill_value  ? set_fill_value!(p, val) :
    name === :chunk       ? set_chunk!(p, val) :
    name === :external    ? API.h5p_set_external(p, val...) :
    name === :filters     ? set_filters!(p, val) :
    name === :layout      ? set_layout!(p, val) :
    name === :no_attrs_hint ?
        @static(API.h5_get_libversion() < v"1.10.5" ?
            error("no_attrs_hint is only valid for HDF5 library versions 1.10.5 or greater") :
            API.h5p_set_dset_no_attrs_hint(p, val)
        ) :
    name === :virtual     ? set_virtual!(p, val) :
    # set-only for convenience
    name === :blosc       ? set_blosc!(p, val) :
    name === :deflate     ? set_deflate!(p, val) :
    name === :fletcher32  ? set_fletcher32!(p, val) :
    name === :shuffle     ? set_shuffle!(p, val) :
    # deprecated
    name === :filter      ? (depwarn("`filter=$val` keyword option is deprecated, use `filters=$val` instead",:class_setproperty!); set_filters!(p, val)) :
    name === :compress    ? (depwarn("`compress=$val` keyword option is deprecated, use `deflate=$val` instead",:class_setproperty!); set_deflate!(p, val)) :
    class_setproperty!(superclass(DatasetCreateProperties), p, name, val)
end

"""
    StringCreateProperties(;kws...)
    StringCreateProperties(f::Function; kws...)

A function argument passed via `do` will be given an initialized property list
that will be closed.
"""
@propertyclass StringCreateProperties API.H5P_STRING_CREATE

@enum_property(char_encoding,
    :ascii => API.H5T_CSET_ASCII,
    :utf8  => API.H5T_CSET_UTF8)


class_propertynames(::Type{StringCreateProperties}) = (
    :char_encoding,
    )
function class_getproperty(::Type{StringCreateProperties}, p::Properties, name::Symbol)
    name === :char_encoding ? get_char_encoding(p) :
    class_getproperty(superclass(StringCreateProperties), p, name)
end
function class_setproperty!(::Type{StringCreateProperties}, p::Properties, name::Symbol, val)
    name === :char_encoding ? set_char_encoding!(p, val) :
    class_setproperty!(superclass(StringCreateProperties), p, name, val)
end

"""
    LinkCreateProperties(;kws...)
    LinkCreateProperties(f::Function; kws...)

Properties used when creating links.

- `char_encoding`: the character enconding, either `:ascii` or `:utf8`.

- `create_intermediate_group :: Bool`: if `true`, will create missing
  intermediate groups.

A function argument passed via `do` will be given an initialized property list
that will be closed.
"""
@propertyclass LinkCreateProperties API.H5P_LINK_CREATE
superclass(::Type{LinkCreateProperties}) = StringCreateProperties

@bool_property(create_intermediate_group)

class_propertynames(::Type{LinkCreateProperties}) = (
    :create_intermediate_group,
    )
function class_getproperty(::Type{LinkCreateProperties}, p::Properties, name::Symbol)
    name === :create_intermediate_group ? get_create_intermediate_group(p) :
    class_getproperty(superclass(LinkCreateProperties), p, name)
end
function class_setproperty!(::Type{LinkCreateProperties}, p::Properties, name::Symbol, val)
    name === :create_intermediate_group ? set_create_intermediate_group!(p, val) :
    class_setproperty!(superclass(LinkCreateProperties), p, name, val)
end

"""
    AttributeCreateProperties(;kws...)
    AttributeCreateProperties(f::Function; kws...)

Properties used when creating attributes.

- `char_encoding`: the character enconding, either `:ascii` or `:utf8`.

A function argument passed via `do` will be given an initialized property list
that will be closed.
"""
@propertyclass AttributeCreateProperties API.H5P_ATTRIBUTE_CREATE
superclass(::Type{AttributeCreateProperties}) = StringCreateProperties


"""
    FileAccessProperties(;kws...)
    FileAccessProperties(f::Function; kws...)

Properties used when accessing files.

- `alignment :: Tuple{Integer, Integer}`: a `(threshold, alignment)` pair: any
  file object greater than or equal in size to threshold bytes will be aligned
  on an address which is a multiple of alignment. Default values are 1, implying
  no alignment.

- `driver`: the file driver used to access the file. See [Drivers](@ref).

- `driver_info` (get only)

- `fclose_degree`: file close degree property. One of:

  - `:weak`
  - `:semi`
  - `:strong`
  - `:default`

- `libver_bounds`: a `(low, high)` pair: `low` sets the earliest possible format
  versions that the library will use when creating objects in the file; `high`
  sets the latest format versions that the library will be allowed to use when
  creating objects in the file. Values can be a `VersionNumber` for the hdf5
  library, `:earliest`, or `:latest` . See $(h5doc("H5P_SET_LIBVER_BOUNDS"))

A function argument passed via `do` will be given an initialized property list
that will be closed.
"""
@propertyclass FileAccessProperties API.H5P_FILE_ACCESS

# Defaults for FileAccessProperties
function init!(fapl::FileAccessProperties)
    # Call default init! for Properties
    invoke(init!, Tuple{Properties}, fapl)
    # Disable file locking by default for mmap
    @static if API.has_h5p_set_file_locking()
        API.h5p_set_file_locking(fapl, false, true)
    end
    set_fclose_degree!(fapl, :strong)
    return fapl
end

@tuple_property(alignment)

@enum_property(fclose_degree,
               :weak    => API.H5F_CLOSE_WEAK,
               :semi    => API.H5F_CLOSE_SEMI,
               :strong  => API.H5F_CLOSE_STRONG,
               :default => API.H5F_CLOSE_DEFAULT)

# getter/setter for libver_bounds
libver_bound_to_enum(val::Integer) = val
libver_bound_to_enum(val::API.H5F_libver_t) = val
function libver_bound_to_enum(val::VersionNumber)
    val >= v"1.15"   ? API.H5F_LIBVER_V200 :
    val >= v"1.14"   ? API.H5F_LIBVER_V114 :
    val >= v"1.12"   ? API.H5F_LIBVER_V112 :
    val >= v"1.10"   ? API.H5F_LIBVER_V110 :
    val >= v"1.8"    ? API.H5F_LIBVER_V18 :
    throw(ArgumentError("libver_bound must be >= v\"1.8\"."))
end
function libver_bound_to_enum(val::Symbol)
    val == :earliest ? API.H5F_LIBVER_EARLIEST :
    val == :latest   ? API.H5F_LIBVER_LATEST :
    throw(ArgumentError("Invalid libver_bound $val."))
end
function libver_bound_from_enum(enum::API.H5F_libver_t)
    enum == API.H5F_LIBVER_EARLIEST ? :earliest :
    enum == API.H5F_LIBVER_V18      ? v"1.8" :
    enum == API.H5F_LIBVER_V110     ? v"1.10" :
    enum == API.H5F_LIBVER_V112     ? v"1.12" :
    enum == API.H5F_LIBVER_V114     ? v"1.14" :
    enum == API.H5F_LIBVER_V200     ? v"2.0" :
    error("Unknown libver_bound value $enum")
end
libver_bound_from_enum(enum) = libver_bound_from_enum(API.H5F_libver_t(enum))
function get_libver_bounds(p::Properties)
    low, high = API.h5p_get_libver_bounds(p)
    return libver_bound_from_enum(low), libver_bound_from_enum(high)
end
function set_libver_bounds!(p::Properties, (low, high)::Tuple{Any,Any})
    API.h5p_set_libver_bounds(p, libver_bound_to_enum(low), libver_bound_to_enum(high))
end
function set_libver_bounds!(p::Properties, val)
    API.h5p_set_libver_bounds(p, libver_bound_to_enum(val), libver_bound_to_enum(val))
end


class_propertynames(::Type{FileAccessProperties}) = (
    :alignment,
    :driver,
    :driver_info,
    :fapl_mpio,
    :fclose_degree,
    :file_locking,
    :libver_bounds,
    :meta_block_size,
    :file_image,
    )

function class_getproperty(::Type{FileAccessProperties}, p::Properties, name::Symbol)
    name === :alignment     ? get_alignment(p) :
    name === :driver        ? Drivers.get_driver(p) :
    name === :driver_info   ? API.h5p_get_driver_info(p) : # get only
    name === :fclose_degree ? get_fclose_degree(p) :
    name === :file_locking  ? API.h5p_get_file_locking(p) :
    name === :libver_bounds ? get_libver_bounds(p) :
    name === :meta_block_size ? API.h5p_get_meta_block_size(p) :
    name === :file_image      ? API.h5p_get_file_image(p) :
    # deprecated
    name === :fapl_mpio     ? (depwarn("The `fapl_mpio` property is deprecated, use `driver=HDF5.Drivers.MPIO(...)` instead.", :fapl_mpio); drv = get_driver(p, MPIO); (drv.comm, drv.info)) :
    class_getproperty(superclass(FileAccessProperties), p, name)
end
function class_setproperty!(::Type{FileAccessProperties}, p::Properties, name::Symbol, val)
    name === :alignment     ? set_alignment!(p, val) :
    name === :driver        ? Drivers.set_driver!(p, val) :
    name === :fclose_degree ? set_fclose_degree!(p, val) :
    name === :file_locking  ? API.h5p_set_file_locking(p, val...) :
    name === :libver_bounds ? set_libver_bounds!(p, val) :
    name === :meta_block_size ? API.h5p_set_meta_block_size(p, val) :
    name === :file_image      ? API.h5p_set_file_image(p, val) :
    # deprecated
    name === :fapl_mpio     ? (depwarn("The `fapl_mpio` property is deprecated, use `driver=HDF5.Drivers.MPIO(...)` instead.", :fapl_mpio); Drivers.set_driver!(p, Drivers.MPIO(val...))) :
    class_setproperty!(superclass(FileAccessProperties), p, name, val)
end


@propertyclass LinkAccessProperties API.H5P_LINK_ACCESS

"""
    GroupAccessProperties(;kws...)

Properties used when accessing datatypes. None are currently defined.
"""
@propertyclass GroupAccessProperties API.H5P_GROUP_ACCESS
superclass(::Type{GroupAccessProperties}) = LinkAccessProperties

"""
    DatatypeAccessProperties(;kws...)

Properties used when accessing datatypes. None are currently defined.
"""
@propertyclass DatatypeAccessProperties API.H5P_DATATYPE_ACCESS
superclass(::Type{DatatypeAccessProperties}) = LinkAccessProperties

"""
    DatasetAccessProperties(;kws...)
    DatasetAccessProperties(f::Function; kws...)

Properties that control access to data in external, virtual, and chunked datasets.

- `chunk_cache`: Chunk cache parameters as (nslots, nbytes, w0).
  Default: (521, 0x100000, 0.75)
- `efile_prefix`: Path prefix for reading external files.
  The default is the current working directory.
  - `:origin`: alias for `raw"\$ORIGIN"` will make the external file relative to
    the HDF5 file.
- `virtual_prefix`: Path prefix for reading virtual datasets.
- `virtual_printf_gap`: The maximum number of missing source files and/or
   datasets with the printf-style names when getting the extent of an unlimited
   virtual dataset
- `virtual_view`: Influences whether the view of the virtual dataset includes
  or excludes missing mapped elements
  - `:first_missing`: includes all data before the first missing mapped data
  - `:last_available`: includes all available mapped data


A function argument passed via `do` will be given an initialized property list
that will be closed.

See [Dataset Access Properties](https://portal.hdfgroup.org/display/HDF5/Dataset+Access+Properties)
"""
@propertyclass DatasetAccessProperties API.H5P_DATASET_ACCESS
superclass(::Type{DatasetAccessProperties}) = LinkAccessProperties

class_propertynames(::Type{DatasetAccessProperties}) = (
    :chunk_cache,
    :efile_prefix,
    :virtual_prefix,
    :virtual_printf_gap,
    :virtual_view
)

@enum_property(virtual_view,
    :first_missing  => API.H5D_VDS_FIRST_MISSING,
    :last_available => API.H5D_VDS_LAST_AVAILABLE
)

function class_getproperty(::Type{DatasetAccessProperties}, p::Properties, name::Symbol)
    name === :chunk_cache ? API.h5p_get_chunk_cache(p) :
    name === :efile_prefix ? API.h5p_get_efile_prefix(p) :
    name === :virtual_prefix ? API.h5p_get_virtual_prefix(p) :
    name === :virtual_printf_gap ? API.h5p_get_virtual_printf_gap(p) :
    name === :virtual_view ? get_virtual_view(p) :
    class_getproperty(superclass(DatasetAccessProperties), p, name)
end
function class_setproperty!(::Type{DatasetAccessProperties}, p::Properties, name::Symbol, val)
    name === :chunk_cache ? API.h5p_set_chunk_cache(p, val...) :
    name === :efile_prefix ? API.h5p_set_efile_prefix(p, val) :
    name === :virtual_prefix ? API.h5p_set_virtual_prefix(p, val) :
    name === :virtual_printf_gap ? API.h5p_set_virtual_printf_gap(p, val) :
    name === :virtual_view ? set_virtual_view!(p, val) :
    class_setproperty!(superclass(DatasetAccessProperties), p, name, val)
end

@propertyclass AttributeAccessProperties API.H5P_ATTRIBUTE_ACCESS
superclass(::Type{AttributeAccessProperties}) = LinkAccessProperties

"""
    DatasetTransferProperties(;kws...)
    DatasetTransferProperties(f::Function; kws...)

Properties used when transferring data to/from datasets

- `dxpl_mpio`: MPI transfer mode when using [`Drivers.MPIO`](@ref) file driver:
   - `:independent`: use independent I/O access (default),
   - `:collective`: use collective I/O access.

A function argument passed via `do` will be given an initialized property list
that will be closed.
"""
@propertyclass DatasetTransferProperties API.H5P_DATASET_XFER

@enum_property(dxpl_mpio,
               :independent => API.H5FD_MPIO_INDEPENDENT,
               :collective  => API.H5FD_MPIO_COLLECTIVE)

class_propertynames(::Type{DatasetTransferProperties}) = (
    :dxpl_mpio,
    )
function class_getproperty(::Type{DatasetTransferProperties}, p::Properties, name::Symbol)
    name === :dxpl_mpio  ? get_dxpl_mpio(p) :
    class_getproperty(superclass(DatasetTransferProperties), p, name)
end
function class_setproperty!(::Type{DatasetTransferProperties}, p::Properties, name::Symbol, val)
    name === :dxpl_mpio  ? set_dxpl_mpio!(p, val) :
    class_setproperty!(superclass(DatasetTransferProperties), p, name, val)
end

@propertyclass FileMountProperties API.H5P_FILE_MOUNT
@propertyclass ObjectCopyProperties API.H5P_OBJECT_COPY


const DEFAULT_PROPERTIES = GenericProperties()
# These properties are initialized in __init__()
const ASCII_LINK_PROPERTIES = LinkCreateProperties()
const UTF8_LINK_PROPERTIES = LinkCreateProperties()
const ASCII_ATTRIBUTE_PROPERTIES = AttributeCreateProperties()
const UTF8_ATTRIBUTE_PROPERTIES = AttributeCreateProperties()

_link_properties(::AbstractString) = copy(UTF8_LINK_PROPERTIES)
_attr_properties(::AbstractString) = copy(UTF8_ATTRIBUTE_PROPERTIES)

#! format: on

"""
    HDF5.Attribute

A HDF5 attribute: this is a piece of metadata attached to an HDF5 `Group` or
`Dataset`. It acts like a `Dataset`, in that it has a defined datatype and
dataspace, and can `read` and `write` data to it.

See also
- [`open_attribute`](@ref)
- [`create_attribute`](@ref)
- [`read_attribute`](@ref)
- [`write_attribute`](@ref)
- [`delete_attribute`](@ref)
"""
Attribute # defined in types.jl

function Base.close(obj::Attribute)
    if obj.id != -1
        if obj.file.id != -1 && isvalid(obj)
            API.h5a_close(obj)
        end
        obj.id = -1
    end
    nothing
end
name(attr::Attribute) = API.h5a_get_name(attr)

datatype(dset::Attribute) = Datatype(API.h5a_get_type(checkvalid(dset)), file(dset))
dataspace(attr::Attribute) = Dataspace(API.h5a_get_space(checkvalid(attr)))

function Base.write(obj::Attribute, x)
    dtype = datatype(x)
    try
        write_attribute(obj, dtype, x)
    finally
        close(dtype)
    end
end

"""
    read_attribute(parent::Union{File,Group,Dataset,Datatype}, name::AbstractString)

Read the value of the named attribute on the parent object.

# Example
```julia-repl
julia> HDF5.read_attribute(g, "time")
2.45
```
"""
function read_attribute(parent::Union{File,Group,Dataset,Datatype}, name::AbstractString)
    obj = open_attribute(parent, name)
    try
        return read(obj)
    finally
        close(obj)
    end
end
read_attribute(attr::Attribute, memtype::Datatype, buf) = API.h5a_read(attr, memtype, buf)

"""
    open_attribute(parent::Union{File,Group,Dataset,Datatype}, name::AbstractString)

Open the [`Attribute`](@ref) named `name` on the object `parent`.
"""
open_attribute(
    parent::Union{File,Object},
    name::AbstractString,
    aapl::AttributeAccessProperties=AttributeAccessProperties()
) = Attribute(API.h5a_open(checkvalid(parent), name, aapl), file(parent))

"""
    create_attribute(parent::Union{File,Object}, name::AbstractString, dtype::Datatype, space::Dataspace)
    create_attribute(parent::Union{File,Object}, name::AbstractString, data)

Create a new [`Attribute`](@ref) object named `name` on the object `parent`,
either by specifying the `Datatype` and `Dataspace` of the attribute, or by
providing the data. Note that no data will be written: use
[`write_attribute`](@ref) to write the data.
"""
function create_attribute(parent::Union{File,Object}, name::AbstractString, data; pv...)
    dtype = datatype(data)
    dspace = dataspace(data)
    obj = try
        create_attribute(parent, name, dtype, dspace; pv...)
    finally
        close(dspace)
    end
    return obj, dtype
end
function create_attribute(
    parent::Union{File,Object}, name::AbstractString, dtype::Datatype, dspace::Dataspace
)
    attrid = API.h5a_create(
        checkvalid(parent), name, dtype, dspace, _attr_properties(name), API.H5P_DEFAULT
    )
    return Attribute(attrid, file(parent))
end

# generic method
function write_attribute(attr::Attribute, memtype::Datatype, x::T) where {T}
    if isbitstype(T)
        API.h5a_write(attr, memtype, x)
    else
        jl_type = get_mem_compatible_jl_type(memtype)
        try
            x_mem = convert(jl_type, x)
            API.h5a_write(attr, memtype, Ref(x_mem))
        catch err
            if err isa MethodError
                throw(
                    ArgumentError(
                        "Could not convert non-bitstype $T to $jl_type for writing to HDF5. Consider implementing `convert(::Type{$jl_type}, ::$T)`"
                    )
                )
            else
                rethrow()
            end
        end
    end
end
function write_attribute(attr::Attribute, memtype::Datatype, x::Ref{T}) where {T}
    if isbitstype(T)
        API.h5a_write(attr, memtype, x)
    else
        jl_type = get_mem_compatible_jl_type(memtype)
        try
            x_mem = convert(Ref{jl_type}, x[])
            API.h5a_write(attr, memtype, x_mem)
        catch err
            if err isa MethodError
                throw(
                    ArgumentError(
                        "Could not convert non-bitstype $T to $jl_type for writing to HDF5. Consider implementing `convert(::Type{$jl_type}, ::$T)`"
                    )
                )
            else
                rethrow()
            end
        end
    end
end

# specific methods
write_attribute(attr::Attribute, memtype::Datatype, x::VLen) =
    API.h5a_write(attr, memtype, x)
function write_attribute(attr::Attribute, memtype::Datatype, x::AbstractArray{T}) where {T}
    length(x) == length(attr) || throw(
        ArgumentError(
            "Invalid length: $(length(x)) != $(length(attr)), for attribute \"$(name(attr))\""
        )
    )
    if isbitstype(T)
        API.h5a_write(attr, memtype, x)
    else
        jl_type = get_mem_compatible_jl_type(memtype)
        try
            x_mem = convert(Array{jl_type}, x)
            API.h5a_write(attr, memtype, x_mem)
        catch err
            if err isa MethodError
                throw(
                    ArgumentError(
                        "Could not convert non-bitstype $T to $jl_type for writing to HDF5. Consider implementing `convert(::Type{$jl_type}, ::$T)`"
                    )
                )
            else
                rethrow()
            end
        end
    end
end
function write_attribute(attr::Attribute, memtype::Datatype, str::AbstractString)
    strbuf = Base.cconvert(Cstring, str)
    GC.@preserve strbuf begin
        if API.h5t_is_variable_str(memtype)
            ptr = Base.unsafe_convert(Cstring, strbuf)
            write_attribute(attr, memtype, Ref(ptr))
        else
            ptr = Base.unsafe_convert(Ptr{UInt8}, strbuf)
            write_attribute(attr, memtype, ptr)
        end
    end
end
function write_attribute(
    attr::Attribute, memtype::Datatype, x::T
) where {T<:Union{ScalarType,Complex{<:ScalarType}}}
    tmp = Ref{T}(x)
    write_attribute(attr, memtype, tmp)
end
function write_attribute(attr::Attribute, memtype::Datatype, strs::Array{<:AbstractString})
    p = Ref{Cstring}(strs)
    write_attribute(attr, memtype, p)
end
write_attribute(attr::Attribute, memtype::Datatype, ::EmptyArray) = nothing

"""
    write_attribute(parent::Union{File,Object}, name::AbstractString, data)

Write `data` as an [`Attribute`](@ref) named `name` on the object `parent`.
"""
function write_attribute(parent::Union{File,Object}, name::AbstractString, data; pv...)
    attr, dtype = create_attribute(parent, name, data; pv...)
    try
        write_attribute(attr, dtype, data)
    catch exc
        delete_attribute(parent, name)
        rethrow(exc)
    finally
        close(attr)
        close(dtype)
    end
    nothing
end

"""
    rename_attribute(parent::Union{File,Object}, oldname::AbstractString, newname::AbstractString)

Rename the [`Attribute`](@ref) of the object `parent` named `oldname` to `newname`.
"""
rename_attribute(
    parent::Union{File,Object}, oldname::AbstractString, newname::AbstractString
) = API.h5a_rename(checkvalid(parent), oldname, newname)

"""
    delete_attribute(parent::Union{File,Object}, name::AbstractString)

Delete the [`Attribute`](@ref) named `name` on the object `parent`.
"""
delete_attribute(parent::Union{File,Object}, name::AbstractString) =
    API.h5a_delete(checkvalid(parent), name)

"""
    h5writeattr(filename, name::AbstractString, data::Dict)

Write `data` as attributes to the object at `name` in the HDF5 file `filename`.
"""
function h5writeattr(filename, name::AbstractString, data::Dict)
    file = h5open(filename, "r+")
    try
        obj = file[name]
        merge!(attrs(obj), data)
        close(obj)
    finally
        close(file)
    end
end

"""
    h5readattr(filename, name::AbstractString)

Read the attributes of the object at `name` in the HDF5 file `filename`, returning a `Dict`.
"""
function h5readattr(filename, name::AbstractString)
    local dat
    file = h5open(filename, "r")
    try
        obj = file[name]
        dat = Dict(attrs(obj))
        close(obj)
    finally
        close(file)
    end
    dat
end

"""
    num_attrs()

Retrieve the number of attributes from an object.

See [`API.h5o_get_info`](@ref).
"""
function num_attrs(obj)
    info = @static if API._libhdf5_build_ver < v"1.12.0"
        API.h5o_get_info(checkvalid(obj))
    else
        API.h5o_get_info(checkvalid(obj), API.H5O_INFO_NUM_ATTRS)
    end
    return Int(info.num_attrs)
end

struct AttributeDict <: AbstractDict{String,Any}
    parent::Object
end
AttributeDict(file::File) = AttributeDict(open_group(file, "."))

"""
    attrs(object::Union{File,Group,Dataset,Datatype})

The attributes dictionary of `object`. Returns an `AttributeDict`, a `Dict`-like
object for accessing the attributes of `object`.

```julia
attrs(object)["name"] = value  # create/overwrite an attribute
attr = attrs(object)["name"]   # read an attribute
delete!(attrs(object), "name") # delete an attribute
keys(attrs(object))            # list the attribute names
```
"""
function attrs(parent)
    return AttributeDict(parent)
end

Base.haskey(attrdict::AttributeDict, path::AbstractString) =
    API.h5a_exists(checkvalid(attrdict.parent), path)
Base.length(attrdict::AttributeDict) = num_attrs(attrdict.parent)

function Base.getindex(x::AttributeDict, name::AbstractString)
    haskey(x, name) || throw(KeyError(name))
    read_attribute(x.parent, name)
end
function Base.get(x::AttributeDict, name::AbstractString, default)
    haskey(x, name) || return default
    read_attribute(x.parent, name)
end
function Base.setindex!(attrdict::AttributeDict, val, name::AbstractString)
    if haskey(attrdict, name)
        # in case of an error, we write first to a temporary, then rename
        _name = name * "_hdf5jl_" * string(uuid4())
        haskey(attrdict, _name) && error("temp attribute name exists against all odds")
        try
            write_attribute(attrdict.parent, _name, val)
            delete_attribute(attrdict.parent, name)
            rename_attribute(attrdict.parent, _name, name)
        finally
            haskey(attrdict, _name) && delete_attribute(attrdict.parent, _name)
        end
    else
        write_attribute(attrdict.parent, name, val)
    end
end
Base.delete!(attrdict::AttributeDict, path::AbstractString) =
    delete_attribute(attrdict.parent, path)

function Base.keys(attrdict::AttributeDict)
    # faster than iteratively calling h5a_get_name_by_idx
    checkvalid(attrdict.parent)
    keyvec = sizehint!(String[], length(attrdict))
    API.h5a_iterate(
        attrdict.parent, idx_type(attrdict.parent), order(attrdict.parent)
    ) do _, attr_name, _
        push!(keyvec, unsafe_string(attr_name))
        return false
    end
    return keyvec
end

function Base.iterate(attrdict::AttributeDict)
    # constuct key vector, then iterate
    # faster than calling h5a_open_by_idx
    iterate(attrdict, (keys(attrdict), 1))
end
function Base.iterate(attrdict::AttributeDict, (keyvec, n))
    iter = iterate(keyvec, n)
    if isnothing(iter)
        return iter
    end
    key, nn = iter
    return (key => attrdict[key]), (keyvec, nn)
end

struct Attributes
    parent::Union{File,Object}
end

"""
    attributes(object::Union{File,Object})

The attributes of a file or object: this returns an `Attributes` object, which
is `Dict`-like object for accessing the attributes of `object`: `getindex` will
return an [`Attribute`](@ref) object, and `setindex!` will call [`write_attribute`](@ref).
"""
attributes(p::Union{File,Object}) = Attributes(p)

Base.isvalid(obj::Attributes) = isvalid(obj.parent)

function Base.getindex(x::Attributes, name::AbstractString)
    haskey(x, name) || throw(KeyError(name))
    open_attribute(x.parent, name)
end
Base.setindex!(x::Attributes, val, name::AbstractString) =
    write_attribute(x.parent, name, val)
Base.haskey(attr::Attributes, path::AbstractString) =
    API.h5a_exists(checkvalid(attr.parent), path)
Base.length(x::Attributes) = num_attrs(x.parent)

function Base.keys(x::Attributes)
    checkvalid(x.parent)
    children = sizehint!(String[], length(x))
    API.h5a_iterate(x.parent, idx_type(x.parent), order(x.parent)) do _, attr_name, _
        push!(children, unsafe_string(attr_name))
        return API.herr_t(0)
    end
    return children
end
Base.read(attr::Attributes, name::AbstractString) = read_attribute(attr.parent, name)

# Dataset methods which act like attributes
Base.write(parent::Dataset, name::AbstractString, data; pv...) =
    write_attribute(parent, name, data; pv...)
function Base.getindex(dset::Dataset, name::AbstractString)
    haskey(dset, name) || throw(KeyError(name))
    open_attribute(dset, name)
end
Base.setindex!(dset::Dataset, val, name::AbstractString) = write_attribute(dset, name, val)
Base.haskey(dset::Union{Dataset,Datatype}, path::AbstractString) =
    API.h5a_exists(checkvalid(dset), path)

using HDF5
using Test

@testset "ros3" begin
    @test HDF5.has_ros3()

    h5open(
        "http://s3.us-east-2.amazonaws.com/hdf5ros3/GMODO-SVM01.h5";
        driver=HDF5.Drivers.ROS3()
    ) do f
        @test keys(f) == ["All_Data", "Data_Products"]
    end
end

using HDF5
using Test

@testset "Dataspaces" begin
    hsize_t = HDF5.API.hsize_t
    # Reference objects without using high-level API
    ds_null   = HDF5.Dataspace(HDF5.API.h5s_create(HDF5.API.H5S_NULL))
    ds_scalar = HDF5.Dataspace(HDF5.API.h5s_create(HDF5.API.H5S_SCALAR))
    ds_zerosz = HDF5.Dataspace(HDF5.API.h5s_create_simple(1, hsize_t[0], hsize_t[0]))
    ds_vector = HDF5.Dataspace(HDF5.API.h5s_create_simple(1, hsize_t[5], hsize_t[5]))
    ds_matrix = HDF5.Dataspace(HDF5.API.h5s_create_simple(2, hsize_t[7, 5], hsize_t[7, 5]))
    ds_maxdim = HDF5.Dataspace(HDF5.API.h5s_create_simple(2, hsize_t[7, 5], hsize_t[20, 20]))
    ds_unlim  = HDF5.Dataspace(HDF5.API.h5s_create_simple(1, hsize_t[1], [HDF5.API.H5S_UNLIMITED]))

    # Testing basic property accessors of dataspaces

    @test isvalid(ds_scalar)

    @test ndims(ds_null) === 0
    @test ndims(ds_scalar) === 0
    @test ndims(ds_zerosz) === 1
    @test ndims(ds_vector) === 1
    @test ndims(ds_matrix) === 2

    # Test that properties of existing datasets can be extracted.
    # Note: Julia reverses the order of dimensions when using the high-level API versus
    #       the dimensions used above to create the reference objects.
    @test size(ds_null) === ()
    @test size(ds_scalar) === ()
    @test size(ds_zerosz) === (0,)
    @test size(ds_vector) === (5,)
    @test size(ds_matrix) === (5, 7)
    @test size(ds_maxdim) === (5, 7)

    @test size(ds_null, 5) === 1
    @test size(ds_scalar, 5) === 1
    @test size(ds_zerosz, 5) === 1
    @test size(ds_vector, 5) === 1
    @test size(ds_matrix, 5) === 1
    @test size(ds_maxdim, 5) === 1
    @test_throws ArgumentError("invalid dimension d; must be positive integer") size(
        ds_null, 0
    )
    @test_throws ArgumentError("invalid dimension d; must be positive integer") size(
        ds_scalar, -1
    )

    @test length(ds_null) === 0
    @test length(ds_scalar) === 1
    @test length(ds_zerosz) === 0
    @test length(ds_vector) === 5
    @test length(ds_matrix) === 35
    @test length(ds_maxdim) === 35

    @test isempty(ds_null)
    @test !isempty(ds_scalar)
    @test isempty(ds_zerosz)
    @test !isempty(ds_vector)

    @test HDF5.isnull(ds_null)
    @test !HDF5.isnull(ds_scalar)
    @test !HDF5.isnull(ds_zerosz)
    @test !HDF5.isnull(ds_vector)

    @test HDF5.get_extent_dims(ds_null) === ((), ())
    @test HDF5.get_extent_dims(ds_scalar) === ((), ())
    @test HDF5.get_extent_dims(ds_zerosz) === ((0,), (0,))
    @test HDF5.get_extent_dims(ds_vector) === ((5,), (5,))
    @test HDF5.get_extent_dims(ds_matrix) === ((5, 7), (5, 7))
    @test HDF5.get_extent_dims(ds_maxdim) === ((5, 7), (20, 20))
    @test HDF5.get_extent_dims(ds_unlim) === ((1,), (-1,))

    # Can create new copies
    ds_tmp  = copy(ds_maxdim)
    ds_tmp2 = HDF5.Dataspace(ds_tmp.id) # copy of ID, but new Julia object
    @test ds_tmp.id == ds_tmp2.id != ds_maxdim.id
    # Equality and hashing
    @test ds_tmp == ds_maxdim
    @test ds_tmp !== ds_maxdim
    @test hash(ds_tmp) != hash(ds_maxdim)
    @test ds_tmp == ds_tmp2
    @test ds_tmp !== ds_tmp2
    @test hash(ds_tmp) == hash(ds_tmp2)

    # Behavior of closing dataspace objects
    close(ds_tmp)
    @test ds_tmp.id == -1
    @test !isvalid(ds_tmp)
    @test !isvalid(ds_tmp2)

    # Validity checking in high-level operations
    @test_throws ErrorException("File or object has been closed") copy(ds_tmp)
    @test_throws ErrorException("File or object has been closed") ndims(ds_tmp)
    @test_throws ErrorException("File or object has been closed") size(ds_tmp)
    @test_throws ErrorException("File or object has been closed") size(ds_tmp, 1)
    @test_throws ErrorException("File or object has been closed") length(ds_tmp)
    @test_throws ErrorException("File or object has been closed") ds_tmp == ds_tmp2
    @test close(ds_tmp) === nothing # no error

    # Test ability to create explicitly-sized dataspaces

    @test dataspace(()) == ds_scalar
    @test dataspace((5,)) == ds_vector
    @test dataspace((5, 7)) == ds_matrix != ds_maxdim
    @test dataspace((5, 7); max_dims=(20, 20)) == ds_maxdim != ds_matrix
    @test dataspace((5, 7), (20, 20)) == ds_maxdim
    @test dataspace(((5, 7), (20, 20))) == ds_maxdim
    @test dataspace((1,); max_dims=(-1,)) == ds_unlim
    @test dataspace((1,), (-1,)) == ds_unlim
    @test dataspace(((1,), (-1,))) == ds_unlim
    # for ≥ 2 numbers, same as single tuple argument
    @test dataspace(5, 7) == ds_matrix
    @test dataspace(5, 7, 1) == dataspace((5, 7, 1))

    # Test dataspaces derived from data

    @test dataspace(nothing) == ds_null
    @test dataspace(HDF5.EmptyArray{Bool}()) == ds_null

    @test dataspace(fill(1.0)) == ds_scalar
    @test dataspace(1) == ds_scalar
    @test dataspace(1 + 1im) == ds_scalar
    @test dataspace("string") == ds_scalar

    @test dataspace(zeros(0)) == ds_zerosz
    @test dataspace(zeros(0, 0)) != ds_zerosz
    @test dataspace(zeros(5, 7)) == ds_matrix
    @test dataspace(HDF5.VLen([[1]])) == dataspace((1,))
    @test dataspace(HDF5.VLen([[1], [2]])) == dataspace((2,))

    # Constructing dataspace for/from HDF5 dataset or attribute

    mktemp() do path, io
        close(io)
        h5open(path, "w") do hid
            dset = create_dataset(hid, "dset", datatype(Int), ds_matrix)
            attr = create_attribute(dset, "attr", datatype(Bool), ds_vector)
            @test dataspace(dset) == ds_matrix
            @test dataspace(dset) !== ds_matrix
            @test dataspace(attr) == ds_vector
            @test dataspace(attr) !== ds_vector
            close(dset)
            close(attr)
            @test_throws ErrorException("File or object has been closed") dataspace(dset)
            @test_throws ErrorException("File or object has been closed") dataspace(attr)
        end
    end

    # Test mid-level routines: set/get_extent_dims

    dspace_norm = dataspace((100, 4))
    @test HDF5.get_extent_dims(dspace_norm)[1] ==
        HDF5.get_extent_dims(dspace_norm)[2] ==
        (100, 4)
    HDF5.set_extent_dims(dspace_norm, (8, 2))
    @test HDF5.get_extent_dims(dspace_norm)[1] ==
        HDF5.get_extent_dims(dspace_norm)[2] ==
        (8, 2)

    dspace_maxd = dataspace((100, 4); max_dims=(256, 5))
    @test HDF5.get_extent_dims(dspace_maxd)[1] == (100, 4)
    @test HDF5.get_extent_dims(dspace_maxd)[2] == (256, 5)
    HDF5.set_extent_dims(dspace_maxd, (8, 2))
    @test HDF5.get_extent_dims(dspace_maxd)[1] == (8, 2)
    HDF5.set_extent_dims(dspace_maxd, (3, 1), (4, 2))
    @test HDF5.get_extent_dims(dspace_maxd)[1] == (3, 1)
    @test HDF5.get_extent_dims(dspace_maxd)[2] == (4, 2)
    HDF5.set_extent_dims(dspace_maxd, (3, 1), (-1, -1)) # unlimited max size
    @test HDF5.get_extent_dims(dspace_maxd)[1] == (3, 1)
    @test HDF5.get_extent_dims(dspace_maxd)[2] == (-1, -1)
end

"""
    HDF5.Group

An object representing a [HDF5
group](https://docs.hdfgroup.org/hdf5/develop/_h5_d_m__u_g.html#subsubsec_data_model_abstract_group).
A group is analagous to a file system directory, in that, except for the root
group, every object must be a member of at least one group.

# See also

- [`create_group`](@ref)
- [`open_group`](@ref)
"""
Group

"""
    create_group(parent::Union{File,Group}, path::AbstractString; properties...)

Create a new [`Group`](@ref) at `path` under the `parent` object. Optional keyword
arguments include any keywords that that belong to
[`LinkCreateProperties`](@ref) or [`GroupCreateProperties`](@ref).
"""
function create_group(
    parent::Union{File,Group},
    path::AbstractString,
    lcpl::LinkCreateProperties,
    gcpl::GroupCreateProperties;
    pv...
)
    if !isempty(pv)
        depwarn(
            "Passing properties as positional and keyword arguments in the same call is deprecated.",
            :create_group
        )
        setproperties!(gcpl; pv...)
    end
    return Group(API.h5g_create(parent, path, lcpl, gcpl, API.H5P_DEFAULT), file(parent))
end
function create_group(parent::Union{File,Group}, path::AbstractString; pv...)
    lcpl = _link_properties(path)
    gcpl = GroupCreateProperties()
    try
        pv = setproperties!(lcpl, gcpl; pv...)
        isempty(pv) || error("invalid keyword options $pv")
        return create_group(parent, path, lcpl, gcpl)
    finally
        close(lcpl)
        close(gcpl)
    end
end

"""
    open_group(parent::Union{File,Group}, path::AbstractString; properties...)

Open an existing [`Group`](@ref) at `path` under the `parent` object.

Optional keyword arguments include any keywords that that belong to
[`GroupAccessProperties`](@ref).
"""
function open_group(
    parent::Union{File,Group}, name::AbstractString, gapl::GroupAccessProperties
)
    return Group(API.h5g_open(checkvalid(parent), name, gapl), file(parent))
end
function open_group(parent::Union{File,Group}, name::AbstractString; pv...)
    gapl = GroupAccessProperties(; pv...)
    return open_group(parent, name, gapl)
end

# Get the root group
root(h5file::File) = open_group(h5file, "/")
root(obj::Union{Group,Dataset}) = open_group(file(obj), "/")

group_info(obj::Union{Group,File}) = API.h5g_get_info(checkvalid(obj))
Base.length(obj::Union{Group,File}) = Int(API.h5g_get_num_objs(checkvalid(obj)))
Base.isempty(x::Union{Group,File}) = length(x) == 0

# filename and name
name(obj::Union{File,Group,Dataset,Datatype}) = API.h5i_get_name(checkvalid(obj))

# iteration by objects
function Base.iterate(parent::Union{File,Group}, iter=(1, nothing))
    n, prev_obj = iter
    prev_obj ≢ nothing && close(prev_obj)
    n > length(parent) && return nothing
    obj = h5object(
        API.h5o_open_by_idx(
            checkvalid(parent), ".", idx_type(parent), order(parent), n - 1, API.H5P_DEFAULT
        ),
        parent
    )
    return (obj, (n + 1, obj))
end

function Base.parent(obj::Union{File,Group,Dataset})
    f = file(obj)
    path = name(obj)
    if length(path) == 1
        return f
    end
    parentname = dirname(path)
    if !isempty(parentname)
        return open_object(f, dirname(path))
    else
        return root(f)
    end
end

# Path manipulation
function split1(path::AbstractString)
    ind = findfirst('/', path)
    isnothing(ind) && return path, ""
    if ind == 1 # matches root group
        return "/", path[2:end]
    else
        indm1, indp1 = prevind(path, ind), nextind(path, ind)
        return path[1:indm1], path[indp1:end] # better to use begin:indm1, but only available on v1.5
    end
end

function Base.haskey(
    parent::Union{File,Group},
    path::AbstractString,
    lapl::LinkAccessProperties=LinkAccessProperties()
)
    # recursively check each step of the path exists
    # see https://portal.hdfgroup.org/display/HDF5/H5L_EXISTS
    checkvalid(parent)
    first, rest = split1(path)
    if first == "/"
        parent = root(parent)
    elseif !API.h5l_exists(parent, first, lapl)
        return false
    end
    exists = true
    if !isempty(rest)
        obj = parent[first]
        exists = haskey(obj, rest, lapl)
        close(obj)
    end
    return exists
end
function Base.keys(x::Union{Group,File})
    checkvalid(x)
    children = sizehint!(String[], length(x))
    API.h5l_iterate(x, idx_type(x), order(x)) do _, name, _
        push!(children, unsafe_string(name))
        return API.herr_t(0)
    end
    return children
end

"""
    delete_object(parent::Union{File,Group}, path::AbstractString)

Delete the object at `parent[path]`.

# Examples
```julia
f = h5open("f.h5", "r+")
delete_object(f, "Group1")
```
"""
delete_object(
    parent::Union{File,Group},
    path::AbstractString,
    lapl::LinkAccessProperties=LinkAccessProperties()
) = API.h5l_delete(checkvalid(parent), path, lapl)
delete_object(obj::Object) = delete_object(parent(obj), ascii(split(name(obj), "/")[end])) # FIXME: remove ascii?

# Move links
move_link(
    src::Union{File,Group},
    src_name::AbstractString,
    dest::Union{File,Group},
    dest_name::AbstractString=src_name,
    lapl::LinkAccessProperties=LinkAccessProperties(),
    lcpl::LinkCreateProperties=LinkCreateProperties()
) = API.h5l_move(checkvalid(src), src_name, checkvalid(dest), dest_name, lcpl, lapl)
move_link(
    parent::Union{File,Group},
    src_name::AbstractString,
    dest_name::AbstractString,
    lapl::LinkAccessProperties=LinkAccessProperties(),
    lcpl::LinkCreateProperties=LinkCreateProperties()
) = API.h5l_move(checkvalid(parent), src_name, parent, dest_name, lcpl, lapl)

"""
    create_external(source::Union{HDF5.File, HDF5.Group}, source_relpath, target_filename, target_path;
                    lcpl_id=HDF5.API.H5P_DEFAULT, lapl_id=HDF5.H5P.DEFAULT)

Create an external link such that `source[source_relpath]` points to `target_path` within the file
with path `target_filename`.

# See also
[`API.h5l_create_external`](@ref)
"""
function create_external(
    source::Union{File,Group},
    source_relpath,
    target_filename,
    target_path;
    lcpl_id=API.H5P_DEFAULT,
    lapl_id=API.H5P_DEFAULT
)
    API.h5l_create_external(
        target_filename, target_path, source, source_relpath, lcpl_id, lapl_id
    )
    nothing
end

function Base.show(io::IO, fid::File)
    if isvalid(fid)
        intent    = API.h5f_get_intent(fid)
        RW_MASK   = API.H5F_ACC_RDONLY | API.H5F_ACC_RDWR
        SWMR_MASK = API.H5F_ACC_SWMR_READ | API.H5F_ACC_SWMR_WRITE
        rw        = (intent & RW_MASK) == API.H5F_ACC_RDONLY ? "(read-only" : "(read-write"
        swmr      = (intent & SWMR_MASK) != 0 ? ", swmr) " : ") "
        print(io, "HDF5.File: ", rw, swmr, fid.filename)
    else
        print(io, "HDF5.File: (closed) ", fid.filename)
    end
end

function Base.show(io::IO, g::Group)
    if isvalid(g)
        print(io, "HDF5.Group: ", name(g), " (file: ", g.file.filename, ")")
    else
        print(io, "HDF5.Group: (invalid)")
    end
end

function Base.show(io::IO, prop::Properties)
    print(io, typeof(prop))
    if prop.id == API.H5P_DEFAULT
        print(io, "()")
    elseif !isvalid(prop)
        print(io, ": (invalid)")
    else
        print(io, "(")
        for name in all_propertynames(typeof(prop))
            # skip deprecated names
            if name in (:compress, :track_times, :fapl_mpio)
                continue
            end
            # not all properties have getters (e.g. shuffle, deflate, etc.),
            # or always well-defined (e.g. chunk if layout != :chunked, dxpl_mpio if no MPI)
            try
                val = getproperty(prop, name)
                if name == :file_image
                    print(
                        io,
                        "\n  ",
                        rpad(name, 15),
                        " = ",
                        repr(typeof(val)),
                        ", length = ",
                        length(val),
                        ","
                    )
                else
                    print(io, "\n  ", rpad(name, 15), " = ", repr(val), ",")
                end
            catch e
            end
        end
        print(io, "\n)")
    end
end

function Base.show(io::IO, dset::Dataset)
    if isvalid(dset)
        print(
            io,
            "HDF5.Dataset: ",
            name(dset),
            " (file: ",
            dset.file.filename,
            " xfer_mode: ",
            dset.xfer.id,
            ")"
        )
    else
        print(io, "HDF5.Dataset: (invalid)")
    end
end

function Base.show(io::IO, attr::Attribute)
    if isvalid(attr)
        print(io, "HDF5.Attribute: ", name(attr))
    else
        print(io, "HDF5.Attribute: (invalid)")
    end
end
function Base.show(io::IO, attr::Attributes)
    print(io, "Attributes of ", attr.parent)
end

Base.show(io::IO, attrdict::AttributeDict) = summary(io, attrdict)
function Base.summary(io::IO, attrdict::AttributeDict)
    print(io, "AttributeDict of ", attrdict.parent)
    if isvalid(attrdict.parent)
        n = length(attrdict)
        print(io, " with ", n, n == 1 ? " attribute" : " attributes")
    end
end

const ENDIAN_DICT = Dict(
    API.H5T_ORDER_LE    => "little endian byte order",
    API.H5T_ORDER_BE    => "big endian byte order",
    API.H5T_ORDER_VAX   => "vax mixed endian byte order",
    API.H5T_ORDER_MIXED => "mixed endian byte order",
    API.H5T_ORDER_NONE  => "no particular byte order",
)

function Base.show(io::IO, dtype::Datatype)
    print(io, "HDF5.Datatype: ")
    if isvalid(dtype)
        API.h5t_committed(dtype) && print(io, name(dtype), " ")
        buffer = IOBuffer(; sizehint=18)
        print(buffer, API.h5lt_dtype_to_text(dtype))
        str = String(take!(buffer))
        if str == "undefined integer"
            println(io, str)
            println(io, "         size: ", API.h5t_get_size(dtype), " bytes")
            println(io, "    precision: ", API.h5t_get_precision(dtype), " bits")
            println(io, "       offset: ", API.h5t_get_offset(dtype), " bits")
            print(io, "        order: ", ENDIAN_DICT[API.h5t_get_order(dtype)])
        else
            print(io, str)
        end
    else
        # Note that API.h5i_is_valid returns `false` on the built-in datatypes (e.g. API.H5T_NATIVE_INT),
        # apparently because they have refcounts of 0 yet are always valid. Just temporarily turn
        # off error printing and try the call to probe if dtype is valid since API.H5LTdtype_to_text
        # special-cases all of the built-in types internally.
        local text
        try
            text = API.h5lt_dtype_to_text(dtype)
        catch
            text = "(invalid)"
        end
        print(io, text)
    end
end

function Base.show(io::IO, br::BlockRange)
    start = Int(br.start0 + 1)
    # choose the simplest possible representation
    if br.count == 1
        if br.block == 1
            # integer
            r = start
        else
            # UnitRange
            r = range(start; length=Int(br.block))
        end
    elseif br.block == 1 && br.count != API.H5S_UNLIMITED
        # StepRange
        r = range(start; step=Int(br.stride), length=Int(br.count))
    else
        # BlockRange(int; ...)
        print(io, BlockRange, "(start=", start)
        if br.stride != 1
            print(io, ", stride=", Int(br.stride))
        end
        if br.count != 1
            print(io, ", count=", br.count == API.API.H5S_UNLIMITED ? -1 : Int(br.count))
        end
        if br.block != 1
            print(io, ", block=", Int(br.block))
        end
        print(io, ")")
        return nothing
    end
    compact = get(io, :compact, false)
    compact || print(io, BlockRange, "(")
    print(io, r)
    compact || print(io, ")")
    return nothing
end

function Base.show(io::IO, dspace::Dataspace)
    if !isvalid(dspace)
        print(io, "HDF5.Dataspace: (invalid)")
        return nothing
    end
    print(io, "HDF5.Dataspace: ")
    type = API.h5s_get_simple_extent_type(dspace)
    if type == API.H5S_NULL
        print(io, "H5S_NULL")
        return nothing
    elseif type == API.H5S_SCALAR
        print(io, "H5S_SCALAR")
        return nothing
    end
    # otherwise type == API.H5S_SIMPLE
    sz, maxsz = get_extent_dims(dspace)
    sel = API.h5s_get_select_type(dspace)
    if sel == API.H5S_SEL_HYPERSLABS && API.h5s_is_regular_hyperslab(dspace)
        io_compact = IOContext(io, :compact => true)
        blockranges = get_regular_hyperslab(dspace)
        ndims = length(blockranges)
        print(io_compact, "(")
        for ii in 1:ndims
            print(io_compact, blockranges[ii])
            ii != ndims && print(io_compact, ", ")
        end
        print(io_compact, ") / (")
        for ii in 1:ndims
            print(io_compact, 1:maxsz[ii])
            ii != ndims && print(io_compact, ", ")
        end
        print(io_compact, ")")
    else
        print(io, sz)
        if maxsz != sz
            print(io, " / ", maxsz)
        end
        if sel != API.H5S_SEL_ALL
            print(io, " [irregular selection]")
        end
    end
end

"""
    SHOW_TREE_ICONS = Ref{Bool}(true)

Configurable option to control whether emoji icons (`true`) or a plain-text annotation
(`false`) is used to indicate the object type by `show_tree`.
"""
const SHOW_TREE_ICONS = Ref{Bool}(true)

"""
    SHOW_TREE_MAX_DEPTH = Ref{Int}(5)

Maximum recursive depth to descend during printing.
"""
const SHOW_TREE_MAX_DEPTH = Ref{Int}(5)

"""
    SHOW_TREE_MAX_CHILDREN = Ref{Int}(50)

Maximum number of children to show at each node.
"""
const SHOW_TREE_MAX_CHILDREN = Ref{Int}(50)

function Base.show(
    io::IO, ::MIME"text/plain", obj::Union{File,Group,Dataset,Attributes,Attribute}
)
    if get(io, :compact, false)::Bool
        show(io, obj)
    else
        show_tree(io, obj)
    end
end

_tree_icon(::Type{Attribute}) = SHOW_TREE_ICONS[] ? "🏷️" : "[A]"
_tree_icon(::Type{Group})     = SHOW_TREE_ICONS[] ? "📂" : "[G]"
_tree_icon(::Type{Dataset})   = SHOW_TREE_ICONS[] ? "🔢" : "[D]"
_tree_icon(::Type{Datatype})  = SHOW_TREE_ICONS[] ? "📄" : "[T]"
_tree_icon(::Type{File})      = SHOW_TREE_ICONS[] ? "🗂️" : "[F]"
_tree_icon(::Type)            = SHOW_TREE_ICONS[] ? "❓" : "[?]"
_tree_icon(obj)               = _tree_icon(typeof(obj))
_tree_icon(obj::Attributes)   = _tree_icon(obj.parent)

_tree_head(io::IO, obj) = print(io, _tree_icon(obj), " ", obj)
_tree_head(io::IO, obj::Datatype) =
    print(io, _tree_icon(obj), " HDF5.Datatype: ", name(obj))

_tree_count(parent::Union{File,Group}, attributes::Bool) =
    length(parent) + (attributes ? length(HDF5.attrs(parent)) : 0)
_tree_count(parent::Dataset, attributes::Bool) = attributes ? length(HDF5.attrs(parent)) : 0
_tree_count(parent::Attributes, _::Bool) = length(parent)
_tree_count(parent::Union{Attribute,Datatype}, _::Bool) = 0

function _show_tree(
    io::IO,
    obj::Union{File,Group,Dataset,Datatype,Attributes,Attribute},
    indent::String="";
    attributes::Bool=true,
    depth::Int=1
)
    isempty(indent) && _tree_head(io, obj)
    isvalid(obj) || return nothing

    INDENT = "   "
    PIPE   = "│  "
    TEE    = "├─ "
    ELBOW  = "└─ "

    limit = get(io, :limit, false)::Bool
    counter = 0
    nchildren = _tree_count(obj, attributes)

    @inline function childstr(io, n, more=" ")
        print(io, "\n", indent, ELBOW * "(", n, more, n == 1 ? "child" : "children", ")")
    end
    @inline function depth_check()
        counter += 1
        if limit && counter > max(2, SHOW_TREE_MAX_CHILDREN[] ÷ depth)
            childstr(io, nchildren - counter + 1, " more ")
            return true
        end
        return false
    end

    if limit && nchildren > 0 && depth > SHOW_TREE_MAX_DEPTH[]
        childstr(io, nchildren)
        return nothing
    end

    if attributes && !isa(obj, Attribute)
        obj′ = obj isa Attributes ? obj.parent : obj
        API.h5a_iterate(obj′, idx_type(obj′), order(obj′)) do _, cname, _
            depth_check() && return API.herr_t(1)

            name = unsafe_string(cname)
            icon = _tree_icon(Attribute)
            islast = counter == nchildren
            print(io, "\n", indent, islast ? ELBOW : TEE, icon, " ", name)
            return API.herr_t(0)
        end
    end

    typeof(obj) <: Union{File,Group} || return nothing

    API.h5l_iterate(obj, idx_type(obj), order(obj)) do loc_id, cname, _
        depth_check() && return API.herr_t(1)

        name = unsafe_string(cname)
        child = obj[name]
        icon = _tree_icon(child)

        islast = counter == nchildren
        print(io, "\n", indent, islast ? ELBOW : TEE, icon, " ", name)
        nextindent = indent * (islast ? INDENT : PIPE)
        _show_tree(io, child, nextindent; attributes=attributes, depth=depth + 1)

        close(child)
        return API.herr_t(0)
    end
    return nothing
end

show_tree(obj; kws...) = show_tree(stdout, obj; kws...)
function show_tree(io::IO, obj; kws...)
    buf = IOBuffer()
    _show_tree(IOContext(buf, io), obj; kws...)
    print(io, String(take!(buf)))
end

# following https://support.hdfgroup.org/HDF5/doc/RM/RM_H5F.html#File-StartSwmrWrite
# and https://support.hdfgroup.org/HDF5/docNewFeatures/SWMR/HDF5_SWMR_Users_Guide.pdf
using HDF5
using Test
using Distributed

if nprocs() == 1
    procs = addprocs(1)
else
    procs = Int64[]
end
@everywhere using HDF5

@testset "swmr" begin
    fname = tempname()

    @testset "swmr modes" begin
        h5open(fname, "w"; swmr=true) do h5
            h5["foo"] = collect(1:10)
        end
        h5open(fname, "r"; swmr=true) do h5
            @test read(h5["foo"]) == collect(1:10)
        end
        h5open(fname, "r+"; swmr=true) do h5
            @test read(h5["foo"]) == collect(1:10)
        end
    end

    @testset "h5d_oappend" begin
        h5open(fname, "w") do h5
            g = create_group(h5, "shoe")
            d = create_dataset(g, "bar", datatype(Float64), ((1,), (-1,)); chunk=(100,))
            dxpl_id = HDF5.get_create_properties(d)
            v = [1.0, 2.0]
            memtype = datatype(Float64)
            # @test HDF5.h5d_oappend(d, dxpl_id, 0, length(v), memtype, v)
        end
    end

    function dataset_write(d, ch_written, ch_read)
        for i in 1:10
            @assert take!(ch_read) == true
            HDF5.set_extent_dims(d, (i * 10,))
            inds::UnitRange{Int} = (1:10) .+ (i - 1) * 10
            d[inds] = inds
            flush(d) # flush the dataset
            put!(ch_written, i)
        end
    end

    @everywhere function dataset_read(d, ch_written, ch_read)
        n = nlast = length(d)
        nbigger = 0
        i = 0
        put!(ch_read, true)
        while n < 100
            i = take!(ch_written)
            for j in 1:1000 # wait for new data to be available to avoid CI failures
                HDF5.refresh(d)
                nlast, n = n, length(d)
                n > nlast && break
                sleep(0.001)
            end
            vals = read(d)
            @assert vals == collect(1:n)
            n > nlast && (nbigger += 1)
            put!(ch_read, true)
        end
        return nbigger
    end

    @everywhere function swmr_reader(fname, ch_written, ch_read)
        h5open(fname, "r"; swmr=true) do h5
            d = h5["foo"]
            dataset_read(d, ch_written, ch_read)
        end
    end

    # Spawn a reader function in a 2nd process, provide two channels for synchronization.
    # Run a writing function in this process. The writing function writes,
    # then notifies `ch_read`, then the reading function reads, and notifies `ch_read`. So read
    # attempts should always follow writes, though there may be a delay before the data is available
    # so there is a step that sleeps until data is available.
    function remote_test(h5)
        ch_written, ch_read = RemoteChannel(1), RemoteChannel(1)
        a = @spawn(swmr_reader(fname, ch_written, ch_read))
        dataset_write(h5["foo"], ch_written, ch_read)
        nbigger = fetch(a)
        @test nbigger == 10
    end

    # create datasets and attributes before staring swmr writing
    function prep_h5_file(h5)
        d = create_dataset(h5, "foo", datatype(Int), ((1,), (100,)); chunk=(1,))
        attributes(h5)["bar"] = "bar"
        g = create_group(h5, "group")
    end

    @testset "create by libver, then start_swmr_write" begin
        #test this h5open method with keyword arg
        h5open(fname, "w"; libver_bounds=(:latest, :latest), swmr=false) do h5
            prep_h5_file(h5)
            HDF5.start_swmr_write(h5) # after creating datasets
            remote_test(h5)
        end
    end

    @testset "create by swmr mode, then close and open again" begin
        h5open(fname, "w"; swmr=true) do h5
            prep_h5_file(h5)
        end
        # close the file after creating datasets, open again with swmr write access but not truncate
        h5open(fname, "r+"; swmr=true) do h5
            remote_test(h5)
        end
    end

    rm(fname) # cleanup file created by swmr tests

    if nprocs() > 1
        rmprocs(procs)
    end
end # testset swmr

function Base.close(obj::Datatype)
    if obj.toclose && obj.id != -1
        if (!isdefined(obj, :file) || obj.file.id != -1) && isvalid(obj)
            API.h5o_close(obj)
        end
        obj.id = -1
    end
    nothing
end

# The datatype of a Datatype is the Datatype
datatype(dt::Datatype) = dt

open_datatype(
    parent::Union{File,Group}, name::AbstractString, tapl::DatatypeAccessProperties
) = Datatype(API.h5t_open(checkvalid(parent), name, tapl), file(parent))

"""
    open_datatype(parent::Union{File,Group}, path::AbstractString; properties...)

Open an existing [`Datatype`](@ref) at `path` under the `parent` object.

Optional keyword arguments include any keywords that that belong to
[`DatatypeAccessProperties`](@ref).
"""
function open_datatype(parent::Union{File,Group}, name::AbstractString; pv...)
    tapl = DatatypeAccessProperties(; pv...)
    return open_datatype(parent, name, tapl)
end

# Note that H5Tcreate is very different; H5Tcommit is the analog of these others
create_datatype(class_id, sz) = Datatype(API.h5t_create(class_id, sz))

function commit_datatype(
    parent::Union{File,Group},
    path::AbstractString,
    dtype::Datatype,
    lcpl::LinkCreateProperties=LinkCreateProperties(),
    tcpl::DatatypeCreateProperties=DatatypeCreateProperties(),
    tapl::DatatypeAccessProperties=DatatypeAccessProperties()
)
    lcpl.char_encoding = cset(typeof(path))
    API.h5t_commit(checkvalid(parent), path, dtype, lcpl, tcpl, tapl)
    dtype.file = file(parent)
    return dtype
end

Base.sizeof(dtype::Datatype) = Int(API.h5t_get_size(dtype))

using HDF5
using Test

macro gcvalid(args...)
    Expr(
        :block,
        quote
            GC.enable(true)
            GC.gc()
            GC.enable(false)
        end,
        [:(@test HDF5.isvalid($(esc(x)))) for x in args]...
    )
end

macro closederror(x)
    quote
        try
            $(esc(x))
        catch e
            isa(e, ErrorException) || rethrow(e)
            e.msg == "File or object has been closed" ||
                error("Attempt to access closed object did not throw")
        end
    end
end

@testset "gc" begin
    GC.enable(false)
    fn = tempname()
    for i in 1:10
        file = h5open(fn, "w")
        memtype_id = HDF5.API.h5t_create(HDF5.API.H5T_COMPOUND, 2 * sizeof(Float64))
        HDF5.API.h5t_insert(memtype_id, "real", 0, HDF5.hdf5_type_id(Float64))
        HDF5.API.h5t_insert(memtype_id, "imag", sizeof(Float64), HDF5.hdf5_type_id(Float64))
        dt = HDF5.Datatype(memtype_id)
        commit_datatype(file, "dt", dt)
        ds = dataspace((2,))
        d = create_dataset(file, "d", dt, ds)
        g = create_group(file, "g")
        a = create_attribute(file, "a", dt, ds)
        @gcvalid dt ds d g a
        close(file)

        @closederror read(d)
        for obj in (d, g)
            @closederror read_attribute(obj, "a")
            @closederror write_attribute(obj, "a", 1)
        end
        for obj in (g, file)
            @closederror open_dataset(obj, "d")
            @closederror read_dataset(obj, "d")
            @closederror write_dataset(obj, "d", 1)
            @closederror read(obj, "x")
            @closederror write(obj, "x", "y")
        end
    end
    for i in 1:10
        file = h5open(fn, "r")
        dt = file["dt"]
        d = file["d"]
        ds = dataspace(d)
        g = file["g"]
        a = attributes(file)["a"]
        @gcvalid dt ds d g a
        close(file)
    end
    GC.enable(true)

    let plist = HDF5.init!(HDF5.FileAccessProperties())  # related to issue #620
        HDF5.API.h5p_close(plist)
        @test_nowarn finalize(plist)
    end

    rm(fn)
end # testset gc

using Pkg, Libdl
Pkg.activate(dirname(@__DIR__))
Pkg.instantiate()

# Configure the test setup based on environment variables set in CI.
# First, we get the settings and remove all local preference configurations
# that may still exist.
const JULIA_HDF5_PATH = get(ENV, "JULIA_HDF5_PATH", "")
rm(joinpath(dirname(@__DIR__), "LocalPreferences.toml"); force=true)

# Next, we configure MPI.jl appropriately.
import MPIPreferences
MPIPreferences.use_system_binary()

# Finally, we configure HDF5.jl as desired.
import UUIDs, Preferences
Preferences.set_preferences!(
    UUIDs.UUID("f67ccb44-e63f-5c2f-98bd-6dc0ccc4ba2f"), # UUID of HDF5.jl
    "libhdf5" => joinpath(JULIA_HDF5_PATH, "libhdf5." * Libdl.dlext),
    "libhdf5_hl" => joinpath(JULIA_HDF5_PATH, "libhdf5_hl." * Libdl.dlext);
    force=true
)

using Random, Test, HDF5

import HDF5.datatype

struct Simple
    a::Float64
    b::Int
end

function datatype(::Type{Simple})
    dtype = HDF5.API.h5t_create(HDF5.API.H5T_COMPOUND, sizeof(Simple))
    HDF5.API.h5t_insert(dtype, "a", fieldoffset(Simple, 1), datatype(Float64))
    HDF5.API.h5t_insert(dtype, "b", fieldoffset(Simple, 2), datatype(Int))
    HDF5.Datatype(dtype)
end

@testset "custom" begin
    N = 5
    v = [Simple(rand(Float64), rand(Int)) for i in 1:N, j in 1:N]

    fn = tempname()
    h5open(fn, "w") do h5f
        dtype = datatype(Simple)
        dspace = dataspace(v)
        dset = create_dataset(h5f, "data", dtype, dspace)
        write_dataset(dset, dtype, v)
    end

    h5open(fn, "r") do h5f
        dset = h5f["data"]
        @test_throws ErrorException read(dset, Float64)
        @test_throws ErrorException read(dset, Union{Float64,Int})

        v_read = read(dset, Simple)
        @test v_read == v

        indices = (1, 1:2:4)
        v_read = read(dset, Simple, indices...)
        @test v_read == v[indices...]

        v_read = read(h5f, "data" => Simple)
        @test v_read == v
    end

    v_read = h5read(fn, "data" => Simple)
    @test v_read == v
end

using HDF5
using Test

@testset "external" begin

    # roughly following https://www.hdfgroup.org/ftp/HDF5/current/src/unpacked/examples/h5_extlink.c
    fn1 = tempname()
    fn2 = tempname()

    source_file = h5open(fn1, "w")
    agroup = create_group(source_file, "agroup")
    target_file = h5open(fn2, "w")
    target_group = create_group(target_file, "target_group")
    target_group["abc"] = "abc"
    target_group["1"] = 1
    target_group["1.1"] = 1.1
    close(target_file)

    # create external link such that source_file["ext_link"] points to target_file["target_group"]
    # test both an HDF5.File and an HDF5.Group for first argument
    HDF5.create_external(source_file, "ext_link", target_file.filename, "target_group")
    HDF5.create_external(agroup, "ext_link", target_file.filename, "target_group")
    close(agroup)
    # write some things via the external link
    new_group = create_group(source_file["ext_link"], "new_group")
    new_group["abc"] = "abc"
    new_group["1"] = 1
    new_group["1.1"] = 1.1
    close(new_group)

    # read things from target_group via exernal link created with HDF5File argument
    group = source_file["ext_link"]
    @test read(group["abc"]) == "abc"
    @test read(group["1"]) == 1
    @test read(group["1.1"]) == 1.1
    close(group)
    # read things from target_group via the external link created with HDF5.Group argument
    groupalt = source_file["agroup/ext_link"]
    @test read(groupalt["abc"]) == "abc"
    @test read(groupalt["1"]) == 1
    @test read(groupalt["1.1"]) == 1.1
    close(groupalt)
    close(source_file)

    ##### tests that should be included but don't work
    # when ggggggggg restarts julia and keeps track of target_file.filename,
    # these tests succeed
    # reopening the target_file crashes due to "file close degree doesn't match"
    # target_file = h5open(target_file.filename, "r")
    # group2 = target_file["target_group"]["new_group"]
    # @test read(group2["abc"])=="abc"
    # @test read(group2["1"])==1
    # @test read(group2["1.1"])==1.1

    rm(fn1)
    # rm(fn2)

end # testset external

"""
    Deflate(level=5)

Deflate/ZLIB lossless compression filter. `level` is an integer between 0 and 9,
inclusive, denoting the compression level, with 0 being no compression, 9 being the
highest compression (but slowest speed).

# External links
- $(h5doc("H5P_SET_DEFLATE"))
- [_Deflate_ on Wikipedia](https://en.wikipedia.org/wiki/Deflate)
"""
struct Deflate <: Filter
    level::Cuint
end
Deflate(; level=5) = Deflate(level)
Base.show(io::IO, deflate::Deflate) = print(io, Deflate, "(level=", Int(deflate.level), ")")

filterid(::Type{Deflate}) = API.H5Z_FILTER_DEFLATE
FILTERS[API.H5Z_FILTER_DEFLATE] = Deflate

function Base.push!(f::FilterPipeline, deflate::Deflate)
    API.h5p_set_deflate(f.plist, deflate.level)
    return f
end

"""
    Shuffle()

The shuffle filter de-interlaces a block of data by reordering the bytes. All the bytes
from one consistent byte position of each data element are placed together in one block;
all bytes from a second consistent byte position of each data element are placed together
a second block; etc. For example, given three data elements of a 4-byte datatype stored as
012301230123, shuffling will re-order data as 000111222333. This can be a valuable step in
an effective compression algorithm because the bytes in each byte position are often
closely related to each other and putting them together can increase the compression
ratio.

As implied above, the primary value of the shuffle filter lies in its coordinated use with
a compression filter; it does not provide data compression when used alone. When the
shuffle filter is applied to a dataset immediately prior to the use of a compression
filter, the compression ratio achieved is often superior to that achieved by the use of a
compression filter without the shuffle filter.

# External links
- $(h5doc("H5P_SET_SHUFFLE"))
"""
struct Shuffle <: Filter end
filterid(::Type{Shuffle}) = API.H5Z_FILTER_SHUFFLE
FILTERS[API.H5Z_FILTER_SHUFFLE] = Shuffle

function Base.push!(f::FilterPipeline, ::Shuffle)
    API.h5p_set_shuffle(f.plist)
    return f
end

"""
    Fletcher32()

The Fletcher32 checksum filter. This doesn't perform compression, but instead checks the validity of the stored data.

This should be applied _after_ any lossy filters have been applied.

# External links
- $(h5doc("H5P_SET_FLETCHER32"))
- [_Fletcher's checksum_ on Wikipedia](https://en.wikipedia.org/wiki/Fletcher's_checksum)
"""
struct Fletcher32 <: Filter end
filterid(::Type{Fletcher32}) = API.H5Z_FILTER_FLETCHER32
FILTERS[API.H5Z_FILTER_FLETCHER32] = Fletcher32
function Base.push!(f::FilterPipeline, ::Fletcher32)
    API.h5p_set_fletcher32(f.plist)
    return f
end

"""
    Szip(coding=:nn, pixels_per_block=8)

Szip compression lossless filter. Options:

- `coding`: the coding method: either `:ec` (entropy coding) or `:nn` (nearest neighbors,
  default)
- `pixels_per_block`: The number of pixels or data elements in each data block (typically
  8, 10, 16, or 32)

# External links
- $(h5doc("H5P_SET_SZIP"))
- [Szip Compression in HDF Products](https://support.hdfgroup.org/doc_resource/SZIP/)
"""
struct Szip <: Filter
    options_mask::Cuint
    pixels_per_block::Cuint
end
function Szip(; coding=:nn, pixels_per_block=8)
    options_mask = Cuint(0)
    if coding == :ec
        options_mask |= API.H5_SZIP_EC_OPTION_MASK
    elseif coding == :nn
        options_mask |= API.H5_SZIP_NN_OPTION_MASK
    else
        error("invalid coding option")
    end
    Szip(options_mask, pixels_per_block)
end
function Base.show(io::IO, szip::Szip)
    print(io, Szip, "(")
    if szip.options_mask & API.H5_SZIP_EC_OPTION_MASK != 0
        print(io, "coding=:ec,")
    elseif szip.options_mask & API.H5_SZIP_NN_OPTION_MASK != 0
        print(io, "coding=:nn,")
    end
    print(io, "pixels_per_block=", Int(szip.pixels_per_block))
end

filterid(::Type{Szip}) = API.H5Z_FILTER_SZIP
FILTERS[API.H5Z_FILTER_SZIP] = Szip
function Base.push!(f::FilterPipeline, szip::Szip)
    API.h5p_set_szip(f.plist, szip.options_mask, szip.pixels_per_block)
    return f
end

"""
    NBit()

The N-Bit filter.

# External links
- $(h5doc("H5P_SET_NBIT"))
"""
struct NBit <: Filter end
filterid(::Type{NBit}) = API.H5Z_FILTER_NBIT
FILTERS[API.H5Z_FILTER_NBIT] = NBit
function Base.push!(f::FilterPipeline, ::NBit)
    API.h5p_set_nbit(f.plist)
    return f
end

"""
    ScaleOffset(scale_type::Integer, scale_offset::Integer)

The scale-offset filter.

# External links
- $(h5doc("H5P_SET_SCALEOFFSET"))
"""
struct ScaleOffset <: Filter
    scale_type::Cint
    scale_factor::Cint
end

filterid(::Type{ScaleOffset}) = API.H5Z_FILTER_SCALEOFFSET
FILTERS[API.H5Z_FILTER_SCALEOFFSET] = ScaleOffset
function Base.push!(f::FilterPipeline, scaleoffset::ScaleOffset)
    API.h5p_set_scaleoffset(f.plist, scaleoffset.scale_type, scaleoffset.scale_factor)
    return f
end

using HDF5
const PRINT_MEMORY = `ps -p $(getpid()) -o rss=`
const DATA = zeros(1000)
macro memtest(ex)
    @info :Memory
    quote
        for i in 1:100
            for _ in 1:100
                $ex
            end
            # HDF5.h5_garbage_collect()
            GC.gc()
            print(rpad(i, 8))
            run(PRINT_MEMORY)
        end
    end
end
@memtest h5open("/tmp/memtest.h5", "w") do file
    dset = create_dataset(file, "A", datatype(DATA), dataspace(DATA); chunk=(100,))
    dset[:] = DATA[:]
end
@memtest h5open("/tmp/memtest.h5", "w") do file
    file["A", chunk=(100,)] = DATA[:]
end
@memtest h5open("/tmp/memtest.h5", "r") do file
    file["A", "dxpl_mpio", 0]
end

# Generate ../src/api/functions.jl
# Run `julia --project=.. gen_wrappers.jl` to execute this script

const group_url_dict = Dict{String,String}([
    func_urls[1] => func_urls[2] for
    func_urls in split.(readlines("DoxygenTagParser/hdf5_group_urls.tsv"))
])
group_url_dict["H5FD"] = group_url_dict["VFL"]

include(joinpath(@__DIR__, "bind_generator.jl"))

# Read in the API definition macros from the definitions file
defs = read(joinpath(@__DIR__, "api_defs.jl"), String)
# Have Julia expand/run the @bind macro to generate expressions for all of the functions
exprs = Base.include_string(
    @__MODULE__, "@macroexpand1 begin\n" * defs * "\nend", "api_defs.jl"
)
# Insert the conditional version helper expression
prepend!(exprs.args, _libhdf5_build_ver_expr.args)
Base.remove_linenums!(exprs)

# Definitions which are not automatically generated, but should still be documented as
# part of the raw low-level API:
append!(bound_api["H5O"], [
    # defined in src/api/helpers.jl
    "h5o_get_info1",
])
append!(bound_api["H5P"], [
    # defined in src/api/helpers.jl
    "h5p_get_class_name",
    "h5p_get_fapl_mpio",
    "h5p_set_fapl_mpio",
])
append!(bound_api["H5T"], [
    # defined in src/api/helpers.jl
    "h5t_get_member_name",
    "h5t_get_tag",
])

# Now dump the text representation to disk
open(joinpath(@__DIR__, "..", "src", "api", "functions.jl"), "w") do fid
    println(
        fid,
        """
#! format: off
# This file is autogenerated by HDF5.jl's `gen/gen_wrappers.jl` and should not be editted.
#
# To add new bindings, define the binding in `gen/api_defs.jl`, re-run
# `gen/gen_wrappers.jl`, and commit the updated `src/api/functions.jl`.
"""
    )
    function triplequote(s::String, indent="", prefix="")
        ret = indent * prefix * "\"\"\"\n"
        for l in eachline(IOBuffer(s))
            ret *= isempty(l) ? "\n" : indent * l * "\n"
        end
        ret *= indent * "\"\"\"\n"
        return ret
    end
    ismacro(ex, sym, n=0) =
        isexpr(ex, :macrocall) && length(ex.args) >= n + 2 && ex.args[1] == sym
    for funcblock in exprs.args
        if ismacro(funcblock, Symbol("@doc"), 2)
            # Pretty print the doc macro as just a juxtaposed doc string and function
            # definition; the `@doc` construction is necessary in AST form for the docs
            # to be included in interactive use of `@bind`, but in source form we can
            # rely on Julia's parsing behavior.
            print(fid, triplequote(funcblock.args[3]), funcblock.args[4], "\n\n")
        elseif ismacro(funcblock, Symbol("@static"), 1) &&
            isexpr(funcblock.args[3], :if, 2) &&
            ismacro(funcblock.args[3].args[2], Symbol("@doc"), 2)
            # Within a @static block, we have to keep the @doc prefix, but we can still
            # switch to triple-quoting and there's special parsing to allow the function
            # definition to be on the next line.
            #
            # Work around the expression printer in this more complex case by printing
            # to a buffer and string-replacing a sentinel value
            docstr = funcblock.args[3].args[2].args[3]
            funcblock.args[3].args[2].args[3] = "SENTINEL_DOC"
            buf = sprint(print, funcblock)
            # Two-step deindent since `r"^\s{4}(\s{4})?"m => s"\1"` errors: see JuliaLang/julia#31456
            buf = replace(buf, r"^\s{4}"m => s"") # deindent
            buf = replace(buf, r"^(\s{4})\s{4}"m => s"\1") # deindent
            # Now format the doc string and replace (note need to indent `function`)
            buf = replace(
                buf,
                r"^\s+@doc \"SENTINEL_DOC\" "m =>
                    triplequote(docstr, " "^4, "@doc ") * " "^4
            )
            print(fid, buf, "\n\n")
        else
            # passthrough
            print(fid, funcblock, "\n\n")
        end
    end
    # Remove last endline
    truncate(fid, position(fid) - 1)
end

# Also generate auto-docs that simply list all of the bound API functions
apidocs = ""
for (mod, desc, urltail) in (
    ("H5", "General Library Functions", "Library"),
    ("H5A", "Attribute Interface", "Attributes"),
    ("H5D", "Dataset Interface", "Datasets"),
    ("H5E", "Error Interface", "Error+Handling"),
    ("H5F", "File Interface", "Files"),
    ("H5G", "Group Interface", "Groups"),
    ("H5I", "Identifier Interface", "Identifiers"),
    ("H5L", "Link Interface", "Links"),
    ("H5O", "Object Interface", "Objects"),
    ("H5PL", "Plugin Interface", "Plugins"),
    ("H5P", "Property Interface", "Property+Lists"),
    ("H5R", "Reference Interface", "References"),
    ("H5S", "Dataspace Interface", "Dataspaces"),
    ("H5T", "Datatype Interface", "Datatypes"),
    ("H5Z", "Filter Interface", "Filters"),
    ("H5FD", "File Drivers", "File+Drivers"),
    ("H5DO", "Optimized Functions Interface", "Optimizations"),
    ("H5DS", "Dimension Scale Interface", "Dimension+Scales"),
    ("H5LT", "Lite Interface", "Lite"),
    ("H5TB", "Table Interface", "Tables"),
)
    global apidocs
    funclist = sort!(bound_api[mod])
    index = join(["- [`$f`](@ref $f)" for f in funclist], "\n")
    funcs = join(funclist, "\n")
    apidocs *= """
        ---

        ## [[`$mod`]($(get(group_url_dict, mod, "https://docs.hdfgroup.org/hdf5/v1_14/"))) — $desc](@id $mod)
        $index
        ```@docs
        $funcs
        ```

        """
end

open(joinpath(@__DIR__, "..", "docs", "src", "api_bindings.md"), "w") do fid
    write(
        fid,
        """
        ```@raw html
        <!-- This file is auto-generated and should not be manually editted. To update, run the
        gen/gen_wrappers.jl script -->
        ```
        ```@meta
        CurrentModule = HDF5.API
        ```

        # Low-level library bindings

        At the lowest level, `HDF5.jl` operates by calling the public API of the HDF5 shared
        library through a set of `ccall` wrapper functions.
        This page documents the function names and nominal C argument types of the API which
        have bindings in this package.
        Note that in many cases, high-level data types are valid arguments through automatic
        `ccall` conversions.
        For instance, `HDF5.Datatype` objects will be automatically converted to their `hid_t` ID
        by Julia's `cconvert`+`unsafe_convert` `ccall` rules.

        There are additional helper wrappers (often for out-argument functions) which are not
        documented here.

        $apidocs
        """
    )
end

nothing

import .FileIO

function loadtodict!(d::AbstractDict, g::Union{File,Group}, prefix::String="")
    for k in keys(g)
        if (v = g[k]) isa Group
            loadtodict!(d, v, prefix * k * "/")
        else
            d[prefix * k] = read(g, k)
        end
    end
    return d
end

_infer_track_order(track_order::Union{Nothing,Bool}, dict::AbstractDict) =
    something(track_order, false)

@require OrderedCollections = "bac558e1-5e72-5ebc-8fee-abe8a469f55d" begin
    _infer_track_order(
        track_order::Union{Nothing,Bool}, dict::OrderedCollections.OrderedDict
    ) = something(track_order, true)
end

# load with just a filename returns a flat dictionary containing all the variables
function fileio_load(
    f::FileIO.File{FileIO.format"HDF5"};
    dict=Dict{String,Any}(),
    track_order::Union{Nothing,Bool}=nothing,
    kwargs...
)
    h5open(
        FileIO.filename(f),
        "r";
        track_order=_infer_track_order(track_order, dict),
        kwargs...
    ) do file
        loadtodict!(dict, file)
    end
end

# when called with explicitly requested variable names, return each one
function fileio_load(
    f::FileIO.File{FileIO.format"HDF5"}, varname::AbstractString; kwargs...
)
    h5open(FileIO.filename(f), "r"; kwargs...) do file
        read(file, varname)
    end
end

function fileio_load(
    f::FileIO.File{FileIO.format"HDF5"}, varnames::AbstractString...; kwargs...
)
    h5open(FileIO.filename(f), "r"; kwargs...) do file
        map(var -> read(file, var), varnames)
    end
end

# save all the key-value pairs in the dict as top-level variables
function fileio_save(
    f::FileIO.File{FileIO.format"HDF5"},
    dict::AbstractDict;
    track_order::Union{Nothing,Bool}=nothing,
    kwargs...
)
    h5open(
        FileIO.filename(f),
        "w";
        track_order=_infer_track_order(track_order, dict),
        kwargs...
    ) do file
        for (k, v) in dict
            isa(k, AbstractString) || throw(
                ArgumentError("keys must be strings (the names of variables), got $k")
            )
            write(file, String(k), v)
        end
    end
end

#!/bin/env julia
#
# Runs JuliaFormatter on the repository
# Invoke this script directly, `./contrib/format/format.jl`
# or via `julia --project=contrib/format contrib/format/format.jl`

# Install the project if not the current project environment
if Base.active_project() != joinpath(@__DIR__, "Project.toml")
    using Pkg
    Pkg.activate(@__DIR__)
    Pkg.resolve()
    Pkg.instantiate()
end

include("JuliaFormatterTool.jl")

using .JuliaFormatterTool

if abspath(PROGRAM_FILE) == @__FILE__
    if length(ARGS) == 0
        run_formatter_loop()
    else
        run_formatter_loop(ARGS[1])
    end
end

module DoxygenTagParser

using Downloads
using LightXML

export parse_tag_file, hdf5_func_url, save_to_tab_separated_values

struct HDF5FunctionInfo
    name::String
    anchorfile::String
    anchor::String
    arglist::String
end

struct HDF5GroupInfo
    name::String
    title::String
    filename::String
end

const DEFAULT_URL_PREFIX = "https://docs.hdfgroup.org/hdf5/v1_14/"
const HDF5_TAG_URL = "$(DEFAULT_URL_PREFIX)hdf5.tag"

"""
    parse_tag_file(url)

Parse a Doxygen tag file. This defaults to "$HDF5_TAG_URL".
"""
function parse_tag_file(hdf5_tag_url=HDF5_TAG_URL)
    filename = if startswith(hdf5_tag_url, "https://")
        Downloads.download(hdf5_tag_url, basename(hdf5_tag_url))
        basename(hdf5_tag_url)
    else
        hdf5_tag_url
    end
    funcdict = Dict{String,HDF5FunctionInfo}()
    groupdict = Dict{String,HDF5GroupInfo}()
    parsed = LightXML.parse_file(filename)
    tag_root = root(parsed)
    for compound_element in child_elements(tag_root)
        compound_kind = attribute(compound_element, "kind")
        if compound_kind == "class"
            # Java or C++ methods
            continue
        elseif compound_kind == "group" || compound_kind == "page"
            group_name = ""
            group_title = ""
            group_filename = ""
            for compound_child in child_elements(compound_element)
                if name(compound_child) == "member" &&
                    attribute(compound_child, "kind") == "function"
                    func_name = ""
                    func_anchorfile = ""
                    func_anchor = ""
                    func_arglist = ""
                    for func_child in child_elements(compound_child)
                        func_child_name = name(func_child)
                        if func_child_name == "name"
                            func_name = content(func_child)
                        elseif func_child_name == "anchorfile"
                            func_anchorfile = content(func_child)
                        elseif func_child_name == "anchor"
                            func_anchor = content(func_child)
                        elseif func_child_name == "arglist"
                            func_arglist = content(func_child)
                        end
                    end
                    if func_name == "H5Pget_chunk"
                        println(compound_element)
                    end
                    funcdict[func_name] = HDF5FunctionInfo(
                        func_name, func_anchorfile, func_anchor, func_arglist
                    )
                elseif name(compound_child) == "name"
                    group_name = content(compound_child)
                elseif name(compound_child) == "title"
                    group_title = content(compound_child)
                    if startswith(group_title, "Java")
                        break
                    end
                elseif name(compound_child) == "filename"
                    group_filename = content(compound_child)
                end
            end
            if startswith(group_title, "Java")
                continue
            end
            groupdict[group_name] = HDF5GroupInfo(group_name, group_title, group_filename)
        end
    end
    return funcdict, groupdict
end

"""
    hdf5_func_url

Build the documentation URL from the anchorfile and anchor.
"""
function hdf5_func_url(info::HDF5FunctionInfo; prefix=DEFAULT_URL_PREFIX)
    return prefix * info.anchorfile * "#" * info.anchor
end

function hdf5_group_url(info::HDF5GroupInfo; prefix="https://docs.hdfgroup.org/hdf5/v1_14/")
    return prefix * info.filename
end

"""
    save_to_tab_separated_values

Save the function names and documentation URLs to a file, separated by a time, with one function per line.
"""
function save_to_tab_separated_values(
    func_filename::AbstractString="hdf5_func_urls.tsv",
    group_filename::AbstractString="hdf5_group_urls.tsv",
    info::Tuple{Dict{String,HDF5FunctionInfo},Dict{String,HDF5GroupInfo}}=parse_tag_file()
)
    funcinfo, groupinfo = info
    open(func_filename, "w") do f
        sorted_funcs = sort!(collect(keys(funcinfo)))
        for func in sorted_funcs
            println(f, func, "\t", hdf5_func_url(funcinfo[func]))
        end
    end
    open(group_filename, "w") do f
        sorted_groups = sort!(collect(keys(groupinfo)))
        for group in sorted_groups
            println(f, group, "\t", hdf5_group_url(groupinfo[group]))
        end
    end
end

function __init__()
    if abspath(PROGRAM_FILE) == @__FILE__()
        main()
    end
end

"""
    main()

Executed when `julia --project=. src/DoxygenTagParser` is run from the shell.
"""
function main()
    nargs = length(ARGS)
    tsv_file = nargs > 0 ? ARGS[1] : "hdf5_func_urls.tsv"
    group_file = nargs > 1 ? ARGS[2] : "hdf5_group_urls.tsv"
    tag_file = nargs > 2 ? ARGS[3] : HDF5_TAG_URL
    info = parse_tag_file(tag_file)
    save_to_tab_separated_values(tsv_file, group_file, info)
end

end

using HDF5
using CRC32c
using H5Zblosc
using Test

gatherf(dst_buf, dst_buf_bytes_used, op_data) = HDF5.API.herr_t(0)
gatherf_bad(dst_buf, dst_buf_bytes_used, op_data) = HDF5.API.herr_t(-1)
gatherf_data(dst_buf, dst_buf_bytes_used, op_data) = HDF5.API.herr_t((op_data == 9) - 1)

function scatterf(src_buf, src_buf_bytes_used, op_data)
    A = [1, 2, 3, 4]
    unsafe_store!(src_buf, pointer(A))
    unsafe_store!(src_buf_bytes_used, sizeof(A))
    return HDF5.API.herr_t(0)
end
scatterf_bad(src_buf, src_buf_bytes_used, op_data) = HDF5.API.herr_t(-1)
function scatterf_data(src_buf, src_buf_bytes_used, op_data)
    A = [1, 2, 3, 4]
    unsafe_store!(src_buf, pointer(A))
    unsafe_store!(src_buf_bytes_used, sizeof(A))
    return HDF5.API.herr_t((op_data == 9) - 1)
end

@testset "plain" begin

    # Create a new file
    fn = tempname()
    f = h5open(fn, "w")
    @test isopen(f)
    # Write scalars
    f["Float64"] = 3.2
    f["Int16"] = Int16(4)
    # compression of empty array (issue #246)
    f["compressedempty", shuffle=true, deflate=4] = Int64[]
    # compression of zero-dimensional array (pull request #445)
    f["compressed_zerodim", shuffle=true, deflate=4] = fill(Int32(42), ())
    f["bloscempty", blosc=4] = Int64[]
    # test creation of an anonymouse dataset
    f[nothing] = 5
    # Create arrays of different types
    A = randn(3, 5)
    write(f, "Afloat64", convert(Matrix{Float64}, A))
    write(f, "Afloat32", convert(Matrix{Float32}, A))
    Ai = rand(1:20, 2, 4)
    write(f, "Aint8", convert(Matrix{Int8}, Ai))
    f["Aint16"] = convert(Matrix{Int16}, Ai)
    write(f, "Aint32", convert(Matrix{Int32}, Ai))
    write(f, "Aint64", convert(Matrix{Int64}, Ai))
    write(f, "Auint8", convert(Matrix{UInt8}, Ai))
    write(f, "Auint16", convert(Matrix{UInt16}, Ai))

    # test writing multiple variable (issue #599)
    write(f, "Auint32", convert(Matrix{UInt32}, Ai), "Auint64", convert(Matrix{UInt64}, Ai))

    # Arrays of bools (pull request #540)
    Abool = [false, true, false]
    write(f, "Abool", Abool)

    salut = "Hi there"
    ucode = "uniçº∂e"
    write(f, "salut", salut)
    write(f, "ucode", ucode)
    # Manually write a variable-length string (issue #187)
    let
        dtype = HDF5.Datatype(HDF5.API.h5t_copy(HDF5.API.H5T_C_S1))
        HDF5.API.h5t_set_size(dtype, HDF5.API.H5T_VARIABLE)
        HDF5.API.h5t_set_cset(dtype, HDF5.cset(typeof(salut)))
        dspace = dataspace(salut)
        dset = create_dataset(f, "salut-vlen", dtype, dspace)
        GC.@preserve salut begin
            HDF5.API.h5d_write(
                dset,
                dtype,
                HDF5.API.H5S_ALL,
                HDF5.API.H5S_ALL,
                HDF5.API.H5P_DEFAULT,
                [pointer(salut)]
            )
        end
    end
    # Arrays of strings
    salut_split = ["Hi", "there"]
    write(f, "salut_split", salut_split)
    salut_2d = ["Hi" "there"; "Salut" "friend"]
    write(f, "salut_2d", salut_2d)
    # Arrays of strings as vlen
    vlen = HDF5.VLen(salut_split)
    write_dataset(f, "salut_vlen", vlen)
    # Arrays of scalars as vlen
    vlen_int = [[3], [1], [4]]
    vleni = HDF5.VLen(vlen_int)
    write_dataset(f, "int_vlen", vleni)
    write_attribute(f["int_vlen"], "vlen_attr", vleni)
    # Empty arrays
    empty = UInt32[]
    write(f, "empty", empty)
    write(f, nothing, empty)
    # Empty strings
    empty_string = ""
    write(f, "empty_string", empty_string)
    # Empty array of strings
    empty_string_array = String[]
    write(f, "empty_string_array", empty_string_array)
    # Array of empty string
    empty_array_of_strings = [""]
    write(f, "empty_array_of_strings", empty_array_of_strings)
    # attributes
    species = [["N", "C"]; ["A", "B"]]
    attributes(f)["species"] = species
    @test read(attributes(f)["species"]) == species
    @test attributes(f)["species"][] == species
    C∞ = 42
    attributes(f)["C∞"] = C∞
    dset = f["salut"]
    @test !isempty(dset)
    label = "This is a string"
    attributes(dset)["typeinfo"] = label
    @test read(attributes(dset)["typeinfo"]) == label
    @test attributes(dset)["typeinfo"][] == label
    @test dset["typeinfo"][] == label
    close(dset)
    # Scalar reference values in attributes
    attributes(f)["ref_test"] = HDF5.Reference(f, "empty_array_of_strings")
    @test read(attributes(f)["ref_test"]) === HDF5.Reference(f, "empty_array_of_strings")
    # Group
    g = create_group(f, "mygroup")
    # Test dataset with compression
    R = rand(1:20, 20, 40)
    g["CompressedA", chunk=(5, 6), shuffle=true, deflate=9] = R
    g["BloscA", chunk=(5, 6), shuffle=true, blosc=9] = R
    close(g)
    # Copy group containing dataset
    copy_object(f, "mygroup", f, "mygroup2")
    # Copy dataset
    g = create_group(f, "mygroup3")
    copy_object(f["mygroup/CompressedA"], g, "CompressedA")
    copy_object(f["mygroup/BloscA"], g, "BloscA")
    close(g)
    # Writing hyperslabs
    dset = create_dataset(
        f, "slab", datatype(Float64), dataspace(20, 20, 5); chunk=(5, 5, 1)
    )
    Xslab = randn(20, 20, 5)
    for i in 1:5
        dset[:, :, i] = Xslab[:, :, i]
    end
    dset = create_dataset(
        f, nothing, datatype(Float64), dataspace(20, 20, 5); chunk=(5, 5, 1)
    )
    dset[:, :, :] = 3.0
    # More complex hyperslab and assignment with "incorrect" types (issue #34)
    d = create_dataset(f, "slab2", datatype(Float64), ((10, 20), (100, 200)); chunk=(1, 1))
    d[:, :] = 5
    d[1, 1] = 4
    # 1d indexing
    d = create_dataset(f, "slab3", datatype(Int), ((10,), (-1,)); chunk=(5,))
    @test d[:] == zeros(Int, 10)
    d[3:5] = 3:5
    # Create a dataset designed to be deleted
    f["deleteme"] = 17.2
    close(f)
    @test !isopen(f)
    # Test the h5read/write interface, with attributes
    W = copy(reshape(1:120, 15, 8))
    Wa = Dict("a" => 1, "b" => 2)
    h5write(fn, "newgroup/W", W)
    h5writeattr(fn, "newgroup/W", Wa)

    # Read the file back in
    fr = h5open(fn)
    x = read(fr, "Float64")
    @test x == 3.2 && isa(x, Float64)
    y = read(fr, "Int16")
    @test y == 4 && isa(y, Int16)
    zerodim = read(fr, "compressed_zerodim")
    @test zerodim == 42 && isa(zerodim, Int32)
    bloscempty = read(fr, "bloscempty")
    @test bloscempty == Int64[] && isa(bloscempty, Vector{Int64})
    Af32 = read(fr, "Afloat32")
    @test convert(Matrix{Float32}, A) == Af32
    @test eltype(Af32) == Float32
    Af64 = read(fr, "Afloat64")
    @test convert(Matrix{Float64}, A) == Af64
    @test eltype(Af64) == Float64
    @test eltype(fr["Afloat64"]) == Float64  # issue 167
    Ai8 = read(fr, "Aint8")
    @test Ai == Ai8
    @test eltype(Ai8) == Int8
    Ai16 = read(fr, "Aint16")
    @test Ai == Ai16
    @test eltype(Ai16) == Int16
    Ai32 = read(fr, "Aint32")
    @test Ai == Ai32
    @test eltype(Ai32) == Int32
    Ai64 = read(fr, "Aint64")
    @test Ai == Ai64
    @test eltype(Ai64) == Int64
    Ai8 = read(fr, "Auint8")
    @test Ai == Ai8
    @test eltype(Ai8) == UInt8
    Ai16 = read(fr, "Auint16")
    @test Ai == Ai16
    @test eltype(Ai16) == UInt16
    Ai32 = read(fr, "Auint32")
    @test Ai == Ai32
    @test eltype(Ai32) == UInt32
    Ai64 = read(fr, "Auint64")
    @test Ai == Ai64
    @test eltype(Ai64) == UInt64

    Abool_read = read(fr, "Abool")
    @test Abool_read == Abool
    @test eltype(Abool_read) == Bool

    salutr = read(fr, "salut")
    @test salut == salutr
    salutr = read(fr, "salut-vlen")
    @test salut == salutr
    ucoder = read(fr, "ucode")
    @test ucode == ucoder
    salut_splitr = read(fr, "salut_split")
    @test salut_splitr == salut_split
    salut_2dr = read(fr, "salut_2d")
    @test salut_2d == salut_2dr
    salut_vlenr = read(fr, "salut_vlen")
    @test HDF5.vlen_get_buf_size(fr["salut_vlen"]) == 7
    @test HDF5.API.h5d_get_access_plist(fr["salut-vlen"]) != 0
    #@test salut_vlenr == salut_split
    vlen_intr = read(fr, "int_vlen")
    @test vlen_intr == vlen_int
    vlen_attrr = read(fr["int_vlen"]["vlen_attr"])
    @test vlen_attrr == vlen_int
    Rr = read(fr, "mygroup/CompressedA")
    @test Rr == R
    Rr2 = read(fr, "mygroup2/CompressedA")
    @test Rr2 == R
    Rr3 = read(fr, "mygroup3/CompressedA")
    @test Rr3 == R
    Rr4 = read(fr, "mygroup/BloscA")
    @test Rr4 == R
    Rr5 = read(fr, "mygroup2/BloscA")
    @test Rr5 == R
    Rr6 = read(fr, "mygroup3/BloscA")
    @test Rr6 == R
    dset = fr["mygroup/CompressedA"]
    @test HDF5.get_chunk(dset) == (5, 6)
    @test HDF5.name(dset) == "/mygroup/CompressedA"
    dset2 = fr["mygroup/BloscA"]
    @test HDF5.get_chunk(dset2) == (5, 6)
    @test HDF5.name(dset2) == "/mygroup/BloscA"
    Xslabr = read(fr, "slab")
    @test Xslabr == Xslab
    Xslabr = h5read(fn, "slab", (:, :, :))  # issue #87
    @test Xslabr == Xslab
    Xslab2r = read(fr, "slab2")
    target = fill(5, 10, 20)
    target[1] = 4
    @test Xslab2r == target
    dset = fr["slab3"]
    @test dset[3:5] == [3:5;]
    emptyr = read(fr, "empty")
    @test isempty(emptyr)
    empty_stringr = read(fr, "empty_string")
    @test empty_stringr == empty_string
    empty_string_arrayr = read(fr, "empty_string_array")
    @test empty_string_arrayr == empty_string_array
    empty_array_of_stringsr = read(fr, "empty_array_of_strings")
    @test empty_array_of_stringsr == empty_array_of_strings
    @test read_attribute(fr, "species") == species
    @test read_attribute(fr, "C∞") == C∞
    dset = fr["salut"]
    @test read_attribute(dset, "typeinfo") == label
    close(dset)
    # Test ref-based reading
    Aref = fr["Afloat64"]
    sel = (2:3, 1:2:5)
    Asub = Aref[sel...]
    @test Asub == A[sel...]
    close(Aref)
    # Test iteration, name, and parent
    for obj in fr
        @test HDF5.filename(obj) == fn
        n = HDF5.name(obj)
        p = parent(obj)
    end
    # Test reading multiple vars at once
    z = read(fr, "Float64", "Int16")
    @test z == (3.2, 4)
    @test typeof(z) == Tuple{Float64,Int16}
    # Test reading entire file at once
    z = read(fr)
    @test z["Float64"] == 3.2
    close(fr)

    # Test object deletion
    fr = h5open(fn, "r+")
    @test haskey(fr, "deleteme")
    delete_object(fr, "deleteme")
    @test !haskey(fr, "deleteme")
    close(fr)

    # Test object move
    h5open(fn, "r+") do io
        io["moveme"] = [1, 2, 3]
        create_group(io, "moveto")
    end

    h5open(fn, "r+") do io
        @test haskey(io, "moveme")
        @test haskey(io, "moveto") && !haskey(io, "moveto/moveme")
        move_link(io, "moveme", io["moveto"])
        @test haskey(io, "moveto/moveme") && !haskey(io, "moveme")
    end

    # Test the h5read interface
    Wr = h5read(fn, "newgroup/W")
    @test Wr == W
    rng = (2:3:15, 3:5)
    Wr = h5read(fn, "newgroup/W", rng)
    @test Wr == W[rng...]
    War = h5readattr(fn, "newgroup/W")
    @test War == Wa

    # issue #618
    # Test that invalid writes treat implicit creation as a transaction, cleaning up the partial
    # operation
    hid = h5open(fn, "w")
    A = rand(3, 3)'
    @test !haskey(hid, "A")
    @test_throws ArgumentError write(hid, "A", A)
    @test !haskey(hid, "A")
    dset = create_dataset(hid, "attr", datatype(Int), dataspace(0))
    @test !haskey(attributes(dset), "attr")
    # broken test - writing attributes does not check that the stride is correct
    @test_skip @test_throws ArgumentError write(dset, "attr", A)
    @test !haskey(attributes(dset), "attr")
    close(hid)

    # more do syntax
    h5open(fn, "w") do fid
        g = create_group(fid, "mygroup")
        write(g, "x", 3.2)
    end

    fid = h5open(fn, "r")
    @test keys(fid) == ["mygroup"]
    g = fid["mygroup"]
    @test keys(g) == ["x"]
    close(g)
    close(fid)
    rm(fn)

    # more do syntax: atomic rename version
    tmpdir = mktempdir()
    outfile = joinpath(tmpdir, "test.h5")

    # create a new file
    h5rewrite(outfile) do fid
        g = create_group(fid, "mygroup")
        write(g, "x", 3.3)
    end
    @test length(readdir(tmpdir)) == 1
    h5open(outfile, "r") do fid
        @test keys(fid) == ["mygroup"]
        @test keys(fid["mygroup"]) == ["x"]
    end

    # fail to overwrite
    @test_throws ErrorException h5rewrite(outfile) do fid
        g = create_group(fid, "mygroup")
        write(g, "oops", 3.3)
        error("failed")
    end
    @test length(readdir(tmpdir)) == 1
    h5open(outfile, "r") do fid
        @test keys(fid) == ["mygroup"]
        @test keys(fid["mygroup"]) == ["x"]
    end

    # overwrite
    h5rewrite(outfile) do fid
        g = create_group(fid, "mygroup")
        write(g, "y", 3.3)
    end
    @test length(readdir(tmpdir)) == 1
    h5open(outfile, "r") do fid
        @test keys(fid) == ["mygroup"]
        @test keys(fid["mygroup"]) == ["y"]
    end
    rm(tmpdir; recursive=true)

    test_files = joinpath(@__DIR__, "test_files")

    d = h5read(joinpath(test_files, "compound.h5"), "/data")
    @test typeof(d[1]) == NamedTuple{
        (:wgt, :xyz, :uvw, :E),Tuple{Float64,Array{Float64,1},Array{Float64,1},Float64}
    }

    # get-datasets
    fn = tempname()
    fd = h5open(fn, "w")
    fd["level_0"] = [1, 2, 3]
    grp = create_group(fd, "mygroup")
    fd["mygroup/level_1"] = [4, 5]
    grp2 = create_group(grp, "deep_group")
    fd["mygroup/deep_group/level_2"] = [6.0, 7.0]
    datasets = HDF5.get_datasets(fd)
    @test sort(map(HDF5.name, datasets)) ==
        sort(["/level_0", "/mygroup/deep_group/level_2", "/mygroup/level_1"])
    close(fd)
    rm(fn)

    # File creation and access property lists
    fid = h5open(
        fn,
        "w";
        userblock=1024,
        libver_bounds=(HDF5.API.H5F_LIBVER_EARLIEST, HDF5.API.H5F_LIBVER_LATEST)
    )
    write(fid, "intarray", [1, 2, 3])
    close(fid)
    h5open(
        fn, "r"; libver_bounds=(HDF5.API.H5F_LIBVER_EARLIEST, HDF5.API.H5F_LIBVER_LATEST)
    ) do fid
        intarray = read(fid, "intarray")
        @test intarray == [1, 2, 3]
    end

    # Test null terminated ASCII string (e.g. exported by h5py) #332
    h5open(joinpath(test_files, "nullterm_ascii.h5"), "r") do fid
        str = read(fid["test"])
        @test str == "Hello World"
    end

    @test HDF5.unpad(UInt8[0x43, 0x43, 0x41], 1) == "CCA"

    # Test the h5read/write interface with a filename as a first argument, when
    # the file does not exist
    rm(fn)
    h5write(fn, "newgroup/W", W)
    Wr = h5read(fn, "newgroup/W")
    @test Wr == W
    close(f)
    rm(fn)

    # Test dataspace convenience versions of create_dataset
    try
        h5open(fn, "w") do f
            create_dataset(f, "test", Int, (128, 32))
            create_dataset(f, "test2", Float64, 128, 64)
            @test size(f["test"]) == (128, 32)
            @test size(f["test2"]) == (128, 64)
        end
    finally
        rm(fn)
    end

    @testset "h5d_fill" begin
        val = 5
        h5open(fn, "w") do f
            d = create_dataset(f, "dataset", datatype(Int), dataspace(6, 6); chunk=(2, 3))
            buf = Array{Int,2}(undef, (6, 6))
            dtype = datatype(Int)
            HDF5.API.h5d_fill(Ref(val), dtype, buf, datatype(Int), dataspace(d))
            @test all(buf .== 5)
            HDF5.API.h5d_write(
                d, dtype, HDF5.API.H5S_ALL, HDF5.API.H5S_ALL, HDF5.API.H5P_DEFAULT, buf
            )
        end
        h5open(fn, "r") do f
            @test all(f["dataset"][:, :] .== 5)
        end
        rm(fn)
    end # testset "Test h5d_fill

    @testset "h5d_gather" begin
        src_buf = rand(Int, (4, 4))
        dst_buf = Array{Int,2}(undef, (4, 4))
        h5open(fn, "w") do f
            d = create_dataset(f, "dataset", datatype(Int), dataspace(4, 4); chunk=(2, 2))
            @test isnothing(
                HDF5.API.h5d_gather(
                    dataspace(d),
                    src_buf,
                    datatype(Int),
                    sizeof(dst_buf),
                    dst_buf,
                    C_NULL,
                    C_NULL
                )
            )
            @test src_buf == dst_buf
            gatherf_ptr = @cfunction(
                gatherf, HDF5.API.herr_t, (Ptr{Nothing}, Csize_t, Ptr{Nothing})
            )
            @test isnothing(
                HDF5.API.h5d_gather(
                    dataspace(d),
                    src_buf,
                    datatype(Int),
                    sizeof(dst_buf) ÷ 2,
                    dst_buf,
                    gatherf_ptr,
                    C_NULL
                )
            )
            gatherf_bad_ptr = @cfunction(
                gatherf_bad, HDF5.API.herr_t, (Ptr{Nothing}, Csize_t, Ptr{Nothing})
            )
            @test_throws HDF5.API.H5Error HDF5.API.h5d_gather(
                dataspace(d),
                src_buf,
                datatype(Int),
                sizeof(dst_buf) ÷ 2,
                dst_buf,
                gatherf_bad_ptr,
                C_NULL
            )
            gatherf_data_ptr = @cfunction(
                gatherf_data, HDF5.API.herr_t, (Ptr{Nothing}, Csize_t, Ref{Int})
            )
            @test isnothing(
                HDF5.API.h5d_gather(
                    dataspace(d),
                    src_buf,
                    datatype(Int),
                    sizeof(dst_buf) ÷ 2,
                    dst_buf,
                    gatherf_data_ptr,
                    Ref(9)
                )
            )
            @test_throws HDF5.API.H5Error HDF5.API.h5d_gather(
                dataspace(d),
                src_buf,
                datatype(Int),
                sizeof(dst_buf) ÷ 2,
                dst_buf,
                gatherf_data_ptr,
                10
            )
        end
        rm(fn)
    end

    @testset "h5d_scatter" begin
        h5open(fn, "w") do f
            dst_buf = Array{Int,2}(undef, (4, 4))
            d = create_dataset(f, "dataset", datatype(Int), dataspace(4, 4); chunk=(2, 2))
            scatterf_ptr = @cfunction(
                scatterf, HDF5.API.herr_t, (Ptr{Ptr{Nothing}}, Ptr{Csize_t}, Ptr{Nothing})
            )
            @test isnothing(
                HDF5.API.h5d_scatter(
                    scatterf_ptr, C_NULL, datatype(Int), dataspace(d), dst_buf
                )
            )
            scatterf_bad_ptr = @cfunction(
                scatterf_bad,
                HDF5.API.herr_t,
                (Ptr{Ptr{Nothing}}, Ptr{Csize_t}, Ptr{Nothing})
            )
            @test_throws HDF5.API.H5Error HDF5.API.h5d_scatter(
                scatterf_bad_ptr, C_NULL, datatype(Int), dataspace(d), dst_buf
            )
            scatterf_data_ptr = @cfunction(
                scatterf_data, HDF5.API.herr_t, (Ptr{Ptr{Int}}, Ptr{Csize_t}, Ref{Int})
            )
            @test isnothing(
                HDF5.API.h5d_scatter(
                    scatterf_data_ptr, Ref(9), datatype(Int), dataspace(d), dst_buf
                )
            )
        end
        rm(fn)
    end

    # Test that switching time tracking off results in identical files
    fn1 = tempname()
    fn2 = tempname()
    h5open(fn1, "w") do f
        f["x", obj_track_times=false] = [1, 2, 3]
    end
    sleep(1)
    h5open(fn2, "w") do f
        f["x", obj_track_times=false] = [1, 2, 3]
    end
    if HDF5.API.h5_get_libversion() < v"2.0.0"
        @test open(crc32c, fn1) == open(crc32c, fn2)
    else
        # @eschnett 2025-11-26: The generated files differ in the 4
        # bytes starting at offset 0x36. In the case I examined these
        # values were 0x69272bef and 0x69272bf0 for the first and
        # second file, respectively, and these are clearly time stamps
        # for the OHDR header.
        @test_broken open(crc32c, fn1) == open(crc32c, fn2)
    end
    rm(fn1)
    rm(fn2)
end # testset plain

@testset "complex" begin
    HDF5.enable_complex_support()

    fn = tempname()
    f = h5open(fn, "w")

    f["ComplexF64"] = 1.0 + 2.0im
    attributes(f["ComplexF64"])["ComplexInt64"] = 1im

    Acmplx = rand(ComplexF64, 3, 5)
    write(f, "Acmplx64", convert(Matrix{ComplexF64}, Acmplx))
    write(f, "Acmplx32", convert(Matrix{ComplexF32}, Acmplx))

    dset = create_dataset(
        f, "Acmplx64_hyperslab", datatype(Complex{Float64}), dataspace(Acmplx)
    )
    for i in 1:size(Acmplx, 2)
        dset[:, i] = Acmplx[:, i]
    end

    HDF5.disable_complex_support()
    @test_throws ErrorException f["_ComplexF64"] = 1.0 + 2.0im
    @test_throws ErrorException write(f, "_Acmplx64", convert(Matrix{ComplexF64}, Acmplx))
    @test_throws ErrorException write(f, "_Acmplx32", convert(Matrix{ComplexF32}, Acmplx))
    HDF5.enable_complex_support()

    close(f)

    fr = h5open(fn)
    z = read(fr, "ComplexF64")
    @test z == 1.0 + 2.0im && isa(z, ComplexF64)
    z_attrs = attributes(fr["ComplexF64"])
    @test read(z_attrs["ComplexInt64"]) == 1im

    Acmplx32 = read(fr, "Acmplx32")
    @test convert(Matrix{ComplexF32}, Acmplx) == Acmplx32
    @test eltype(Acmplx32) == ComplexF32
    Acmplx64 = read(fr, "Acmplx64")
    @test convert(Matrix{ComplexF64}, Acmplx) == Acmplx64
    @test eltype(Acmplx64) == ComplexF64

    dset = fr["Acmplx64_hyperslab"]
    Acmplx64_hyperslab = zeros(eltype(dset), size(dset))
    for i in 1:size(dset, 2)
        Acmplx64_hyperslab[:, i] = dset[:, i]
    end
    @test convert(Matrix{ComplexF64}, Acmplx) == Acmplx64_hyperslab

    HDF5.disable_complex_support()
    z = read(fr, "ComplexF64")
    @test isa(z, NamedTuple{(:r, :i),Tuple{Float64,Float64}})

    Acmplx32 = read(fr, "Acmplx32")
    @test eltype(Acmplx32) == NamedTuple{(:r, :i),Tuple{Float32,Float32}}
    Acmplx64 = read(fr, "Acmplx64")
    @test eltype(Acmplx64) == NamedTuple{(:r, :i),Tuple{Float64,Float64}}

    close(fr)

    HDF5.enable_complex_support()
end

# test strings with null and undefined references
@testset "undefined and null" begin
    fn = tempname()
    f = h5open(fn, "w")

    # don't silently truncate data
    @test_throws ArgumentError write(f, "test", ["hello", "there", "\0"])
    @test_throws ArgumentError write(f, "trunc1", "\0")
    @test_throws ArgumentError write(f, "trunc2", "trunc\0ateme")

    # test writing uninitialized string arrays
    undefstrarr = similar(Vector(1:3), String) # strs = String[#undef, #undef, #undef]
    @test_throws UndefRefError write(f, "undef", undefstrarr)

    close(f)
    rm(fn)
end # testset null and undefined

# test writing abstract arrays
@testset "abstract arrays" begin

    # test writing reinterpreted data
    fn = tempname()
    try
        h5open(fn, "w") do f
            data = reinterpret(UInt8, [true, false, false])
            write(f, "reinterpret array", data)
        end

        @test h5open(fn, "r") do f
            read(f, "reinterpret array")
        end == UInt8[0x01, 0x00, 0x00]
    finally
        rm(fn)
    end

    # don't silently fail for arrays with a different stride
    fn = tempname()
    try
        data = rand(UInt16, 2, 3)
        pdv_data = PermutedDimsArray(data, (2, 1))

        @test_throws ArgumentError h5write(fn, "pdv_data", pdv_data)
    finally
        rm(fn)
    end

    # test alignment
    fn = tempname()
    h5open(fn, "w"; alignment=(0, 8)) do fid
        fid["x"] = zeros(10, 10)
    end
end # writing abstract arrays

# issue #705
@testset "empty and 0-size arrays" begin
    fn = tempname()
    hfile = h5open(fn, "w")

    # Write datasets with various 0-sizes
    write(hfile, "empty", HDF5.EmptyArray{Int64}()) # HDF5 empty
    write(hfile, "zerodim", fill(1.0π))   # 0-dimensional
    write(hfile, "zerovec", zeros(0))     # 1-dimensional, size 0
    write(hfile, "zeromat", zeros(0, 0))  # 2-dimensional, size 0
    write(hfile, "zeromat2", zeros(0, 1)) # 2-dimensional, size 0 with non-zero axis
    dempty = hfile["empty"]
    dzerodim = hfile["zerodim"]
    dzerovec = hfile["zerovec"]
    dzeromat = hfile["zeromat"]
    dzeromat2 = hfile["zeromat2"]

    # Test that eltype is preserved (especially for EmptyArray)
    @test eltype(dempty) == Int64
    @test eltype(dzerodim) == Float64
    @test eltype(dzerovec) == Float64
    @test eltype(dzeromat) == Float64
    @test eltype(dzeromat2) == Float64
    # Test sizes are as expected
    @test size(dempty) == ()
    @test size(dzerovec) == (0,)
    @test size(dzeromat) == (0, 0)
    @test size(dzeromat2) == (0, 1)
    @test HDF5.isnull(dempty)
    @test !HDF5.isnull(dzerovec)
    @test !HDF5.isnull(dzeromat)
    @test !HDF5.isnull(dzeromat2)
    # Reading back must preserve emptiness
    @test read(dempty) isa HDF5.EmptyArray
    # but 0-dimensional Array{T,0} are stored as HDF5 scalar
    @test size(dzerodim) == ()
    @test !HDF5.isnull(dzerodim)
    @test read(dzerodim) == 1.0π

    # Similar tests for writing to attributes
    write(dempty, "attr", HDF5.EmptyArray{Float64}())
    write(dzerodim, "attr", fill(1.0ℯ))
    write(dzerovec, "attr", zeros(Int64, 0))
    write(dzeromat, "attr", zeros(Int64, 0, 0))
    write(dzeromat2, "attr", zeros(Int64, 0, 1))
    aempty = dempty["attr"]
    azerodim = dzerodim["attr"]
    azerovec = dzerovec["attr"]
    azeromat = dzeromat["attr"]
    azeromat2 = dzeromat2["attr"]
    # Test that eltype is preserved (especially for EmptyArray)
    @test eltype(aempty) == Float64
    @test eltype(azerodim) == Float64
    @test eltype(azerovec) == Int64
    @test eltype(azeromat) == Int64
    @test eltype(azeromat2) == Int64
    # Test sizes are as expected
    @test size(aempty) == ()
    @test size(azerovec) == (0,)
    @test size(azeromat) == (0, 0)
    @test size(azeromat2) == (0, 1)
    @test HDF5.isnull(aempty)
    @test !HDF5.isnull(azerovec)
    @test !HDF5.isnull(azeromat)
    @test !HDF5.isnull(azeromat2)
    # Reading back must preserve emptiness
    @test read(aempty) isa HDF5.EmptyArray
    # but 0-dimensional Array{T,0} are stored as HDF5 scalar
    @test size(azerodim) == ()
    @test !HDF5.isnull(azerodim)
    @test read(azerodim) == 1.0ℯ

    # Concatenation of EmptyArrays is not supported
    x = HDF5.EmptyArray{Float64}()
    @test_throws ErrorException [x x]
    @test_throws ErrorException [x; x]
    @test_throws ErrorException [x x; x x]

    close(hfile)
    rm(fn)

    # check that printing EmptyArray doesn't error
    buf = IOBuffer()
    show(buf, HDF5.EmptyArray{Int64}())
    @test String(take!(buf)) == "HDF5.EmptyArray{Int64}()"
    show(buf, MIME"text/plain"(), HDF5.EmptyArray{Int64}())
    @test String(take!(buf)) == "HDF5.EmptyArray{Int64}()"
end # empty and 0-size arrays

@testset "generic read of native types" begin
    fn = tempname()
    hfile = h5open(fn, "w")

    dtype_varstring = HDF5.Datatype(HDF5.API.h5t_copy(HDF5.API.H5T_C_S1))
    HDF5.API.h5t_set_size(dtype_varstring, HDF5.API.H5T_VARIABLE)

    write(hfile, "uint8_array", UInt8[(1:8)...])
    write(hfile, "bool_scalar", true)

    fixstring = "fix"
    varstring = "var"
    write(hfile, "fixed_string", fixstring)
    vardset = create_dataset(
        hfile, "variable_string", dtype_varstring, dataspace(varstring)
    )
    GC.@preserve varstring begin
        HDF5.API.h5d_write(
            vardset,
            dtype_varstring,
            HDF5.API.H5S_ALL,
            HDF5.API.H5S_ALL,
            HDF5.API.H5P_DEFAULT,
            [pointer(varstring)]
        )
    end
    flush(hfile)
    close(dtype_varstring)

    # generic read() handles concrete types with definite sizes transparently
    d = read(hfile["uint8_array"], UInt8)
    @test d isa Vector{UInt8}
    @test d == 1:8
    d = read(hfile["bool_scalar"], Bool)
    @test d isa Bool
    @test d == true
    d = read(hfile["fixed_string"], HDF5.FixedString{length(fixstring),0})
    @test d isa String
    @test d == fixstring
    d = read(hfile["variable_string"], Cstring)
    @test d isa String
    @test d == varstring
    # will also accept memory-compatible reinterpretations
    d = read(hfile["uint8_array"], Int8)
    @test d isa Vector{Int8}
    @test d == 1:8
    d = read(hfile["bool_scalar"], UInt8)
    @test d isa UInt8
    @test d == 0x1
    # but should throw on non-compatible types
    @test_throws ErrorException("""
                                Type size mismatch
                                sizeof(UInt16) = 2
                                sizeof($(sprint(show, datatype(UInt8)))) = 1
                                """) read(hfile["uint8_array"], UInt16)

    # Strings are not fixed size, but generic read still handles them if given the correct
    # underlying FixedString or Cstring type; a method overload makes String work, too.
    d = read(hfile["fixed_string"], String)
    @test d isa String
    @test d == fixstring
    d = read(hfile["variable_string"], String)
    @test d isa String
    @test d == varstring

    close(hfile)
    rm(fn)
end # generic read of native types

@testset "show" begin
    fn = tempname()

    # First create data objects and sure they print useful outputs

    hfile = h5open(fn, "w"; swmr=true)
    @test sprint(show, hfile) == "HDF5.File: (read-write, swmr) $fn"

    group = create_group(hfile, "group")
    @test sprint(show, group) == "HDF5.Group: /group (file: $fn)"

    dset = create_dataset(group, "dset", datatype(Int), dataspace((1,)))
    @test sprint(show, dset) == "HDF5.Dataset: /group/dset (file: $fn xfer_mode: 0)"

    meta = create_attribute(dset, "meta", datatype(Bool), dataspace((1,)))
    @test sprint(show, meta) == "HDF5.Attribute: meta"

    dsetattrs = attributes(dset)
    @test sprint(show, dsetattrs) ==
        "Attributes of HDF5.Dataset: /group/dset (file: $fn xfer_mode: 0)"

    prop = HDF5.init!(HDF5.LinkCreateProperties())
    @test sprint(show, prop) == """
    HDF5.LinkCreateProperties(
      create_intermediate_group = false,
      char_encoding   = :ascii,
    )"""

    prop = HDF5.DatasetCreateProperties()
    @test sprint(show, prop) == "HDF5.DatasetCreateProperties()"

    dtype = HDF5.Datatype(HDF5.API.h5t_copy(HDF5.API.H5T_IEEE_F64LE))
    @test sprint(show, dtype) == "HDF5.Datatype: H5T_IEEE_F64LE"
    commit_datatype(hfile, "type", dtype)
    @test sprint(show, dtype) == "HDF5.Datatype: /type H5T_IEEE_F64LE"

    dtypemeta = create_attribute(dtype, "dtypemeta", datatype(Bool), dataspace((1,)))
    @test sprint(show, dtypemeta) == "HDF5.Attribute: dtypemeta"

    dtypeattrs = attributes(dtype)
    @test sprint(show, dtypeattrs) == "Attributes of HDF5.Datatype: /type H5T_IEEE_F64LE"

    dspace_null = HDF5.Dataspace(HDF5.API.h5s_create(HDF5.API.H5S_NULL))
    dspace_scal = HDF5.Dataspace(HDF5.API.h5s_create(HDF5.API.H5S_SCALAR))
    dspace_norm = dataspace((100, 4))
    dspace_maxd = dataspace((100, 4); max_dims=(256, 4))
    dspace_slab = HDF5.hyperslab(dataspace((100, 4)), 1:20:100, 1:4)
    if HDF5.libversion ≥ v"1.10.7"
        dspace_irrg = HDF5.Dataspace(
            HDF5.API.h5s_combine_select(
                HDF5.API.h5s_copy(dspace_slab),
                HDF5.API.H5S_SELECT_OR,
                HDF5.hyperslab(dataspace((100, 4)), 2, 2)
            )
        )
        @test sprint(show, dspace_irrg) == "HDF5.Dataspace: (100, 4) [irregular selection]"
    end
    @test sprint(show, dspace_null) == "HDF5.Dataspace: H5S_NULL"
    @test sprint(show, dspace_scal) == "HDF5.Dataspace: H5S_SCALAR"
    @test sprint(show, dspace_norm) == "HDF5.Dataspace: (100, 4)"
    @test sprint(show, dspace_maxd) == "HDF5.Dataspace: (100, 4) / (256, 4)"
    @test sprint(show, dspace_slab) == "HDF5.Dataspace: (1:20:81, 1:4) / (1:100, 1:4)"

    # Now test printing after closing each object

    close(dspace_null)
    @test sprint(show, dspace_null) == "HDF5.Dataspace: (invalid)"

    close(dtype)
    @test sprint(show, dtype) == "HDF5.Datatype: (invalid)"

    close(prop)
    @test sprint(show, prop) == "HDF5.DatasetCreateProperties: (invalid)"

    close(meta)
    @test sprint(show, meta) == "HDF5.Attribute: (invalid)"

    close(dtypemeta)
    @test sprint(show, dtypemeta) == "HDF5.Attribute: (invalid)"

    close(dset)
    @test sprint(show, dset) == "HDF5.Dataset: (invalid)"
    @test sprint(show, dsetattrs) == "Attributes of HDF5.Dataset: (invalid)"

    close(group)
    @test sprint(show, group) == "HDF5.Group: (invalid)"

    close(hfile)
    @test sprint(show, hfile) == "HDF5.File: (closed) $fn"

    # Go back and check different access modes for file printing
    hfile = h5open(fn, "r+"; swmr=true)
    @test sprint(show, hfile) == "HDF5.File: (read-write, swmr) $fn"
    close(hfile)
    hfile = h5open(fn, "r"; swmr=true)
    @test sprint(show, hfile) == "HDF5.File: (read-only, swmr) $fn"
    close(hfile)
    hfile = h5open(fn, "r")
    @test sprint(show, hfile) == "HDF5.File: (read-only) $fn"
    close(hfile)
    hfile = h5open(fn, "cw")
    @test sprint(show, hfile) == "HDF5.File: (read-write) $fn"
    close(hfile)

    rm(fn)

    # Make an interesting file tree
    hfile = h5open(fn, "w")
    # file level
    hfile["version"] = 1.0
    attributes(hfile)["creator"] = "HDF5.jl"
    # group level
    create_group(hfile, "inner")
    attributes(hfile["inner"])["dirty"] = true
    # dataset level
    hfile["inner/data"] = collect(-5:5)
    attributes(hfile["inner/data"])["mode"] = 1
    # non-trivial committed datatype
    # TODO: print more datatype information
    tmeta = HDF5.Datatype(
        HDF5.API.h5t_create(HDF5.API.H5T_COMPOUND, sizeof(Int) + sizeof(Float64))
    )
    HDF5.API.h5t_insert(tmeta, "scale", 0, HDF5.hdf5_type_id(Int))
    HDF5.API.h5t_insert(tmeta, "bias", sizeof(Int), HDF5.hdf5_type_id(Float64))
    tstr = datatype("fixed")
    t = HDF5.Datatype(
        HDF5.API.h5t_create(HDF5.API.H5T_COMPOUND, sizeof(tmeta) + sizeof(tstr))
    )
    HDF5.API.h5t_insert(t, "meta", 0, tmeta)
    HDF5.API.h5t_insert(t, "type", sizeof(tmeta), tstr)
    commit_datatype(hfile, "dtype", t)

    buf = IOBuffer()
    iobuf = IOContext(buf, :limit => true, :module => Main)
    show3(io::IO, x) = show(IOContext(io, iobuf), MIME"text/plain"(), x)

    HDF5.show_tree(iobuf, hfile)
    msg = String(take!(buf))
    @test occursin(
        r"""
🗂️ HDF5.File: .*$
├─ 🏷️ creator
├─ 📄 dtype
├─ 📂 inner
│  ├─ 🏷️ dirty
│  └─ 🔢 data
│     └─ 🏷️ mode
└─ 🔢 version"""m,
        msg
    )
    @test sprint(show3, hfile) == msg

    HDF5.show_tree(iobuf, hfile; attributes=false)
    @test occursin(
        r"""
🗂️ HDF5.File: .*$
├─ 📄 dtype
├─ 📂 inner
│  └─ 🔢 data
└─ 🔢 version"""m,
        String(take!(buf))
    )

    HDF5.show_tree(iobuf, attributes(hfile))
    msg = String(take!(buf))
    @test occursin(
        r"""
🗂️ Attributes of HDF5.File: .*$
└─ 🏷️ creator"""m,
        msg
    )
    @test sprint(show3, attributes(hfile)) == msg

    HDF5.show_tree(iobuf, hfile["inner"])
    msg = String(take!(buf))
    @test occursin(
        r"""
📂 HDF5.Group: /inner .*$
├─ 🏷️ dirty
└─ 🔢 data
   └─ 🏷️ mode"""m,
        msg
    )
    @test sprint(show3, hfile["inner"]) == msg

    HDF5.show_tree(iobuf, hfile["inner"]; attributes=false)
    @test occursin(
        r"""
📂 HDF5.Group: /inner .*$
└─ 🔢 data"""m,
        String(take!(buf))
    )

    HDF5.show_tree(iobuf, hfile["inner/data"])
    msg = String(take!(buf))
    @test occursin(
        r"""
🔢 HDF5.Dataset: /inner/data .*$
└─ 🏷️ mode"""m,
        msg
    )
    # xfer_mode changes between printings, so need regex again
    @test occursin(
        r"""
🔢 HDF5.Dataset: /inner/data .*$
└─ 🏷️ mode"""m,
        sprint(show3, hfile["inner/data"])
    )

    HDF5.show_tree(iobuf, hfile["inner/data"]; attributes=false)
    @test occursin(
        r"""
🔢 HDF5.Dataset: /inner/data .*$"""m,
        String(take!(buf))
    )

    HDF5.show_tree(iobuf, hfile["dtype"])
    @test occursin(
        r"""
📄 HDF5.Datatype: /dtype""",
        String(take!(buf))
    )

    HDF5.show_tree(iobuf, hfile["inner/data"]["mode"]; attributes=true)
    @test occursin(
        r"""
🏷️ HDF5.Attribute: mode""",
        String(take!(buf))
    )

    # configurable options

    # no emoji icons
    HDF5.SHOW_TREE_ICONS[] = false
    @test occursin(
        r"""
\[F\] HDF5.File: .*$
├─ \[A\] creator
├─ \[T\] dtype
├─ \[G\] inner
│  ├─ \[A\] dirty
│  └─ \[D\] data
│     └─ \[A\] mode
└─ \[D\] version"""m,
        sprint(show3, hfile)
    )
    HDF5.SHOW_TREE_ICONS[] = true

    # no tree printing
    show(IOContext(iobuf, :compact => true), MIME"text/plain"(), hfile)
    msg = String(take!(buf))
    @test msg == sprint(show, hfile)

    close(hfile)

    # Now test the print-limiting heuristics for large/complex datasets

    # group with a large number of children; tests child entry truncation heuristic
    h5open(fn, "w") do hfile
        dt, ds = datatype(Int), dataspace(())
        opts = Iterators.product('A':'Z', 1:9)
        for ii in opts
            create_dataset(hfile, string(ii...), dt, ds)
        end

        def = HDF5.SHOW_TREE_MAX_CHILDREN[]
        HDF5.SHOW_TREE_MAX_CHILDREN[] = 5

        HDF5.show_tree(iobuf, hfile)
        msg = String(take!(buf))
        @test occursin(
            r"""
🗂️ HDF5.File: .*$
├─ 🔢 A1
├─ 🔢 A2
├─ 🔢 A3
├─ 🔢 A4
├─ 🔢 A5
└─ \(229 more children\)"""m,
            msg
        )
        @test sprint(show3, hfile) == msg

        HDF5.SHOW_TREE_MAX_CHILDREN[] = def

        # IOContext can halt limiting
        HDF5.show_tree(IOContext(iobuf, :limit => false), hfile)
        @test countlines(seekstart(buf)) == length(opts) + 1
        truncate(buf, 0)
    end

    # deeply nested set of elements; test that the tree is truncated
    h5open(fn, "w") do hfile
        p = HDF5.root(hfile)::HDF5.Group
        opts = 'A':'Z'
        for ii in opts
            p = create_group(p, string(ii))
        end

        def = HDF5.SHOW_TREE_MAX_DEPTH[]
        HDF5.SHOW_TREE_MAX_DEPTH[] = 5

        HDF5.show_tree(iobuf, hfile)
        msg = String(take!(buf))
        @test occursin(
            r"""
🗂️ HDF5.File: .*$
└─ 📂 A
   └─ 📂 B
      └─ 📂 C
         └─ 📂 D
            └─ 📂 E
               └─ \(1 child\)"""m,
            msg
        )
        @test sprint(show3, hfile) == msg

        HDF5.SHOW_TREE_MAX_DEPTH[] = def

        # IOContext can halt limiting
        HDF5.show_tree(IOContext(iobuf, :limit => false), hfile)
        @test countlines(seekstart(buf)) == length(opts) + 1
        truncate(buf, 0)
    end

    rm(fn)
end # show tests

@testset "split1" begin
    @test HDF5.split1("/") == ("/", "")
    @test HDF5.split1("a") == ("a", "")
    @test HDF5.split1("/a/b/c") == ("/", "a/b/c")
    @test HDF5.split1("a/b/c") == ("a", "b/c")
    @test HDF5.split1(GenericString("a")) == ("a", "")
    @test HDF5.split1(GenericString("/a/b/c")) == ("/", "a/b/c")
    @test HDF5.split1(GenericString("a/b/c")) == ("a", "b/c")

    # The following two paths have the same graphemes but different code unit structures:
    # the first one is
    #     <latin small letter a with circumflex> "/" <greek small leter alpha>
    # while the second one is
    #     "a" <combining circumflex accent> "/" <greek small letter alpha>
    circa = "â" # <latin small leter a with circumflex>
    acomb = "â" # "a" + <combining circumflex accent>
    path1 = circa * "/α"
    path2 = acomb * "/α"
    # Sanity checks that the two strings are different but equivalent under normalization
    @test path1 != path2
    @test Base.Unicode.normalize(path1, :NFC) == Base.Unicode.normalize(path2, :NFC)
    # Check split1 operates correctly
    @test HDF5.split1(path1) == (circa, "α")
    @test HDF5.split1(path2) == (acomb, "α")
    @test HDF5.split1("/" * path1) == ("/", path1)
    @test HDF5.split1("/" * path2) == ("/", path2)
end # split1 tests

# Also tests AbstractString interface
@testset "haskey" begin
    fn = tempname()
    hfile = h5open(fn, "w")

    group1 = create_group(hfile, "group1")
    group2 = create_group(group1, "group2")

    @test haskey(hfile, "/")
    @test haskey(hfile, GenericString("group1"))
    @test !haskey(hfile, GenericString("groupna"))
    @test haskey(hfile, "group1/group2")
    @test !haskey(hfile, "group1/groupna")
    @test_throws KeyError hfile["nothing"]

    dset1 = create_dataset(hfile, "dset1", datatype(Int), dataspace((1,)))
    dset2 = create_dataset(group1, "dset2", datatype(Int), dataspace((1,)))

    @test haskey(hfile, "dset1")
    @test !haskey(hfile, "dsetna")
    @test haskey(hfile, "group1/dset2")
    @test !haskey(hfile, "group1/dsetna")

    meta1 = create_attribute(dset1, "meta1", datatype(Bool), dataspace((1,)))
    @test haskey(dset1, "meta1")
    @test !haskey(dset1, "metana")
    @test_throws KeyError dset1["nothing"]

    attribs = attributes(hfile)
    attribs["test1"] = true
    attribs["test2"] = "foo"

    @test haskey(attribs, "test1")
    @test haskey(attribs, "test2")
    @test !haskey(attribs, "testna")
    @test_throws KeyError attribs["nothing"]

    attribs = attributes(dset2)
    attribs["attr"] = "foo"
    @test haskey(attribs, GenericString("attr"))

    close(hfile)
    rm(fn)
end # haskey tests

@testset "AbstractString" begin
    fn = GenericString(tempname())
    hfile = h5open(fn, "w")
    close(hfile)
    hfile = h5open(fn)
    close(hfile)
    hfile = h5open(fn, "w")

    @test_nowarn create_group(hfile, GenericString("group1"))
    @test_nowarn create_dataset(
        hfile, GenericString("dset1"), datatype(Int), dataspace((1,))
    )
    @test_nowarn create_dataset(hfile, GenericString("dset2"), 1)

    @test_nowarn hfile[GenericString("group1")]
    @test_nowarn hfile[GenericString("dset1")]

    dset1 = hfile["dset1"]
    @test_nowarn create_attribute(
        dset1, GenericString("meta1"), datatype(Bool), dataspace((1,))
    )
    @test_nowarn create_attribute(dset1, GenericString("meta2"), 1)
    @test_nowarn dset1[GenericString("meta1")]
    @test_nowarn dset1[GenericString("x")] = 2

    array_of_strings = ["test",]
    write(hfile, "array_of_strings", array_of_strings)
    @test_nowarn attributes(hfile)[GenericString("ref_test")] = HDF5.Reference(
        hfile, GenericString("array_of_strings")
    )
    @test read(attributes(hfile)[GenericString("ref_test")]) ===
        HDF5.Reference(hfile, "array_of_strings")

    hfile[GenericString("test")] = 17.2
    @test_nowarn delete_object(hfile, GenericString("test"))
    @test_nowarn delete_attribute(dset1, GenericString("meta1"))

    # transient types
    memtype_id = HDF5.API.h5t_copy(HDF5.API.H5T_NATIVE_DOUBLE)
    dt = HDF5.Datatype(memtype_id)
    @test !HDF5.API.h5t_committed(dt)
    commit_datatype(hfile, GenericString("dt"), dt)
    @test HDF5.API.h5t_committed(dt)

    dt = datatype(Int)
    ds = dataspace(0)
    d = create_dataset(hfile, GenericString("d"), dt, ds)
    g = create_group(hfile, GenericString("g"))
    a = create_attribute(hfile, GenericString("a"), dt, ds)

    for obj in (d, g)
        @test_nowarn write_attribute(obj, GenericString("a"), 1)
        @test_nowarn read_attribute(obj, GenericString("a"))
        @test_nowarn write(obj, GenericString("aa"), 1)
        @test_nowarn attributes(obj)["attr1"] = GenericString("b")
    end
    @test_nowarn write(d, "attr2", GenericString("c"))
    @test_nowarn write_dataset(g, GenericString("ag"), GenericString("gg"))
    @test_nowarn write_dataset(
        g, GenericString("ag_array"), [GenericString("a1"), GenericString("a2")]
    )

    genstrs = GenericString["fee", "fi", "foo"]
    @test_nowarn write_attribute(d, GenericString("myattr"), genstrs)
    @test genstrs == read(d["myattr"])

    for obj in (hfile,)
        @test_nowarn open_dataset(obj, GenericString("d"))
        @test_nowarn write_dataset(obj, GenericString("dd"), 1)
        @test_nowarn read_dataset(obj, GenericString("dd"))
        @test_nowarn read(obj, GenericString("dd"))
        @test_nowarn read(obj, GenericString("dd") => Int)
    end
    read(attributes(hfile), GenericString("a"))

    write(hfile, GenericString("ASD"), GenericString("Aa"))
    write(g, GenericString("ASD"), GenericString("Aa"))
    write(g, GenericString("ASD1"), [GenericString("Aa")])

    # test writing multiple variable
    @test_nowarn write(
        hfile, GenericString("a1"), rand(2, 2), GenericString("a2"), rand(2, 2)
    )

    # copy methods
    d1 = create_dataset(hfile, GenericString("d1"), dt, ds)
    d1["x"] = 32
    @test_nowarn copy_object(hfile, GenericString("d1"), hfile, GenericString("d1copy1"))
    @test_nowarn copy_object(d1, hfile, GenericString("d1copy2"))

    fn = GenericString(tempname())
    A = Matrix(reshape(1:120, 15, 8))
    @test_nowarn h5write(fn, GenericString("A"), A)
    @test_nowarn h5read(fn, GenericString("A"))
    @test_nowarn h5read(fn, GenericString("A"), (2:3:15, 3:5))

    @test_nowarn h5write(fn, GenericString("x"), 1)
    @test_nowarn h5read(fn, GenericString("x") => Int)

    @test_nowarn h5rewrite(fn) do fid
        g = create_group(fid, "mygroup")
        write(g, "x", 3.3)
    end
    @test_nowarn h5rewrite(fn) do fid
        g = create_group(fid, "mygroup")
        write(g, "y", 3.3)
    end

    @test_nowarn h5write(fn, "W", [1 2; 3 4])
    @test_nowarn h5writeattr(fn, GenericString("W"), Dict("a" => 1, "b" => 2))
    @test_nowarn h5readattr(fn, GenericString("W"))

    fn_external = GenericString(tempname())
    dset = HDF5.create_external_dataset(hfile, "ext", fn_external, Int, (10, 20))
    dcpl = HDF5.get_create_properties(dset)
    @test HDF5.API.h5p_get_external_count(dcpl) == 1
    ext_prop = HDF5.API.h5p_get_external(dcpl)
    @test ext_prop.name == fn_external
    @test ext_prop.offset == 0
    @test ext_prop.size == 10 * 20 * sizeof(Int)
    dapl = HDF5.get_access_properties(dset)
    dapl.efile_prefix = "efile_test"
    @test HDF5.API.h5p_get_efile_prefix(dapl) == "efile_test"
    close(hfile)
end

@testset "opaque data" begin
    mktemp() do path, io
        close(io)
        fid = h5open(path, "w")

        num   = 1
        olen  = 4
        otype = HDF5.Datatype(HDF5.API.h5t_create(HDF5.API.H5T_OPAQUE, olen))
        HDF5.API.h5t_set_tag(otype, "opaque test")

        # scalar
        dat0 = rand(UInt8, olen)
        create_dataset(fid, "scalar", otype, dataspace(()))
        write_dataset(fid["scalar"], otype, dat0)
        # vector
        dat1 = [rand(UInt8, olen) for _ in 1:4]
        buf1 = reduce(vcat, dat1)
        create_dataset(fid, "vector", otype, dataspace(dat1))
        write_dataset(fid["vector"], otype, buf1)
        # matrix
        dat2 = [rand(UInt8, olen) for _ in 1:4, _ in 1:2]
        buf2 = reduce(vcat, dat2)
        create_dataset(fid, "matrix", otype, dataspace(dat2))
        write_dataset(fid["matrix"], otype, buf2)

        # opaque data within a compound data type
        ctype = HDF5.Datatype(
            HDF5.API.h5t_create(HDF5.API.H5T_COMPOUND, sizeof(num) + sizeof(otype))
        )
        HDF5.API.h5t_insert(ctype, "v", 0, datatype(num))
        HDF5.API.h5t_insert(ctype, "d", sizeof(num), otype)
        cdat = vcat(reinterpret(UInt8, [num]), dat0)
        create_dataset(fid, "compound", ctype, dataspace(()))
        write_dataset(fid["compound"], ctype, cdat)

        opaque0 = read(fid["scalar"])
        @test opaque0.tag == "opaque test"
        @test opaque0.data == dat0
        opaque1 = read(fid["vector"])
        @test opaque1.tag == "opaque test"
        @test opaque1.data == dat1
        opaque2 = read(fid["matrix"])
        @test opaque2.tag == "opaque test"
        @test opaque2.data == dat2

        # Note: opaque tag is lost
        compound = read(fid["compound"])
        @test compound == (v=num, d=dat0)

        close(fid)
    end
end

@testset "FixedStrings and FixedArrays" begin
    # properties for FixedString
    fix = HDF5.FixedString{4,0}((b"test"...,))
    @test length(typeof(fix)) == 4
    @test length(fix) == 4
    @test HDF5.pad(typeof(fix)) == 0
    @test HDF5.pad(fix) == 0
    # issue #742, large fixed strings are readable
    mktemp() do path, io
        close(io)
        num = Int64(9)
        ref = join('a':'z')^1000
        fid = h5open(path, "w")
        # long string serialized as FixedString
        fid["longstring"] = ref

        # compound datatype containing a FixedString
        compound_dtype = HDF5.Datatype(
            HDF5.API.h5t_create(HDF5.API.H5T_COMPOUND, sizeof(num) + sizeof(ref))
        )
        HDF5.API.h5t_insert(compound_dtype, "n", 0, datatype(num))
        HDF5.API.h5t_insert(compound_dtype, "a", sizeof(num), datatype(ref))
        c = create_dataset(fid, "compoundlongstring", compound_dtype, dataspace(()))
        # normally this is done with a `struct name{N}; n::Int64; a::NTuple{N,Char}; end`,
        # but we need to not actually instantiate the `NTuple`.
        buf = IOBuffer()
        write(buf, num, ref)
        @assert position(buf) == sizeof(compound_dtype)
        write_dataset(c, compound_dtype, take!(buf))

        # Test reading without stalling
        d = fid["longstring"]
        T = HDF5.get_jl_type(d)
        @test T <: HDF5.FixedString
        @test length(T) == length(ref)
        @test read(d) == ref

        T = HDF5.get_jl_type(c)
        @test T <: NamedTuple
        @test fieldnames(T) == (:n, :a)
        @test read(c) == (n=num, a=ref)

        close(fid)
    end

    fix = HDF5.FixedArray{Float64,(2, 2),4}((1, 2, 3, 4))
    @test size(typeof(fix)) == (2, 2)
    @test size(fix) == (2, 2)
    @test eltype(typeof(fix)) == Float64
    @test eltype(fix) == Float64
    # large fixed arrays are readable
    mktemp() do path, io
        close(io)
        ref = rand(Float64, 3000)
        t = HDF5.Datatype(
            HDF5.API.h5t_array_create(datatype(Float64), ndims(ref), collect(size(ref)))
        )
        scalarspace = dataspace(())

        fid = h5open(path, "w")
        d = create_dataset(fid, "longnums", t, scalarspace)
        write_dataset(d, t, ref)

        T = HDF5.get_jl_type(d)
        @test T <: HDF5.FixedArray
        @test size(T) == size(ref)
        @test eltype(T) == eltype(ref)
        @test read(d) == ref

        close(fid)
    end
end

@testset "Object Exists" begin
    hfile = h5open(tempname(), "w")
    g1 = create_group(hfile, "group1")
    @test_throws HDF5.API.H5Error create_group(hfile, "group1")
    create_group(g1, "group1a")
    @test_throws HDF5.API.H5Error create_group(hfile, "/group1/group1a")
    @test_throws HDF5.API.H5Error create_group(g1, "group1a")

    # issue #1055
    create_group(hfile, SubString("abcdef", 1, 3))
    @test haskey(hfile, "abc")
    @test !haskey(hfile, "abcdef")

    create_dataset(hfile, "dset1", 1)
    create_dataset(hfile, "/group1/dset1", 1)

    @test_throws ErrorException create_dataset(hfile, "dset1", 1)
    @test_throws ErrorException create_dataset(hfile, "group1", 1)
    @test_throws ErrorException create_dataset(g1, "dset1", 1)

    close(hfile)
end

@testset "HDF5 existance" begin
    fn1 = tempname()
    fn2 = tempname()

    open(fn1, "w") do f
        write(f, "Hello text file")
    end

    @test !HDF5.ishdf5(fn1) # check that a non-hdf5 file retuns false
    @test !HDF5.ishdf5(fn2) # checks that a file that does not exist returns false

    @test_throws ErrorException h5write(fn1, "x", 1) # non hdf5 file throws
    h5write(fn2, "x", 1)

    @test HDF5.ishdf5(fn2)

    rm(fn1)
    rm(fn2)
end

@testset "bounds" begin

    # issue #954
    h5open(tempname(), "w") do f
        a, _ = create_attribute(f, "a", zeros(4))
        @test_throws ArgumentError write(a, ones(2))
        d, _ = create_dataset(f, "dd", zeros(4))
        @test_throws ArgumentError write(d, ones(2))
    end
end

using Test
using HDF5
using HDF5.API

@testset "Object API" begin
    fn = tempname()

    # Write some data
    h5open(fn, "w") do h5f
        h5f["data"] = 5
        h5f["lore"] = 9.0
        attrs(h5f["lore"])["evil"] = true
    end

    # Read the data
    h5open(fn, "r") do h5f
        @test API.h5o_exists_by_name(h5f, "data")
        @test API.h5o_exists_by_name(h5f, "lore")
        @static if HDF5.API.h5_get_libversion() <= v"1.14.5"
            # Buggy behavior in earlier versions of HDF5 returns FAIL (-1)
            @test_throws API.H5Error API.h5o_exists_by_name(h5f, "noonian")
        else
            # The correct behavior is to return false (0)
            @test API.h5o_exists_by_name(h5f, "noonian") == 0
        end

        loc_id = API.h5o_open(h5f, "data", API.H5P_DEFAULT)
        try
            @test loc_id > 0
            oinfo = API.h5o_get_info(loc_id)
            @test oinfo.num_attrs == 0
            @test oinfo.type == API.H5O_TYPE_DATASET

            oinfo1 = API.h5o_get_info1(loc_id)
            @test oinfo1.num_attrs == 0
            @test oinfo1.type == API.H5O_TYPE_DATASET

            @static if HDF5.API.h5_get_libversion() >= v"1.12.0"
                oninfo = API.h5o_get_native_info(loc_id)
                @test oninfo.hdr.version > 0
                @test oninfo.hdr.nmesgs > 0
                @test oninfo.hdr.nchunks > 0
                @test oninfo.hdr.flags > 0
                @test oninfo.hdr.space.total > 0
                @test oninfo.hdr.space.meta > 0
                @test oninfo.hdr.space.mesg > 0
                @test oninfo.hdr.space.free > 0
                @test oninfo.hdr.mesg.present > 0
            end
        finally
            API.h5o_close(loc_id)
        end

        oinfo = API.h5o_get_info_by_name(h5f, ".")
        @test oinfo.type == API.H5O_TYPE_GROUP

        oinfo = API.h5o_get_info_by_name(h5f, "lore")
        @test oinfo.num_attrs == 1

        @static if HDF5.API.h5_get_libversion() >= v"1.12.0"
            oninfo = API.h5o_get_native_info_by_name(h5f, "lore")
            @test oninfo.hdr.version > 0
            @test oninfo.hdr.nmesgs > 0
            @test oninfo.hdr.nchunks > 0
            @test oninfo.hdr.flags > 0
            @test oninfo.hdr.space.total > 0
            @test oninfo.hdr.space.meta > 0
            @test oninfo.hdr.space.mesg > 0
            @test oninfo.hdr.space.free > 0
            @test oninfo.hdr.mesg.present > 0
        end

        oinfo = API.h5o_get_info_by_idx(h5f, ".", API.H5_INDEX_NAME, API.H5_ITER_INC, 0)
        @test oinfo.num_attrs == 0

        @static if HDF5.API.h5_get_libversion() >= v"1.12.0"
            oninfo = API.h5o_get_native_info_by_idx(
                h5f, ".", API.H5_INDEX_NAME, API.H5_ITER_INC, 1
            )
            @test oninfo.hdr.version > 0
            @test oninfo.hdr.nmesgs > 0
            @test oninfo.hdr.nchunks > 0
            @test oninfo.hdr.flags > 0
            @test oninfo.hdr.space.total > 0
            @test oninfo.hdr.space.meta > 0
            @test oninfo.hdr.space.mesg > 0
            @test oninfo.hdr.space.free > 0
            @test oninfo.hdr.mesg.present > 0
        end
    end
end

"""
    HDF5.Dataspace

A dataspace defines the size and the shape of a dataset or an attribute.

A dataspace is typically constructed by calling [`dataspace`](@ref).

The following functions have methods defined for `Dataspace` objects
- `==`
- `ndims`
- `size`
- `length`
- `isempty`
- [`isnull`](@ref)
"""
Dataspace # defined in types.jl

Base.:(==)(dspace1::Dataspace, dspace2::Dataspace) =
    API.h5s_extent_equal(checkvalid(dspace1), checkvalid(dspace2))
Base.hash(dspace::Dataspace, h::UInt) = hash(dspace.id, hash(Dataspace, h))
Base.copy(dspace::Dataspace) = Dataspace(API.h5s_copy(checkvalid(dspace)))

function Base.close(obj::Dataspace)
    if obj.id != -1
        if isvalid(obj)
            API.h5s_close(obj)
        end
        obj.id = -1
    end
    nothing
end

"""
    dataspace(obj::Union{Attribute, Dataset, Dataspace})

The [`Dataspace`](@ref) of `obj`.
"""
dataspace(ds::Dataspace) = ds

# Create a dataspace from in-memory types
"""
    dataspace(data)

The default `Dataspace` used for representing a Julia object `data`:
 - strings or numbers: a scalar `Dataspace`
 - arrays: a simple `Dataspace`
 - `struct` types: a scalar `Dataspace`
 - `nothing` or an `EmptyArray`: a null dataspace
"""
dataspace(x::T) where {T} =
    if isstructtype(T)
        Dataspace(API.h5s_create(API.H5S_SCALAR))
    else
        throw(MethodError(dataspace, x))
    end
dataspace(x::Union{T,Complex{T}}) where {T<:ScalarType} =
    Dataspace(API.h5s_create(API.H5S_SCALAR))
dataspace(::AbstractString) = Dataspace(API.h5s_create(API.H5S_SCALAR))

function _dataspace(sz::Dims{N}, max_dims::Union{Dims{N},Tuple{}}=()) where {N}
    dims = API.hsize_t[sz[i] for i in N:-1:1]
    if isempty(max_dims)
        maxd = dims
    else
        # This allows max_dims to be specified as -1 without triggering an overflow
        # exception due to the signed -> unsigned conversion.
        maxd = API.hsize_t[API.hssize_t(max_dims[i]) % API.hsize_t for i in N:-1:1]
    end
    return Dataspace(API.h5s_create_simple(length(dims), dims, maxd))
end
dataspace(A::AbstractArray{T,N}; max_dims::Union{Dims{N},Tuple{}}=()) where {T,N} =
    _dataspace(size(A), max_dims)
# special array types
dataspace(v::VLen; max_dims::Union{Dims,Tuple{}}=()) = _dataspace(size(v.data), max_dims)
dataspace(A::EmptyArray) = Dataspace(API.h5s_create(API.H5S_NULL))
dataspace(n::Nothing) = Dataspace(API.h5s_create(API.H5S_NULL))

# for giving sizes explicitly
"""
    dataspace(dims::Tuple; max_dims::Tuple=dims)
    dataspace(dims::Tuple, max_dims::Tuple)

Construct a simple `Dataspace` for the given dimensions `dims`. The maximum
dimensions `maxdims` specifies the maximum possible size: `-1` can be used to
indicate unlimited dimensions.
"""
dataspace(sz::Dims{N}; max_dims::Union{Dims{N},Tuple{}}=()) where {N} =
    _dataspace(sz, max_dims)
dataspace(sz::Dims{N}, max_dims::Union{Dims{N},Tuple{}}) where {N} =
    _dataspace(sz, max_dims)
dataspace(dims::Tuple{Dims{N},Dims{N}}) where {N} = _dataspace(first(dims), last(dims))
dataspace(sz1::Int, sz2::Int, sz3::Int...; max_dims::Union{Dims,Tuple{}}=()) =
    _dataspace(tuple(sz1, sz2, sz3...), max_dims)

function Base.ndims(dspace::Dataspace)
    API.h5s_get_simple_extent_ndims(checkvalid(dspace))
end
function Base.size(dspace::Dataspace)
    h5_dims = API.h5s_get_simple_extent_dims(checkvalid(dspace), nothing)
    N = length(h5_dims)
    return ntuple(i -> @inbounds(Int(h5_dims[N - i + 1])), N)
end
function Base.size(dspace::Dataspace, d::Integer)
    d > 0 || throw(ArgumentError("invalid dimension d; must be positive integer"))
    N = ndims(dspace)
    d > N && return 1
    h5_dims = API.h5s_get_simple_extent_dims(dspace, nothing)
    return @inbounds Int(h5_dims[N - d + 1])
end
function Base.length(dspace::Dataspace)
    isnull(dspace) && return 0
    h5_dims = API.h5s_get_simple_extent_dims(checkvalid(dspace), nothing)
    return Int(prod(h5_dims))
end
Base.isempty(dspace::Dataspace) = length(dspace) == 0

"""
    isnull(dspace::Union{HDF5.Dataspace, HDF5.Dataset, HDF5.Attribute})

Determines whether the given object has no size (consistent with the `API.H5S_NULL` dataspace).

# Examples
```julia-repl
julia> HDF5.isnull(dataspace(HDF5.EmptyArray{Float64}()))
true

julia> HDF5.isnull(dataspace((0,)))
false
```
"""
function isnull(dspace::Dataspace)
    return API.h5s_get_simple_extent_type(checkvalid(dspace)) == API.H5S_NULL
end

"""
    HDF5.get_regular_hyperslab(dspace)::Tuple

Get the hyperslab selection from `dspace`. Returns a tuple of [`BlockRange`](@ref) objects.
"""
function get_regular_hyperslab(dspace::Dataspace)
    start0, stride, count, block = API.h5s_get_regular_hyperslab(dspace)
    N = length(start0)
    ntuple(N) do i
        ri = N - i + 1
        @inbounds BlockRange(start0[ri], stride[ri], count[ri], block[ri])
    end
end

struct BlockRange
    start0::API.hsize_t
    stride::API.hsize_t
    count::API.hsize_t
    block::API.hsize_t
end

"""
    HDF5.BlockRange(;start::Integer, stride::Integer=1, count::Integer=1, block::Integer=1)

A `BlockRange` represents a selection along a single dimension of a HDF5
hyperslab. It is similar to a Julia `range` object, with some extra features for
selecting multiple contiguous blocks.

- `start`: the index of the first element in the first block (1-based).
- `stride`: the step between the first element of each block (must be >0)
- `count`: the number of blocks (can be -1 for an unlimited number of blocks)
- `block`: the number of elements in each block.


    HDF5.BlockRange(obj::Union{Integer, OrdinalRange})

Convert `obj` to a `BlockRange` object.

# External links
- [HDF5 User Guide, section 7.4.2.1 "Selecting Hyperslabs"](https://support.hdfgroup.org/HDF5/doc/UG/HDF5_Users_Guide-Responsive%20HTML5/index.html#t=HDF5_Users_Guide%2FDataspaces%2FHDF5_Dataspaces_and_Partial_I_O.htm%23TOC_7_4_2_Programming_Modelbc-8&rhtocid=7.2.0_2)
"""
function BlockRange(; start::Integer, stride::Integer=1, count::Integer=1, block::Integer=1)
    if count == -1
        count = API.H5S_UNLIMITED
    end
    BlockRange(start - 1, stride, count, block)
end
BlockRange(start::Integer; stride=1, count=1, block=1) =
    BlockRange(; start=start, stride=stride, count=count, block=block)
BlockRange(r::AbstractUnitRange; stride=max(length(r), 1), count=1) =
    BlockRange(; start=first(r), stride=stride, count=count, block=length(r))
BlockRange(r::OrdinalRange) = BlockRange(; start=first(r), stride=step(r), count=length(r))
BlockRange(br::BlockRange) = br

Base.to_index(d::Dataset, br::BlockRange) = br
Base.length(br::BlockRange) = Int(br.count * br.block)

function Base.range(br::BlockRange)
    start = Int(br.start0 + 1)
    if br.count == 1
        # UnitRange
        return range(start; length=Int(br.block))
    elseif br.block == 1 && br.count != API.H5S_UNLIMITED
        # StepRange
        return range(start; step=Int(br.stride), length=Int(br.count))
    else
        error("$br cannot be converted to a Julia range")
    end
end
Base.convert(::Type{T}, br::BlockRange) where {T<:AbstractRange} = convert(T, range(br))

"""
    HDF5.select_hyperslab!(dspace::Dataspace, [op, ], idxs::Tuple)

Selects a hyperslab region of the `dspace`. `idxs` should be a tuple of
integers, ranges or [`BlockRange`](@ref) objects.

- `op` determines how the new selection is to be combined with the already
  selected dataspace:
  - `:select` (default): replace the existing selection with the new selection.
  - `:or`: adds the new selection to the existing selection.
     Aliases: `|`, `∪`, `union`.
  - `:and`: retains only the overlapping portions of the new and existing
    selection. Aliases: `&`, `∩`, `intersect`.
  - `:xor`: retains only the elements that are members of the new selection or
    the existing selection, excluding elements that are members of both
    selections. Aliases: `⊻`, `xor`
  - `:notb`: retains only elements of the existing selection that are not in the
    new selection. Alias: `setdiff`.
  - `:nota`: retains only elements of the new selection that are not in the
    existing selection.

"""
function select_hyperslab!(
    dspace::Dataspace, op::Union{Symbol,typeof.((&, |, ⊻, ∪, ∩, setdiff))...}, idxs::Tuple
)
    N = ndims(dspace)
    length(idxs) == N || error("Number of indices does not match dimension of Dataspace")

    blockranges = map(BlockRange, idxs)
    _start0 = API.hsize_t[blockranges[N - i + 1].start0 for i in 1:N]
    _stride = API.hsize_t[blockranges[N - i + 1].stride for i in 1:N]
    _count = API.hsize_t[blockranges[N - i + 1].count for i in 1:N]
    _block = API.hsize_t[blockranges[N - i + 1].block for i in 1:N]

    _op = if op == :select
        API.H5S_SELECT_SET
    elseif (op == :or || op === (|) || op === (∪))
        API.H5S_SELECT_OR
    elseif (op == :and || op === (&) || op === (∩))
        API.H5S_SELECT_AND
    elseif (op == :xor || op === (⊻))
        API.H5S_SELECT_XOR
    elseif op == :notb || op === setdiff
        API.H5S_SELECT_NOTB
    elseif op == :nota
        API.H5S_SELECT_NOTA
    else
        error("invalid operator $op")
    end

    API.h5s_select_hyperslab(dspace, _op, _start0, _stride, _count, _block)
    return dspace
end
select_hyperslab!(dspace::Dataspace, idxs::Tuple) = select_hyperslab!(dspace, :select, idxs)

hyperslab(dspace::Dataspace, I::Union{AbstractRange{Int},Integer,BlockRange}...) =
    hyperslab(dspace, I)

function hyperslab(dspace::Dataspace, I::Tuple)
    select_hyperslab!(copy(dspace), I)
end

# methods for Dataset/Attribute which operate on Dataspace
function Base.ndims(obj::Union{Dataset,Attribute})
    dspace = dataspace(obj)
    try
        return Base.ndims(dspace)
    finally
        close(dspace)
    end
end
function Base.size(obj::Union{Dataset,Attribute})
    dspace = dataspace(obj)
    try
        return Base.size(dspace)
    finally
        close(dspace)
    end
end
function Base.size(obj::Union{Dataset,Attribute}, d::Integer)
    dspace = dataspace(obj)
    try
        return Base.size(dspace, d)
    finally
        close(dspace)
    end
end
function Base.length(obj::Union{Dataset,Attribute})
    dspace = dataspace(obj)
    try
        return Base.length(dspace)
    finally
        close(dspace)
    end
end
function Base.isempty(obj::Union{Dataset,Attribute})
    dspace = dataspace(obj)
    try
        return Base.isempty(dspace)
    finally
        close(dspace)
    end
end
function isnull(obj::Union{Dataset,Attribute})
    dspace = dataspace(obj)
    try
        return isnull(dspace)
    finally
        close(dspace)
    end
end

function hyperslab(dset::Dataset, I::Union{AbstractRange{Int},Int}...)
    dspace = dataspace(dset)
    try
        return hyperslab(dspace, I...)
    finally
        close(dspace)
    end
end

# Single character types
# These are needed to safely handle VLEN objects
abstract type CharType <: AbstractString end

struct ASCIIChar <: CharType
    c::UInt8
end
Base.length(c::ASCIIChar) = 1

struct UTF8Char <: CharType
    c::UInt8
end
Base.length(c::UTF8Char) = 1

chartype(::Type{String}) = ASCIIChar
stringtype(::Type{ASCIIChar}) = String
stringtype(::Type{UTF8Char}) = String

cset(::Type{<:AbstractString}) = API.H5T_CSET_UTF8
cset(::Type{UTF8Char}) = API.H5T_CSET_UTF8
cset(::Type{ASCIIChar}) = API.H5T_CSET_ASCII

function unpad(s::String, pad::Integer)::String
    if pad == API.H5T_STR_NULLTERM # null-terminated
        ind = findfirst(isequal('\0'), s)
        isnothing(ind) ? s : s[1:prevind(s, ind)]
    elseif pad == API.H5T_STR_NULLPAD # padded with nulls
        rstrip(s, '\0')
    elseif pad == API.H5T_STR_SPACEPAD # padded with spaces
        rstrip(s, ' ')
    else
        error("Unrecognized string padding mode $pad")
    end
end
unpad(s, pad::Integer) = unpad(String(s), pad)

# VLEN objects
struct VLen{T}
    data::Array
end
VLen(strs::Array{S}) where {S<:String} = VLen{chartype(S)}(strs)
VLen(A::Array{Array{T}}) where {T<:ScalarType} = VLen{T}(A)
VLen(A::Array{Array{T,N}}) where {T<:ScalarType,N} = VLen{T}(A)
function Base.cconvert(::Type{Ptr{Cvoid}}, v::VLen)
    len = length(v.data)
    h = Vector{API.hvl_t}(undef, len)
    for ii in 1:len
        d = v.data[ii]
        p = unsafe_convert(Ptr{UInt8}, d)
        h[ii] = API.hvl_t(length(d), p)
    end
    return h
end

datatype(A::VLen{T}) where {T<:ScalarType} = Datatype(API.h5t_vlen_create(hdf5_type_id(T)))
function datatype(str::VLen{C}) where {C<:CharType}
    type_id = API.h5t_copy(hdf5_type_id(C))
    API.h5t_set_size(type_id, 1)
    API.h5t_set_cset(type_id, cset(C))
    Datatype(API.h5t_vlen_create(type_id))
end

# Compound types

# These will use finalizers. Close them eagerly to avoid issues.
datatype(::T) where {T} = Datatype(hdf5_type_id(T), true)

datatype(::Type{T}) where {T} = Datatype(hdf5_type_id(T), true)
datatype(x::AbstractArray{T}) where {T} = Datatype(hdf5_type_id(T), true)

hdf5_type_id(::Type{T}) where {T} = hdf5_type_id(T, Val(isstructtype(T)))
function hdf5_type_id(::Type{T}, isstruct::Val{true}) where {T}
    dtype = API.h5t_create(API.H5T_COMPOUND, sizeof(T))
    for (idx, fn) in enumerate(fieldnames(T))
        ftype = fieldtype(T, idx)
        API.h5t_insert(dtype, Symbol(fn), fieldoffset(T, idx), hdf5_type_id(ftype))
    end
    return dtype
end
# Perhaps we need a custom error type here
hdf5_type_id(::Type{T}, isstruct::Val{false}) where {T} =
    throw(MethodError(hdf5_type_id, (T, isstruct)))

# Opaque types
struct Opaque
    data
    tag::String
end

# An empty array type
struct EmptyArray{T} <: AbstractArray{T,0} end
# Required AbstractArray interface
Base.size(::EmptyArray) = ()
Base.IndexStyle(::Type{<:EmptyArray}) = IndexLinear()
Base.getindex(::EmptyArray, ::Int) = error("cannot index an `EmptyArray`")
Base.setindex!(::EmptyArray, v, ::Int) = error("cannot assign to an `EmptyArray`")
# Optional interface
Base.similar(::EmptyArray{T}) where {T} = EmptyArray{T}()
Base.similar(::EmptyArray, ::Type{S}) where {S} = EmptyArray{S}()
Base.similar(::EmptyArray, ::Type{S}, dims::Dims) where {S} = Array{S}(undef, dims)
# Override behavior for 0-dimensional Array
Base.length(::EmptyArray) = 0
# Required to avoid indexing during printing
Base.show(io::IO, E::EmptyArray) = print(io, typeof(E), "()")
Base.show(io::IO, ::MIME"text/plain", E::EmptyArray) = show(io, E)
# FIXME: Concatenation doesn't work for this type (it's treated as a length-1 array like
# Base's 0-dimensional arrays), so just forceably abort.
Base.cat_size(::EmptyArray) = error("concatenation of HDF5.EmptyArray is unsupported")
Base.cat_size(::EmptyArray, d) = error("concatenation of HDF5.EmptyArray is unsupported")

# Stub types to encode fixed-size arrays for API.H5T_ARRAY
struct FixedArray{T,D,L}
    data::NTuple{L,T}
end
Base.size(::Type{FixedArray{T,D,L}}) where {T,D,L} = D
Base.size(x::FixedArray) = size(typeof(x))
Base.eltype(::Type{FixedArray{T,D,L}}) where {T,D,L} = T
Base.eltype(x::FixedArray) = eltype(typeof(x))

struct FixedString{N,PAD}
    data::NTuple{N,UInt8}
end
Base.length(::Type{FixedString{N,PAD}}) where {N,PAD} = N
Base.length(str::FixedString) = length(typeof(str))
pad(::Type{FixedString{N,PAD}}) where {N,PAD} = PAD
pad(x::T) where {T<:FixedString} = pad(T)

struct VariableArray{T}
    len::Csize_t
    p::Ptr{Cvoid}
end
Base.eltype(::Type{VariableArray{T}}) where {T} = T

## Conversion between Julia types and HDF5 atomic types
#! format: off
hdf5_type_id(::Type{Bool})      = API.H5T_NATIVE_B8
hdf5_type_id(::Type{Int8})      = API.H5T_NATIVE_INT8
hdf5_type_id(::Type{UInt8})     = API.H5T_NATIVE_UINT8
hdf5_type_id(::Type{Int16})     = API.H5T_NATIVE_INT16
hdf5_type_id(::Type{UInt16})    = API.H5T_NATIVE_UINT16
hdf5_type_id(::Type{Int32})     = API.H5T_NATIVE_INT32
hdf5_type_id(::Type{UInt32})    = API.H5T_NATIVE_UINT32
hdf5_type_id(::Type{Int64})     = API.H5T_NATIVE_INT64
hdf5_type_id(::Type{UInt64})    = API.H5T_NATIVE_UINT64
hdf5_type_id(::Type{Float32})   = API.H5T_NATIVE_FLOAT
hdf5_type_id(::Type{Float64})   = API.H5T_NATIVE_DOUBLE
hdf5_type_id(::Type{Reference}) = API.H5T_STD_REF_OBJ
hdf5_type_id(::Type{<:AbstractString}) = API.H5T_C_S1
#! format: on

# It's not safe to use particular id codes because these can change, so we use characteristics of the type.
function _hdf5_type_map(class_id, is_signed, native_size)
    if class_id == API.H5T_INTEGER
        if is_signed == API.H5T_SGN_2
            return if native_size == 1
                Int8
            elseif native_size == 2
                Int16
            elseif native_size == 4
                Int32
            elseif native_size == 8
                Int64
            else
                throw(KeyError((class_id, is_signed, native_size)))
            end
        else
            return if native_size == 1
                UInt8
            elseif native_size == 2
                UInt16
            elseif native_size == 4
                UInt32
            elseif native_size == 8
                UInt64
            else
                throw(KeyError((class_id, is_signed, native_size)))
            end
        end
    else
        return if native_size == 4
            Float32
        elseif native_size == 8
            Float64
        else
            throw(KeyError((class_id, is_signed, native_size)))
        end
    end
end

# global configuration for complex support
const COMPLEX_SUPPORT = Ref(true)
const COMPLEX_FIELD_NAMES = Ref(("r", "i"))
enable_complex_support() = COMPLEX_SUPPORT[] = true
disable_complex_support() = COMPLEX_SUPPORT[] = false
set_complex_field_names(real::AbstractString, imag::AbstractString) =
    COMPLEX_FIELD_NAMES[] = ((real, imag))

# Create a datatype from in-memory types
datatype(x::ScalarType) = Datatype(hdf5_type_id(typeof(x)), false)
datatype(::Type{T}) where {T<:ScalarType} = Datatype(hdf5_type_id(T), false)
datatype(A::AbstractArray{T}) where {T<:ScalarType} = Datatype(hdf5_type_id(T), false)
function datatype(::Type{Complex{T}}) where {T<:ScalarType}
    COMPLEX_SUPPORT[] ||
        error("complex support disabled. call HDF5.enable_complex_support() to enable")
    dtype = API.h5t_create(API.H5T_COMPOUND, 2 * sizeof(T))
    API.h5t_insert(dtype, COMPLEX_FIELD_NAMES[][1], 0, hdf5_type_id(T))
    API.h5t_insert(dtype, COMPLEX_FIELD_NAMES[][2], sizeof(T), hdf5_type_id(T))
    return Datatype(dtype)
end
datatype(x::Complex{<:ScalarType}) = datatype(typeof(x))
datatype(A::AbstractArray{Complex{T}}) where {T<:ScalarType} = datatype(eltype(A))

function datatype(str::AbstractString)
    type_id = API.h5t_copy(hdf5_type_id(typeof(str)))
    API.h5t_set_size(type_id, max(sizeof(str), 1))
    API.h5t_set_cset(type_id, cset(typeof(str)))
    Datatype(type_id)
end
function datatype(::Type{S}) where {S<:AbstractString}
    type_id = API.h5t_copy(hdf5_type_id(S))
    API.h5t_set_size(type_id, API.H5T_VARIABLE)
    API.h5t_set_cset(type_id, cset(S))
    Datatype(type_id)
end
function datatype(::Array{S}) where {S<:AbstractString}
    type_id = API.h5t_copy(hdf5_type_id(S))
    API.h5t_set_size(type_id, API.H5T_VARIABLE)
    API.h5t_set_cset(type_id, cset(S))
    Datatype(type_id)
end

# conversions to Julia types
function get_jl_type(obj_type::Datatype)
    class_id = API.h5t_get_class(obj_type)
    if class_id == API.H5T_OPAQUE
        return Opaque
    else
        return get_mem_compatible_jl_type(obj_type)
    end
end

function get_jl_type(obj)
    dtype = datatype(obj)
    try
        return get_jl_type(dtype)
    finally
        close(dtype)
    end
end

Base.eltype(dset::Union{Dataset,Attribute}) = get_jl_type(dset)

function get_mem_compatible_jl_type(obj_type::Datatype)
    class_id = API.h5t_get_class(obj_type)
    if class_id == API.H5T_STRING
        if API.h5t_is_variable_str(obj_type)
            return Cstring
        else
            N = sizeof(obj_type)
            PAD = API.h5t_get_strpad(obj_type)
            return FixedString{N,PAD}
        end
    elseif class_id == API.H5T_INTEGER || class_id == API.H5T_FLOAT
        native_type = API.h5t_get_native_type(obj_type)
        try
            native_size = API.h5t_get_size(native_type)
            if class_id == API.H5T_INTEGER
                is_signed = API.h5t_get_sign(native_type)
            else
                is_signed = nothing
            end
            return _hdf5_type_map(class_id, is_signed, native_size)
        finally
            API.h5t_close(native_type)
        end
    elseif class_id == API.H5T_BITFIELD
        return Bool
    elseif class_id == API.H5T_ENUM
        super_type = API.h5t_get_super(obj_type)
        try
            native_type = API.h5t_get_native_type(super_type)
            try
                native_size = API.h5t_get_size(native_type)
                is_signed = API.h5t_get_sign(native_type)
                return _hdf5_type_map(API.H5T_INTEGER, is_signed, native_size)
            finally
                API.h5t_close(native_type)
            end
        finally
            API.h5t_close(super_type)
        end
    elseif class_id == API.H5T_REFERENCE
        # TODO update to use version 1.12 reference functions/types
        return Reference
    elseif class_id == API.H5T_OPAQUE
        # TODO: opaque objects should get their own fixed-size data type; punning like
        #       this permits recursively reading (i.e. compound data type containing an
        #       opaque field). Requires figuring out what to do about the tag...
        len = Int(API.h5t_get_size(obj_type))
        return FixedArray{UInt8,(len,),len}
    elseif class_id == API.H5T_VLEN
        superid = API.h5t_get_super(obj_type)
        return VariableArray{get_mem_compatible_jl_type(Datatype(superid))}
    elseif class_id == API.H5T_COMPOUND
        N = API.h5t_get_nmembers(obj_type)

        membernames = ntuple(N) do i
            API.h5t_get_member_name(obj_type, i - 1)
        end

        membertypes = ntuple(N) do i
            dtype = Datatype(API.h5t_get_member_type(obj_type, i - 1))
            return get_mem_compatible_jl_type(dtype)
        end

        # check if should be interpreted as complex
        iscomplex =
            COMPLEX_SUPPORT[] &&
            N == 2 &&
            (membernames == COMPLEX_FIELD_NAMES[]) &&
            (membertypes[1] == membertypes[2]) &&
            (membertypes[1] <: ScalarType)

        if iscomplex
            return Complex{membertypes[1]}
        else
            return NamedTuple{Symbol.(membernames),Tuple{membertypes...}}
        end
    elseif class_id == API.H5T_ARRAY
        dims = API.h5t_get_array_dims(obj_type)
        nd = length(dims)
        eltyp = Datatype(API.h5t_get_super(obj_type))
        elT = get_mem_compatible_jl_type(eltyp)
        dimsizes = ntuple(i -> Int(dims[nd - i + 1]), nd)  # reverse order
        return FixedArray{elT,dimsizes,prod(dimsizes)}
    end
    error("Class id ", class_id, " is not yet supported")
end

# convert special types to native julia types
function normalize_types(::Type{T}, buf::AbstractMatrix{UInt8}) where {T}
    # First dimension spans bytes of a single element of type T --- (recursively) normalize
    # each range of bytes to final type, returning vector of normalized data.
    return [_normalize_types(T, view(buf, :, ind)) for ind in axes(buf, 2)]
end

# high-level description which should always work --- here, the buffer contains the bytes
# for exactly 1 element of an object of type T, so reinterpret the `UInt8` vector as a
# length-1 array of type `T` and extract the (only) element.
function _typed_load(::Type{T}, buf::AbstractVector{UInt8}) where {T}
    return @inbounds reinterpret(T, buf)[1]
end
# fast-path for common concrete types with simple layout (which should be nearly all cases)
@static if VERSION ≤ v"1.10.0-DEV.1390" # Maybe a few dev versions earlier
    function _typed_load(
        ::Type{T}, buf::V
    ) where {T,V<:Union{Vector{UInt8},Base.FastContiguousSubArray{UInt8,1}}}
        dest = Ref{T}()
        GC.@preserve dest buf Base._memcpy!(
            unsafe_convert(Ptr{Cvoid}, dest), pointer(buf), sizeof(T)
        )
        return dest[]
        # TODO: The above can maybe be replaced with
        #   return GC.@preserve buf unsafe_load(convert(Ptr{t}, pointer(buf)))
        # dependent on data elements being properly aligned for all datatypes, on all
        # platforms.
    end
else
    # TODO reimplement fast path _typed_load for Julia 1.10, consider refactor
    function _typed_load(
        ::Type{T}, buf::V
    ) where {T,V<:Union{Vector{UInt8},Base.FastContiguousSubArray{UInt8,1}}}
        dest = Ref{T}()
        GC.@preserve dest buf Libc.memcpy(
            unsafe_convert(Ptr{Cvoid}, dest), pointer(buf), sizeof(T)
        )
        return dest[]
        # TODO: The above can maybe be replaced with
        #   return GC.@preserve buf unsafe_load(convert(Ptr{t}, pointer(buf)))
        # dependent on data elements being properly aligned for all datatypes, on all
        # platforms.
    end
end

_normalize_types(::Type{T}, buf::AbstractVector{UInt8}) where {T} = _typed_load(T, buf)
function _normalize_types(::Type{T}, buf::AbstractVector{UInt8}) where {K,T<:NamedTuple{K}}
    # Compound data types do not necessarily have members of uniform size, so instead of
    # dim-1 => bytes of single element and dim-2 => over elements, just loop over exact
    # byte ranges within the provided buffer vector.
    nv = ntuple(length(K)) do ii
        elT = fieldtype(T, ii)
        off = fieldoffset(T, ii) % Int
        sub = view(buf, off .+ (1:sizeof(elT)))
        return _normalize_types(elT, sub)
    end
    return NamedTuple{K}(nv)
end
function _normalize_types(
    ::Type{V}, buf::AbstractVector{UInt8}
) where {T,V<:VariableArray{T}}
    va = _typed_load(V, buf)
    pbuf = unsafe_wrap(Array, convert(Ptr{UInt8}, va.p), (sizeof(T), Int(va.len)))
    if do_normalize(T)
        # If `T` a non-trivial type, recursively normalize the vlen buffer.
        return normalize_types(T, pbuf)
    else
        # Otherwise if `T` is simple type, directly reinterpret the vlen buffer.
        # (copy since libhdf5 will reclaim `pbuf = va.p` in `API.h5d_vlen_reclaim`)
        return copy(vec(reinterpret(T, pbuf)))
    end
end
function _normalize_types(::Type{F}, buf::AbstractVector{UInt8}) where {T,F<:FixedArray{T}}
    if do_normalize(T)
        # If `T` a non-trivial type, recursively normalize the buffer after reshaping to
        # matrix with dim-1 => bytes of single element and dim-2 => over elements.
        return reshape(normalize_types(T, reshape(buf, sizeof(T), :)), size(F)...)
    else
        # Otherwise, if `T` is simple type, directly reinterpret the array and reshape to
        # final dimensions. The copy ensures (a) the returned array is independent of
        # [potentially much larger] read() buffer, and (b) that the returned data is an
        # Array and not ReshapedArray of ReinterpretArray of SubArray of ...
        return copy(reshape(reinterpret(T, buf), size(F)...))
    end
end
_normalize_types(::Type{Cstring}, buf::AbstractVector{UInt8}) =
    unsafe_string(_typed_load(Ptr{UInt8}, buf))
_normalize_types(::Type{T}, buf::AbstractVector{UInt8}) where {T<:FixedString} =
    unpad(String(buf), pad(T))

do_normalize(::Type{T}) where {T} = false
do_normalize(::Type{NamedTuple{T,U}}) where {U,T} =
    any(i -> do_normalize(fieldtype(U, i)), 1:fieldcount(U))
do_normalize(::Type{T}) where {T<:Union{Cstring,FixedString,FixedArray,VariableArray}} =
    true

do_reclaim(::Type{T}) where {T} = false
do_reclaim(::Type{NamedTuple{T,U}}) where {U,T} =
    any(i -> do_reclaim(fieldtype(U, i)), 1:fieldcount(U))
do_reclaim(::Type{T}) where {T<:Union{Cstring,VariableArray}} = true

using HDF5, Test

function test_attrs(o::Union{HDF5.File,HDF5.Object})
    @test attrs(o) isa HDF5.AttributeDict

    attrs(o)["a"] = 1
    @test haskey(attrs(o), "a")
    @test attrs(o)["a"] == 1

    attrs(o)["b"] = [2, 3]
    @test attrs(o)["b"] == [2, 3]
    @test haskey(attrs(o), "a")
    @test length(attrs(o)) == 2
    @test sort(keys(attrs(o))) == ["a", "b"]

    @test !haskey(attrs(o), "c")

    # overwrite: same type
    attrs(o)["a"] = 4
    @test attrs(o)["a"] == 4
    @test get(attrs(o), "a", nothing) == 4
    @test length(attrs(o)) == 2
    @test sort(keys(attrs(o))) == ["a", "b"]

    # overwrite: different size
    attrs(o)["b"] = [4, 5, 6]
    @test attrs(o)["b"] == [4, 5, 6]
    @test length(attrs(o)) == 2
    @test sort(keys(attrs(o))) == ["a", "b"]

    # overwrite: different type
    attrs(o)["b"] = "a string"
    @test attrs(o)["b"] == "a string"
    @test length(attrs(o)) == 2
    @test sort(keys(attrs(o))) == ["a", "b"]

    # delete a key
    delete!(attrs(o), "a")
    @test !haskey(attrs(o), "a")
    @test length(attrs(o)) == 1
    @test sort(keys(attrs(o))) == ["b"]

    @test_throws KeyError attrs(o)["a"]
    @test isnothing(get(attrs(o), "a", nothing))
end

@testset "attrs interface" begin
    filename = tempname()
    f = h5open(filename, "w")

    try
        # Test attrs on a HDF5.File
        test_attrs(f)

        # Test attrs on a HDF5.Group
        g = create_group(f, "group_foo")
        test_attrs(g)

        # Test attrs on a HDF5.Dataset
        d = create_dataset(g, "dataset_bar", Int, (32, 32))
        test_attrs(d)

        # Test attrs on a HDF5.Datatype
        t = commit_datatype(
            g, "datatype_int16", HDF5.Datatype(HDF5.API.h5t_copy(HDF5.API.H5T_NATIVE_INT16))
        )
        test_attrs(t)
    finally
        close(f)
    end
end

@testset "variable length strings" begin
    filename = tempname()
    h5open(filename, "w") do f
        # https://github.com/JuliaIO/HDF5.jl/issues/1129
        attr = create_attribute(f, "attr-name", datatype(String), dataspace(String))
        write_attribute(attr, datatype(String), "attr-value")
        @test attrs(f)["attr-name"] == "attr-value"
    end
end

"""
    h5open(filename::AbstractString, mode::AbstractString="r"; swmr=false, pv...)

Open or create an HDF5 file where `mode` is one of:
 - "r"  read only
 - "r+" read and write
 - "cw" read and write, create file if not existing, do not truncate
 - "w"  read and write, create a new file (destroys any existing contents)

Pass `swmr=true` to enable (Single Writer Multiple Reader) SWMR write access for "w" and
"r+", or SWMR read access for "r".

Properties can be specified as keywords for [`FileAccessProperties`](@ref) and [`FileCreateProperties`](@ref).

Also the keywords `fapl` and `fcpl` can be used to provide default instances of these property lists. Property
lists passed in via keyword will be closed. This is useful to set properties not currently defined by HDF5.jl.

Note that `h5open` uses `fclose_degree = :strong` by default, but this can be overriden by the `fapl` keyword.
"""
function h5open(
    filename::AbstractString,
    mode::AbstractString,
    fapl::FileAccessProperties,
    fcpl::FileCreateProperties=FileCreateProperties();
    swmr::Bool=false
)
    #! format: off
    rd, wr, cr, tr, ff =
        mode == "r"  ? (true,  false, false, false, false) :
        mode == "r+" ? (true,  true,  false, false, true ) :
        mode == "cw" ? (false, true,  true,  false, true ) :
        mode == "w"  ? (false, true,  true,  true,  false) :
        # mode == "w+" ? (true,  true,  true,  true,  false) :
        # mode == "a"  ? (true,  true,  true,  true,  true ) :
        error("invalid open mode: ", mode)
    #! format: on
    if ff && !wr
        error("HDF5 does not support appending without writing")
    end

    if cr && (tr || !isfile(filename))
        flag = swmr ? API.H5F_ACC_TRUNC | API.H5F_ACC_SWMR_WRITE : API.H5F_ACC_TRUNC
        fid = API.h5f_create(filename, flag, fcpl, fapl)
    elseif fapl.driver isa Drivers.Core && fapl.driver.backing_store == 0
        flag = wr ? API.H5F_ACC_RDWR : API.H5F_ACC_RDONLY
        fid = API.h5f_open(filename, flag, fapl)
    else
        occursin(r"(s3a?|https?)://", filename) ||
            ishdf5(filename) ||
            error(
                "unable to determine if $filename is accessible in the HDF5 format (file may not exist)"
            )
        if wr
            flag = swmr ? API.H5F_ACC_RDWR | API.H5F_ACC_SWMR_WRITE : API.H5F_ACC_RDWR
        else
            flag = swmr ? API.H5F_ACC_RDONLY | API.H5F_ACC_SWMR_READ : API.H5F_ACC_RDONLY
        end
        fid = API.h5f_open(filename, flag, fapl)
    end
    return File(fid, filename)
end

function h5open(
    filename::AbstractString,
    mode::AbstractString="r";
    swmr::Bool=false,
    # With garbage collection, the other modes don't make sense
    fapl = FileAccessProperties(; fclose_degree=:strong),
    fcpl = FileCreateProperties(),
    pv...
)
    try
        pv = setproperties!(fapl, fcpl; pv...)
        isempty(pv) || error("invalid keyword options $pv")
        return h5open(filename, mode, fapl, fcpl; swmr=swmr)
    finally
        close(fapl)
        close(fcpl)
    end
end

"""
    h5open(f::Function, args...; pv...)

Apply the function f to the result of `h5open(args...; kwargs...)` and close the resulting
`HDF5.File` upon completion.
For example with a `do` block:

    h5open("foo.h5","w") do h5
        h5["foo"]=[1,2,3]
    end

"""
function h5open(f::Function, args...; context=copy(CONTEXT), pv...)
    file = h5open(args...; pv...)
    task_local_storage(:hdf5_context, context) do
        if (track_order = get(pv, :track_order, nothing)) !== nothing
            context.file_create.track_order = context.group_create.track_order = track_order
        end
        try
            f(file)  # the function body can access `context` via `get_context_property`
        finally
            close(file)
            close(context)
        end
    end
end

"""
    h5open(file_image::Vector{UInt8}, mode::AbstractString="r";
        name=nothing,
        fapl=FileAccessProperties(),
        increment=8192,
        backing_store=false,
        write_tracking=false,
        page_size=524288,
        pv...
    )

Open a file image contained in a `Vector{UInt8}`. See [`API.h5p_set_file_image`](@ref).

Unlike [`Drivers.Core`](@ref) the default here is not to use a backing store.
"""
function h5open(
    file_image::Vector{UInt8},
    mode::AbstractString="r";
    name=nothing,
    fapl=FileAccessProperties(),
    increment=8192,
    backing_store=false,
    write_tracking=false,
    page_size=524288,
    pv...
)
    fapl.driver = Drivers.Core(; increment, backing_store, write_tracking, page_size)
    fapl.file_image = file_image
    if isnothing(name)
        if fapl.driver.backing_store != 0
            # The temporary file will be used as a backing store
            name = tempname()
        else
            # Provide it with a unique name based on the objectid
            name = "<memory objectid>: " * repr(objectid(file_image))
        end
    end
    h5open(name, mode; fapl, pv...)
end

function h5rewrite(f::Function, filename::AbstractString, args...)
    tmppath, tmpio = mktemp(dirname(filename))
    close(tmpio)

    try
        val = h5open(f, tmppath, "w", args...)
        Base.Filesystem.rename(tmppath, filename)
        return val
    catch
        Base.Filesystem.unlink(tmppath)
        rethrow()
    end
end

function Base.close(obj::File)
    if obj.id != -1
        API.h5f_close(obj)
        obj.id = -1
    end
    nothing
end

"""
  isopen(obj::HDF5.File)

Returns `true` if `obj` has not been closed, `false` if it has been closed.
"""
Base.isopen(obj::File) = obj.id != -1

"""
    ishdf5(name::AbstractString)

Returns `true` if the file specified by `name` is in the HDF5 format, and `false` otherwise.
"""
function ishdf5(name::AbstractString)
    isfile(name) || return false # fastpath in case the file is non-existant
    # TODO: v1.12 use the more robust API.h5f_is_accesible
    try
        # docs falsely claim API.h5f_is_hdf5 doesn't error, but it does
        return API.h5f_is_hdf5(name)
    catch
        return false
    end
end

# Extract the file
file(f::File) = f
file(o::Union{Object,Attribute}) = o.file
fd(obj::Object) = API.h5i_get_file_id(checkvalid(obj))

filename(obj::Union{File,Group,Dataset,Attribute,Datatype}) =
    API.h5f_get_name(checkvalid(obj))

"""
    start_swmr_write(h5::HDF5.File)

Start Single Reader Multiple Writer (SWMR) writing mode.

# External links
[*Single Writer Multiple Reader* from the HDF5 manual](https://portal.hdfgroup.org/display/HDF5/Single+Writer+Multiple+Reader++-+SWMR).
"""
start_swmr_write(h5::File) = API.h5f_start_swmr_write(h5)

# Flush buffers
Base.flush(f::Union{Object,Attribute,Datatype,File}, scope=API.H5F_SCOPE_GLOBAL) =
    API.h5f_flush(checkvalid(f), scope)

# File image conversion

function Vector{UInt8}(h5f::File)
    flush(h5f)
    API.h5f_get_file_image(h5f)
end
function File(file_image::Vector{UInt8}, name=nothing)
    h5open(file_image; name)
end
Base.convert(::Type{Vector{UInt8}}, h5f::File) = Vector{UInt8}(h5f)
Base.convert(::Type{File}, file_image::Vector{UInt8}) = File(file_image)

using HDF5
using Test

hf = h5open(tempname(), "w")

fv = 3.14
data = [1.0, 2.0, 3.0, 4.0, 5.0, 6.0]
floatsize = sizeof(data[1])
h5t = datatype(data[1])
title = "lal"
name = "mym"
nfield = 2
nrec = 3
recsize = nfield * floatsize
colname = ["f1_verylongnameforfun", "f2"]
offset = [0, floatsize]
tid = [h5t.id, h5t.id]
chunk = 7
fillvalue = [3.14, 2.71]
compress = 1

HDF5.API.h5tb_make_table(
    title,
    hf,
    name,
    nfield,
    nrec,
    recsize,
    colname,
    offset,
    tid,
    chunk,
    fillvalue,
    compress,
    data
)
fieldsize = [floatsize, floatsize]
HDF5.API.h5tb_append_records(hf, name, nrec, recsize, offset, fieldsize, data)
HDF5.API.h5tb_write_records(
    hf, name, 1, 4, recsize, offset, fieldsize, collect(1:8) .+ 20.0
)
buf = fill(0.0, 100)

HDF5.API.h5tb_read_table(hf, name, recsize, offset, fieldsize, buf)
@test buf[1:12] == [1.0, 2.0, 21.0, 22.0, 23.0, 24.0, 25.0, 26.0, 27.0, 28.0, 5.0, 6.0]
buf .= 0.0
HDF5.API.h5tb_read_records(hf, name, 2, 3, recsize, offset, fieldsize, buf)
@test buf[1:6] == collect(23:28)

h5_nfields, h5_nrec = HDF5.API.h5tb_get_table_info(hf, name)
@test h5_nfields == nfield
@test h5_nrec == 6

h5_colname, h5_fieldsize, h5_offset, h5_recsize = HDF5.API.h5tb_get_field_info(hf, name)

@test h5_colname == colname
@test h5_fieldsize == fieldsize
@test h5_offset == offset
@test h5_recsize == recsize

close(hf)

# Dataset defined in types.jl

# Get the dataspace of a dataset
dataspace(dset::Dataset) = Dataspace(API.h5d_get_space(checkvalid(dset)))

"""
    open_dataset(parent::Union{File, Group}, path::AbstractString; properties...)

Open an existing [`HDF5.Dataset`](@ref) at `path` under `parent`

Optional keyword arguments include any keywords that that belong to
[`DatasetAccessProperties`](@ref) or [`DatasetTransferProperties`](@ref).
"""
open_dataset(
    parent::Union{File,Group},
    name::AbstractString,
    dapl::DatasetAccessProperties,
    dxpl::DatasetTransferProperties
) = Dataset(API.h5d_open(checkvalid(parent), name, dapl), file(parent), dxpl)

function open_dataset(parent::Union{File,Group}, name::AbstractString; pv...)
    dapl = DatasetAccessProperties()
    dxpl = DatasetTransferProperties()
    pv = setproperties!(dapl, dxpl; pv...)
    isempty(pv) || error("invalid keyword options $(keys(pv))")
    open_dataset(parent, name, dapl, dxpl)
end

# Setting dset creation properties with name/value pairs
"""
    create_dataset(parent, path, datatype, dataspace; properties...)

# Arguments
* `parent` - `File` or `Group`
* `path` - `String` describing the path of the dataset within the HDF5 file or
           `nothing` to create an anonymous dataset
* `datatype` - `Datatype` or `Type` or the dataset
* `dataspace` - `Dataspace` or `Dims` of the dataset
* `properties` - keyword name-value pairs set properties of the dataset

# Keywords

There are many keyword properties that can be set. Below are a few select keywords.
* `chunk` - `Dims` describing the size of a chunk. Needed to apply filters.
* `filters` - `AbstractVector{<: Filters.Filter}` describing the order of the filters to apply to the data. See [`Filters`](@ref)
* `external` - `Tuple{AbstractString, Intger, Integer}` `(filepath, offset, filesize)` External dataset file location, data offset, and file size. See [`API.h5p_set_external`](@ref).

Additionally, the initial create, transfer, and access properties can be provided as a keyword:
* `dcpl` - [`DatasetCreateProperties`](@ref)
* `dxpl` - [`DatasetTransferProperties`](@ref)
* `dapl` - [`DatasetAccessProperties`](@ref)

"""
function create_dataset(
    parent::Union{File,Group},
    path::Union{AbstractString,Nothing},
    dtype::Datatype,
    dspace::Dataspace;
    dcpl::DatasetCreateProperties=DatasetCreateProperties(),
    dxpl::DatasetTransferProperties=DatasetTransferProperties(),
    dapl::DatasetAccessProperties=DatasetAccessProperties(),
    pv...
)
    !isnothing(path) &&
        haskey(parent, path) &&
        error(
            "cannot create dataset: object \"", path, "\" already exists at ", name(parent)
        )
    pv = setproperties!(dcpl, dxpl, dapl; pv...)
    isempty(pv) || error("invalid keyword options")
    if isnothing(path)
        ds = API.h5d_create_anon(parent, dtype, dspace, dcpl, dapl)
    else
        ds = API.h5d_create(parent, path, dtype, dspace, _link_properties(path), dcpl, dapl)
    end
    Dataset(ds, file(parent), dxpl)
end
create_dataset(
    parent::Union{File,Group},
    path::Union{AbstractString,Nothing},
    dtype::Datatype,
    dspace_dims::Dims;
    pv...
) = create_dataset(checkvalid(parent), path, dtype, dataspace(dspace_dims); pv...)
create_dataset(
    parent::Union{File,Group},
    path::Union{AbstractString,Nothing},
    dtype::Datatype,
    dspace_dims::Tuple{Dims,Dims};
    pv...
) = create_dataset(
    checkvalid(parent),
    path,
    dtype,
    dataspace(dspace_dims[1]; max_dims=dspace_dims[2]);
    pv...
)
create_dataset(
    parent::Union{File,Group},
    path::Union{AbstractString,Nothing},
    dtype::Type,
    dspace_dims::Tuple{Dims,Dims};
    pv...
) = create_dataset(
    checkvalid(parent),
    path,
    datatype(dtype),
    dataspace(dspace_dims[1]; max_dims=dspace_dims[2]);
    pv...
)
create_dataset(
    parent::Union{File,Group},
    path::Union{AbstractString,Nothing},
    dtype::Type,
    dspace_dims::Dims;
    pv...
) = create_dataset(checkvalid(parent), path, datatype(dtype), dataspace(dspace_dims); pv...)
create_dataset(
    parent::Union{File,Group},
    path::Union{AbstractString,Nothing},
    dtype::Type,
    dspace_dims::Int...;
    pv...
) = create_dataset(checkvalid(parent), path, datatype(dtype), dataspace(dspace_dims); pv...)
create_dataset(
    parent::Union{File,Group},
    path::Union{AbstractString,Nothing},
    dtype::Type,
    dspace::Dataspace;
    pv...
) = create_dataset(checkvalid(parent), path, datatype(dtype), dspace; pv...)

# Get the datatype of a dataset
datatype(dset::Dataset) = Datatype(API.h5d_get_type(checkvalid(dset)), file(dset))

"""
    read_dataset(parent::Union{File,Group}, name::AbstractString)

Read a dataset with named `name` from `parent`. This will typically return an array.
The dataset will be opened, read, and closed.

See also [`HDF5.open_dataset`](@ref), [`Base.read`](@ref)
"""
function read_dataset(parent::Union{File,Group}, name::AbstractString)
    local ret
    obj = open_dataset(parent, name)
    try
        ret = read(obj)
    finally
        close(obj)
    end
    ret
end

refresh(ds::Dataset) = API.h5d_refresh(checkvalid(ds))
Base.flush(ds::Dataset) = API.h5d_flush(checkvalid(ds))

# Array constructor for datasets
Base.Array(x::Dataset) = read(x)

# The next two lines are kept for v"1.4" <= VERSION <= v"1.5"
Base.lastindex(dset::Dataset) = length(dset)
Base.lastindex(dset::Dataset, d::Int) = size(dset, d)

function iscompact(obj::Dataset)
    prop = API.h5d_get_create_plist(checkvalid(obj))
    try
        API.h5p_get_layout(prop) == API.H5D_COMPACT
    finally
        API.h5p_close(prop)
    end
end

function ischunked(obj::Dataset)
    prop = API.h5d_get_create_plist(checkvalid(obj))
    try
        API.h5p_get_layout(prop) == API.H5D_CHUNKED
    finally
        API.h5p_close(prop)
    end
end

function iscontiguous(obj::Dataset)
    prop = API.h5d_get_create_plist(checkvalid(obj))
    try
        API.h5p_get_layout(prop) == API.H5D_CONTIGUOUS
    finally
        API.h5p_close(prop)
    end
end

# Reading with mmap
ismmappable(::Type{<:ScalarType}) = true
ismmappable(::Type{Complex{T}}) where {T<:BitsType} = true
ismmappable(::Type) = false
ismmappable(obj::Dataset, ::Type{T}) where {T} = ismmappable(T) && iscontiguous(obj)
ismmappable(obj::Dataset) = ismmappable(obj, get_jl_type(obj))

function readmmap(obj::Dataset, ::Type{T}) where {T}
    dspace = dataspace(obj)
    stype = API.h5s_get_simple_extent_type(dspace)
    (stype != API.H5S_SIMPLE) && error("can only mmap simple dataspaces")
    dims = size(dspace)

    if isempty(dims)
        return T[]
    end
    if !Sys.iswindows()
        local fdint
        prop = API.h5d_get_access_plist(obj)
        try
            # TODO: Should check return value of API.h5f_get_driver()
            fdptr = API.h5f_get_vfd_handle(obj.file, prop)
            fdint = unsafe_load(convert(Ptr{Cint}, fdptr))
        finally
            API.h5p_close(prop)
        end
        fd = fdio(fdint)
    else
        # This is a workaround since the regular code path does not work on windows
        # (see #89 for background). The error is that "Mmap.mmap(fd, ...)" cannot
        # create create a valid file mapping. The question is if the handler
        # returned by "API.h5f_get_vfd_handle" has
        # the correct format as required by the "fdio" function. The former
        # calls
        # https://gitlabext.iag.uni-stuttgart.de/libs/hdf5/blob/develop/src/H5FDcore.c#L1209
        #
        # The workaround is to create a new file handle, which should actually
        # not make any problems. Since we need to know the permissions of the
        # original file handle, we first retrieve them using the "API.h5f_get_intent"
        # function

        # Check permissions
        intent = API.h5f_get_intent(obj.file)
        flag = intent == API.H5F_ACC_RDONLY ? "r" : "r+"
        fd = open(obj.file.filename, flag)
    end

    offset = API.h5d_get_offset(obj)
    if offset == -1 % API.haddr_t
        # note that API.h5d_get_offset may not actually raise an error, so we need to check it here
        error("Error getting offset")
    elseif offset % Base.datatype_alignment(T) == 0
        A = Mmap.mmap(fd, Array{T,length(dims)}, dims, offset)
    else
        Aflat = Mmap.mmap(fd, Vector{UInt8}, prod(dims) * sizeof(T), offset)
        A = reshape(reinterpret(T, Aflat), dims)
    end

    if Sys.iswindows()
        close(fd)
    end

    return A
end

function readmmap(obj::Dataset)
    T = get_jl_type(obj)
    ismmappable(T) || error("Cannot mmap datasets of type $T")
    iscontiguous(obj) || error("Cannot mmap discontiguous dataset")
    readmmap(obj, T)
end

# Generic write
function Base.write(
    parent::Union{File,Group},
    name1::Union{AbstractString,Nothing},
    val1,
    name2::Union{AbstractString,Nothing},
    val2,
    nameval...
) # FIXME: remove?
    if !iseven(length(nameval))
        error("name, value arguments must come in pairs")
    end
    write(parent, name1, val1)
    write(parent, name2, val2)
    for i in 1:2:length(nameval)
        thisname = nameval[i]
        if !isa(thisname, AbstractString)
            error("Argument ", i + 5, " should be a string, but it's a ", typeof(thisname))
        end
        write(parent, thisname, nameval[i + 1])
    end
end

# Plain dataset & attribute writes
# Due to method ambiguities we generate these explicitly

# Create datasets and attributes with "native" types, but don't write the data.
# The return syntax is: dset, dtype = create_dataset(parent, name, data; properties...)

function create_dataset(
    parent::Union{File,Group}, name::Union{AbstractString,Nothing}, data; pv...
)
    dtype = datatype(data)
    dspace = dataspace(data)
    obj = try
        create_dataset(parent, name, dtype, dspace; pv...)
    finally
        close(dspace)
    end
    return obj, dtype
end

# Create and write, closing the objects upon exit
"""
    write_dataset(parent::Union{File,Group}, name::Union{AbstractString,Nothing}, data; pv...)

Create and write a dataset with `data`. Keywords are forwarded to [`create_dataset`](@ref).
Providing `nothing` as the name will create an anonymous dataset.

See also [`create_dataset`](@ref)
"""
function write_dataset(
    parent::Union{File,Group}, name::Union{AbstractString,Nothing}, data; pv...
)
    obj, dtype = create_dataset(parent, name, data; pv...)
    try
        write_dataset(obj, dtype, data)
    catch exc
        delete_object(obj)
        rethrow(exc)
    finally
        close(obj)
        close(dtype)
    end
    nothing
end

# Write to already-created objects
function Base.write(obj::Dataset, x)
    dtype = datatype(x)
    try
        write_dataset(obj, dtype, x)
    finally
        close(dtype)
    end
end

# For plain files and groups, let "write(obj, name, val; properties...)" mean "write_dataset"
Base.write(parent::Union{File,Group}, name::Union{AbstractString,Nothing}, data; pv...) =
    write_dataset(parent, name, data; pv...)

# Indexing

Base.eachindex(::IndexLinear, A::Dataset) = Base.OneTo(length(A))
Base.axes(dset::Dataset) = map(Base.OneTo, size(dset))
Base.axes(dset::Dataset, d::Integer) = Base.OneTo(size(dset, d))

# Write to a subset of a dataset using array slices: dataset[:,:,10] = array

const IndexType = Union{AbstractRange{Int},Int,Colon}
function Base.setindex!(dset::Dataset, X::Array{T}, I::IndexType...) where {T}
    !isconcretetype(T) && error("type $T is not concrete")
    U = get_jl_type(dset)

    # perform conversions for numeric types
    if (U <: Number) && (T <: Number) && U !== T
        X = convert(Array{U}, X)
    end

    filetype = datatype(dset)
    memtype = _memtype(filetype, eltype(X))
    close(filetype)

    dspace = dataspace(dset)
    stype = API.h5s_get_simple_extent_type(dspace)
    stype == API.H5S_NULL && error("attempting to write to null dataspace")

    indices = Base.to_indices(dset, I)
    dspace = hyperslab(dspace, indices...)

    memspace = dataspace(X)

    if API.h5s_get_select_npoints(dspace) != API.h5s_get_select_npoints(memspace)
        error("number of elements in src and dest arrays must be equal")
    end

    try
        API.h5d_write(dset, memtype, memspace, dspace, dset.xfer, X)
    finally
        close(memtype)
        close(memspace)
        close(dspace)
    end

    return X
end

function Base.setindex!(
    dset::Dataset, X::Array{S}, I::IndexType...
) where {S<:AbstractString}
    !isconcretetype(S) && error("type $S is not concrete")
    U = get_jl_type(dset)

    filetype = datatype(dset)
    memtype = _memtype(filetype, eltype(X))
    close(filetype)

    dspace = dataspace(dset)
    stype = API.h5s_get_simple_extent_type(dspace)
    stype == API.H5S_NULL && error("attempting to write to null dataspace")

    indices = Base.to_indices(dset, I)
    dspace = hyperslab(dspace, indices...)

    memspace = dataspace(X)

    if API.h5s_get_select_npoints(dspace) != API.h5s_get_select_npoints(memspace)
        error("number of elements in src and dest arrays must be equal")
    end

    p = Ref{Cstring}(X)
    try
        API.h5d_write(dset, memtype, memspace, dspace, dset.xfer, p)
    finally
        close(memtype)
        close(memspace)
        close(dspace)
    end

    return X
end

function Base.setindex!(dset::Dataset, x, I::IndexType...)
    indices = Base.to_indices(dset, I)
    X = fill(x, map(length, indices))
    Base.setindex!(dset, X, indices...)
end

function Base.setindex!(dset::Dataset, x::T, I::IndexType...) where {T<:AbstractString}
    indices = Base.to_indices(dset, I)
    X = fill(x, map(length, indices))
    Base.setindex!(dset, X, indices...)
end

function Base.setindex!(dset::Dataset, X::AbstractArray, I::IndexType...)
    Base.setindex!(dset, Array(X), I...)
end

"""
    create_external_dataset(parent, name, filepath, dtype, dspace, offset = 0)

Create an external dataset with data in an external file.
* `parent` - File or Group
* `name` - Name of the Dataset
* `filepath` - File path to where the data is tored
* `dtype` - Datatype, Type, or value where `datatype` is applicable
* `offset` - Offset, in bytes, from the beginning of the file to the location in the file where the data starts.

See also [`API.h5p_set_external`](@ref) to link to multiple segments.
"""
function create_external_dataset(
    parent::Union{File,Group},
    name::AbstractString,
    filepath::AbstractString,
    t,
    sz::Dims,
    offset::Integer=0
)
    create_external_dataset(parent, name, filepath, datatype(t), dataspace(sz), offset)
end
function create_external_dataset(
    parent::Union{File,Group},
    name::AbstractString,
    filepath::AbstractString,
    dtype::Datatype,
    dspace::Dataspace,
    offset::Integer=0
)
    checkvalid(parent)
    create_dataset(
        parent,
        name,
        dtype,
        dspace;
        external=(filepath, offset, length(dspace) * sizeof(dtype))
    )
end

### HDF5 utilities ###

# default behavior
read_dataset(
    dset::Dataset, memtype::Datatype, buf, xfer::DatasetTransferProperties=dset.xfer
) = API.h5d_read(dset, memtype, API.H5S_ALL, API.H5S_ALL, xfer, buf)
write_dataset(
    dset::Dataset, memtype::Datatype, x, xfer::DatasetTransferProperties=dset.xfer
) = API.h5d_write(dset, memtype, API.H5S_ALL, API.H5S_ALL, xfer, x)

# type-specific behaviors
function _check_invalid(dataset::Dataset, buf::AbstractArray)
    num_bytes_dset = Base.checked_mul(sizeof(datatype(dataset)), length(dataset))
    num_bytes_buf = Base.checked_mul(sizeof(eltype(buf)), length(buf))
    num_bytes_buf == num_bytes_dset || throw(
        ArgumentError(
            "Invalid number of bytes: $num_bytes_buf != $num_bytes_dset, for dataset \"$(name(dataset))\""
        )
    )
    stride(buf, 1) == 1 || throw(
        ArgumentError("Cannot read/write arrays with a different stride than `Array`")
    )
end
function read_dataset(
    dataset::Dataset,
    memtype::Datatype,
    buf::AbstractArray,
    xfer::DatasetTransferProperties=dataset.xfer
)
    _check_invalid(dataset, buf)
    API.h5d_read(dataset, memtype, API.H5S_ALL, API.H5S_ALL, xfer, buf)
end

function write_dataset(
    dataset::Dataset,
    memtype::Datatype,
    buf::AbstractArray{T},
    xfer::DatasetTransferProperties=dataset.xfer
) where {T}
    _check_invalid(dataset, buf)
    if isbitstype(T)
        API.h5d_write(dataset, memtype, API.H5S_ALL, API.H5S_ALL, xfer, buf)
    else
        # For non-bitstypes, we need to convert the buffer to a bitstype
        # For mutable structs, this will usually be a NamedTuple.
        jl_type = get_mem_compatible_jl_type(memtype)
        try
            memtype_buf = convert(Array{jl_type}, buf)
            API.h5d_write(dataset, memtype, API.H5S_ALL, API.H5S_ALL, xfer, memtype_buf)
        catch err
            if err isa MethodError
                throw(
                    ArgumentError(
                        "Could not convert non-bitstype $T to $jl_type for writing to HDF5. Consider implementing `convert(::Type{$jl_type}, ::$T)`"
                    )
                )
            else
                rethrow()
            end
        end
    end
end

function write_dataset(
    dataset::Dataset,
    memtype::Datatype,
    buf::Base.ReinterpretArray,
    xfer::DatasetTransferProperties=dataset.xfer
)
    # We cannot obtain a pointer of a ReinterpretArrayin Julia 1.11 and beyond
    # https://github.com/JuliaLang/julia/issues/51962
    buf_copy = copy(buf)
    @assert !(typeof(buf_copy) <: Base.ReinterpretArray) "Copying $(typeof(buf)) resulted in another Base.ReinterpretArray"
    write_dataset(dataset, memtype, buf_copy, xfer)
end

function write_dataset(
    dataset::Dataset,
    memtype::Datatype,
    str::Union{AbstractString,Nothing},
    xfer::DatasetTransferProperties=dataset.xfer
)
    strbuf = Base.cconvert(Cstring, str)
    GC.@preserve strbuf begin
        # unsafe_convert(Cstring, strbuf) is responsible for enforcing the no-'\0' policy,
        # but then need explicit convert to Ptr{UInt8} since Ptr{Cstring} -> Ptr{Cvoid} is
        # not automatic.
        buf = convert(Ptr{UInt8}, Base.unsafe_convert(Cstring, strbuf))
        API.h5d_write(dataset, memtype, API.H5S_ALL, API.H5S_ALL, xfer, buf)
    end
end
function write_dataset(
    dataset::Dataset, memtype::Datatype, x::T, xfer::DatasetTransferProperties=dataset.xfer
) where {T<:Union{ScalarType,Complex{<:ScalarType}}}
    tmp = Ref{T}(x)
    API.h5d_write(dataset, memtype, API.H5S_ALL, API.H5S_ALL, xfer, tmp)
end
function write_dataset(
    dataset::Dataset,
    memtype::Datatype,
    strs::Array{<:AbstractString},
    xfer::DatasetTransferProperties=dataset.xfer
)
    p = Ref{Cstring}(strs)
    API.h5d_write(dataset, memtype, API.H5S_ALL, API.H5S_ALL, xfer, p)
end
write_dataset(
    dataset::Dataset,
    memtype::Datatype,
    ::EmptyArray,
    xfer::DatasetTransferProperties=dataset.xfer
) = nothing

"""
    get_datasets(file::HDF5.File) -> datasets::Vector{HDF5.Dataset}

Get all the datasets in an hdf5 file without loading the data.
"""
function get_datasets(file::File)
    list = Dataset[]
    get_datasets!(list, file)
    list
end
function get_datasets!(list::Vector{Dataset}, node::Union{File,Group,Dataset})
    if isa(node, Dataset)
        push!(list, node)
    else
        for c in keys(node)
            get_datasets!(list, node[c])
        end
    end
end

### Chunks ###

# heuristic chunk layout (return empty array to disable chunking)
function heuristic_chunk(T, shape)
    Ts = sizeof(T)
    sz = prod(shape)
    sz == 0 && return Int[] # never return a zero-size chunk
    chunk = [shape...]
    nd = length(chunk)
    # simplification of ugly heuristic target chunk size from PyTables/h5py:
    target = min(1500000, max(12000, floor(Int, 300 * cbrt(Ts * sz))))
    Ts > target && return ones(chunk)
    # divide last non-unit dimension by 2 until we get <= target
    # (since Julia default to column-major, favor contiguous first dimension)
    while Ts * prod(chunk) > target
        i = nd
        while chunk[i] == 1
            i -= 1
        end
        chunk[i] >>= 1
    end
    return chunk
end
heuristic_chunk(T, ::Tuple{}) = Int[]
heuristic_chunk(A::AbstractArray{T}) where {T} = heuristic_chunk(T, size(A))
heuristic_chunk(x) = Int[]
# (strings are saved as scalars, and hence cannot be chunked)

"""
    do_write_chunk(dataset::Dataset, offset, chunk_bytes::AbstractArray, filter_mask=0)

Write a raw chunk at a given offset.
`chunk_bytes` is an AbstractArray that can be converted to a pointer, Ptr{Cvoid}.
`offset` is a 1-based list of rank `ndims(dataset)` and must fall on a chunk boundary.
"""
function do_write_chunk(dataset::Dataset, offset, chunk_bytes::AbstractArray, filter_mask=0)
    checkvalid(dataset)
    offs = collect(API.hsize_t, reverse(offset)) .- 1
    write_chunk(dataset, offs, chunk_bytes; filter_mask=UInt32(filter_mask))
end

"""
    do_write_chunk(dataset::Dataset, index, chunk_bytes::AbstractArray, filter_mask=0)

Write a raw chunk at a given linear index.
`chunk_bytes` is an AbstractArray that can be converted to a pointer, Ptr{Cvoid}.
`index` is 1-based and consecutive up to the number of chunks.
"""
function do_write_chunk(
    dataset::Dataset, index::Integer, chunk_bytes::AbstractArray, filter_mask=0
)
    checkvalid(dataset)
    index -= 1
    write_chunk(dataset, index, chunk_bytes; filter_mask=UInt32(filter_mask))
end

"""
    do_read_chunk(dataset::Dataset, offset)

Read a raw chunk at a given offset.
`offset` is a 1-based list of rank `ndims(dataset)` and must fall on a chunk boundary.
"""
function do_read_chunk(dataset::Dataset, offset)
    checkvalid(dataset)
    offs = collect(API.hsize_t, reverse(offset)) .- 1
    filters = Ref{UInt32}()
    buf = read_chunk(dataset, offs; filters=filters)
    return (filters[], buf)
end

"""
    do_read_chunk(dataset::Dataset, index::Integer)

Read a raw chunk at a given index.
`index` is 1-based and consecutive up to the number of chunks.
"""
function do_read_chunk(dataset::Dataset, index::Integer)
    checkvalid(dataset)
    index -= 1
    filters = Ref{UInt32}()
    buf = read_chunk(dataset, index; filters=filters)
    return (filters[], buf)
end

struct ChunkStorage{I<:IndexStyle,N} <: AbstractArray{Tuple{UInt32,Vector{UInt8}},N}
    dataset::Dataset
end
ChunkStorage{I,N}(dataset) where {I,N} = ChunkStorage{I,N}(dataset)
Base.IndexStyle(::ChunkStorage{I}) where {I<:IndexStyle} = I()

# ChunkStorage{IndexCartesian,N} (default)

function ChunkStorage(dataset)
    ChunkStorage{IndexCartesian,ndims(dataset)}(dataset)
end

Base.size(cs::ChunkStorage{IndexCartesian}) = get_num_chunks_per_dim(cs.dataset)

function Base.axes(cs::ChunkStorage{IndexCartesian})
    chunk = get_chunk(cs.dataset)
    extent = size(cs.dataset)
    ntuple(i -> 1:chunk[i]:extent[i], length(extent))
end

# Filter flags provided
function Base.setindex!(
    chunk_storage::ChunkStorage{IndexCartesian},
    v::Tuple{<:Integer,AbstractArray},
    index::Integer...
)
    do_write_chunk(chunk_storage.dataset, index, v[2], v[1])
end

# Filter flags will default to 0
function Base.setindex!(
    chunk_storage::ChunkStorage{IndexCartesian}, v::AbstractArray, index::Integer...
)
    do_write_chunk(chunk_storage.dataset, index, v)
end

function Base.getindex(chunk_storage::ChunkStorage{IndexCartesian}, index::Integer...)
    do_read_chunk(chunk_storage.dataset, API.hsize_t.(index))
end

# ChunkStorage{IndexLinear,1}

ChunkStorage{IndexLinear}(dataset)         = ChunkStorage{IndexLinear,1}(dataset)
Base.size(cs::ChunkStorage{IndexLinear})   = (get_num_chunks(cs.dataset),)
Base.length(cs::ChunkStorage{IndexLinear}) = get_num_chunks(cs.dataset)

function Base.setindex!(
    chunk_storage::ChunkStorage{IndexLinear},
    v::Tuple{<:Integer,AbstractArray},
    index::Integer
)
    do_write_chunk(chunk_storage.dataset, index, v[2], v[1])
end

# Filter flags will default to 0
function Base.setindex!(
    chunk_storage::ChunkStorage{IndexLinear}, v::AbstractArray, index::Integer
)
    do_write_chunk(chunk_storage.dataset, index, v)
end

function Base.getindex(chunk_storage::ChunkStorage{IndexLinear}, index::Integer)
    do_read_chunk(chunk_storage.dataset, index)
end

# TODO: Move to show.jl. May need to include show.jl after this line.
# ChunkStorage axes may be StepRanges, but this is not available until v"1.6.0"
# no method matching CartesianIndices(::Tuple{StepRange{Int64,Int64},UnitRange{Int64}}) until v"1.6.0"

function Base.show(io::IO, cs::ChunkStorage{IndexCartesian,N}) where {N}
    println(io, "HDF5.ChunkStorage{IndexCartesian,$N}")
    print(io, "Axes: ")
    println(io, axes(cs))
    print(io, cs.dataset)
end
Base.show(
    io::IO, ::MIME{Symbol("text/plain")}, cs::ChunkStorage{IndexCartesian,N}
) where {N} = show(io, cs)

function get_chunk(dset::Dataset)
    p = get_create_properties(dset)
    local ret
    try
        ret = get_chunk(p)
    finally
        close(p)
    end
    ret
end

struct ChunkInfo{N}
    offset::NTuple{N,Int}
    filter_mask::Cuint
    addr::API.haddr_t
    size::API.hsize_t
end
function Base.show(io::IO, ::MIME"text/plain", info::Vector{<:ChunkInfo})
    print(io, typeof(info))
    println(io, " with $(length(info)) elements:")
    println(io, "Offset    \tFilter Mask                     \tAddress\tSize")
    println(io, "----------\t--------------------------------\t-------\t----")
    for ci in info
        println(
            io,
            @sprintf("%10s", ci.offset),
            "\t",
            bitstring(ci.filter_mask),
            "\t",
            ci.addr,
            "\t",
            ci.size
        )
    end
end

"""
    HDF5.get_chunk_info_all(dataset, [dxpl])

Obtain information on all the chunks in a dataset. Returns a
`Vector{ChunkInfo{N}}`.  The fields of `ChunkInfo{N}` are
* offset - `NTuple{N, Int}` indicating the offset of the chunk in terms of elements, reversed to F-order
* filter_mask - Cuint, 32-bit flags indicating whether filters have been applied to the cunk
* addr - haddr_t, byte-offset of the chunk in the file
* size - hsize_t, size of the chunk in bytes
"""
function get_chunk_info_all(dataset, dxpl=API.H5P_DEFAULT)
    @static if hasmethod(API.h5d_chunk_iter, Tuple{API.hid_t})
        return _get_chunk_info_all_by_iter(dataset, dxpl)
    else
        return _get_chunk_info_all_by_index(dataset, dxpl)
    end
end

"""
    _get_chunk_info_all_by_iter(dataset, [dxpl])

Implementation of [`get_chunk_info_all`](@ref) via [`HDF5.API.h5d_chunk_iter`](@ref).

We expect this will be faster, O(N), than using `h5d_get_chunk_info` since this allows us to iterate
through the chunks once.
"""
@inline function _get_chunk_info_all_by_iter(dataset, dxpl=API.H5P_DEFAULT)
    ds = dataspace(dataset)
    N = ndims(ds)
    info = ChunkInfo{N}[]
    num_chunks = get_num_chunks(dataset)
    sizehint!(info, num_chunks)
    API.h5d_chunk_iter(dataset, dxpl) do offset, filter_mask, addr, size
        _offset = reverse(unsafe_load(Ptr{NTuple{N,API.hsize_t}}(offset)))
        push!(info, ChunkInfo{N}(_offset, filter_mask, addr, size))
        return HDF5.API.H5_ITER_CONT
    end
    return info
end

"""
    _get_chunk_info_all_by_index(dataset, [dxpl])

Implementation of [`get_chunk_info_all`](@ref) via [`HDF5.API.h5d_get_chunk_info`](@ref).

We expect this will be slower, O(N^2), than using `h5d_chunk_iter` since each call to `h5d_get_chunk_info`
iterates through the B-tree structure.
"""
@inline function _get_chunk_info_all_by_index(dataset, dxpl=API.H5P_DEFAULT)
    ds = dataspace(dataset)
    N = ndims(ds)
    info = ChunkInfo{N}[]
    num_chunks = get_num_chunks(dataset)
    sizehint!(info, num_chunks)
    for chunk_index in 0:(num_chunks - 1)
        _info_nt = HDF5.API.h5d_get_chunk_info(dataset, chunk_index)
        _offset = (reverse(_info_nt[:offset])...,)
        filter_mask = _info_nt[:filter_mask]
        addr = _info_nt[:addr]
        size = _info_nt[:size]
        push!(info, ChunkInfo{N}(_offset, filter_mask, addr, size))
    end
    return info
end

# properties that require chunks in order to work (e.g. any filter)
# values do not matter -- just needed to form a NamedTuple with the desired keys
const chunked_props = (; compress=nothing, deflate=nothing, blosc=nothing, shuffle=nothing)

using HDF5
using Test

@testset "mmap" begin

    # Create a new file
    fn = tempname()
    f = h5open(fn, "w")
    @test isopen(f)

    # Create two datasets, one with late allocation (the default for contiguous
    # datasets) and the other with explicit early allocation.
    hdf5_A = create_dataset(f, "A", datatype(Int64), dataspace(3, 3))
    hdf5_B = create_dataset(
        f, "B", datatype(Float64), dataspace(3, 3); alloc_time=HDF5.API.H5D_ALLOC_TIME_EARLY
    )
    # The late case cannot be mapped yet.
    @test_throws ErrorException("Error getting offset") HDF5.readmmap(f["A"])
    # Then write and fill dataset A, making it mappable. B was filled with 0.0 at
    # creation.
    A = rand(Int64, 3, 3)
    hdf5_A[:, :] = A
    flush(f)
    close(f)
    # Read HDF5 file & MMAP
    f = h5open(fn, "r")
    A_mmaped = HDF5.readmmap(f["A"])
    @test all(A .== A_mmaped)
    @test all(iszero, HDF5.readmmap(f["B"]))
    # Check that it is read only
    @test_throws ReadOnlyMemoryError A_mmaped[1, 1] = 33
    close(f)
    # Now check if we can write
    f = h5open(fn, "r+")
    A_mmaped = HDF5.readmmap(f["A"])
    A_mmaped[1, 1] = 33
    close(f)

    # issue #863 - fix mmapping complex arrays
    fn = tempname()
    f = h5open(fn, "w")
    A = rand(ComplexF32, 5, 5)
    f["A"] = A
    close(f)
    f = h5open(fn, "r+")
    complex_support = HDF5.COMPLEX_SUPPORT[]
    # Complex arrays can be mmapped when complex support is enabled
    complex_support || HDF5.enable_complex_support()
    @test A == read(f["A"])
    @test A == HDF5.readmmap(f["A"])
    # But mmapping should throw an error when support is disabled
    HDF5.disable_complex_support()
    At = [(r=real(c), i=imag(c)) for c in A]
    @test read(f["A"]) == At # readable as array of NamedTuples
    @test_throws ErrorException("Cannot mmap datasets of type $(eltype(At))") HDF5.readmmap(
        f["A"]
    )
    close(f)
    # Restore complex support state
    complex_support && HDF5.enable_complex_support()
end # testset

import Base: @deprecate, @deprecate_binding, depwarn

###
### v0.16 deprecations
###

### Changed in PR #844
@deprecate silence_errors(f::Function) f()

for name in names(API; all=true)
    if name ∉ names(HDF5; all=true) && startswith(uppercase(String(name)), "H")
        depmsg = ", use HDF5.API.$name instead."
        @eval Base.@deprecate_binding $name API.$name false $depmsg
    end
end

### Changed in PR #847
import Base: getindex, setindex!
@deprecate getindex(p::Properties, name::Symbol) Base.getproperty(p, name)
@deprecate setindex!(p::Properties, val, name::Symbol) Base.setproperty!(p, name, val)

# UTF8_LINK_PROPERTIES etc. used to be Refs, so required UTF8_LINK_PROPERTIES[] to set.
@deprecate getindex(p::Properties) p

function create_property(class; kwargs...)
    (oldname, newtype) =
        class == HDF5.API.H5P_OBJECT_CREATE    ? (:H5P_OBJECT_CREATE, ObjectCreateProperties) :
        class == HDF5.API.H5P_FILE_CREATE      ? (:H5P_FILE_CREATE, FileCreateProperties) :
        class == HDF5.API.H5P_FILE_ACCESS      ? (:H5P_FILE_ACCESS, FileAccessProperties) :
        class == HDF5.API.H5P_DATASET_CREATE   ? (:H5P_DATASET_CREATE, DatasetCreateProperties) :
        class == HDF5.API.H5P_DATASET_ACCESS   ? (:H5P_DATASET_ACCESS, DatasetAccessProperties) :
        class == HDF5.API.H5P_DATASET_XFER     ? (:H5P_DATASET_XFER, DatasetTransferProperties) :
        class == HDF5.API.H5P_FILE_MOUNT       ? (:H5P_FILE_MOUNT, FileMountProperties) :
        class == HDF5.API.H5P_GROUP_CREATE     ? (:H5P_GROUP_CREATE, GroupCreateProperties) :
        class == HDF5.API.H5P_GROUP_ACCESS     ? (:H5P_GROUP_ACCESS, GroupAccessProperties) :
        class == HDF5.API.H5P_DATATYPE_CREATE  ? (:H5P_DATATYPE_CREATE, DatatypeCreateProperties) :
        class == HDF5.API.H5P_DATATYPE_ACCESS  ? (:H5P_DATATYPE_ACCESS, DatatypeAccessProperties) :
        class == HDF5.API.H5P_STRING_CREATE    ? (:H5P_STRING_CREATE, StringCreateProperties) :
        class == HDF5.API.H5P_ATTRIBUTE_CREATE ? (:H5P_ATTRIBUTE_CREATE, AttributeCreateProperties) :
        class == HDF5.API.H5P_OBJECT_COPY      ? (:H5P_OBJECT_COPY, ObjectCopyProperties) :
        class == HDF5.API.H5P_LINK_CREATE      ? (:H5P_LINK_CREATE, LinkCreateProperties) :
        class == HDF5.API.H5P_LINK_ACCESS      ? (:H5P_LINK_ACCESS, LinkAccessProperties) :
        error("invalid class")
    Base.depwarn(
        "`create_property(HDF5.$oldname; kwargs...)` has been deprecated, use `$newtype(;kwargs...)` instead.",
        :create_property
    )
    init!(newtype(; kwargs...))
end

@deprecate set_chunk(p::Properties, dims...) set_chunk!(p, dims) false
@deprecate get_userblock(p::Properties) p.userblock false

function set_shuffle!(p::Properties, ::Tuple{})
    depwarn("`shuffle=()` option is deprecated, use `shuffle=true`", :set_shuffle!)
    set_shuffle!(p, true)
end

# see src/properties.jl for the following deprecated keywords
# :compress
# :fapl_mpio
# :track_times

### Changed in PR #887
# see src/properties.jl for the following deprecated keyword
# :filter

### Changed in PR #902
import Base: append!, push!
import .Filters: ExternalFilter
@deprecate append!(filters::Filters.FilterPipeline, extra::NTuple{N,Integer}) where {N} append!(
    filters, [ExternalFilter(extra...)]
)
@deprecate push!(p::Filters.FilterPipeline, f::NTuple{N,Integer}) where {N} push!(
    p, ExternalFilter(f...)
)
@deprecate ExternalFilter(t::Tuple) ExternalFilter(t...) false

### Changed in PR #979
# Querying items in the file
@deprecate object_info(obj::Union{File,Object}) API.h5o_get_info1(checkvalid(obj))

### Changed in PR #994
@deprecate set_track_order(p::Properties, val::Bool) set_track_order!(
    p::Properties, val::Bool
) false

# Ensure that objects haven't been closed
Base.isvalid(obj::Union{File,Datatype,Dataspace}) = obj.id != -1 && API.h5i_is_valid(obj)
Base.isvalid(obj::Union{Group,Dataset,Attribute}) =
    obj.id != -1 && obj.file.id != -1 && API.h5i_is_valid(obj)
checkvalid(obj) = isvalid(obj) ? obj : error("File or object has been closed")

# Close functions

# Close functions that should first check that the file is still open. The common case is a
# file that has been closed with CLOSE_STRONG but there are still finalizers that have not run
# for the datasets, etc, in the file.

function Base.close(obj::Union{Group,Dataset})
    if obj.id != -1
        if obj.file.id != -1 && isvalid(obj)
            API.h5o_close(obj)
        end
        obj.id = -1
    end
    nothing
end

# Object (group, named datatype, or dataset) open
function h5object(obj_id::API.hid_t, parent)
    obj_type = API.h5i_get_type(obj_id)
    if obj_type == API.H5I_GROUP
        Group(obj_id, file(parent))
    elseif obj_type == API.H5I_DATATYPE
        Datatype(obj_id, file(parent))
    elseif obj_type == API.H5I_DATASET
        Dataset(obj_id, file(parent))
    else
        error("Invalid object type for path ", path)
    end
end

open_object(parent, path::AbstractString) =
    h5object(API.h5o_open(checkvalid(parent), path, API.H5P_DEFAULT), parent)

function gettype(parent, path::AbstractString)
    obj_id = API.h5o_open(checkvalid(parent), path, API.H5P_DEFAULT)
    obj_type = API.h5i_get_type(obj_id)
    API.h5o_close(obj_id)
    return obj_type
end

# Copy objects
"""
    copy_object(src_parent::Union{File,Group}, src_path::AbstractString, dst_parent::Union{File,Group}, dst_path::AbstractString)

Copy data from `src_parent[src_path]` to `dst_parent[dst_path]`.

# Examples
```julia
f = h5open("f.h5", "r")
g = h5open("g.h5", "cw")
copy_object(f, "Group1", g, "GroupA")
copy_object(f["Group1"], "data1", g, "DataSet/data_1")
```
"""
copy_object(
    src_parent::Union{File,Group},
    src_path::AbstractString,
    dst_parent::Union{File,Group},
    dst_path::AbstractString
) = API.h5o_copy(
    checkvalid(src_parent),
    src_path,
    checkvalid(dst_parent),
    dst_path,
    API.H5P_DEFAULT,
    _link_properties(dst_path)
)
"""
    copy_object(src_obj::Object, dst_parent::Union{File,Group}, dst_path::AbstractString)

# Examples
```julia
copy_object(f["Group1"], g, "GroupA")
copy_object(f["Group1/data1"], g, "DataSet/data_1")
```
"""
copy_object(src_obj::Object, dst_parent::Union{File,Group}, dst_path::AbstractString) =
    API.h5o_copy(
        checkvalid(src_obj),
        ".",
        checkvalid(dst_parent),
        dst_path,
        API.H5P_DEFAULT,
        _link_properties(dst_path)
    )

using Test
using HDF5

@testset "Strings" begin
    # Check creation of variable length string by passing String
    fn = tempname()
    h5open(fn, "w") do f
        ds = create_dataset(f, "strings", String, (4,))
        ds[1] = "Hello"
        ds[2] = "Hi"
        ds[3] = "Bonjour"
        ds[4] = GenericString("Hola")
    end
    h5open(fn, "r") do f
        ds = f["strings"]
        @test ds[1] == "Hello"
        @test ds[2] == "Hi"
        @test ds[3] == "Bonjour"
        @test ds[4] == "Hola"
    end
    rm(fn)

    # Check multiple assignment
    h5open(fn, "w") do f
        ds = create_dataset(f, "strings2", String, (3,))
        ds[:] = "Guten tag"
    end
    h5open(fn, "r") do f
        ds = f["strings2"]
        @test ds[1] == "Guten tag"
        @test ds[2] == "Guten tag"
        @test ds[3] == "Guten tag"
    end
    rm(fn)

    # Check assignment to a scalar dataset
    h5open(fn, "w") do f
        ds = write_dataset(f, "string", GenericString("Hi"))
    end
    h5open(fn) do f
        @test f["string"][] == "Hi"
    end
    rm(fn)
end

import HDF5.API

@testset "plugins" begin
    state = API.h5pl_get_loading_state()
    @test state != API.H5PL_TYPE_ERROR
    @test API.h5pl_set_loading_state(state) === nothing
    tmp = mktempdir()
    @test API.h5pl_append(tmp) === nothing
    @test API.h5pl_get(1) == tmp
    tmp = mktempdir()
    @test API.h5pl_prepend(tmp) === nothing
    @test API.h5pl_get(0) == tmp
    tmp = mktempdir()
    @test API.h5pl_replace(tmp, 1) === nothing
    @test API.h5pl_get(1) == tmp
    tmp = mktempdir()
    @test API.h5pl_insert(tmp, 1) === nothing
    @test API.h5pl_get(1) == tmp
    @test API.h5pl_remove(1) === nothing
    @test API.h5pl_size() == 3
end

### Read and write operations common to multiple types

# Convenience macros
macro read(fid, sym)
    !isa(sym, Symbol) && error("Second input to @read must be a symbol (i.e., a variable)")
    esc(:($sym = read($fid, $(string(sym)))))
end
macro write(fid, sym)
    !isa(sym, Symbol) && error("Second input to @write must be a symbol (i.e., a variable)")
    esc(:(write($fid, $(string(sym)), $sym)))
end

# Generic read functions

"""
    read(parent::Union{HDF5.File, HDF5.Group}, name::AbstractString; pv...)
    read(parent::Union{HDF5.File, HDF5.Group}, name::AbstractString => dt::HDF5.Datatype; pv...)

Read a dataset or attribute from a HDF5 file of group identified by `name`.
Optionally, specify the [`HDF5.Datatype`](@ref) to be read.
"""
function Base.read(parent::Union{File,Group}, name::AbstractString; pv...)
    obj = getindex(parent, name; pv...)
    val = read(obj)
    close(obj)
    val
end

function Base.read(
    parent::Union{File,Group}, name_type_pair::Pair{<:AbstractString,DataType}; pv...
)
    obj = getindex(parent, name_type_pair[1]; pv...)
    val = read(obj, name_type_pair[2])
    close(obj)
    val
end

# "Plain" (unformatted) reads. These work only for simple types: scalars, arrays, and strings
# See also "Reading arrays using getindex" below
# This infers the Julia type from the HDF5.Datatype. Specific file formats should provide their own read(dset).
const DatasetOrAttribute = Union{Dataset,Attribute}

"""
    read(obj::HDF5.DatasetOrAttribute}

Read the data within a [`HDF5.Dataset`](@ref) or [`HDF5.Attribute`](@ref).
"""
function Base.read(obj::DatasetOrAttribute)
    dtype = datatype(obj)
    T = get_jl_type(dtype)
    val = generic_read(obj, dtype, T)
    close(dtype)
    return val
end

function Base.getindex(obj::DatasetOrAttribute, I...)
    dtype = datatype(obj)
    T = get_jl_type(dtype)
    val = generic_read(obj, dtype, T, I...)
    close(dtype)
    return val
end

function Base.read(obj::DatasetOrAttribute, ::Type{T}, I...) where {T}
    dtype = datatype(obj)
    val = generic_read(obj, dtype, T, I...)
    close(dtype)
    return val
end

# `Type{String}` does not have a definite size, so the generic_read does not accept
# it even though it will return a `String`. This explicit overload allows that usage.
function Base.read(obj::DatasetOrAttribute, ::Type{String}, I...)
    dtype = datatype(obj)
    T = get_jl_type(dtype)
    T <: Union{Cstring,FixedString} || error(name(obj), " cannot be read as type `String`")
    val = generic_read(obj, dtype, T, I...)
    close(dtype)
    return val
end

"""
    copyto!(output_buffer::AbstractArray{T}, obj::Union{DatasetOrAttribute}) where T

Copy [part of] a HDF5 dataset or attribute to a preallocated output buffer.
The output buffer must be convertible to a pointer and have a contiguous layout.
"""
function Base.copyto!(
    output_buffer::AbstractArray{T}, obj::DatasetOrAttribute, I...
) where {T}
    dtype = datatype(obj)
    val = nothing
    try
        val = generic_read!(output_buffer, obj, dtype, T, I...)
    finally
        close(dtype)
    end
    return val
end

# Special handling for reading OPAQUE datasets and attributes
function generic_read!(
    buf::Matrix{UInt8}, obj::DatasetOrAttribute, filetype::Datatype, ::Type{Opaque}
)
    generic_read(obj, filetype, Opaque, buf)
end
function generic_read(
    obj::DatasetOrAttribute,
    filetype::Datatype,
    ::Type{Opaque},
    buf::Union{Matrix{UInt8},Nothing}=nothing
)
    sz = size(obj)
    if isnothing(buf)
        buf = Matrix{UInt8}(undef, sizeof(filetype), prod(sz))
    end
    if obj isa Dataset
        read_dataset(obj, filetype, buf, obj.xfer)
    else
        read_attribute(obj, filetype, buf)
    end
    tag = API.h5t_get_tag(filetype)
    if isempty(sz)
        # scalar (only) result
        data = vec(buf)
    else
        # array of opaque objects
        data = reshape([buf[:, i] for i in 1:prod(sz)], sz...)
    end
    return Opaque(data, tag)
end

# generic read function
function generic_read!(
    buf::Union{AbstractMatrix{UInt8},AbstractArray{T}},
    obj::DatasetOrAttribute,
    filetype::Datatype,
    ::Type{T},
    I...
) where {T}
    return _generic_read(obj, filetype, T, buf, I...)
end
function generic_read(
    obj::DatasetOrAttribute, filetype::Datatype, ::Type{T}, I...
) where {T}
    return _generic_read(obj, filetype, T, nothing, I...)
end
function _generic_read(
    obj::DatasetOrAttribute,
    filetype::Datatype,
    ::Type{T},
    buf::Union{AbstractMatrix{UInt8},AbstractArray{T},Nothing},
    I...
) where {T}
    sz, scalar, dspace = _size_of_buffer(obj, I)

    if isempty(sz)
        close(dspace)
        return EmptyArray{T}()
    end

    try
        if isnothing(buf)
            buf = _normalized_buffer(T, sz)
        else
            sizeof(buf) != prod(sz) * sizeof(T) && error(
                "Provided array buffer of size, $(size(buf)), and element type, $(eltype(buf)), does not match the dataset of size, $sz, and type, $T"
            )
        end
    catch err
        close(dspace)
        rethrow(err)
    end

    memtype = _memtype(filetype, T)
    memspace = isempty(I) ? dspace : dataspace(sz)

    try
        if obj isa Dataset
            API.h5d_read(obj, memtype, memspace, dspace, obj.xfer, buf)
        else
            API.h5a_read(obj, memtype, buf)
        end

        if do_normalize(T)
            out = reshape(normalize_types(T, buf), sz...)
        else
            out = buf
        end

        xfer_id = obj isa Dataset ? obj.xfer.id : API.H5P_DEFAULT
        do_reclaim(T) && API.h5d_vlen_reclaim(memtype, memspace, xfer_id, buf)

        if scalar
            return out[1]
        else
            return out
        end
    catch e
        # Add nicer errors if reading fails.
        if obj isa Dataset
            prop = get_create_properties(obj)
            try
                Filters.ensure_filters_available(Filters.FilterPipeline(prop))
            finally
                close(prop)
            end
        end
        throw(e)
    finally
        close(memtype)
        close(memspace)
        close(dspace)
    end
end

"""
    similar(obj::DatasetOrAttribute, [::Type{T}], [dims::Integer...]; normalize = true)

Return a `Array{T}` or `Matrix{UInt8}` to that can contain [part of] the dataset.

The `normalize` keyword will normalize the buffer for string and array datatypes.
"""
function Base.similar(
    obj::DatasetOrAttribute, ::Type{T}, dims::Dims; normalize::Bool=true
) where {T}
    filetype = datatype(obj)
    try
        return similar(obj, filetype, T, dims; normalize=normalize)
    finally
        close(filetype)
    end
end
Base.similar(
    obj::DatasetOrAttribute, ::Type{T}, dims::Integer...; normalize::Bool=true
) where {T} = similar(obj, T, Int.(dims); normalize=normalize)

# Base.similar without specifying the Julia type
function Base.similar(obj::DatasetOrAttribute, dims::Dims; normalize::Bool=true)
    filetype = datatype(obj)
    try
        T = get_jl_type(filetype)
        return similar(obj, filetype, T, dims; normalize=normalize)
    finally
        close(filetype)
    end
end
Base.similar(obj::DatasetOrAttribute, dims::Integer...; normalize::Bool=true) =
    similar(obj, Int.(dims); normalize=normalize)

# Opaque types
function Base.similar(
    obj::DatasetOrAttribute, filetype::Datatype, ::Type{Opaque}; normalize::Bool=true
)
    # normalize keyword for consistency, but it is ignored for Opaque
    sz = size(obj)
    return Matrix{UInt8}(undef, sizeof(filetype), prod(sz))
end

# Undocumented Base.similar signature allowing filetype to be specified
function Base.similar(
    obj::DatasetOrAttribute, filetype::Datatype, ::Type{T}, dims::Dims; normalize::Bool=true
) where {T}
    # We are reusing code that expect indices
    I = Base.OneTo.(dims)
    sz, scalar, dspace = _size_of_buffer(obj, I)
    memtype = _memtype(filetype, T)
    try
        buf = _normalized_buffer(T, sz)

        if normalize && do_normalize(T)
            buf = reshape(normalize_types(T, buf), sz)
        end

        return buf
    finally
        close(dspace)
        close(memtype)
    end
end
Base.similar(
    obj::DatasetOrAttribute,
    filetype::Datatype,
    ::Type{T},
    dims::Integer...;
    normalize::Bool=true
) where {T} = similar(obj, filetype, T, Int.(dims); normalize=normalize)

# Utilities used in Base.similar implementation

#=
    _memtype(filetype::Datatype, T)

This is a utility function originall from generic_read.
It gets the native memory type for the system based on filetype, and checks
if the size matches.
=#
@inline function _memtype(filetype::Datatype, ::Type{T}) where {T}
    !isconcretetype(T) && error("type $T is not concrete")

    # padded layout in memory
    memtype = Datatype(API.h5t_get_native_type(filetype))

    if sizeof(T) != sizeof(memtype)
        error("""
              Type size mismatch
              sizeof($T) = $(sizeof(T))
              sizeof($memtype) = $(sizeof(memtype))
              """)
    end

    return memtype
end

@inline function _memtype(filetype::Datatype, ::Type{S}) where {S<:AbstractString}
    return datatype(S)
end

#=
    _size_of_buffer(obj::DatasetOrAttribute, [I::Tuple, dspace::Dataspace])

This is a utility function originally from generic_read, but factored out.
The primary purpose is to determine the size and shape of the buffer to
create in order to hold the contents of a Dataset or Attribute.

# Arguments
* obj - A Dataset or Attribute
* I - (optional) indices, defaults to ()
* dspace - (optional) dataspace, defaults to dataspace(obj).
           This argument will be consumed by hyperslab and returned.

# Returns
* `sz` the size of the selection
* `scalar`, which is true if the value should be read as a scalar.
* `dspace`, hyper
=#
@inline function _size_of_buffer(
    obj::DatasetOrAttribute, I::Tuple=(), dspace::Dataspace=dataspace(obj)
)
    !isempty(I) &&
        obj isa Attribute &&
        error("HDF5 attributes do not support hyperslab selections")

    stype = API.h5s_get_simple_extent_type(dspace)

    if !isempty(I) && stype != API.H5S_NULL
        indices = Base.to_indices(obj, I)
        dspace = hyperslab(dspace, indices...)
    end

    scalar = false
    if stype == API.H5S_SCALAR
        sz = (1,)
        scalar = true
    elseif stype == API.H5S_NULL
        sz = ()
        # scalar = false
    elseif isempty(I)
        sz = size(dspace)
        # scalar = false
    else
        # Determine the size by the length of non-Int indices
        sz = map(length, filter(i -> !isa(i, Int), indices))
        if isempty(sz)
            # All indices are Int, so this is scalar
            sz = (1,)
            scalar = true
        end
    end

    return sz, scalar, dspace
end

#=
    _normalized_buffer(T, sz)

Return a Matrix{UInt8} for a normalized type or `Array{T}` for a regular type.
See `do_normalize` in typeconversions.jl.
=#
@inline function _normalized_buffer(::Type{T}, sz::NTuple{N,Int}) where {T,N}
    if do_normalize(T)
        # The entire dataset is read into in a buffer matrix where the first dimension at
        # any stage of normalization is the bytes for a single element of type `T`, and
        # the second dimension of the matrix runs through all elements.
        buf = Matrix{UInt8}(undef, sizeof(T), prod(sz))
    else
        buf = Array{T}(undef, sz...)
    end

    return buf
end

"""
    VirtualMapping(
        vspace::Dataspace,
        srcfile::AbstractString,
        srcdset::AbstractString,
        srcspace::Dataspace
    )

Specify a map of elements of the virtual dataset (VDS) described by `vspace` to
the elements of the source dataset described by `srcspace`. The source dataset
is identified by the name of the file where it is located, `srcfile`, and the
name of the dataset, `srcdset`.

Both `srcfile` and `srcdset` support "printf"-style formats with `%b` being
replaced by the block count of the selection.

For more details on how source file resolution works, see
[`H5P_SET_VIRTUAL`](https://portal.hdfgroup.org/display/HDF5/H5P_SET_VIRTUAL).
"""
struct VirtualMapping
    vspace::Dataspace
    srcfile::String
    srcdset::String
    srcspace::Dataspace
end

"""
    VirtualLayout(dcpl::DatasetCreateProperties)

The collection of [`VirtualMapping`](@ref)s associated with `dcpl`. This is an
`AbstractVector{VirtualMapping}`, supporting `length`, `getindex` and `push!`.
"""
struct VirtualLayout <: AbstractVector{VirtualMapping}
    dcpl::DatasetCreateProperties
end

function Base.length(vlayout::VirtualLayout)
    return API.h5p_get_virtual_count(vlayout.dcpl)
end
Base.size(vlayout::VirtualLayout) = (length(vlayout),)

function Base.push!(vlayout::VirtualLayout, vmap::VirtualMapping)
    API.h5p_set_virtual(
        vlayout.dcpl, vmap.vspace, vmap.srcfile, vmap.srcdset, vmap.srcspace
    )
    return vlayout
end
function Base.append!(vlayout::VirtualLayout, vmaps)
    for vmap in vmaps
        push!(vlayout, vmap)
    end
    return vlayout
end

function Base.getindex(vlayout::VirtualLayout, i::Integer)
    vspace = Dataspace(API.h5p_get_virtual_vspace(vlayout.dcpl, i - 1))
    srcfile = API.h5p_get_virtual_filename(vlayout.dcpl, i - 1)
    srcdset = API.h5p_get_virtual_dsetname(vlayout.dcpl, i - 1)
    srcspace = Dataspace(API.h5p_get_virtual_srcspace(vlayout.dcpl, i - 1))
    return VirtualMapping(vspace, srcfile, srcdset, srcspace)
end

module Drivers

export POSIX, ROS3

import ..API
import ..HDF5: HDF5, Properties, h5doc

using Libdl: dlopen, dlsym
if !isdefined(Base, :get_extension)
    using Requires: @require
end

function get_driver(p::Properties)
    driver_id = API.h5p_get_driver(p)
    D = get(DRIVERS, driver_id) do
        error("Unknown driver type")
    end
    get_driver(p, D)
end

abstract type Driver end

const DRIVERS = Dict{API.hid_t,Type{<:Driver}}()

"""
    Core([increment::Csize_t, backing_store::Cuint, [write_tracking::Cuint, page_size::Csize_t]])
    Core(; increment::Csize_t = 8192, backing_store::Cuint = true, write_tracking::Cuint = false, page_size::Csize_t = 524288)

# Arguments

* `increment`: specifies the increment by which allocated memory is to be increased each time more memory is required. (default: 8192)
* `backing_store`: Boolean flag indicating whether to write the file contents to disk when the file is closed. (default: true)
* `write_tracking`: Boolean flag indicating whether write tracking is enabled. (default: false)
* `page_size`: Size, in bytes, of write aggregation pages. (default: 524288)
"""
struct Core <: Driver
    increment::Csize_t
    backing_store::Cuint #Bool
    write_tracking::Cuint #Bool
    page_size::Csize_t
end
Core(increment, backing_store) = Core(increment, backing_store, false, 524288)
Core(; increment=8192, backing_store=true, write_tracking=false, page_size=524288) =
    Core(increment, backing_store, write_tracking, page_size)

function get_driver(p::Properties, ::Type{Core})
    r_increment = Ref{Csize_t}(0)
    r_backing_store = Ref{Bool}(0)
    r_write_tracking = Ref{Bool}(0)
    r_page_size = Ref{Csize_t}(0)
    API.h5p_get_fapl_core(p, r_increment, r_backing_store)
    API.h5p_get_core_write_tracking(p, r_write_tracking, r_page_size)
    return Core(r_increment[], r_backing_store[], r_write_tracking[], r_page_size[])
end

function set_driver!(fapl::Properties, driver::Core)
    HDF5.init!(fapl)
    API.h5p_set_fapl_core(fapl, driver.increment, driver.backing_store)
    API.h5p_set_core_write_tracking(fapl, driver.write_tracking, driver.page_size)
    DRIVERS[API.h5p_get_driver(fapl)] = Core
    return nothing
end

"""
    POSIX()

Also referred to as SEC2, this driver uses POSIX file-system functions like read and
write to perform I/O to a single, permanent file on local disk with no system
buffering. This driver is POSIX-compliant and is the default file driver for all systems.
"""
struct POSIX <: Driver end

function get_driver(fapl::Properties, ::Type{POSIX})
    POSIX()
end

function set_driver!(fapl::Properties, ::POSIX)
    HDF5.init!(fapl)
    API.h5p_set_fapl_sec2(fapl)
    DRIVERS[API.h5p_get_driver(fapl)] = POSIX
    return nothing
end

function __init__()
    # Initialize POSIX key in DRIVERS
    HDF5.FileAccessProperties() do fapl
        set_driver!(fapl, POSIX())
    end

    # Check whether the libhdf5 was compiled with parallel support.
    HDF5.HAS_PARALLEL[] = API._has_symbol(:H5Pset_fapl_mpio)
    HDF5.HAS_ROS3[] = API._has_symbol(:H5Pset_fapl_ros3)

    @static if !isdefined(Base, :get_extension)
        @require MPI = "da04e1cc-30fd-572f-bb4f-1f8673147195" include("../../ext/MPIExt.jl")
    end
end

# The docstring for `MPIO` basically belongs to the struct `MPIO` in
# ext/MPIExt/MPIExt.jl. However, we need to document it here to make it
# work smoothly both for Julia without package extensions (up to v1.8) and
# with package extensions (v1.9 and newer).
@doc """
    MPIO(comm::MPI.Comm, info::MPI.Info)
    MPIO(comm::MPI.Comm; kwargs....)

The parallel MPI file driver. This requires the use of
[MPI.jl](https://github.com/JuliaParallel/MPI.jl), and a custom HDF5 binary that has been
built with MPI support.

- `comm` is the communicator over which the file will be opened.
- `info`/`kwargs` are MPI-IO options, and are passed to `MPI_FILE_OPEN`.

# See also

- [`HDF5.has_parallel`](@ref)
- [Parallel HDF5](@ref)

# External links

- $(h5doc("H5P_SET_FAPL_MPIO"))
- [Parallel HDF5](https://portal.hdfgroup.org/display/HDF5/Parallel+HDF5)
"""
function MPIO end

include("ros3.jl")
end # module

module MPIExt

isdefined(Base, :get_extension) ? (using MPI) : (using ..MPI)
import Libdl
using HDF5: HDF5, API, Drivers, Drivers.Driver, Properties, h5doc, h5open

###
### MPIO
###

# define API functions here
function API.h5p_set_fapl_mpio(fapl_id, comm, info)
    API.lock(API.liblock)
    var"#status#" = try
        ccall(
            (:H5Pset_fapl_mpio, API.libhdf5),
            API.herr_t,
            (API.hid_t, MPI.MPI_Comm, MPI.MPI_Info),
            fapl_id,
            comm,
            info
        )
    finally
        API.unlock(API.liblock)
    end
    var"#status#" < 0 && API.@h5error("Error setting MPIO properties")
    return nothing
end

function API.h5p_get_fapl_mpio(fapl_id, comm, info)
    API.lock(API.liblock)
    var"#status#" = try
        ccall(
            (:H5Pget_fapl_mpio, API.libhdf5),
            API.herr_t,
            (API.hid_t, Ptr{MPI.MPI_Comm}, Ptr{MPI.MPI_Info}),
            fapl_id,
            comm,
            info
        )
    finally
        API.unlock(API.liblock)
    end
    var"#status#" < 0 && API.@h5error("Error getting MPIO properties")
    return nothing
end

# The docstring for `MPIO` is included in the function `MPIO` in
# src/drivers/drivers.jl.
struct MPIO <: Driver
    comm::MPI.Comm
    info::MPI.Info
end
Drivers.MPIO(comm::MPI.Comm, info::MPI.Info) = MPIO(comm, info)
Drivers.MPIO(comm::MPI.Comm; kwargs...) = MPIO(comm, MPI.Info(; kwargs...))

function Drivers.set_driver!(fapl::Properties, mpio::MPIO)
    HDF5.has_parallel() || error(
        "HDF5.jl has no parallel support." *
        " Make sure that you're using MPI-enabled HDF5 libraries, and that" *
        " MPI was loaded before HDF5." *
        " See HDF5.jl docs for details."
    )
    # Note: HDF5 creates a COPY of the comm and info objects, so we don't need to keep a reference around.
    API.h5p_set_fapl_mpio(fapl, mpio.comm, mpio.info)
    Drivers.DRIVERS[API.h5p_get_driver(fapl)] = MPIO
    return nothing
end

function Drivers.get_driver(fapl::Properties, ::Type{MPIO})
    comm = MPI.Comm()
    info = MPI.Info()
    API.h5p_get_fapl_mpio(fapl, comm, info)
    return MPIO(comm, info)
end

"""
    h5open(filename, [mode="r"], comm::MPI.Comm, [info::MPI.Info]; pv...)

Open or create a parallel HDF5 file using the MPI-IO driver.

Equivalent to `h5open(filename, mode; fapl_mpio=(comm, info), pv...)`.
Throws an informative error if the loaded HDF5 libraries do not include parallel
support.

See the [HDF5 docs](https://portal.hdfgroup.org/display/HDF5/H5P_SET_FAPL_MPIO)
for details on the `comm` and `info` arguments.
"""
function HDF5.h5open(
    filename::AbstractString,
    mode::AbstractString,
    comm::MPI.Comm,
    info::MPI.Info=MPI.Info();
    pv...
)
    HDF5.h5open(filename, mode; driver=MPIO(comm, info), pv...)
end

HDF5.h5open(filename::AbstractString, comm::MPI.Comm, args...; pv...) =
    HDF5.h5open(filename, "r", comm, args...; pv...)

end

using HDF5
import HDF5.Drivers
using Test

@testset "Drivers" begin
    fn = tempname()
    A = rand(UInt8, 256, 128)
    h5open(fn, "w"; driver=Drivers.Core()) do f
        ds = write_dataset(f, "core_dataset", A)
    end
    @test isfile(fn)
    h5open(fn, "r") do f
        @test f["core_dataset"][] == A
    end

    fn = tempname()
    file_image = h5open(fn, "w"; driver=Drivers.Core(; backing_store=false)) do f
        ds = write_dataset(f, "core_dataset", A)
        Vector{UInt8}(f)
    end
    @test !isfile(fn)

    h5open(file_image) do f
        @test f["core_dataset"][] == A
    end

    fn = tempname()
    h5open(fn, "r"; driver=Drivers.Core(; backing_store=false), file_image) do f
        @test f["core_dataset"][] == A
    end
end

"""
HDF5.Filters

This module contains the interface for using filters in HDF5.jl.

# Example Usage
```julia
using HDF5
using HDF5.Filters

# Create a new file
fn = tempname()

# Create test data
data = rand(1000, 1000)

# Open temp file for writing
f = h5open(fn, "w") 

# Create datasets
dsdeflate = create_dataset(f, "deflate", datatype(data), dataspace(data),
                           chunk=(100, 100), deflate=3)

dsshufdef = create_dataset(f, "shufdef", datatype(data), dataspace(data),
                           chunk=(100, 100), shuffle=true, deflate=3)

dsfiltdef = create_dataset(f, "filtdef", datatype(data), dataspace(data),
                           chunk=(100, 100), filters=Filters.Deflate(3))

dsfiltshufdef = create_dataset(f, "filtshufdef", datatype(data), dataspace(data),
                               chunk=(100, 100), filters=[Filters.Shuffle(), Filters.Deflate(3)])

# Write data
write(dsdeflate, data)
write(dsshufdef, data)
write(dsfiltdef, data)
write(dsfiltshufdef, data)

close(f)
```

## Additonal Examples

See [test/filter.jl](https://github.com/JuliaIO/HDF5.jl/blob/master/test/filter.jl) for further examples.
"""
module Filters

# builtin filters
export Deflate, Shuffle, Fletcher32, Szip, NBit, ScaleOffset, ExternalFilter

import ..HDF5: Properties, h5doc, API

"""
    Filter

Abstract type to describe HDF5 Filters.
See the Extended Help for information on implementing a new filter.

# Extended Help

## Filter interface

The Filter interface is implemented upon the Filter subtype.

See [`API.h5z_register`](@ref) for details.

### Required Methods to Implement
* `filterid` - registered filter ID
* `filter_func` - implement the actual filter

### Optional Methods to Implement
* `filtername` - defaults to "Unnamed Filter"
* `encoder_present` - defaults to true
* `decoder_present` - defaults to true
* `can_apply_func` - defaults to nothing
* `set_local_func` - defaults to nothing

### Advanced Methods to Implement
* `can_apply_cfunc` - Defaults to wrapping @cfunction around the result of `can_apply_func`
* `set_local_cfunc` - Defaults to wrapping @cfunction around the result of `set_local_func`
* `filter_cfunc` - Defaults to wrapping @cfunction around the result of `filter_func`
* `register_filter` - Defaults to using the above functions to register the filter

Implement the Advanced Methods to avoid @cfunction from generating a runtime closure which may not work on all systems.
"""
abstract type Filter end

"""
    FILTERS

Maps filter id to filter type.
"""
const FILTERS = Dict{API.H5Z_filter_t,Type{<:Filter}}()

"""
    filterid(F) where {F <: Filter}


The internal filter id of a filter of type `F`.
"""
filterid

"""
    encoder_present(::Type{F}) where {F<:Filter}

Can the filter have an encode or compress the data?
Defaults to true.
Returns a Bool. See [`API.h5z_register`](@ref).
"""
encoder_present(::Type{F}) where {F<:Filter} = true

"""
    decoder_present(::Type{F}) where {F<:Filter}

Can the filter decode or decompress the data?
Defaults to true.
Returns a Bool.
See [`API.h5z_register`](@ref)
"""
decoder_present(::Type{F}) where {F<:Filter} = true

"""
    filtername(::Type{F}) where {F<:Filter}

What is the name of a filter?
Defaults to "Unnamed Filter"
Returns a String describing the filter. See [`API.h5z_register`](@ref)
"""
filtername(::Type{F}) where {F<:Filter} = "Unnamed Filter"

"""
    can_apply_func(::Type{F}) where {F<:Filter}

Return a function indicating whether the filter can be applied or `nothing` if no function exists.
The function signature is `func(dcpl_id::API.hid_t, type_id::API.hid_t, space_id::API.hid_t)`.
See [`API.h5z_register`](@ref)
"""
can_apply_func(::Type{F}) where {F<:Filter} = nothing

"""
    can_apply_cfunc(::Type{F}) where {F<:Filter}

Return a C function pointer for the can apply function.
By default, this will return the result of using `@cfunction` on the function
specified by `can_apply_func(F)` or `C_NULL` if `nothing`.

Overriding this will allow `@cfunction` to return a `Ptr{Nothing}` rather
than a `CFunction`` closure which may not work on all systems.
"""
function can_apply_cfunc(::Type{F}) where {F<:Filter}
    func = can_apply_func(F)
    if func === nothing
        return C_NULL
    else
        return @cfunction($func, API.herr_t, (API.hid_t, API.hid_t, API.hid_t))
    end
end

"""
    set_local_func(::Type{F}) where {F<:Filter}

Return a function that sets dataset specific parameters or `nothing` if no function exists.
The function signature is `func(dcpl_id::API.hid_t, type_id::API.hid_t, space_id::API.hid_t)`.
See [`API.h5z_register`](@ref).
"""
set_local_func(::Type{F}) where {F<:Filter} = nothing

"""
    set_local_cfunc(::Type{F}) where {F<:Filter}

Return a C function pointer for the set local function.
By default, this will return the result of using `@cfunction` on the function
specified by `set_local_func(F)` or `C_NULL` if `nothing`.

Overriding this will allow `@cfunction` to return a `Ptr{Nothing}` rather
than a `CFunction`` closure which may not work on all systems.
"""
function set_local_cfunc(::Type{F}) where {F<:Filter}
    func = set_local_func(F)
    if func === nothing
        return C_NULL
    else
        return @cfunction($func, API.herr_t, (API.hid_t, API.hid_t, API.hid_t))
    end
end

"""
    filter_func(::Type{F}) where {F<:Filter}

Returns a function that performs the actual filtering.

See [`API.h5z_register`](@ref)
"""
filter_func(::Type{F}) where {F<:Filter} = nothing

"""
    filter_cfunc(::Type{F}) where {F<:Filter}

Return a C function pointer for the filter function.
By default, this will return the result of using `@cfunction` on the function
specified by `filter_func(F)` or will throw an error if `nothing`.

Overriding this will allow `@cfunction` to return a `Ptr{Nothing}` rather
than a `CFunction`` closure which may not work on all systems.
"""
function filter_cfunc(::Type{F}) where {F<:Filter}
    func = filter_func(F)
    if func === nothing
        error("Filter function for $F must be defined via `filter_func`.")
    end
    c_filter_func = @cfunction(
        $func, Csize_t, (Cuint, Csize_t, Ptr{Cuint}, Csize_t, Ptr{Csize_t}, Ptr{Ptr{Cvoid}})
    )
    return c_filter_func
end

# Generic implementation of register_filter
"""
    register_filter(::Type{F}) where F <: Filter

Register the filter with the HDF5 library via [`API.h5z_register`](@ref).
Also add F to the FILTERS dictionary.
"""
function register_filter(::Type{F}) where {F<:Filter}
    id = filterid(F)
    encoder = encoder_present(F)
    decoder = decoder_present(F)
    name = filtername(F)
    can_apply = can_apply_cfunc(F)
    set_local = set_local_cfunc(F)
    func = filter_cfunc(F)
    GC.@preserve name begin
        API.h5z_register(
            API.H5Z_class_t(
                API.H5Z_CLASS_T_VERS,
                id,
                encoder,
                decoder,
                pointer(name),
                can_apply,
                set_local,
                func
            )
        )
    end
    FILTERS[id] = F
    return nothing
end

"""
    ExternalFilter(filter_id::API.H5Z_filter_t, flags::Cuint, data::Vector{Cuint}, name::String, config::Cuint)
    ExternalFilter(filter_id, flags, data::Integer...)
    ExternalFilter(filter_id, data::AbstractVector{<:Integer} = Cuint[])

Intended to support arbitrary, unregistered, external filters. Allows the
quick creation of filters using internal/proprietary filters without subtyping
`HDF5.Filters.Filter`.
Users are instead encouraged to define subtypes on `HDF5.Filters.Filter`.

# Fields / Arguments
* `filter_id` - (required) `Integer` filter identifer.
* `flags` -     (optional) bit vector describing general properties of the filter. Defaults to `API.H5Z_FLAG_MANDATORY`
* `data` -      (optional) auxillary data for the filter. See [`cd_values`](@ref API.h5p_set_filter). Defaults to `Cuint[]`
* `name` -      (optional) `String` describing the name of the filter. Defaults to "Unknown Filter with id [filter_id]"
* `config` -    (optional) bit vector representing information about the filter regarding whether it is able to encode data, decode data, neither, or both. Defaults to `0`.

# See also:
* [`API.h5p_set_filter`](@ref)
* [`H5Z_GET_FILTER_INFO`](https://portal.hdfgroup.org/display/HDF5/H5Z_GET_FILTER_INFO).
* [Registered Filter Plugins](https://portal.hdfgroup.org/display/support/Registered+Filter+Plugins)
`flags` bits
* `API.H5Z_FLAG_OPTIONAL`
* `API.H5Z_FLAG_MANDATORY`
`config` bits 
* `API.H5Z_FILTER_CONFIG_ENCODE_ENABLED`
* `API.H5Z_FILTER_CONFIG_DECODE_ENABLED`
"""
struct ExternalFilter <: Filter
    filter_id::API.H5Z_filter_t
    flags::Cuint
    data::Vector{Cuint}
    name::String
    config::Cuint
end
function ExternalFilter(filter_id, flags, data::AbstractVector{<:Integer})
    ExternalFilter(filter_id, flags, Cuint.(data), "Unknown Filter with id $filter_id", 0)
end
function ExternalFilter(filter_id, flags, data::Integer...)
    ExternalFilter(filter_id, flags, Cuint[data...])
end
function ExternalFilter(filter_id, data::AbstractVector{<:Integer}=Cuint[])
    ExternalFilter(filter_id, API.H5Z_FLAG_MANDATORY, data)
end
filterid(filter::ExternalFilter) = filter.filter_id
filtername(filter::ExternalFilter) = filter.name
filtername(::Type{ExternalFilter}) = "Unknown Filter"
encoder_present(::Type{ExternalFilter}) = false
decoder_present(::Type{ExternalFilter}) = false

"""
    UnknownFilter

Unknown filter type. Alias for [`ExternalFilter`](@ref) (see related documentation).
"""
const UnknownFilter = ExternalFilter

"""
    FilterPipeline(plist::DatasetCreateProperties)

The filter pipeline associated with `plist`. Acts like a `AbstractVector{Filter}`,
supporting the following operations:

- `length(pipeline)`: the number of filters.
- `pipeline[i]` to return the `i`th filter.
- `pipeline[FilterType]` to return a filter of type `FilterType`
- `push!(pipline, filter)` to add an extra filter to the pipeline.
- `append!(pipeline, filters)` to add multiple filters to the pipeline.
- `delete!(pipeline, FilterType)` to remove a filter of type `FilterType` from the pipeline.
- `empty!(pipeline)` to remove all filters from the pipeline.
"""
struct FilterPipeline{P<:Properties} <: AbstractVector{Filter}
    plist::P
end

function Base.length(f::FilterPipeline)
    API.h5p_get_nfilters(f.plist)
end
Base.size(f::FilterPipeline) = (length(f),)

function Base.getindex(f::FilterPipeline, i::Integer)
    id = API.h5p_get_filter(f.plist, i - 1, C_NULL, C_NULL, C_NULL, 0, C_NULL, C_NULL)
    F = get(FILTERS, id, ExternalFilter)
    return getindex(f, F, i)
end

function Base.getindex(
    f::FilterPipeline, ::Type{ExternalFilter}, i::Integer, cd_values::Vector{Cuint}=Cuint[]
)
    flags = Ref{Cuint}()
    cd_nelmts = Ref{Csize_t}(length(cd_values))
    namebuf = Array{UInt8}(undef, 256)
    config = Ref{Cuint}()
    id = API.h5p_get_filter(
        f.plist, i - 1, flags, cd_nelmts, cd_values, length(namebuf), namebuf, config
    )
    if cd_nelmts[] > length(cd_values)
        resize!(cd_values, cd_nelmts[])
        return getindex(f, ExternalFilter, i, cd_values)
    end
    resize!(namebuf, findfirst(isequal(0), namebuf) - 1)
    resize!(cd_values, cd_nelmts[])
    return ExternalFilter(id, flags[], cd_values, String(namebuf), config[])
end

function Base.getindex(f::FilterPipeline, ::Type{F}, i::Integer) where {F<:Filter}
    @assert isbitstype(F)
    ref = Ref{F}()
    GC.@preserve ref begin
        id = API.h5p_get_filter(
            f.plist,
            i - 1,
            C_NULL,
            div(sizeof(F), sizeof(Cuint)),
            pointer_from_objref(ref),
            0,
            C_NULL,
            C_NULL
        )
    end
    @assert id == filterid(F)
    return ref[]
end
function Base.getindex(f::FilterPipeline, ::Type{F}) where {F<:Filter}
    @assert isbitstype(F)
    ref = Ref{F}()
    GC.@preserve ref begin
        API.h5p_get_filter_by_id(
            f.plist,
            filterid(F),
            C_NULL,
            div(sizeof(F), sizeof(Cuint)),
            pointer_from_objref(ref),
            0,
            C_NULL,
            C_NULL
        )
    end
    return ref[]
end

function Base.empty!(filters::FilterPipeline)
    API.h5p_remove_filter(filters.plist, API.H5Z_FILTER_ALL)
    return filters
end
function Base.delete!(filters::FilterPipeline, ::Type{F}) where {F<:Filter}
    API.h5p_remove_filter(filters.plist, filterid(F))
    return filters
end
function Base.append!(
    filters::FilterPipeline, extra::Union{AbstractVector{<:Filter},NTuple{N,Filter} where N}
)
    for filter in extra
        push!(filters, filter)
    end
    return filters
end
function Base.push!(p::FilterPipeline, f::F) where {F<:Filter}
    ref = Ref(f)
    GC.@preserve ref begin
        API.h5p_set_filter(
            p.plist,
            filterid(F),
            API.H5Z_FLAG_OPTIONAL,
            div(sizeof(F), sizeof(Cuint)),
            pointer_from_objref(ref)
        )
    end
    return p
end
function Base.push!(p::FilterPipeline, f::ExternalFilter)
    GC.@preserve f begin
        API.h5p_set_filter(p.plist, f.filter_id, f.flags, length(f.data), pointer(f.data))
    end
    return p
end

# Convert a Filter to an Integer subtype using filterid
function Base.convert(::Type{I}, ::Type{F}) where {I<:Integer,F<:Filter}
    Base.convert(I, filterid(F))
end
function Base.convert(::Type{I}, f::Filter) where {I<:Integer}
    Base.convert(I, filterid(f))
end

"""
    EXTERNAL_FILTER_JULIA_PACKAGES

Maps filter id to the Julia package name that contains the filter.
"""
const EXTERNAL_FILTER_JULIA_PACKAGES = Dict{API.H5Z_filter_t,String}([
    32008 => "H5Zbitshuffle",
    32001 => "H5Zblosc",
    307   => "H5Zbzip2",
    32004 => "H5Zlz4",
    32015 => "H5Zzstd",
])

"""
Error if all filters in a filter pipeline are not available.
"""
function ensure_filters_available(f::FilterPipeline)
    if !API.h5p_all_filters_avail(f.plist)
        nfilters = length(f)
        for i in 1:nfilters
            filter::UnknownFilter = getindex(f, UnknownFilter, i)
            filter_id = filterid(filter)
            filter_name = filtername(filter)
            if !API.h5z_filter_avail(filter_id)
                if haskey(EXTERNAL_FILTER_JULIA_PACKAGES, filter_id)
                    error(
                        """
                        filter missing, filter id: $filter_id name: $filter_name
                        Try running `import $(EXTERNAL_FILTER_JULIA_PACKAGES[filter_id])` to install this filter.
                        """
                    )
                else
                    error(
                        """
                        filter missing, filter id: $filter_id name: $filter_name
                        This filter is not currently available as a Julia package.
                        For more information, see https://portal.hdfgroup.org/display/support/Registered+Filter+Plugins
                        """
                    )
                end
            end
        end
    else
        return nothing
    end
    error("unreachable")
end

include("builtin.jl")
include("filters_midlevel.jl")
include("registered.jl")

end # module

const liblock = ReentrantLock()

# Try to acquire the lock (test-test-set) and close if successful
# Otherwise, defer finalization
# https://github.com/JuliaIO/HDF5.jl/issues/1048
function try_close_finalizer(x)
    if !islocked(liblock) && trylock(liblock) do
        close(x)
        true
    end
    else
        finalizer(try_close_finalizer, x)
    end
    return nothing
end

# An error thrown by libhdf5
mutable struct H5Error <: Exception
    msg::String
    id::hid_t
end

macro h5error(msg)
    # Check if the is actually any errors on the stack. This is necessary as there are a
    # small number of functions which return `0` in case of an error, but `0` is also a
    # valid return value, e.g. `h5t_get_member_offset`

    # This needs to be a macro as we need to call `h5e_get_current_stack()` _before_
    # evaluating the message expression, as some message expressions can call API
    # functions, which would clear the error stack.
    quote
        err_id = h5e_get_current_stack()
        if h5e_get_num(err_id) > 0
            throw(H5Error($(esc(msg)), err_id))
        else
            h5e_close_stack(err_id)
        end
    end
end

Base.cconvert(::Type{hid_t}, err::H5Error) = err
Base.unsafe_convert(::Type{hid_t}, err::H5Error) = err.id

function Base.close(err::H5Error)
    if err.id != -1 && isvalid(err)
        h5e_close_stack(err)
        err.id = -1
    end
    return nothing
end
Base.isvalid(err::H5Error) = err.id != -1 && h5i_is_valid(err)

Base.length(err::H5Error) = h5e_get_num(err)
Base.isempty(err::H5Error) = length(err) == 0

function H5Error(msg::AbstractString)
    id = h5e_get_current_stack()
    err = H5Error(msg, id)
    finalizer(close, err)
    return err
end

const SHORT_ERROR = Ref(true)

function Base.showerror(io::IO, err::H5Error)
    n_total = length(err)
    print(io, "$(typeof(err)): ", err.msg)
    print(io, "\nlibhdf5 Stacktrace:")
    h5e_walk(err, H5E_WALK_UPWARD) do n, errptr
        n += 1 # 1-based indexing
        errval = unsafe_load(errptr)
        print(io, "\n", lpad("[$n] ", 4 + ndigits(n_total)))
        if errval.func_name != C_NULL
            printstyled(io, unsafe_string(errval.func_name); bold=true)
            print(io, ": ")
        end
        major = h5e_get_msg(errval.maj_num)[2]
        minor = h5e_get_msg(errval.min_num)[2]
        print(io, major, "/", minor)
        if errval.desc != C_NULL
            printstyled(
                io,
                "\n",
                " "^(4 + ndigits(n_total)),
                unsafe_string(errval.desc);
                color=:light_black
            )
        end
        if SHORT_ERROR[]
            if n_total > 1
                print(io, "\n", lpad("⋮", 2 + ndigits(n_total)))
            end
            return true # stop iterating
        end
        return false
    end
    return nothing
end

using HDF5
using HDF5.Filters
import HDF5.Filters.Registered
using Test
using H5Zblosc, H5Zlz4, H5Zbzip2, H5Zzstd
using Preferences

@static if VERSION >= v"1.6"
    using H5Zbitshuffle
end

using HDF5.Filters: ExternalFilter, isavailable, isencoderenabled, isdecoderenabled

@testset "filter" begin

    # Create a new file
    fn = tempname()

    # Create test data
    data = rand(1000, 1000)

    # Open temp file for writing
    f = h5open(fn, "w")

    # Create datasets
    dsdeflate = create_dataset(
        f, "deflate", datatype(data), dataspace(data); chunk=(100, 100), deflate=3
    )

    dsshufdef = create_dataset(
        f,
        "shufdef",
        datatype(data),
        dataspace(data);
        chunk=(100, 100),
        shuffle=true,
        deflate=3
    )

    dsfiltdef = create_dataset(
        f,
        "filtdef",
        datatype(data),
        dataspace(data);
        chunk=(100, 100),
        filters=Filters.Deflate(3)
    )

    dsfiltshufdef = create_dataset(
        f,
        "filtshufdef",
        datatype(data),
        dataspace(data);
        chunk=(100, 100),
        filters=[Filters.Shuffle(), Filters.Deflate(3)]
    )

    # Write data
    write(dsdeflate, data)
    write(dsshufdef, data)
    write(dsfiltdef, data)
    write(dsfiltshufdef, data)

    # Test compression filters

    compressionFilters = Dict(
        "blosc" => BloscFilter,
        "bzip2" => Bzip2Filter,
        "lz4" => Lz4Filter,
        "zstd" => ZstdFilter,
    )

    for (name, filter) in compressionFilters
        ds = create_dataset(
            f, name, datatype(data), dataspace(data); chunk=(100, 100), filters=filter()
        )
        write(ds, data)

        ds = create_dataset(
            f,
            "shuffle+" * name,
            datatype(data),
            dataspace(data);
            chunk=(100, 100),
            filters=[Filters.Shuffle(), filter()]
        )
        write(ds, data)
    end

    ds = create_dataset(
        f,
        "blosc_bitshuffle",
        datatype(data),
        dataspace(data);
        chunk=(100, 100),
        filters=BloscFilter(; shuffle=H5Zblosc.BITSHUFFLE)
    )

    write(ds, data)

    function extra_bitshuffle()
        ds = create_dataset(
            f,
            "bitshuffle_lz4",
            datatype(data),
            dataspace(data);
            chunk=(100, 100),
            filters=BitshuffleFilter(; compressor=:lz4)
        )

        write(ds, data)

        ds = create_dataset(
            f,
            "bitshuffle_zstd",
            datatype(data),
            dataspace(data);
            chunk=(100, 100),
            filters=BitshuffleFilter(; compressor=:zstd, comp_level=5)
        )

        write(ds, data)

        ds = create_dataset(
            f,
            "bitshuffle_plain",
            datatype(data),
            dataspace(data);
            chunk=(100, 100),
            filters=BitshuffleFilter()
        )

        write(ds, data)
    end

    @static VERSION >= v"1.6" ? extra_bitshuffle() : nothing

    # Close and re-open file for reading
    close(f)
    f = h5open(fn)

    try

        # Read datasets and test for equality
        for name in keys(f)
            ds = f[name]
            @testset "$name" begin
                @debug "Filter Dataset" HDF5.name(ds)
                @test ds[] == data
                filters = HDF5.get_create_properties(ds).filters
                if startswith(name, "shuffle+")
                    @test filters[1] isa Shuffle
                    @test filters[2] isa compressionFilters[name[9:end]]
                elseif haskey(compressionFilters, name) || name == "blosc_bitshuffle"
                    name = replace(name, r"_.*" => "")
                    @test filters[1] isa compressionFilters[name]
                end

                if v"1.12.3" ≤ HDF5.API._libhdf5_build_ver
                    infos = HDF5.get_chunk_info_all(ds)
                    filter_masks = [info.filter_mask for info in infos]
                    @test only(unique(filter_masks)) === UInt32(0)
                end
            end
        end
    finally
        close(f)
    end

    # Test that reading a dataset with a missing filter has an informative error message.
    h5open(fn, "w") do f
        data = zeros(100, 100)
        ds = create_dataset(
            f,
            "data",
            datatype(data),
            dataspace(data);
            chunk=(100, 100),
            filters=Lz4Filter()
        )
        write(ds, data)
        close(ds)
    end
    HDF5.API.h5z_unregister(Filters.filterid(H5Zlz4.Lz4Filter))
    h5open(fn) do f
        filter_name = Filters.filtername(H5Zlz4.Lz4Filter)
        filter_id = Filters.filterid(H5Zlz4.Lz4Filter)
        @test_throws(
            ErrorException("""
                           filter missing, filter id: $filter_id name: $filter_name
                           Try running `import H5Zlz4` to install this filter.
                           """),
            read(f["data"])
        )
        HDF5.Filters.register_filter(H5Zlz4.Lz4Filter)
    end

    # Issue #896 and https://github.com/JuliaIO/HDF5.jl/issues/285#issuecomment-1002243321
    # Create an ExternalFilter from a Tuple
    h5open(fn, "w") do f
        data = rand(UInt8, 512, 16, 512)
        # Tuple of integers should become an Unknown Filter
        ds, dt = create_dataset(
            f, "data", data; chunk=(256, 1, 256), filter=(H5Z_FILTER_BZIP2, 0)
        )
        # Tuple of Filters should get pushed into the pipeline one by one
        dsfiltshufdef = create_dataset(
            f,
            "filtshufdef",
            datatype(data),
            dataspace(data);
            chunk=(128, 4, 128),
            filters=(Filters.Shuffle(), Filters.Deflate(3))
        )
        write(ds, data)
        close(ds)
        write(dsfiltshufdef, data)
        close(dsfiltshufdef)
    end

    h5open(fn, "r") do f
        @test f["data"][] == data
        @test f["filtshufdef"][] == data
    end

    # Filter Pipeline test for ExternalFilter
    FILTERS_backup = copy(HDF5.Filters.FILTERS)
    empty!(HDF5.Filters.FILTERS)
    h5open(fn, "w") do f
        data = collect(1:128)
        filter = ExternalFilter(
            H5Z_FILTER_LZ4, 0, Cuint[0, 2, 4, 6, 8, 10], "Unknown LZ4", 0
        )
        ds, dt = create_dataset(f, "data", data; chunk=(32,), filters=filter)
        dcpl = HDF5.get_create_properties(ds)
        pipeline = HDF5.Filters.FilterPipeline(dcpl)
        @test pipeline[1].data == filter.data
    end
    merge!(HDF5.Filters.FILTERS, FILTERS_backup)

    @test HDF5.API.h5z_filter_avail(HDF5.API.H5Z_FILTER_DEFLATE)
    @test HDF5.API.h5z_filter_avail(HDF5.API.H5Z_FILTER_FLETCHER32)
    @test HDF5.API.h5z_filter_avail(HDF5.API.H5Z_FILTER_NBIT)
    @test HDF5.API.h5z_filter_avail(HDF5.API.H5Z_FILTER_SCALEOFFSET)
    @test HDF5.API.h5z_filter_avail(HDF5.API.H5Z_FILTER_SHUFFLE)
    if !Preferences.has_preference(HDF5, "libhdf5")
        if HDF5.API.h5_get_libversion() < v"1.14"
            @test_broken HDF5.API.h5z_filter_avail(HDF5.API.H5Z_FILTER_SZIP)
        else
            @test HDF5.API.h5z_filter_avail(HDF5.API.H5Z_FILTER_SZIP)
        end
    end
    @test HDF5.API.h5z_filter_avail(H5Z_FILTER_BZIP2)
    @test HDF5.API.h5z_filter_avail(H5Z_FILTER_LZ4)
    @test HDF5.API.h5z_filter_avail(H5Z_FILTER_ZSTD)
    @test HDF5.API.h5z_filter_avail(H5Z_FILTER_BLOSC)

    # Test the RegisteredFilter module for filters we know to be loaded
    reg_loaded = [
        Registered.BZIP2Filter,
        Registered.LZ4Filter,
        Registered.ZstandardFilter,
        Registered.BLOSCFilter
    ]
    for func in reg_loaded
        f = func()
        @test HDF5.API.h5z_filter_avail(f)
        @test (Filters.filterid(f) => func) in Registered.available_registered_filters()
        @test func(HDF5.API.H5Z_FLAG_OPTIONAL) isa ExternalFilter
        @test func(
            HDF5.API.H5Z_FLAG_OPTIONAL, Cuint[], HDF5.API.H5Z_FILTER_CONFIG_ENCODE_ENABLED
        ) isa ExternalFilter
    end
    HDF5.API.h5z_unregister(H5Z_FILTER_LZ4)
    HDF5.Filters.register_filter(H5Zlz4.Lz4Filter)
    @test isavailable(H5Z_FILTER_LZ4)
    @test isavailable(Lz4Filter)
    @test isencoderenabled(H5Z_FILTER_LZ4)
    @test isdecoderenabled(H5Z_FILTER_LZ4)
    @test isencoderenabled(Lz4Filter)
    @test isdecoderenabled(Lz4Filter)
end # @testset "filter"

#! format: off
# The `@bind` macro is used to automatically generate Julia bindings to the low-level
# HDF5 library functions.
#
# Each line should consist of two arguments:
#
#   1. An `@ccall`-like function definition expression for the C library interface,
#      including the return type.
#   2. Either an error string (which is thrown by `hdf5error()`) or an expression which
#      builds an error string and may refer to any of the named function arguments.
#
# The C library names are automatically generated from the Julia function name by
# uppercasing the `h5?` and removing the first underscore ---
# e.g. `h5d_close` -> `H5Dclose`. Versioned function names (such as
# `h5d_open2` -> `H5Dopen2`) have the trailing number removed for the Julia function
# definition. Other arbitrary mappings may be added by adding an entry to the
# `bind_exceptions` Dict in `bind_generator.jl`.
#
# Execute gen_wrappers.jl to generate ../src/api/functions.jl from this file.

###
### HDF5 General library functions
###

@bind h5_close()::herr_t "Error closing the HDF5 resources"
@bind h5_dont_atexit()::herr_t "Error calling dont_atexit"
@bind h5_free_memory(buf::Ptr{Cvoid})::herr_t "Error freeing memory"
@bind h5_garbage_collect()::herr_t "Error on garbage collect"
@bind h5_get_libversion(majnum::Ref{Cuint}, minnum::Ref{Cuint}, relnum::Ref{Cuint})::herr_t "Error getting HDF5 library version"
@bind h5_is_library_threadsafe(is_ts::Ref{Cuchar})::herr_t "Error determining thread safety"
@bind h5_open()::herr_t "Error initializing the HDF5 library"
@bind h5_set_free_list_limits(reg_global_lim::Cint, reg_list_lim::Cint, arr_global_lim::Cint, arr_list_lim::Cint, blk_global_lim::Cint, blk_list_lim::Cint)::herr_t "Error setting limits on free lists"

###
### Attribute Interface
###

@bind h5a_close(id::hid_t)::herr_t "Error closing attribute"
@bind h5a_create2(loc_id::hid_t, attr_name::Cstring, type_id::hid_t, space_id::hid_t, acpl_id::hid_t, aapl_id::hid_t)::hid_t string("Error creating attribute ", attr_name, " for object ", h5i_get_name(loc_id))
@bind h5a_create_by_name(loc_id::hid_t, obj_name::Cstring, attr_name::Cstring, type_id::hid_t, space_id::hid_t, acpl_id::hid_t, aapl_id::hid_t, lapl_id::hid_t)::hid_t string("Error creating attribute ", attr_name, " for object ", obj_name)
@bind h5a_delete(loc_id::hid_t, attr_name::Cstring)::herr_t string("Error deleting attribute ", attr_name)
@bind h5a_delete_by_idx(loc_id::hid_t, obj_name::Cstring, idx_type::Cint, order::Cint, n::hsize_t, lapl_id::hid_t)::herr_t string("Error deleting attribute ", n, " from object ", obj_name)
@bind h5a_delete_by_name(loc_id::hid_t, obj_name::Cstring, attr_name::Cstring, lapl_id::hid_t)::herr_t string("Error removing attribute ", attr_name, " from object ", obj_name)
@bind h5a_exists(obj_id::hid_t, attr_name::Cstring)::htri_t string("Error checking whether attribute ", attr_name, " exists")
@bind h5a_exists_by_name(loc_id::hid_t, obj_name::Cstring, attr_name::Cstring, lapl_id::hid_t)::htri_t string("Error checking whether object ", obj_name, " has attribute ", attr_name)
@bind h5a_get_create_plist(attr_id::hid_t)::hid_t "Cannot get creation property list"
@bind h5a_get_name(attr_id::hid_t, buf_size::Csize_t, buf::Ptr{UInt8})::Cssize_t "Error getting attribute name"
@bind h5a_get_name_by_idx(loc_id::hid_t, obj_name::Cstring, index_type::Cint, order::Cint, idx::hsize_t, name::Ptr{UInt8}, size::Csize_t, lapl_id::hid_t)::Cssize_t "Error getting attribute name"
@bind h5a_get_space(attr_id::hid_t)::hid_t "Error getting attribute dataspace"
@bind h5a_get_type(attr_id::hid_t)::hid_t "Error getting attribute type"
@bind h5a_iterate2(obj_id::hid_t, idx_type::Cint, order::Cint, n::Ptr{hsize_t}, op::Ptr{Cvoid}, op_data::Any)::herr_t string("Error iterating attributes in object ", h5i_get_name(obj_id))
@bind h5a_open(obj_id::hid_t, attr_name::Cstring, aapl_id::hid_t)::hid_t string("Error opening attribute ", attr_name, " for object ", h5i_get_name(obj_id))
@bind h5a_open_by_idx(obj_id::hid_t, pathname::Cstring, idx_type::Cint, order::Cint, n::hsize_t, aapl_id::hid_t, lapl_id::hid_t)::hid_t string("Error opening attribute ", n, " of ", h5i_get_name(obj_id), "/", pathname)
@bind h5a_read(attr_id::hid_t, mem_type_id::hid_t, buf::Ptr{Cvoid})::herr_t string("Error reading attribute ", h5a_get_name(attr_id))
@bind h5a_rename(loc_id::hid_t, old_attr_name::Cstring, new_attr_name::Cstring)::herr_t string("Could not rename attribute")
@bind h5a_write(attr_hid::hid_t, mem_type_id::hid_t, buf::Ptr{Cvoid})::herr_t "Error writing attribute data"

###
### Dataset Interface
###

@bind h5d_chunk_iter(dset_id::hid_t, dxpl_id::hid_t, cb::Ptr{Nothing}, op_data::Any)::herr_t "Error iterating over chunks" (v"1.12.3", nothing)
@bind h5d_close(dataset_id::hid_t)::herr_t "Error closing dataset"
@bind h5d_create2(loc_id::hid_t, pathname::Cstring, dtype_id::hid_t, space_id::hid_t, lcpl_id::hid_t, dcpl_id::hid_t, dapl_id::hid_t)::hid_t string("Error creating dataset ", h5i_get_name(loc_id), "/", pathname)
@bind h5d_create_anon(loc_id::hid_t, type_id::hid_t, space_id::hid_t, dcpl_id::hid_t, dapl_id::hid_t)::hid_t "Error in creating anonymous dataset"
@bind h5d_extend(dataset_id::hid_t, size::Ptr{hsize_t})::herr_t "Error extending dataset" # deprecated in favor of h5d_set_extent
@bind h5d_fill(fill::Ptr{Cvoid}, fill_type_id::hid_t, buf::Ptr{Cvoid}, buf_type_id::hid_t, space_id::hid_t)::herr_t "Error filling dataset"
@bind h5d_flush(dataset_id::hid_t)::herr_t "Error flushing dataset"
@bind h5d_gather(src_space_id::hid_t, src_buf::Ptr{Cvoid}, type_id::hid_t, dst_buf_size::Csize_t, dst_buf::Ptr{Cvoid}, op::Ptr{Cvoid}, op_data::Any)::herr_t "Error gathering dataset"
@bind h5d_get_access_plist(dataset_id::hid_t)::hid_t "Error getting dataset access property list"
@bind h5d_get_chunk_info(dataset_id::hid_t, fspace_id::hid_t, index::hsize_t, offset::Ptr{hsize_t}, filter_mask::Ptr{Cuint}, addr::Ptr{haddr_t}, size::Ptr{hsize_t})::herr_t "Error getting chunk info"
@bind h5d_get_chunk_info_by_coord(dataset_id::hid_t, offset::Ptr{hsize_t}, filter_mask::Ptr{Cuint}, addr::Ptr{haddr_t}, size::Ptr{hsize_t})::herr_t "Error getting chunk info by coord" (v"1.10.5",nothing)
@bind h5d_get_chunk_storage_size(dataset_id::hid_t, offset::Ptr{hsize_t}, chunk_nbytes::Ptr{hsize_t})::herr_t "Error getting chunk storage size"
@bind h5d_get_create_plist(dataset_id::hid_t)::hid_t "Error getting dataset create property list"
@bind h5d_get_num_chunks(dataset_id::hid_t, fspace_id::hid_t, nchunks::Ptr{hsize_t})::herr_t "Error getting number of chunks" (v"1.10.5",nothing)
@bind h5d_get_offset(dataset_id::hid_t)::haddr_t "Error getting offset"
@bind h5d_get_space(dataset_id::hid_t)::hid_t "Error getting dataspace"
@bind h5d_get_space_status(dataset_id::hid_t, status::Ref{Cint})::herr_t "Error getting dataspace status"
@bind h5d_get_storage_size(dataset_id::hid_t)::hsize_t "Error getting storage size"
@bind h5d_get_type(dataset_id::hid_t)::hid_t "Error getting dataspace type"
@bind h5d_iterate(buf::Ptr{Cvoid}, type_id::hid_t, space_id::hid_t, operator::Ptr{Cvoid}, operator_data::Any)::herr_t "Error iterating dataset"
@bind h5d_open2(loc_id::hid_t, pathname::Cstring, dapl_id::hid_t)::hid_t string("Error opening dataset ", h5i_get_name(loc_id), "/", pathname)
@bind h5d_read(dataset_id::hid_t, mem_type_id::hid_t, mem_space_id::hid_t, file_space_id::hid_t, xfer_plist_id::hid_t, buf::Ptr{Cvoid})::herr_t string("Error reading dataset ", h5i_get_name(dataset_id))
# The function was renamed to H5Dread_chunk1 in v2.0
@bind h5d_read_chunk(dset::hid_t, dxpl_id::hid_t, offset::Ptr{hsize_t}, filters::Ptr{UInt32}, buf::Ptr{Cvoid})::herr_t "Error reading chunk" (nothing, v"2.0")
@bind h5d_read_chunk1(dset::hid_t, dxpl_id::hid_t, offset::Ptr{hsize_t}, filters::Ptr{UInt32}, buf::Ptr{Cvoid})::herr_t "Error reading chunk" (v"2.0", nothing)
@bind h5d_refresh(dataset_id::hid_t)::herr_t "Error refreshing dataset"
@bind h5d_scatter(op::Ptr{Cvoid}, op_data::Any, type_id::hid_t, dst_space_id::hid_t, dst_buf::Ptr{Cvoid})::herr_t "Error scattering to dataset"
@bind h5d_set_extent(dataset_id::hid_t, new_dims::Ptr{hsize_t})::herr_t "Error extending dataset dimensions"
@bind h5d_vlen_get_buf_size(dset_id::hid_t, type_id::hid_t, space_id::hid_t, buf::Ptr{hsize_t})::herr_t "Error getting vlen buffer size"
@bind h5d_vlen_reclaim(type_id::hid_t, space_id::hid_t, plist_id::hid_t, buf::Ptr{Cvoid})::herr_t "Error reclaiming vlen buffer"
@bind h5d_write(dataset_id::hid_t, mem_type_id::hid_t, mem_space_id::hid_t, file_space_id::hid_t, xfer_plist_id::hid_t, buf::Ptr{Cvoid})::herr_t "Error writing dataset"
@bind h5d_write_chunk(dset_id::hid_t, dxpl_id::hid_t, filter_mask::UInt32, offset::Ptr{hsize_t}, bufsize::Csize_t, buf::Ptr{Cvoid})::herr_t "Error writing chunk"

###
### Error Interface
###

@bind h5e_get_auto2(estack_id::hid_t, func::Ref{Ptr{Cvoid}}, client_data::Ref{Ptr{Cvoid}})::herr_t "Error getting error reporting behavior"
@bind h5e_set_auto2(estack_id::hid_t, func::Ptr{Cvoid}, client_data::Ptr{Cvoid})::herr_t "Error setting error reporting behavior"
@bind h5e_get_current_stack()::hid_t "Unable to return current error stack"
@bind h5e_get_msg(mesg_id::hid_t, mesg_type::Ref{Cint}, mesg::Ref{UInt8}, len::Csize_t)::Cssize_t "Error getting message"
@bind h5e_get_num(estack_id::hid_t)::Cssize_t "Error getting stack length"
@bind h5e_close_stack(stack_id::hid_t)::herr_t "Error closing stack"
@bind h5e_walk2(stack_id::hid_t, direction::Cint, op::Ptr{Cvoid}, op_data::Any)::herr_t "Error walking stack"

###
### File Interface
###

@bind h5f_clear_elink_file_cache(file_id::hid_t)::herr_t "Error in h5f_clear_elink_file_cache (not annotated)"
@bind h5f_close(file_id::hid_t)::herr_t "Error closing file"
@bind h5f_create(pathname::Cstring, flags::Cuint, fcpl_id::hid_t, fapl_id::hid_t)::hid_t "Error creating file $pathname"
@bind h5f_delete(filename::Cstring, fapl_id::hid_t)::herr_t "Error in h5f_delete (not annotated)"
@bind h5f_flush(object_id::hid_t, scope::Cint)::herr_t "Error flushing object to file"
@bind h5f_format_convert(fid::hid_t)::herr_t "Error in h5f_format_convert (not annotated)"
@bind h5f_get_access_plist(file_id::hid_t)::hid_t "Error getting file access property list"
@bind h5f_get_create_plist(file_id::hid_t)::hid_t "Error getting file create property list"
@bind h5f_get_dset_no_attrs_hint(file_id::hid_t, minimize::Ptr{hbool_t})::herr_t "Error getting dataset no attributes hint"
@bind h5f_get_eoa(file_id::hid_t, eoa::Ptr{haddr_t})::herr_t "Error in h5f_get_eoa (not annotated)"
@bind h5f_get_file_image(file_id::hid_t, buf_ptr::Ptr{Cvoid}, buf_len::Csize_t)::Cssize_t "Error in h5f_get_file_image (not annotated)"
@bind h5f_get_fileno(file_id::hid_t, fileno::Ptr{Culong})::herr_t "Error in h5f_get_fileno (not annotated)"
@bind h5f_get_filesize(file_id::hid_t, size::Ptr{hsize_t})::herr_t "Error in h5f_get_filesize (not annotated)"
@bind h5f_get_free_sections(file_id::hid_t, type::H5F_mem_t, nsects::Csize_t, sect_info::Ptr{H5F_sect_info_t})::Cssize_t "Error in h5f_get_free_sections (not annotated)"
@bind h5f_get_freespace(file_id::hid_t)::hssize_t "Error in h5f_get_freespace (not annotated)"
@bind h5f_get_intent(file_id::hid_t, intent::Ptr{Cuint})::herr_t "Error getting file intent"
@bind h5f_get_info2(obj_id::hid_t, file_info::Ptr{H5F_info2_t})::herr_t "Error in h5f_get_info2 (not annotated)"
@bind h5f_get_mdc_config(file_id::hid_t, config_ptr::Ptr{H5AC_cache_config_t})::herr_t "Error in h5f_get_mdc_config (not annotated)"
@bind h5f_get_mdc_hit_rate(file_id::hid_t, hit_rate_ptr::Ptr{Cdouble})::herr_t "Error in h5f_get_mdc_hit_rate (not annotated)"
@bind h5f_get_mdc_image_info(file_id::hid_t, image_addr::Ptr{haddr_t}, image_size::Ptr{hsize_t})::herr_t "Error in h5f_get_mdc_image_info (not annotated)"
@bind h5f_get_mdc_logging_status(file_id::hid_t, is_enabled::Ptr{hbool_t}, is_currently_logging::Ptr{hbool_t})::herr_t "Error in h5f_get_mdc_logging_status (not annotated)"
@bind h5f_get_mdc_size(file_id::hid_t, max_size_ptr::Ptr{Csize_t}, min_clean_size_ptr::Ptr{Csize_t}, cur_size_ptr::Ptr{Csize_t}, cur_num_entries_ptr::Ptr{Cint})::herr_t "Error in h5f_get_mdc_size (not annotated)"
@bind h5f_get_metadata_read_retry_info(file_id::hid_t, info::Ptr{H5F_retry_info_t})::herr_t "Error in h5f_get_metadata_read_retry_info (not annotated)"
@bind h5f_get_mpi_atomicity(file_id::hid_t, flag::Ptr{hbool_t})::herr_t "Error in h5f_get_mpi_atomicity (not annotated)"
@bind h5f_get_name(obj_id::hid_t, buf::Ptr{UInt8}, buf_size::Csize_t)::Cssize_t "Error getting file name"
@bind h5f_get_obj_count(file_id::hid_t, types::Cuint)::Cssize_t "Error getting object count"
@bind h5f_get_obj_ids(file_id::hid_t, types::Cuint, max_objs::Csize_t, obj_id_list::Ptr{hid_t})::Cssize_t "Error getting objects"
@bind h5f_get_page_buffering_stats(file_id::hid_t, accesses::Ptr{Cuint}, hits::Ptr{Cuint}, misses::Ptr{Cuint}, evictions::Ptr{Cuint}, bypasses::Ptr{Cuint})::herr_t "Error in h5f_get_page_buffering_stats (not annotated)"
@bind h5f_get_vfd_handle(file_id::hid_t, fapl_id::hid_t, file_handle::Ref{Ptr{Cvoid}})::herr_t "Error getting VFD handle"
@bind h5f_increment_filesize(file_id::hid_t, increment::hsize_t)::herr_t "Error in h5f_increment_filesize (not annotated)"
@bind h5f_is_accessible(container_name::Cstring, fapl_id::hid_t)::htri_t "Error in h5f_is_accessible (not annotated)"
@bind h5f_is_hdf5(pathname::Cstring)::htri_t "Unable to access file $pathname"
@bind h5f_mount(loc::hid_t, name::Cstring, child::hid_t, plist::hid_t)::herr_t "Error in h5f_mount (not annotated)"
@bind h5f_open(pathname::Cstring, flags::Cuint, fapl_id::hid_t)::hid_t "Error opening file $pathname"
@bind h5f_reopen(file_id::hid_t)::hid_t "Error in h5f_reopen (not annotated)"
@bind h5f_reset_mdc_hit_rate_stats(file_id::hid_t)::herr_t "Error in h5f_reset_mdc_hit_rate_stats (not annotated)"
@bind h5f_reset_page_buffering_stats(file_id::hid_t)::herr_t "Error in h5f_reset_page_buffering_stats (not annotated)"
@bind h5f_set_dset_no_attrs_hint(file_id::hid_t, minimize::hbool_t)::herr_t "Error in setting dataset no attributes hint"
@bind h5f_set_libver_bounds(file_id::hid_t, low::H5F_libver_t, high::H5F_libver_t)::herr_t "Error in h5f_set_libver_bounds (not annotated)"
@bind h5f_set_mdc_config(file_id::hid_t, config_ptr::Ptr{H5AC_cache_config_t})::herr_t "Error in h5f_set_mdc_config (not annotated)"
@bind h5f_set_mpi_atomicity(file_id::hid_t, flag::hbool_t)::herr_t "Error in h5f_set_mpi_atomicity (not annotated)"
@bind h5f_start_mdc_logging(file_id::hid_t)::herr_t "Error in h5f_start_mdc_logging (not annotated)"
@bind h5f_start_swmr_write(id::hid_t)::herr_t "Error starting SWMR write"
@bind h5f_stop_mdc_logging(file_id::hid_t)::herr_t "Error in h5f_stop_mdc_logging (not annotated)"
@bind h5f_unmount(loc::hid_t, name::Cstring)::herr_t "Error in h5f_unmount (not annotated)"

###
### Group Interface
###

@bind h5g_close(group_id::hid_t)::herr_t "Error closing group"
@bind h5g_create2(loc_id::hid_t, pathname::Cstring, lcpl_id::hid_t, gcpl_id::hid_t, gapl_id::hid_t)::hid_t "Error creating group $(h5i_get_name(loc_id))/$(pathname)"
@bind h5g_get_create_plist(group_id::hid_t)::hid_t "Error getting group create property list"
@bind h5g_get_info(group_id::hid_t, buf::Ptr{H5G_info_t})::herr_t "Error getting group info"
@bind h5g_get_num_objs(loc_id::hid_t, num_obj::Ptr{hsize_t})::hid_t "Error getting group length"
@bind h5g_get_objname_by_idx(loc_id::hid_t, idx::hsize_t, pathname::Ptr{UInt8}, size::Csize_t)::Cssize_t "Error getting group object name $(h5i_get_name(loc_id))/$(pathname)"
@bind h5g_open2(loc_id::hid_t, pathname::Cstring, gapl_id::hid_t)::hid_t "Error opening group $(h5i_get_name(loc_id))/$(pathname)"

###
### Identifier Interface
###

@bind h5i_dec_ref(obj_id::hid_t)::Cint "Error decementing reference"
@bind h5i_get_file_id(obj_id::hid_t)::hid_t "Error getting file identifier"
@bind h5i_get_name(obj_id::hid_t, buf::Ptr{UInt8}, buf_size::Csize_t)::Cssize_t "Error getting object name"
@bind h5i_get_ref(obj_id::hid_t)::Cint "Error getting reference count"
@bind h5i_get_type(obj_id::hid_t)::Cint "Error getting type"
@bind h5i_inc_ref(obj_id::hid_t)::Cint "Error incrementing identifier refcount"
@bind h5i_is_valid(obj_id::hid_t)::htri_t "Cannot determine whether object is valid"

###
### Link Interface
###

@bind h5l_create_external(target_file_name::Cstring, target_obj_name::Cstring, link_loc_id::hid_t, link_name::Cstring, lcpl_id::hid_t, lapl_id::hid_t)::herr_t string("Error creating external link ", link_name, " pointing to ", target_obj_name, " in file ", target_file_name)
@bind h5l_create_hard(obj_loc_id::hid_t, obj_name::Cstring, link_loc_id::hid_t, link_name::Cstring, lcpl_id::hid_t, lapl_id::hid_t)::herr_t string("Error creating hard link ", link_name, " pointing to ", obj_name)
@bind h5l_create_soft(target_path::Cstring, link_loc_id::hid_t, link_name::Cstring, lcpl_id::hid_t, lapl_id::hid_t)::herr_t string("Error creating soft link ", link_name, " pointing to ", target_path)
@bind h5l_delete(obj_id::hid_t, pathname::Cstring, lapl_id::hid_t)::herr_t string("Error deleting ", h5i_get_name(obj_id), "/", pathname)
@bind h5l_move(src_obj_id::hid_t, src_name::Cstring, dest_obj_id::hid_t, dest_name::Cstring, lcpl_id::hid_t, lapl_id::hid_t)::herr_t string("Error moving ", h5i_get_name(src_obj_id), "/", src_name, " to ", h5i_get_name(dest_obj_id), "/", dest_name)
@bind h5l_exists(loc_id::hid_t, pathname::Cstring, lapl_id::hid_t)::htri_t string("Cannot determine whether ", pathname, " exists")
@bind h5l_get_info(link_loc_id::hid_t, link_name::Cstring, link_buf::Ptr{H5L_info_t}, lapl_id::hid_t)::herr_t string("Error getting info for link ", link_name)
@bind h5l_get_name_by_idx(loc_id::hid_t, group_name::Cstring, index_field::Cint, order::Cint, n::hsize_t, name::Ptr{UInt8}, size::Csize_t, lapl_id::hid_t)::Cssize_t "Error getting object name"
# libhdf5 v1.10 provides the name H5Literate
# libhdf5 v1.12 provides the same under H5Literate1, and a newer interface on H5Literate2
@bind h5l_iterate(group_id::hid_t, idx_type::Cint, order::Cint, idx::Ptr{hsize_t}, op::Ptr{Cvoid}, op_data::Any)::herr_t string("Error iterating through links in group ", h5i_get_name(group_id)) (nothing, v"1.12")
@bind h5l_iterate1(group_id::hid_t, idx_type::Cint, order::Cint, idx::Ptr{hsize_t}, op::Ptr{Cvoid}, op_data::Any)::herr_t string("Error iterating through links in group ", h5i_get_name(group_id)) (v"1.12", nothing)

###
### Object Interface
###


@bind h5o_are_mdc_flushes_disabled(object_id::hid_t, are_disabled::Ptr{hbool_t})::herr_t "Error in h5o_are_mdc_flushes_disabled (not annotated)"
@bind h5o_close(object_id::hid_t)::herr_t "Error closing object"
@bind h5o_copy(src_loc_id::hid_t, src_name::Cstring, dst_loc_id::hid_t, dst_name::Cstring, ocpypl_id::hid_t, lcpl_id::hid_t)::herr_t string("Error copying object ", h5i_get_name(src_loc_id), "/", src_name, " to ", h5i_get_name(dst_loc_id), "/", dst_name)
@bind h5o_decr_refcount(object_id::hid_t)::herr_t "Error in h5o_decr_refcount (not annotated)"
@bind h5o_disable_mdc_flushes(object_id::hid_t)::herr_t "Error in h5o_disable_mdc_flushes (not annotated)"
@bind h5o_enable_mdc_flushes(object_id::hid_t)::herr_t "Error in h5o_enable_mdc_flushes (not annotated)"
@bind h5o_exists_by_name(loc_id::hid_t, name::Cstring, lapl_id::hid_t)::htri_t "Error in h5o_exists_by_name (not annotated)"
@bind h5o_flush(obj_id::hid_t)::herr_t "Error in h5o_flush (not annotated)"
@bind h5o_get_comment(obj_id::hid_t, comment::Ptr{Cchar}, bufsize::Csize_t)::Cssize_t "Error in h5o_get_comment (not annotated)"
@bind h5o_get_comment_by_name(loc_id::hid_t, name::Cstring, comment::Ptr{Cchar}, bufsize::Csize_t, lapl_id::hid_t)::Cssize_t "Error in h5o_get_comment_by_name (not annotated)"
@bind h5o_get_info1(object_id::hid_t, buf::Ptr{H5O_info1_t})::herr_t "Error getting object info" (nothing, v"1.10.3")
@bind h5o_get_info2(loc_id::hid_t, oinfo::Ptr{H5O_info1_t}, fields::Cuint)::herr_t "Error in h5o_get_info2 (not annotated)" (v"1.10.3", v"1.12.0")
@bind h5o_get_info3(loc_id::hid_t, oinfo::Ptr{H5O_info2_t}, fields::Cuint)::herr_t "Error in h5o_get_info3 (not annotated)" (v"1.12.0", nothing)
@bind h5o_get_info_by_idx1(loc_id::hid_t, group_name::Cstring, idx_type::H5_index_t, order::H5_iter_order_t, n::hsize_t, oinfo::Ptr{H5O_info1_t}, lapl_id::hid_t)::herr_t "Error in h5o_get_info_by_idx1 (not annotated)" (nothing, v"1.10.3")
@bind h5o_get_info_by_idx2(loc_id::hid_t, group_name::Cstring, idx_type::H5_index_t, order::H5_iter_order_t, n::hsize_t, oinfo::Ptr{H5O_info1_t}, fields::Cuint, lapl_id::hid_t)::herr_t "Error in h5o_get_info_by_idx2 (not annotated)" (v"1.10.3", v"1.12.0")
@bind h5o_get_info_by_idx3(loc_id::hid_t, group_name::Cstring, idx_type::H5_index_t, order::H5_iter_order_t, n::hsize_t, oinfo::Ptr{H5O_info2_t}, fields::Cuint, lapl_id::hid_t)::herr_t "Error in h5o_get_info_by_idx3 (not annotated)" (v"1.12.0", nothing)
@bind h5o_get_info_by_name1(loc_id::hid_t, name::Cstring, oinfo::Ptr{H5O_info1_t}, lapl_id::hid_t)::herr_t "Error in h5o_get_info_by_name1 (not annotated)" (nothing, v"1.10.3")
@bind h5o_get_info_by_name2(loc_id::hid_t, name::Cstring, oinfo::Ptr{H5O_info1_t}, fields::Cuint, lapl_id::hid_t)::herr_t "Error in h5o_get_info_by_name2 (not annotated)" (v"1.10.3", v"1.12.0")
@bind h5o_get_info_by_name3(loc_id::hid_t, name::Cstring, oinfo::Ptr{H5O_info2_t}, fields::Cuint, lapl_id::hid_t)::herr_t "Error in h5o_get_info_by_name3 (not annotated)" (v"1.12.0", nothing)
@bind h5o_get_native_info(loc_id::hid_t, oinfo::Ptr{H5O_native_info_t}, fields::Cuint)::herr_t "Error in h5o_get_native_info (not annotated)"
@bind h5o_get_native_info_by_idx(loc_id::hid_t, group_name::Cstring, idx_type::H5_index_t, order::H5_iter_order_t, n::hsize_t, oinfo::Ptr{H5O_native_info_t}, fields::Cuint, lapl_id::hid_t)::herr_t "Error in h5o_get_native_info_by_idx (not annotated)"
@bind h5o_get_native_info_by_name(loc_id::hid_t, name::Cstring, oinfo::Ptr{H5O_native_info_t}, fields::Cuint, lapl_id::hid_t)::herr_t "Error in h5o_get_native_info_by_name (not annotated)"
@bind h5o_incr_refcount(object_id::hid_t)::herr_t "Error in h5o_incr_refcount (not annotated)"
@bind h5o_link(obj_id::hid_t, new_loc_id::hid_t, new_name::Cstring, lcpl_id::hid_t, lapl_id::hid_t)::herr_t "Error in h5o_link (not annotated)"
@bind h5o_open(loc_id::hid_t, pathname::Cstring, lapl_id::hid_t)::hid_t string("Error opening object ", h5i_get_name(loc_id), "/", pathname)
@bind h5o_open_by_addr(loc_id::hid_t, addr::haddr_t)::hid_t "Error opening object by address"
@bind h5o_open_by_idx(loc_id::hid_t, group_name::Cstring, index_type::Cint, order::Cint, n::hsize_t, lapl_id::hid_t)::hid_t string("Error opening object of index ", n)
@bind h5o_refresh(oid::hid_t)::herr_t "Error in h5o_refresh (not annotated)"
@bind h5o_set_comment(obj_id::hid_t, comment::Cstring)::herr_t "Error in h5o_set_comment (not annotated)"
@bind h5o_set_comment_by_name(loc_id::hid_t, name::Cstring, comment::Cstring, lapl_id::hid_t)::herr_t "Error in h5o_set_comment_by_name (not annotated)"
@bind h5o_token_cmp(loc_id::hid_t, token1::Ptr{H5O_token_t}, token2::Ptr{H5O_token_t}, cmp_value::Ptr{Cint})::herr_t "Error in h5o_token_cmp (not annotated)"
@bind h5o_token_from_str(loc_id::hid_t, token_str::Cstring, token::Ptr{H5O_token_t})::herr_t "Error in h5o_token_from_str (not annotated)"
@bind h5o_token_to_str(loc_id::hid_t, token::Ptr{H5O_token_t}, token_str::Ptr{Ptr{Cchar}})::herr_t "Error in h5o_token_to_str (not annotated)"
@bind h5o_visit1(obj_id::hid_t, idx_type::H5_index_t, order::H5_iter_order_t, op::H5O_iterate1_t, op_data::Ptr{Cvoid})::herr_t "Error in h5o_visit1 (not annotated)" (nothing, v"1.12.0")
#@bind h5o_visit2(obj_id::hid_t, idx_type::H5_index_t, order::H5_iter_order_t, op::H5O_iterate1_t, op_data::Ptr{Cvoid}, fields::Cuint)::herr_t "Error in h5o_visit2 (not annotated)"
@bind h5o_visit3(obj_id::hid_t, idx_type::H5_index_t, order::H5_iter_order_t, op::H5O_iterate2_t, op_data::Ptr{Cvoid}, fields::Cuint)::herr_t "Error in h5o_visit3 (not annotated)" (v"1.12.0", nothing)
@bind h5o_visit_by_name1(loc_id::hid_t, obj_name::Cstring, idx_type::H5_index_t, order::H5_iter_order_t, op::H5O_iterate1_t, op_data::Ptr{Cvoid}, lapl_id::hid_t)::herr_t "Error in h5o_visit_by_name1 (not annotated)" (nothing, v"1.12.0")
#@bind h5o_visit_by_name2(loc_id::hid_t, obj_name::Cstring, idx_type::H5_index_t, order::H5_iter_order_t, op::H5O_iterate1_t, op_data::Ptr{Cvoid}, fields::Cuint, lapl_id::hid_t)::herr_t "Error in h5o_visit_by_name2 (not annotated)"
@bind h5o_visit_by_name3(loc_id::hid_t, obj_name::Cstring, idx_type::H5_index_t, order::H5_iter_order_t, op::H5O_iterate2_t, op_data::Ptr{Cvoid}, fields::Cuint, lapl_id::hid_t)::herr_t "Error in h5o_visit_by_name3 (not annotated)" (v"1.12.0", nothing)

###
### Property Interface
###

# get
@bind h5p_get(plist_id::hid_t, name::Cstring, value::Ptr{Cvoid})::herr_t "Error in h5p_get (not annotated)"
@bind h5p_get_alignment(fapl_id::hid_t, threshold::Ref{hsize_t}, alignment::Ref{hsize_t})::herr_t "Error getting alignment"
@bind h5p_get_alloc_time(plist_id::hid_t, alloc_time::Ptr{Cint})::herr_t "Error getting allocation timing"
@bind h5p_get_append_flush(dapl_id::hid_t, dims::Cuint, boundary::Ptr{hsize_t}, func::Ptr{H5D_append_cb_t}, udata::Ptr{Ptr{Cvoid}})::herr_t "Error in h5p_get_append_flush (not annotated)"
@bind h5p_get_attr_creation_order(plist_id::hid_t, crt_order_flags::Ptr{Cuint})::herr_t "Error getting attribute creation order"
@bind h5p_get_attr_phase_change(plist_id::hid_t, max_compact::Ptr{Cuint}, min_dense::Ptr{Cuint})::herr_t "Error in h5p_get_attr_phase_change (not annotated)"
@bind h5p_get_btree_ratios(plist_id::hid_t, left::Ptr{Cdouble}, middle::Ptr{Cdouble}, right::Ptr{Cdouble})::herr_t "Error in h5p_get_btree_ratios (not annotated)"
@bind h5p_get_buffer(plist_id::hid_t, tconv::Ptr{Ptr{Cvoid}}, bkg::Ptr{Ptr{Cvoid}})::Csize_t "Error in h5p_get_buffer (not annotated)"
@bind h5p_get_cache(plist_id::hid_t, mdc_nelmts::Ptr{Cint}, rdcc_nslots::Ptr{Csize_t}, rdcc_nbytes::Ptr{Csize_t}, rdcc_w0::Ptr{Cdouble})::herr_t "Error in h5p_get_cache (not annotated)"
@bind h5p_get_char_encoding(plist_id::hid_t, encoding::Ref{Cint})::herr_t "Error getting char encoding"
@bind h5p_get_chunk(plist_id::hid_t, n_dims::Cint, dims::Ptr{hsize_t})::Cint "Error getting chunk size"
@bind h5p_get_chunk_cache(dapl_id::hid_t, rdcc_nslots::Ptr{Csize_t}, rdcc_nbytes::Ptr{Csize_t}, rdcc_w0::Ptr{Cdouble})::herr_t "Error in h5p_get_chunk_cache (not annotated)"
@bind h5p_get_chunk_opts(plist_id::hid_t, opts::Ptr{Cuint})::herr_t "Error in h5p_get_chunk_opts (not annotated)"
@bind h5p_get_class(plist_id::hid_t)::hid_t "Error in h5p_get_class (not annotated)"
#@bind h5p_get_class_name(pclass_id::hid_t)::Ptr{Cchar} "Error in h5p_get_class_name (not annotated)"
@bind h5p_get_class_parent(pclass_id::hid_t)::hid_t "Error in h5p_get_class_parent (not annotated)"
@bind h5p_get_copy_object(plist_id::hid_t, copy_options::Ptr{Cuint})::herr_t "Error in h5p_get_copy_object (not annotated)"
@bind h5p_get_core_write_tracking(fapl_id::hid_t, is_enabled::Ptr{hbool_t}, page_size::Ptr{Csize_t})::herr_t "Error in h5p_get_core_write_tracking (not annotated)"
@bind h5p_get_create_intermediate_group(lcpl_id::hid_t, crt_intermed_group::Ref{Cuint})::herr_t "Error getting create intermediate group property"
@bind h5p_get_data_transform(plist_id::hid_t, expression::Ptr{Cchar}, size::Csize_t)::Cssize_t "Error in h5p_get_data_transform (not annotated)"
@bind h5p_get_driver(plist_id::hid_t)::hid_t "Error getting driver identifier"
@bind h5p_get_driver_info(plist_id::hid_t)::Ptr{Cvoid} "Error getting driver info"
@bind h5p_get_dset_no_attrs_hint(dcpl_id::hid_t, minimize::Ptr{hbool_t})::herr_t "Error in getting dataset no attributes hint property"
@bind h5p_get_dxpl_mpio(dxpl_id::hid_t, xfer_mode::Ptr{Cint})::herr_t "Error getting MPIO transfer mode"
@bind h5p_get_edc_check(plist_id::hid_t)::H5Z_EDC_t "Error in h5p_get_edc_check (not annotated)"
@bind h5p_get_efile_prefix(dapl_id::hid_t, prefix::Ptr{UInt8}, size::Csize_t)::Cssize_t "Error getting external file prefix"
@bind h5p_get_elink_acc_flags(lapl_id::hid_t, flags::Ptr{Cuint})::herr_t "Error in h5p_get_elink_acc_flags (not annotated)"
@bind h5p_get_elink_cb(lapl_id::hid_t, func::Ptr{H5L_elink_traverse_t}, op_data::Ptr{Ptr{Cvoid}})::herr_t "Error in h5p_get_elink_cb (not annotated)"
@bind h5p_get_elink_fapl(lapl_id::hid_t)::hid_t "Error in h5p_get_elink_fapl (not annotated)"
@bind h5p_get_elink_file_cache_size(plist_id::hid_t, efc_size::Ptr{Cuint})::herr_t "Error in h5p_get_elink_file_cache_size (not annotated)"
@bind h5p_get_elink_prefix(plist_id::hid_t, prefix::Ptr{Cchar}, size::Csize_t)::Cssize_t "Error in h5p_get_elink_prefix (not annotated)"
@bind h5p_get_est_link_info(plist_id::hid_t, est_num_entries::Ptr{Cuint}, est_name_len::Ptr{Cuint})::herr_t "Error in h5p_get_est_link_info (not annotated)"
@bind h5p_get_evict_on_close(fapl_id::hid_t, evict_on_close::Ptr{hbool_t})::herr_t "Error in h5p_get_evict_on_close (not annotated)"
# Argument type changed for Windows in v2.0
@bind h5p_get_external(plist::hid_t, idx::Cuint, name_size::Csize_t, name::Ptr{Cuchar}, offset::Ptr{off_t}, size::Ptr{hsize_t})::herr_t "Error getting external file properties" (nothing, v"2.0")
@bind h5p_get_external(plist::hid_t, idx::Cuint, name_size::Csize_t, name::Ptr{Cuchar}, offset::Ptr{H5Doff_t}, size::Ptr{hsize_t})::herr_t "Error getting external file properties" (v"2.0", nothing)
@bind h5p_get_external_count(plist::hid_t)::Cint "Error getting external count"
@bind h5p_get_family_offset(fapl_id::hid_t, offset::Ptr{hsize_t})::herr_t "Error in h5p_get_family_offset (not annotated)"
@bind h5p_get_fapl_core(fapl_id::hid_t, increment::Ptr{Csize_t}, backing_store::Ptr{hbool_t})::herr_t "Error in h5p_get_fapl_core (not annotated)"
@bind h5p_get_fapl_family(fapl_id::hid_t, memb_size::Ptr{hsize_t}, memb_fapl_id::Ptr{hid_t})::herr_t "Error in h5p_get_fapl_family (not annotated)"
@bind h5p_get_fapl_hdfs(fapl_id::hid_t, fa_out::Ptr{H5FD_hdfs_fapl_t})::herr_t "Error in h5p_get_fapl_hdfs (not annotated)"
@bind h5p_get_fapl_multi(fapl_id::hid_t, memb_map::Ptr{H5FD_mem_t}, memb_fapl::Ptr{hid_t}, memb_name::Ptr{Ptr{Cchar}}, memb_addr::Ptr{haddr_t}, relax::Ptr{hbool_t})::herr_t "Error in h5p_get_fapl_multi (not annotated)"
@bind h5p_get_fapl_splitter(fapl_id::hid_t, config_ptr::Ptr{H5FD_splitter_vfd_config_t})::herr_t "Error in h5p_get_fapl_splitter (not annotated)"
@bind h5p_get_fapl_ros3(fapl_id::hid_t, fa_out::Ptr{H5FD_ros3_fapl_t})::herr_t "Error in getting ros3 properties"
@bind h5p_get_fclose_degree(fapl_id::hid_t, fc_degree::Ref{Cint})::herr_t "Error getting close degree"
@bind h5p_get_file_image(fapl_id::hid_t, buf_ptr_ptr::Ptr{Ptr{Cvoid}}, buf_len_ptr::Ptr{Csize_t})::herr_t "Error in h5p_get_file_image (not annotated)"
@bind h5p_get_file_image_callbacks(fapl_id::hid_t, callbacks_ptr::Ptr{H5FD_file_image_callbacks_t})::herr_t "Error in h5p_get_file_image_callbacks (not annotated)"
@bind h5p_get_file_locking(fapl_id::hid_t, use_file_locking::Ptr{hbool_t}, ignore_when_disabled::Ptr{hbool_t})::herr_t "Error in h5p_get_file_locking (not annotated)"
@bind h5p_get_file_space(plist_id::hid_t, strategy::Ptr{H5F_file_space_type_t}, threshold::Ptr{hsize_t})::herr_t "Error in h5p_get_file_space (not annotated)"
@bind h5p_get_file_space_page_size(plist_id::hid_t, fsp_size::Ptr{hsize_t})::herr_t "Error in h5p_get_file_space_page_size (not annotated)"
@bind h5p_get_file_space_strategy(plist_id::hid_t, strategy::Ptr{H5F_fspace_strategy_t}, persist::Ptr{hbool_t}, threshold::Ptr{hsize_t})::herr_t "Error in h5p_get_file_space_strategy (not annotated)"
@bind h5p_get_fill_time(plist_id::hid_t, fill_time::Ptr{H5D_fill_time_t})::herr_t "Error in h5p_get_fill_time (not annotated)"
@bind h5p_get_fill_value(plist_id::hid_t, type_id::hid_t, value::Ptr{Cvoid})::herr_t "Error in h5p_get_fill_value (not annotated)"
@bind h5p_get_filter2(plist_id::hid_t, idx::Cuint, flags::Ptr{Cuint}, cd_nemlts::Ref{Csize_t}, cd_values::Ptr{Cuint}, namelen::Csize_t, name::Ptr{Cchar}, filter_config::Ptr{Cuint})::H5Z_filter_t "Error getting filter"
@bind h5p_get_filter_by_id2(plist_id::hid_t, filter_id::H5Z_filter_t, flags::Ref{Cuint}, cd_nelmts::Ref{Csize_t}, cd_values::Ptr{Cuint}, namelen::Csize_t, name::Ptr{UInt8}, filter_config::Ptr{Cuint})::herr_t "Error getting filter ID"
@bind h5p_get_gc_references(fapl_id::hid_t, gc_ref::Ptr{Cuint})::herr_t "Error in h5p_get_gc_references (not annotated)"
@bind h5p_get_hyper_vector_size(fapl_id::hid_t, size::Ptr{Csize_t})::herr_t "Error in h5p_get_hyper_vector_size (not annotated)"
@bind h5p_get_istore_k(plist_id::hid_t, ik::Ptr{Cuint})::herr_t "Error in h5p_get_istore_k (not annotated)"
@bind h5p_get_layout(plist_id::hid_t)::Cint string("Error getting layout")
@bind h5p_get_libver_bounds(fapl_id::hid_t, low::Ref{Cint}, high::Ref{Cint})::herr_t "Error getting library version bounds"
@bind h5p_get_link_creation_order(plist_id::hid_t, crt_order_flags::Ptr{Cuint})::herr_t "Error getting link creation order"
@bind h5p_get_link_phase_change(plist_id::hid_t, max_compact::Ptr{Cuint}, min_dense::Ptr{Cuint})::herr_t "Error in h5p_get_link_phase_change (not annotated)"
@bind h5p_get_local_heap_size_hint(plist_id::hid_t, size_hint::Ref{Csize_t})::herr_t "Error getting local heap size hint"
@bind h5p_get_mcdt_search_cb(plist_id::hid_t, func::Ptr{H5O_mcdt_search_cb_t}, op_data::Ptr{Ptr{Cvoid}})::herr_t "Error in h5p_get_mcdt_search_cb (not annotated)"
@bind h5p_get_mdc_config(plist_id::hid_t, config_ptr::Ptr{H5AC_cache_config_t})::herr_t "Error in h5p_get_mdc_config (not annotated)"
@bind h5p_get_mdc_image_config(plist_id::hid_t, config_ptr::Ptr{H5AC_cache_image_config_t})::herr_t "Error in h5p_get_mdc_image_config (not annotated)"
@bind h5p_get_mdc_log_options(plist_id::hid_t, is_enabled::Ptr{hbool_t}, location::Ptr{Cchar}, location_size::Ptr{Csize_t}, start_on_access::Ptr{hbool_t})::herr_t "Error in h5p_get_mdc_log_options (not annotated)"
@bind h5p_get_meta_block_size(fapl_id::hid_t, size::Ptr{hsize_t})::herr_t "Error in h5p_get_meta_block_size (not annotated)"
@bind h5p_get_metadata_read_attempts(plist_id::hid_t, attempts::Ptr{Cuint})::herr_t "Error in h5p_get_metadata_read_attempts (not annotated)"
@bind h5p_get_multi_type(fapl_id::hid_t, type::Ptr{H5FD_mem_t})::herr_t "Error in h5p_get_multi_type (not annotated)"
@bind h5p_get_nfilters(plist_id::hid_t)::Cint "Error getting nfilters"
@bind h5p_get_nlinks(plist_id::hid_t, nlinks::Ptr{Csize_t})::herr_t "Error in h5p_get_nlinks (not annotated)"
@bind h5p_get_nprops(id::hid_t, nprops::Ptr{Csize_t})::herr_t "Error in h5p_get_nprops (not annotated)"
@bind h5p_get_obj_track_times(plist_id::hid_t, track_times::Ref{UInt8})::herr_t "Error getting object time tracking"
@bind h5p_get_object_flush_cb(plist_id::hid_t, func::Ptr{H5F_flush_cb_t}, udata::Ptr{Ptr{Cvoid}})::herr_t "Error in h5p_get_object_flush_cb (not annotated)"
@bind h5p_get_page_buffer_size(plist_id::hid_t, buf_size::Ptr{Csize_t}, min_meta_perc::Ptr{Cuint}, min_raw_perc::Ptr{Cuint})::herr_t "Error in h5p_get_page_buffer_size (not annotated)"
@bind h5p_get_preserve(plist_id::hid_t)::Cint "Error in h5p_get_preserve (not annotated)"
@bind h5p_get_shared_mesg_index(plist_id::hid_t, index_num::Cuint, mesg_type_flags::Ptr{Cuint}, min_mesg_size::Ptr{Cuint})::herr_t "Error in h5p_get_shared_mesg_index (not annotated)"
@bind h5p_get_shared_mesg_nindexes(plist_id::hid_t, nindexes::Ptr{Cuint})::herr_t "Error in h5p_get_shared_mesg_nindexes (not annotated)"
@bind h5p_get_shared_mesg_phase_change(plist_id::hid_t, max_list::Ptr{Cuint}, min_btree::Ptr{Cuint})::herr_t "Error in h5p_get_shared_mesg_phase_change (not annotated)"
@bind h5p_get_sieve_buf_size(fapl_id::hid_t, size::Ptr{Csize_t})::herr_t "Error in h5p_get_sieve_buf_size (not annotated)"
@bind h5p_get_size(id::hid_t, name::Ptr{Cchar}, size::Ptr{Csize_t})::herr_t "Error in h5p_get_size (not annotated)"
@bind h5p_get_sizes(plist_id::hid_t, sizeof_addr::Ptr{Csize_t}, sizeof_size::Ptr{Csize_t})::herr_t "Error in h5p_get_sizes (not annotated)"
@bind h5p_get_small_data_block_size(fapl_id::hid_t, size::Ptr{hsize_t})::herr_t "Error in h5p_get_small_data_block_size (not annotated)"
@bind h5p_get_sym_k(plist_id::hid_t, ik::Ptr{Cuint}, lk::Ptr{Cuint})::herr_t "Error in h5p_get_sym_k (not annotated)"
@bind h5p_get_type_conv_cb(dxpl_id::hid_t, op::Ptr{H5T_conv_except_func_t}, operate_data::Ptr{Ptr{Cvoid}})::herr_t "Error in h5p_get_type_conv_cb (not annotated)"
@bind h5p_get_userblock(plist_id::hid_t, len::Ptr{hsize_t})::herr_t "Error getting userblock"
@bind h5p_get_version(plist_id::hid_t, boot::Ptr{Cuint}, freelist::Ptr{Cuint}, stab::Ptr{Cuint}, shhdr::Ptr{Cuint})::herr_t "Error in h5p_get_version (not annotated)"
@bind h5p_get_virtual_count(dcpl_id::hid_t, count::Ptr{Csize_t})::herr_t "Error in h5p_get_virtual_count (not annotated)"
@bind h5p_get_virtual_dsetname(dcpl_id::hid_t, index::Csize_t, name::Ptr{Cchar}, size::Csize_t)::Cssize_t "Error in h5p_get_virtual_dsetname (not annotated)"
@bind h5p_get_virtual_filename(dcpl_id::hid_t, index::Csize_t, name::Ptr{Cchar}, size::Csize_t)::Cssize_t "Error in h5p_get_virtual_filename (not annotated)"
@bind h5p_get_virtual_prefix(dapl_id::hid_t, prefix::Ptr{Cchar}, size::Csize_t)::Cssize_t "Error in h5p_get_virtual_prefix (not annotated)"
@bind h5p_get_virtual_printf_gap(dapl_id::hid_t, gap_size::Ptr{hsize_t})::herr_t "Error in h5p_get_virtual_printf_gap (not annotated)"
@bind h5p_get_virtual_srcspace(dcpl_id::hid_t, index::Csize_t)::hid_t "Error in h5p_get_virtual_srcspace (not annotated)"
@bind h5p_get_virtual_view(dapl_id::hid_t, view::Ptr{H5D_vds_view_t})::herr_t "Error in h5p_get_virtual_view (not annotated)"
@bind h5p_get_virtual_vspace(dcpl_id::hid_t, index::Csize_t)::hid_t "Error in h5p_get_virtual_vspace (not annotated)"
@bind h5p_get_vlen_mem_manager(plist_id::hid_t, alloc_func::Ptr{H5MM_allocate_t}, alloc_info::Ptr{Ptr{Cvoid}}, free_func::Ptr{H5MM_free_t}, free_info::Ptr{Ptr{Cvoid}})::herr_t "Error in h5p_get_vlen_mem_manager (not annotated)"
@bind h5p_get_vol_id(plist_id::hid_t, vol_id::Ptr{hid_t})::herr_t "Error in h5p_get_vol_id (not annotated)"
@bind h5p_get_vol_info(plist_id::hid_t, vol_info::Ptr{Ptr{Cvoid}})::herr_t "Error in h5p_get_vol_info (not annotated)"

# set
@bind h5p_set(plist_id::hid_t, name::Cstring, value::Ptr{Cvoid})::herr_t "Error in h5p_set (not annotated)"
@bind h5p_set_alignment(plist_id::hid_t, threshold::hsize_t, alignment::hsize_t)::herr_t "Error setting alignment"
@bind h5p_set_alloc_time(plist_id::hid_t, alloc_time::Cint)::herr_t "Error setting allocation timing"
@bind h5p_set_append_flush(dapl_id::hid_t, ndims::Cuint, boundary::Ptr{hsize_t}, func::H5D_append_cb_t, udata::Ptr{Cvoid})::herr_t "Error in h5p_set_append_flush (not annotated)"
@bind h5p_set_attr_creation_order(plist_id::hid_t, crt_order_flags::Cuint)::herr_t "Error setting attribute creation order"
@bind h5p_set_attr_phase_change(plist_id::hid_t, max_compact::Cuint, min_dense::Cuint)::herr_t "Error in h5p_set_attr_phase_change (not annotated)"
@bind h5p_set_btree_ratios(plist_id::hid_t, left::Cdouble, middle::Cdouble, right::Cdouble)::herr_t "Error in h5p_set_btree_ratios (not annotated)"
@bind h5p_set_buffer(plist_id::hid_t, size::Csize_t, tconv::Ptr{Cvoid}, bkg::Ptr{Cvoid})::herr_t "Error in h5p_set_buffer (not annotated)"
@bind h5p_set_cache(plist_id::hid_t, mdc_nelmts::Cint, rdcc_nslots::Csize_t, rdcc_nbytes::Csize_t, rdcc_w0::Cdouble)::herr_t "Error in h5p_set_cache (not annotated)"
@bind h5p_set_char_encoding(plist_id::hid_t, encoding::Cint)::herr_t "Error setting char encoding"
@bind h5p_set_chunk(plist_id::hid_t, ndims::Cint, dims::Ptr{hsize_t})::herr_t "Error setting chunk size"
@bind h5p_set_chunk_cache(dapl_id::hid_t, rdcc_nslots::Csize_t, rdcc_nbytes::Csize_t, rdcc_w0::Cdouble)::herr_t "Error setting chunk cache"
@bind h5p_set_chunk_opts(plist_id::hid_t, opts::Cuint)::herr_t "Error in h5p_set_chunk_opts (not annotated)"
@bind h5p_set_copy_object(plist_id::hid_t, copy_options::Cuint)::herr_t "Error in h5p_set_copy_object (not annotated)"
@bind h5p_set_core_write_tracking(fapl_id::hid_t, is_enabled::hbool_t, page_size::Csize_t)::herr_t "Error in h5p_set_core_write_tracking (not annotated)"
@bind h5p_set_create_intermediate_group(plist_id::hid_t, setting::Cuint)::herr_t "Error setting create intermediate group"
@bind h5p_set_data_transform(plist_id::hid_t, expression::Cstring)::herr_t "Error in h5p_set_data_transform (not annotated)"
@bind h5p_set_deflate(plist_id::hid_t, setting::Cuint)::herr_t "Error setting compression method and level (deflate)"
@bind h5p_set_driver(plist_id::hid_t, driver_id::hid_t, driver_info::Ptr{Cvoid})::herr_t "Error in h5p_set_driver (not annotated)"
@bind h5p_set_dset_no_attrs_hint(dcpl_id::hid_t, minimize::hbool_t)::herr_t "Error in setting dataset no attributes hint property"
@bind h5p_set_dxpl_mpio(dxpl_id::hid_t, xfer_mode::Cint)::herr_t "Error setting MPIO transfer mode"
@bind h5p_set_edc_check(plist_id::hid_t, check::H5Z_EDC_t)::herr_t "Error in h5p_set_edc_check (not annotated)"
@bind h5p_set_efile_prefix(plist_id::hid_t, prefix::Cstring)::herr_t "Error setting external file prefix"
@bind h5p_set_elink_acc_flags(lapl_id::hid_t, flags::Cuint)::herr_t "Error in h5p_set_elink_acc_flags (not annotated)"
@bind h5p_set_elink_cb(lapl_id::hid_t, func::H5L_elink_traverse_t, op_data::Ptr{Cvoid})::herr_t "Error in h5p_set_elink_cb (not annotated)"
@bind h5p_set_elink_fapl(lapl_id::hid_t, fapl_id::hid_t)::herr_t "Error in h5p_set_elink_fapl (not annotated)"
@bind h5p_set_elink_file_cache_size(plist_id::hid_t, efc_size::Cuint)::herr_t "Error in h5p_set_elink_file_cache_size (not annotated)"
@bind h5p_set_elink_prefix(plist_id::hid_t, prefix::Cstring)::herr_t "Error in h5p_set_elink_prefix (not annotated)"
@bind h5p_set_est_link_info(plist_id::hid_t, est_num_entries::Cuint, est_name_len::Cuint)::herr_t "Error in h5p_set_est_link_info (not annotated)"
@bind h5p_set_evict_on_close(fapl_id::hid_t, evict_on_close::hbool_t)::herr_t "Error in h5p_set_evict_on_close (not annotated)"
# Argument type changed for Windows in v2.0
@bind h5p_set_external(plist_id::hid_t, name::Cstring, offset::off_t, size::hsize_t)::herr_t "Error setting external property" (nothing, v"2.0")
@bind h5p_set_external(plist_id::hid_t, name::Cstring, offset::H5Doff_t, size::hsize_t)::herr_t "Error setting external property" (v"2.0", nothing)
@bind h5p_set_family_offset(fapl_id::hid_t, offset::hsize_t)::herr_t "Error in h5p_set_family_offset (not annotated)"
@bind h5p_set_fapl_core(fapl_id::hid_t, increment::Csize_t, backing_store::hbool_t)::herr_t "Error in h5p_set_fapl_core (not annotated)"
@bind h5p_set_fapl_family(fapl_id::hid_t, memb_size::hsize_t, memb_fapl_id::hid_t)::herr_t "Error in h5p_set_fapl_family (not annotated)"
@bind h5p_set_fapl_hdfs(fapl_id::hid_t, fa::Ptr{H5FD_hdfs_fapl_t})::herr_t "Error in h5p_set_fapl_hdfs (not annotated)"
@bind h5p_set_fapl_log(fapl_id::hid_t, logfile::Cstring, flags::Culonglong, buf_size::Csize_t)::herr_t "Error in h5p_set_fapl_log (not annotated)"
@bind h5p_set_fapl_multi(fapl_id::hid_t, memb_map::Ptr{H5FD_mem_t}, memb_fapl::Ptr{hid_t}, memb_name::Ptr{Cstring}, memb_addr::Ptr{haddr_t}, relax::hbool_t)::herr_t "Error in h5p_set_fapl_multi (not annotated)"
@bind h5p_set_fapl_sec2(fapl_id::hid_t)::herr_t "Error setting Sec2 properties"
@bind h5p_set_fapl_ros3(fapl_id::hid_t, fa::Ptr{H5FD_ros3_fapl_t})::herr_t "Error in setting ros3 properties"
@bind h5p_set_fapl_split(fapl::hid_t, meta_ext::Cstring, meta_plist_id::hid_t, raw_ext::Cstring, raw_plist_id::hid_t)::herr_t "Error in h5p_set_fapl_split (not annotated)"
@bind h5p_set_fapl_splitter(fapl_id::hid_t, config_ptr::Ptr{H5FD_splitter_vfd_config_t})::herr_t "Error in h5p_set_fapl_splitter (not annotated)"
@bind h5p_set_fapl_stdio(fapl_id::hid_t)::herr_t "Error in h5p_set_fapl_stdio (not annotated)"
@bind h5p_set_fapl_windows(fapl_id::hid_t)::herr_t "Error in h5p_set_fapl_windows (not annotated)"
@bind h5p_set_fclose_degree(plist_id::hid_t, fc_degree::Cint)::herr_t "Error setting close degree"
@bind h5p_set_file_image(fapl_id::hid_t, buf_ptr::Ptr{Cvoid}, buf_len::Csize_t)::herr_t "Error in h5p_set_file_image (not annotated)"
@bind h5p_set_file_image_callbacks(fapl_id::hid_t, callbacks_ptr::Ptr{H5FD_file_image_callbacks_t})::herr_t "Error in h5p_set_file_image_callbacks (not annotated)"
@bind h5p_set_file_locking(fapl_id::hid_t, use_file_locking::hbool_t, ignore_when_disabled::hbool_t)::herr_t "Error in h5p_set_file_locking (not annotated)"
@bind h5p_set_file_space(plist_id::hid_t, strategy::H5F_file_space_type_t, threshold::hsize_t)::herr_t "Error in h5p_set_file_space (not annotated)"
@bind h5p_set_file_space_page_size(plist_id::hid_t, fsp_size::hsize_t)::herr_t "Error in h5p_set_file_space_page_size (not annotated)"
@bind h5p_set_file_space_strategy(plist_id::hid_t, strategy::H5F_fspace_strategy_t, persist::hbool_t, threshold::hsize_t)::herr_t "Error in h5p_set_file_space_strategy (not annotated)"
@bind h5p_set_fill_time(plist_id::hid_t, fill_time::H5D_fill_time_t)::herr_t "Error in h5p_set_fill_time (not annotated)"
@bind h5p_set_fill_value(plist_id::hid_t, type_id::hid_t, value::Ptr{Cvoid})::herr_t "Error in h5p_set_fill_value (not annotated)"
@bind h5p_set_filter(plist_id::hid_t, filter_id::H5Z_filter_t, flags::Cuint, cd_nelmts::Csize_t, cd_values::Ptr{Cuint})::herr_t "Error setting filter"
@bind h5p_set_filter_callback(plist_id::hid_t, func::H5Z_filter_func_t, op_data::Ptr{Cvoid})::herr_t "Error in h5p_set_filter_callback (not annotated)"
@bind h5p_set_fletcher32(plist_id::hid_t)::herr_t "Error enabling Fletcher32 filter"
@bind h5p_set_gc_references(fapl_id::hid_t, gc_ref::Cuint)::herr_t "Error in h5p_set_gc_references (not annotated)"
@bind h5p_set_hyper_vector_size(plist_id::hid_t, size::Csize_t)::herr_t "Error in h5p_set_hyper_vector_size (not annotated)"
@bind h5p_set_istore_k(plist_id::hid_t, ik::Cuint)::herr_t "Error in h5p_set_istore_k (not annotated)"
@bind h5p_set_layout(plist_id::hid_t, setting::Cint)::herr_t "Error setting layout"
@bind h5p_set_libver_bounds(fapl_id::hid_t, low::Cint, high::Cint)::herr_t "Error setting library version bounds"
@bind h5p_set_link_creation_order(plist_id::hid_t, crt_order_flags::Cuint)::herr_t "Error setting link creation order"
@bind h5p_set_link_phase_change(plist_id::hid_t, max_compact::Cuint, min_dense::Cuint)::herr_t "Error in h5p_set_link_phase_change (not annotated)"
@bind h5p_set_local_heap_size_hint(plist_id::hid_t, size_hint::Csize_t)::herr_t "Error setting local heap size hint"
@bind h5p_set_mcdt_search_cb(plist_id::hid_t, func::H5O_mcdt_search_cb_t, op_data::Ptr{Cvoid})::herr_t "Error in h5p_set_mcdt_search_cb (not annotated)"
@bind h5p_set_mdc_config(plist_id::hid_t, config_ptr::Ptr{H5AC_cache_config_t})::herr_t "Error in h5p_set_mdc_config (not annotated)"
@bind h5p_set_mdc_image_config(plist_id::hid_t, config_ptr::Ptr{H5AC_cache_image_config_t})::herr_t "Error in h5p_set_mdc_image_config (not annotated)"
@bind h5p_set_mdc_log_options(plist_id::hid_t, is_enabled::hbool_t, location::Cstring, start_on_access::hbool_t)::herr_t "Error in h5p_set_mdc_log_options (not annotated)"
@bind h5p_set_meta_block_size(fapl_id::hid_t, size::hsize_t)::herr_t "Error in h5p_set_meta_block_size (not annotated)"
@bind h5p_set_metadata_read_attempts(plist_id::hid_t, attempts::Cuint)::herr_t "Error in h5p_set_metadata_read_attempts (not annotated)"
@bind h5p_set_multi_type(fapl_id::hid_t, type::H5FD_mem_t)::herr_t "Error in h5p_set_multi_type (not annotated)"
@bind h5p_set_nbit(plist_id::hid_t)::herr_t "Error enabling nbit filter"
@bind h5p_set_nlinks(plist_id::hid_t, nlinks::Csize_t)::herr_t "Error in h5p_set_nlinks (not annotated)"
@bind h5p_set_obj_track_times(plist_id::hid_t, track_times::UInt8)::herr_t "Error setting object time tracking"
@bind h5p_set_object_flush_cb(plist_id::hid_t, func::H5F_flush_cb_t, udata::Ptr{Cvoid})::herr_t "Error in h5p_set_object_flush_cb (not annotated)"
@bind h5p_set_page_buffer_size(plist_id::hid_t, buf_size::Csize_t, min_meta_per::Cuint, min_raw_per::Cuint)::herr_t "Error in h5p_set_page_buffer_size (not annotated)"
@bind h5p_set_preserve(plist_id::hid_t, status::hbool_t)::herr_t "Error in h5p_set_preserve (not annotated)"
@bind h5p_set_scaleoffset(plist_id::hid_t, scale_type::Cint, scale_factor::Cint)::herr_t "Error enabling szip filter"
@bind h5p_set_shared_mesg_index(plist_id::hid_t, index_num::Cuint, mesg_type_flags::Cuint, min_mesg_size::Cuint)::herr_t "Error in h5p_set_shared_mesg_index (not annotated)"
@bind h5p_set_shared_mesg_nindexes(plist_id::hid_t, nindexes::Cuint)::herr_t "Error in h5p_set_shared_mesg_nindexes (not annotated)"
@bind h5p_set_shared_mesg_phase_change(plist_id::hid_t, max_list::Cuint, min_btree::Cuint)::herr_t "Error in h5p_set_shared_mesg_phase_change (not annotated)"
@bind h5p_set_shuffle(plist_id::hid_t)::herr_t "Error enabling shuffle filter"
@bind h5p_set_sieve_buf_size(fapl_id::hid_t, size::Csize_t)::herr_t "Error in h5p_set_sieve_buf_size (not annotated)"
@bind h5p_set_sizes(plist_id::hid_t, sizeof_addr::Csize_t, sizeof_size::Csize_t)::herr_t "Error in h5p_set_sizes (not annotated)"
@bind h5p_set_small_data_block_size(fapl_id::hid_t, size::hsize_t)::herr_t "Error in h5p_set_small_data_block_size (not annotated)"
@bind h5p_set_sym_k(plist_id::hid_t, ik::Cuint, lk::Cuint)::herr_t "Error in h5p_set_sym_k (not annotated)"
@bind h5p_set_szip(plist_id::hid_t, options_mask::Cuint, pixels_per_block::Cuint)::herr_t "Error enabling szip filter"
@bind h5p_set_type_conv_cb(dxpl_id::hid_t, op::H5T_conv_except_func_t, operate_data::Ptr{Cvoid})::herr_t "Error in h5p_set_type_conv_cb (not annotated)"
@bind h5p_set_userblock(plist_id::hid_t, len::hsize_t)::herr_t "Error setting userblock"
@bind h5p_set_virtual(dcpl_id::hid_t, vspace_id::hid_t, src_file_name::Cstring, src_dset_name::Cstring, src_space_id::hid_t)::herr_t "Error setting virtual"
@bind h5p_set_virtual_prefix(dapl_id::hid_t, prefix::Cstring)::herr_t "Error in h5p_set_virtual_prefix (not annotated)"
@bind h5p_set_virtual_printf_gap(dapl_id::hid_t, gap_size::hsize_t)::herr_t "Error in h5p_set_virtual_printf_gap (not annotated)"
@bind h5p_set_virtual_view(dapl_id::hid_t, view::H5D_vds_view_t)::herr_t "Error in h5p_set_virtual_view (not annotated)"
@bind h5p_set_vlen_mem_manager(plist_id::hid_t, alloc_func::H5MM_allocate_t, alloc_info::Ptr{Cvoid}, free_func::H5MM_free_t, free_info::Ptr{Cvoid})::herr_t "Error in h5p_set_vlen_mem_manager (not annotated)"
@bind h5p_set_vol(plist_id::hid_t, new_vol_id::hid_t, new_vol_info::Ptr{Cvoid})::herr_t "Error in h5p_set_vol (not annotated)"

# others

@bind h5p_add_merge_committed_dtype_path(plist_id::hid_t, path::Cstring)::herr_t "Error in h5p_add_merge_committed_dtype_path (not annotated)"
@bind h5p_all_filters_avail(plist_id::hid_t)::htri_t "Error in h5p_all_filters_avail (not annotated)"
@bind h5p_close(id::hid_t)::herr_t "Error closing property list"
@bind h5p_close_class(plist_id::hid_t)::herr_t "Error in h5p_close_class (not annotated)"
@bind h5p_copy(plist_id::hid_t)::hid_t "Error in h5p_copy (not annotated)"
@bind h5p_copy_prop(dst_id::hid_t, src_id::hid_t, name::Cstring)::herr_t "Error in h5p_copy_prop (not annotated)"
@bind h5p_create(cls_id::hid_t)::hid_t "Error creating property list"
@bind h5p_create_class(parent::hid_t, name::Cstring, create::H5P_cls_create_func_t, create_data::Ptr{Cvoid}, copy::H5P_cls_copy_func_t, copy_data::Ptr{Cvoid}, close::H5P_cls_close_func_t, close_data::Ptr{Cvoid})::hid_t "Error in h5p_create_class (not annotated)"
@bind h5p_decode(buf::Ptr{Cvoid})::hid_t "Error in h5p_decode (not annotated)"
@bind h5p_encode1(plist_id::hid_t, buf::Ptr{Cvoid}, nalloc::Ptr{Csize_t})::herr_t "Error in h5p_encode1 (not annotated)"
@bind h5p_encode2(plist_id::hid_t, buf::Ptr{Cvoid}, nalloc::Ptr{Csize_t}, fapl_id::hid_t)::herr_t "Error in h5p_encode2 (not annotated)"
@bind h5p_equal(id1::hid_t, id2::hid_t)::htri_t "Error in h5p_equal (not annotated)"
@bind h5p_exist(plist_id::hid_t, name::Cstring)::htri_t "Error in h5p_exist (not annotated)"
@bind h5p_fill_value_defined(plist::hid_t, status::Ptr{H5D_fill_value_t})::herr_t "Error in h5p_fill_value_defined (not annotated)"
@bind h5p_free_merge_committed_dtype_paths(plist_id::hid_t)::herr_t "Error in h5p_free_merge_committed_dtype_paths (not annotated)"
@bind h5p_insert1(plist_id::hid_t, name::Cstring, size::Csize_t, value::Ptr{Cvoid}, prp_set::H5P_prp_set_func_t, prp_get::H5P_prp_get_func_t, prp_delete::H5P_prp_delete_func_t, prp_copy::H5P_prp_copy_func_t, prp_close::H5P_prp_close_func_t)::herr_t "Error in h5p_insert1 (not annotated)"
@bind h5p_insert2(plist_id::hid_t, name::Cstring, size::Csize_t, value::Ptr{Cvoid}, set::H5P_prp_set_func_t, get::H5P_prp_get_func_t, prp_del::H5P_prp_delete_func_t, copy::H5P_prp_copy_func_t, compare::H5P_prp_compare_func_t, close::H5P_prp_close_func_t)::herr_t "Error in h5p_insert2 (not annotated)"
@bind h5p_isa_class(plist_id::hid_t, pclass_id::hid_t)::htri_t "Error in h5p_isa_class (not annotated)"
@bind h5p_iterate(id::hid_t, idx::Ptr{Cint}, iter_func::H5P_iterate_t, iter_data::Ptr{Cvoid})::Cint "Error in h5p_iterate (not annotated)"
@bind h5p_modify_filter(plist_id::hid_t, filter_id::H5Z_filter_t, flags::Cuint, cd_nelmts::Csize_t, cd_values::Ptr{Cuint})::herr_t "Error modifying filter"
@bind h5p_register1(cls_id::hid_t, name::Cstring, size::Csize_t, def_value::Ptr{Cvoid}, prp_create::H5P_prp_create_func_t, prp_set::H5P_prp_set_func_t, prp_get::H5P_prp_get_func_t, prp_del::H5P_prp_delete_func_t, prp_copy::H5P_prp_copy_func_t, prp_close::H5P_prp_close_func_t)::herr_t "Error in h5p_register1 (not annotated)"
@bind h5p_register2(cls_id::hid_t, name::Cstring, size::Csize_t, def_value::Ptr{Cvoid}, create::H5P_prp_create_func_t, set::H5P_prp_set_func_t, get::H5P_prp_get_func_t, prp_del::H5P_prp_delete_func_t, copy::H5P_prp_copy_func_t, compare::H5P_prp_compare_func_t, close::H5P_prp_close_func_t)::herr_t "Error in h5p_register2 (not annotated)"
@bind h5p_remove(plist_id::hid_t, name::Cstring)::herr_t "Error in h5p_remove (not annotated)"
@bind h5p_remove_filter(plist_id::hid_t, filter_id::H5Z_filter_t)::herr_t "Error removing filter"
@bind h5p_unregister(pclass_id::hid_t, name::Cstring)::herr_t "Error in h5p_unregister (not annotated)"

###
### Plugin Interface
###

@bind h5pl_set_loading_state(plugin_control_mask::Cuint)::herr_t "Error setting plugin loading state"
@bind h5pl_get_loading_state(plugin_control_mask::Ptr{Cuint})::herr_t "Error getting plugin loading state"
@bind h5pl_append(search_path::Cstring)::herr_t "Error appending plugin path"
@bind h5pl_prepend(search_path::Cstring)::herr_t "Error prepending plugin path"
@bind h5pl_replace(search_path::Cstring, index::Cuint)::herr_t "Error replacing plugin path"
@bind h5pl_insert(search_path::Cstring, index::Cuint)::herr_t "Error inserting plugin path"
@bind h5pl_remove(index::Cuint)::herr_t "Error removing plugin path"
@bind h5pl_get(index::Cuint, path_buf::Ptr{Cchar}, buf_size::Csize_t)::Cssize_t "Error getting plugin path"
@bind h5pl_size(num_paths::Ptr{Cuint})::herr_t "Error in getting number of plugins paths"

###
### Reference Interface
###

@bind h5r_create(ref::Ptr{Cvoid}, loc_id::hid_t, pathname::Cstring, ref_type::Cint, space_id::hid_t)::herr_t string("Error creating reference to object ", h5i_get_name(loc_id), "/", pathname)
@bind h5r_dereference2(obj_id::hid_t, oapl_id::hid_t, ref_type::Cint, ref::Ptr{Cvoid})::hid_t "Error dereferencing object"
@bind h5r_get_obj_type2(loc_id::hid_t, ref_type::Cint, ref::Ptr{Cvoid}, obj_type::Ptr{Cint})::herr_t "Error getting object type"
@bind h5r_get_region(loc_id::hid_t, ref_type::Cint, ref::Ptr{Cvoid})::hid_t "Error getting region from reference"

###
### Dataspace Interface
###

@bind h5s_close(space_id::hid_t)::herr_t "Error closing dataspace"
@bind h5s_combine_hyperslab(dspace_id::hid_t, seloper::H5S_seloper_t, start::Ptr{hsize_t}, stride::Ptr{hsize_t}, count::Ptr{hsize_t}, block::Ptr{hsize_t})::herr_t "Error selecting hyperslab"
@bind h5s_combine_select(space1_id::hid_t, op::H5S_seloper_t , space2_id::hid_t)::hid_t "Error combining dataspaces" (v"1.10.7", nothing)
@bind h5s_copy(space_id::hid_t)::hid_t "Error copying dataspace"
@bind h5s_create(class::Cint)::hid_t "Error creating dataspace"
@bind h5s_create_simple(rank::Cint, current_dims::Ptr{hsize_t}, maximum_dims::Ptr{hsize_t})::hid_t "Error creating simple dataspace"
@bind h5s_extent_copy(dst::hid_t, src::hid_t)::herr_t "Error copying extent"
@bind h5s_extent_equal(space1_id::hid_t, space2_id::hid_t)::htri_t "Error comparing dataspaces"
@bind h5s_get_regular_hyperslab(space_id::hid_t, start::Ptr{hsize_t}, stride::Ptr{hsize_t}, count::Ptr{hsize_t}, block::Ptr{hsize_t})::herr_t "Error getting regular hyperslab selection"
@bind h5s_get_select_bounds(space_id::hid_t, starts::Ptr{hsize_t}, ends::Ptr{hsize_t})::herr_t "Error getting bounding box for selection"
@bind h5s_get_select_elem_npoints(space_id::hid_t)::hssize_t "Error getting number of elements in dataspace selection"
@bind h5s_get_select_elem_pointlist(space_id::hid_t, startpoint::hsize_t, numpoints::hsize_t, buf::Ptr{hsize_t})::herr_t "Error getting list of element points"
@bind h5s_get_select_hyper_blocklist(space_id::hid_t, startblock::hsize_t, numblocks::hsize_t, buf::Ptr{hsize_t})::herr_t "Error getting list of hyperslab blocks"
@bind h5s_get_select_hyper_nblocks(space_id::hid_t)::hssize_t "Error getting number of selected blocks"
@bind h5s_get_select_npoints(space_id::hid_t)::hsize_t "Error getting the number of selected points"
@bind h5s_get_select_type(space_id::hid_t)::H5S_sel_type "Error getting the selection type"
@bind h5s_get_simple_extent_dims(space_id::hid_t, dims::Ptr{hsize_t}, maxdims::Ptr{hsize_t})::Cint "Error getting the dimensions for a dataspace"
@bind h5s_get_simple_extent_ndims(space_id::hid_t)::Cint "Error getting the number of dimensions for a dataspace"
@bind h5s_get_simple_extent_type(space_id::hid_t)::H5S_class_t "Error getting the dataspace type"
@bind h5s_is_regular_hyperslab(space_id::hid_t)::htri_t "Error determining whether datapace is regular hyperslab"
@bind h5s_is_simple(space_id::hid_t)::htri_t "Error determining whether dataspace is simple"
@bind h5s_modify_select(space_id::hid_t, op::H5S_seloper_t, space2_id::hid_t)::herr_t "Error modifying selection"
@bind h5s_offset_simple(space_id::hid_t, offset::Ptr{hssize_t})::herr_t "Error offsetting simple dataspace extent"
@bind h5s_select_adjust(space_id::hid_t, offset::Ptr{hssize_t})::herr_t "Error adjusting selection offset"
@bind h5s_select_all(space_id::hid_t)::herr_t "Error selecting all of dataspace"
@bind h5s_select_copy(dst::hid_t, src::hid_t)::herr_t "Error copying selection"
@bind h5s_select_elements(space_id::hid_t, op::H5S_seloper_t, num_elem::Csize_t, coord::Ptr{hsize_t})::herr_t "Error selecting elements"
@bind h5s_select_hyperslab(dspace_id::hid_t, seloper::H5S_seloper_t, start::Ptr{hsize_t}, stride::Ptr{hsize_t}, count::Ptr{hsize_t}, block::Ptr{hsize_t})::herr_t "Error selecting hyperslab"
@bind h5s_select_intersect_block(space_id::hid_t, starts::Ptr{hsize_t}, ends::Ptr{hsize_t})::htri_t "Error determining whether selection intersects block"
@bind h5s_select_shape_same(space1_id::hid_t, space2_id::hid_t)::htri_t "Error determining whether dataspace shapes are the same"
@bind h5s_select_valid(spaceid::hid_t)::htri_t "Error determining whether selection is within extent"
@bind h5s_set_extent_none(space_id::hid_t)::herr_t "Error setting dataspace extent to none"
@bind h5s_set_extent_simple(dspace_id::hid_t, rank::Cint, current_size::Ptr{hsize_t}, maximum_size::Ptr{hsize_t})::herr_t "Error setting dataspace size"

###
### Datatype Interface
###

@bind h5t_array_create2(basetype_id::hid_t, ndims::Cuint, sz::Ptr{hsize_t})::hid_t string("Error creating H5T_ARRAY of id ", basetype_id, " and size ", sz)
@bind h5t_close(dtype_id::hid_t)::herr_t "Error closing datatype"
@bind h5t_committed(dtype_id::hid_t)::htri_t "Error determining whether datatype is committed"
@bind h5t_commit2(loc_id::hid_t, name::Cstring, dtype_id::hid_t, lcpl_id::hid_t, tcpl_id::hid_t, tapl_id::hid_t)::herr_t "Error committing type"
# @bind h5t_commit_anon
# @bind h5t_compiler_conv
@bind h5t_copy(dtype_id::hid_t)::hid_t "Error copying datatype"
@bind h5t_create(class_id::Cint, sz::Csize_t)::hid_t string("Error creating datatype of id ", class_id)
# @bind h5t_decode
# @bind h5t_detect_class
# @bind h5t_encode
# @bind h5t_enum_create
@bind h5t_enum_insert(dtype_id::hid_t, name::Cstring, value::Ptr{Cvoid})::herr_t string("Error adding ", name, " to enum datatype")
# @bind h5t_enum_nameof
# @bind h5t_enum_valueof
@bind h5t_equal(dtype_id1::hid_t, dtype_id2::hid_t)::htri_t "Error checking datatype equality"
# @bind ht5_find
@bind h5t_get_array_dims2(dtype_id::hid_t, dims::Ptr{hsize_t})::Cint "Error getting dimensions of array"
@bind h5t_get_array_ndims(dtype_id::hid_t)::Cint "Error getting ndims of array"
@bind h5t_get_class(dtype_id::hid_t)::Cint "Error getting class"
@bind h5t_get_cset(dtype_id::hid_t)::Cint "Error getting character set encoding"
@bind h5t_get_ebias(dtype_id::hid_t)::Csize_t "Error getting exponent bias"
@bind h5t_get_fields(dtype_id::hid_t, spos::Ref{Csize_t}, epos::Ref{Csize_t}, esize::Ref{Csize_t}, mpos::Ref{Csize_t}, msize::Ref{Csize_t})::herr_t "Error getting datatype floating point bit positions"
@bind h5t_get_member_class(dtype_id::hid_t, index::Cuint)::Cint string("Error getting class of compound datatype member #", index)
@bind h5t_get_member_index(dtype_id::hid_t, membername::Cstring)::Cint string("Error getting index of compound datatype member \"", membername, "\"")
# @bind h5t_get_member_name(dtype_id::hid_t, index::Cuint)::Cstring string("Error getting name of compound datatype member #", index) # See below
@bind h5t_get_member_offset(dtype_id::hid_t, index::Cuint)::Csize_t "Error getting offset of compound datatype #$(index)"
@bind h5t_get_member_type(dtype_id::hid_t, index::Cuint)::hid_t string("Error getting type of compound datatype member #", index)
# @bind h5t_get_member_value
@bind h5t_get_native_type(dtype_id::hid_t, direction::Cint)::hid_t "Error getting native type"
@bind h5t_get_nmembers(dtype_id::hid_t)::Cint "Error getting the number of members"
# @bind h5t_get_norm
@bind h5t_get_offset(dtype_id::hid_t)::Cint "Error getting offset"
@bind h5t_get_order(dtype_id::hid_t)::Cint "Error getting order"
# @bind h5t_get_pad(dtype_id::hid_t, lsb::Ptr{H5T_pad_t}, msb::Ptr{H5T_pad_t})::herr_t "Error getting pad"
@bind h5t_get_precision(dtype_id::hid_t)::Csize_t "Error getting precision"
@bind h5t_get_sign(dtype_id::hid_t)::Cint "Error getting sign"
@bind h5t_get_size(dtype_id::hid_t)::Csize_t "Error getting type size"
@bind h5t_get_strpad(dtype_id::hid_t)::Cint "Error getting string padding"
@bind h5t_get_super(dtype_id::hid_t)::hid_t "Error getting super type"
# @bind h5t_get_tag(type_id::hid_t)::Cstring "Error getting datatype opaque tag" # See below
@bind h5t_insert(dtype_id::hid_t, fieldname::Cstring, offset::Csize_t, field_id::hid_t)::herr_t string("Error adding field ", fieldname, " to compound datatype")
@bind h5t_is_variable_str(type_id::hid_t)::htri_t "Error determining whether string is of variable length"
@bind h5t_lock(type_id::hid_t)::herr_t "Error locking type"
@bind h5t_open2(loc_id::hid_t, name::Cstring, tapl_id::hid_t)::hid_t string("Error opening type ", h5i_get_name(loc_id), "/", name)
# @bind h5t_pack
# @bind h5t_reclaim
# @bind h5t_refresh
# @bind h5t_register
@bind h5t_set_cset(dtype_id::hid_t, cset::Cint)::herr_t "Error setting character set in datatype"
@bind h5t_set_ebias(dtype_id::hid_t, ebias::Csize_t)::herr_t "Error setting datatype floating point exponent bias"
@bind h5t_set_fields(dtype_id::hid_t, spos::Csize_t, epos::Csize_t, esize::Csize_t, mpos::Csize_t, msize::Csize_t)::herr_t "Error setting datatype floating point bit positions"
# @bind h5t_set_inpad(dtype_id::hid_t, inpad::H5T_pad_t)::herr_t "Error setting inpad"
# @bind h5t_set_norm(dtype_id::hid_t, norm::H5T_norm_t)::herr_t "Error setting mantissa"
@bind h5t_set_offset(dtype_id::hid_t, offset::Csize_t)::herr_t "Error setting offset"
@bind h5t_set_order(dtype_id::hid_t, order::Cint)::herr_t "Error setting order"
@bind h5t_set_precision(dtype_id::hid_t, sz::Csize_t)::herr_t "Error setting precision of datatype"
@bind h5t_set_size(dtype_id::hid_t, sz::Csize_t)::herr_t "Error setting size of datatype"
@bind h5t_set_strpad(dtype_id::hid_t, sz::Cint)::herr_t "Error setting size of datatype"
@bind h5t_set_tag(dtype_id::hid_t, tag::Cstring)::herr_t "Error setting opaque tag"
# @bind h5t_unregister
@bind h5t_vlen_create(base_type_id::hid_t)::hid_t "Error creating vlen type"
# The following are not automatically wrapped since they have requirements about freeing
# the memory that is returned from the calls. They are implemented via api_helpers.jl
#@bind h5t_get_member_name(dtype_id::hid_t, index::Cuint)::Cstring string("Error getting name of compound datatype member #", index)
#@bind h5t_get_tag(type_id::hid_t)::Cstring "Error getting datatype opaque tag"

###
### Optimized Functions Interface
###

@bind h5do_append(dset_id::hid_t, dxpl_id::hid_t, index::Cuint, num_elem::hsize_t, memtype::hid_t, buffer::Ptr{Cvoid})::herr_t "error appending"
# h5do_write_chunk is deprecated as of hdflib 1.10.3
@bind h5do_write_chunk(dset_id::hid_t, dxpl_id::hid_t, filter_mask::UInt32, offset::Ptr{hsize_t}, bufsize::Csize_t, buf::Ptr{Cvoid})::herr_t "Error writing chunk"

###
### High Level Dimension Scale Interface
###

@bind h5ds_attach_scale(did::hid_t, dsid::hid_t, idx::Cuint)::herr_t "Unable to attach scale"
@bind h5ds_detach_scale(did::hid_t, dsid::hid_t, idx::Cuint)::herr_t "Unable to detach scale"
@bind h5ds_get_label(did::hid_t, idx::Cuint, label::Ptr{UInt8}, size::hsize_t)::herr_t "Unable to get label"
@bind h5ds_get_num_scales(did::hid_t, idx::Cuint)::Cint "Error getting number of scales"
@bind h5ds_get_scale_name(did::hid_t, name::Ptr{UInt8}, size::Csize_t)::Cssize_t "Unable to get scale name"
@bind h5ds_is_attached(did::hid_t, dsid::hid_t, idx::Cuint)::htri_t "Unable to check if dimension is attached"
@bind h5ds_is_scale(did::hid_t)::htri_t "Unable to check if dataset is scale"
@bind h5ds_set_label(did::hid_t, idx::Cuint, label::Ref{UInt8})::herr_t "Unable to set label"
@bind h5ds_set_scale(dsid::hid_t, dimname::Cstring)::herr_t "Unable to set scale"


###
### HDF5 Lite Interface
###

@bind h5lt_dtype_to_text(datatype::hid_t, str::Ptr{UInt8}, lang_type::Cint, len::Ref{Csize_t})::herr_t "Error getting datatype text representation"

###
### Table Interface
###
@bind h5tb_append_records(loc_id::hid_t, dset_name::Cstring, nrecords::hsize_t, type_size::Csize_t, field_offset::Ptr{Csize_t}, field_sizes::Ptr{Csize_t}, data::Ptr{Cvoid})::herr_t "Error adding record to table"
@bind h5tb_get_field_info(loc_id::hid_t, table_name::Cstring, field_names::Ptr{Ptr{UInt8}}, field_sizes::Ptr{Csize_t}, field_offsets::Ptr{Csize_t}, type_size::Ptr{Csize_t})::herr_t "Error getting field information"
@bind h5tb_get_table_info(loc_id::hid_t, table_name::Cstring, nfields::Ptr{hsize_t}, nrecords::Ptr{hsize_t})::herr_t "Error getting table information"
# NOTE: The HDF5 docs incorrectly specify type_size::hsize_t where as it should be type_size::Csize_t
@bind h5tb_make_table(table_title::Cstring, loc_id::hid_t, dset_name::Cstring, nfields::hsize_t, nrecords::hsize_t, type_size::Csize_t, field_names::Ptr{Cstring}, field_offset::Ptr{Csize_t}, field_types::Ptr{hid_t}, chunk_size::hsize_t, fill_data::Ptr{Cvoid}, compress::Cint, data::Ptr{Cvoid})::herr_t "Error creating and writing dataset to table"
@bind h5tb_read_records(loc_id::hid_t, table_name::Cstring, start::hsize_t, nrecords::hsize_t, type_size::Csize_t, field_offsets::Ptr{Csize_t}, dst_sizes::Ptr{Csize_t}, data::Ptr{Cvoid})::herr_t "Error reading record from table"
@bind h5tb_read_table(loc_id::hid_t, table_name::Cstring, dst_size::Csize_t, dst_offset::Ptr{Csize_t}, dst_sizes::Ptr{Csize_t}, dst_buf::Ptr{Cvoid})::herr_t "Error reading table"
@bind h5tb_write_records(loc_id::hid_t, table_name::Cstring, start::hsize_t, nrecords::hsize_t, type_size::Csize_t, field_offsets::Ptr{Csize_t}, field_sizes::Ptr{Csize_t}, data::Ptr{Cvoid})::herr_t "Error writing record to table"

###
### Filter Interface
###

@bind h5z_register(filter_class::Ref{H5Z_class_t})::herr_t "Unable to register new filter"
@bind h5z_unregister(id::H5Z_filter_t)::herr_t "Unable to unregister filter"
@bind h5z_filter_avail(id::H5Z_filter_t)::htri_t "Unable to get check filter availability"
@bind h5z_get_filter_info(filter::H5Z_filter_t, filter_config_flags::Ptr{Cuint})::herr_t "Error getting filter information"

###
### File driver interface
### FD consts: these are defined in hdf5 as macros

@bind h5fd_core_init()::hid_t "Error initializing file driver"
@bind h5fd_family_init()::hid_t "Error initializing file driver"
@bind h5fd_log_init()::hid_t "Error initializing file driver"
@bind h5fd_mpio_init()::hid_t "Error initializing file driver"
@bind h5fd_multi_init()::hid_t "Error initializing file driver"
@bind h5fd_sec2_init()::hid_t "Error initializing file driver"
@bind h5fd_stdio_init()::hid_t "Error initializing file driver"

# Work around JuliaLang/Pkg.jl#2500
if VERSION < v"1.8-"
    test_project = first(Base.load_path())
    preferences_file = "../LocalPreferences.toml"
    test_preferences_file = joinpath(dirname(test_project), "LocalPreferences.toml")
    if isfile(preferences_file) && !isfile(test_preferences_file)
        cp(preferences_file, test_preferences_file)
        @info "copied LocalPreferences.toml to $test_preferences_file"
    end
end

using HDF5
using Test
using Pkg
filter_path = joinpath(dirname(pathof(HDF5)), "..", "filters")
if !Base.BinaryPlatforms.CPUID.test_cpu_feature(Base.BinaryPlatforms.CPUID.JL_X86_avx2)
    Pkg.add(PackageSpec(; name="Blosc_jll", version=v"1.21.2+0"))
end
Pkg.develop([
    PackageSpec(; path=joinpath(filter_path, "H5Zblosc")),
    PackageSpec(; path=joinpath(filter_path, "H5Zbzip2")),
    PackageSpec(; path=joinpath(filter_path, "H5Zlz4")),
    PackageSpec(; path=joinpath(filter_path, "H5Zzstd")),
])
@static if VERSION >= v"1.6"
    Pkg.develop(PackageSpec(; path=joinpath(filter_path, "H5Zbitshuffle")))
end

@info "libhdf5 v$(HDF5.API.h5_get_libversion())"

# To debug HDF5.jl tests, uncomment the next line
# ENV["JULIA_DEBUG"] = "Main"

@testset "HDF5.jl" begin
    @debug "plain"
    include("plain.jl")
    @debug "create_dataset"
    include("create_dataset.jl")
    @debug "strings"
    include("strings.jl")
    @debug "api"
    include("api.jl")
    @debug "compound"
    include("compound.jl")
    @debug "custom"
    include("custom.jl")
    @debug "reference"
    include("reference.jl")
    @debug "dataspace"
    include("dataspace.jl")
    @debug "datatype"
    include("datatype.jl")
    @debug "hyperslab"
    include("hyperslab.jl")
    @debug "attributes"
    include("attributes.jl")
    @debug "readremote"
    include("readremote.jl")
    @debug "extend_test"
    include("extend_test.jl")
    @debug "gc"
    include("gc.jl")
    @debug "external"
    include("external.jl")
    @debug "swmr"
    include("swmr.jl")
    @debug "mmap"
    include("mmap.jl")
    @debug "properties"
    include("properties.jl")
    @debug "table"
    include("table.jl")
    @debug "filter"
    include("filter.jl")
    @debug "chunkstorage"
    include("chunkstorage.jl")
    @debug "fileio"
    include("fileio.jl")
    @debug "nonallocating"
    include("nonallocating.jl")
    @debug "filter test utils"
    include("filters/FilterTestUtils.jl")
    @debug "objects"
    include("objects.jl")
    # `h5d_get_space` seems to be broken for virtual datasets for libhdf5 1.10,
    # see https://github.com/JuliaIO/HDF5.jl/pull/1061#issuecomment-1571009149
    if HDF5.API.h5_get_libversion() >= v"1.12"
        @debug "virtual datasets"
        include("virtual_dataset.jl")
    end

    # basic MPI tests, for actual parallel tests we need to run in MPI mode
    include("mpio.jl")

    if HDF5.has_ros3()
        include("ros3.jl")
    end

    # Clean up after all resources
    HDF5.API.h5_close()
end

using HDF5
using Test

@testset "properties" begin
    fn = tempname()
    h5open(
        fn,
        "w";
        userblock=1024,
        alignment=(0, sizeof(Int)),
        libver_bounds=(:earliest, :latest),
        meta_block_size=1024,
        strategy=:fsm_aggr,
        persist=1,
        threshold=2,
        file_space_page_size=0x800
    ) do hfile
        # generic
        g = create_group(hfile, "group")
        if HDF5.API.h5_get_libversion() >= v"1.10.5"
            kwargs = (:no_attrs_hint => true,)
        else
            kwargs = ()
        end
        d = create_dataset(
            g,
            "dataset",
            datatype(Int),
            dataspace((500, 50));
            alloc_time=HDF5.API.H5D_ALLOC_TIME_EARLY,
            chunk=(5, 10),
            fill_value=1,
            fill_time=:never,
            obj_track_times=false,
            chunk_cache=(522, 0x200000, 0.80),
            efile_prefix=:origin,
            virtual_prefix="virtual",
            virtual_printf_gap=2,
            virtual_view=:last_available,
            kwargs...
        )
        attributes(d)["metadata"] = "test"

        flush(hfile)

        fcpl = HDF5.get_create_properties(hfile)
        fapl = HDF5.get_access_properties(hfile)
        gcpl = HDF5.get_create_properties(hfile["group"])
        dcpl = HDF5.get_create_properties(d)
        dapl = HDF5.get_access_properties(d)
        acpl = HDF5.get_create_properties(attributes(d)["metadata"])

        # Retrievability of properties
        @test isvalid(fcpl)
        @test isvalid(fapl)
        @test isvalid(gcpl)
        @test isvalid(dcpl)
        @test isvalid(dapl)
        @test isvalid(acpl)

        # Retrieving property values:
        @test fcpl.userblock == 1024
        @test fcpl.obj_track_times
        @test fcpl.file_space_page_size == 0x800
        @test fcpl.strategy == :fsm_aggr
        @test fcpl.persist == 1
        @test fcpl.threshold == 2

        @test fapl.alignment == (0, sizeof(Int))
        @test fapl.driver == Drivers.POSIX()
        @test_throws HDF5.API.H5Error fapl.driver_info
        @test fapl.fclose_degree == :strong
        @test fapl.libver_bounds ==
            (:earliest, HDF5.libver_bound_from_enum(HDF5.API.H5F_LIBVER_LATEST))
        @test fapl.meta_block_size == 1024

        @test gcpl.local_heap_size_hint == 0
        @test gcpl.obj_track_times

        @test HDF5.UTF8_LINK_PROPERTIES.char_encoding == :utf8
        @test HDF5.UTF8_LINK_PROPERTIES.create_intermediate_group

        @test dcpl.alloc_time == :early
        @test dcpl.chunk == (5, 10)
        @test dcpl.layout == :chunked
        @test !dcpl.obj_track_times
        @test dcpl.fill_time == :never
        @test dcpl.fill_value == 1.0
        if HDF5.API.h5_get_libversion() >= v"1.10.5"
            @test dcpl.no_attrs_hint == true
        end

        @test dapl.chunk_cache.nslots == 522
        @test dapl.chunk_cache.nbytes == 0x200000
        @test dapl.chunk_cache.w0 == 0.8
        @test dapl.efile_prefix == raw"$ORIGIN"
        @test dapl.virtual_prefix == "virtual"
        # We probably need to actually use a virtual dataset
        @test_broken dapl.virtual_printf_gap == 2
        if HDF5.API.h5_get_libversion() >= v"1.14.0"
            @test dapl.virtual_view == :last_available
        else
            @test_broken dapl.virtual_view == :last_available
        end

        @test acpl.char_encoding == :utf8

        # Test auto-initialization of property lists on get
        dcpl2 = HDF5.DatasetCreateProperties() # uninitialized
        @test dcpl2.id < 1 # 0 or -1
        @test !isvalid(dcpl2)
        @test dcpl2.alloc_time == :late
        @test isvalid(dcpl2)

        # Test H5Pcopy
        dapl2 = copy(dapl)
        @test dapl2.id != dapl.id
        @test dapl2.virtual_prefix == dapl.virtual_prefix
        dapl2.virtual_prefix = "somewhere_else"
        @test dapl2.virtual_prefix != dapl.virtual_prefix

        nothing
    end

    file_image = read(fn)

    rm(fn; force=true)

    fapl = HDF5.FileAccessProperties()
    fapl.driver = HDF5.Drivers.Core(; backing_store=false)
    fapl.file_image = copy(file_image)
    @test fapl.file_image == file_image
    file_image2 = h5open(fn, "r"; fapl) do f
        @test haskey(f, "group")
        convert(Vector{UInt8}, f)
    end
    # file_image2 does not include user block
    @test file_image2 == @view(file_image[1025:end])

    rm(fn; force=true)
end

using HDF5
using Test

@testset "non-allocating methods" begin
    fn = tempname()

    data = rand(UInt16, 16, 16)

    h5open(fn, "w") do h5f
        h5f["data"] = data
    end

    h5open(fn, "r") do h5f
        buffer = similar(h5f["data"])
        copyto!(buffer, h5f["data"])
        @test isequal(buffer, data)

        # Consider making this a view later
        v = h5f["data"][1:4, 1:4]

        buffer = similar(v)
        @test size(buffer) == (4, 4)
        copyto!(buffer, v)
        @test isequal(buffer, @view(data[1:4, 1:4]))

        @test size(similar(h5f["data"], Int16)) == size(h5f["data"])
        @test size(similar(h5f["data"], 5, 6)) == (5, 6)
        @test size(similar(h5f["data"], Int16, 8, 7)) == (8, 7)
        @test size(similar(h5f["data"], Int16, 8, 7; normalize=false)) == (8, 7)
        @test_broken size(similar(h5f["data"], Int8, 8, 7)) == (8, 7)

        @test size(similar(h5f["data"], (5, 6))) == (5, 6)
        @test size(similar(h5f["data"], Int16, (8, 7))) == (8, 7)
        @test size(similar(h5f["data"], Int16, (8, 7); normalize=false)) == (8, 7)
        @test size(similar(h5f["data"], Int16, 0x8, 0x7; normalize=false)) == (8, 7)
    end

    rm(fn)
end

using HDF5
using Test
using LinearAlgebra: norm

@testset "readremote" begin

    # check that we can read the official HDF5 example files

    # download and save test file via:
    # urlbase = "https://support.hdfgroup.org/ftp/HDF5/examples/files/exbyapi/"
    test_files = joinpath(@__DIR__, "test_files")
    # if !isdir(test_files)
    #     mkdir(test_files)
    # end
    # function joinpath(test_files, name)
    #     file = joinpath(test_files, name)
    #     if !isfile(file)
    #         file = download(urlbase*name, file)
    #     end
    #     file
    # end

    #! format: off
    fcmp =
        [
            0 1       2   3       4       5       6
            2 1.66667 2.4 3.28571 4.22222 5.18182 6.15385
            4 2.33333 2.8 3.57143 4.44444 5.36364 6.30769
            6 3       3.2 3.85714 4.66667 5.54545 6.46154
        ]'
    icmp = [
        0 -1 -2 -3 -4 -5 -6
        0  0  0  0  0  0  0
        0  1  2  3  4  5  6
        0  2  4  6  8 10 12
    ]'
    SOLID, LIQUID, GAS, PLASMA = 0, 1, 2, 3
    ecmp =
        [
            SOLID SOLID  SOLID SOLID  SOLID SOLID  SOLID
            SOLID LIQUID GAS   PLASMA SOLID LIQUID GAS
            SOLID GAS    SOLID GAS    SOLID GAS    SOLID
            SOLID PLASMA GAS   LIQUID SOLID PLASMA GAS
        ]'
    scmp = ["Parting", "is such", "sweet", "sorrow."]
    vicmp = Array{Int32}[[3, 2, 1], [1, 1, 2, 3, 5, 8, 13, 21, 34, 55, 89, 144]]
    opq = Array{UInt8}[
        [0x4f, 0x50, 0x41, 0x51, 0x55, 0x45, 0x30],
        [0x4f, 0x50, 0x41, 0x51, 0x55, 0x45, 0x31],
        [0x4f, 0x50, 0x41, 0x51, 0x55, 0x45, 0x32],
        [0x4f, 0x50, 0x41, 0x51, 0x55, 0x45, 0x33]
    ]
    # For H5T_ARRAY
    AA = Array{Int,2}[
        [0   0   0;
         0  -1  -2;
         0  -2  -4;
         0  -3  -6;
         0  -4  -8],
        [0   1   2;
         1   1   1;
         2   1   0;
         3   1  -1;
         4   1  -2],
        [0   2   4;
         2   3   4;
         4   4   4;
         6   5   4;
         8   6   4],
        [0   3   6;
         3   5   7;
         6   7   8;
         9   9   9;
         12  11  10]]
    #! format: on

    file = joinpath(test_files, "h5ex_t_floatatt.h5")
    fid = h5open(file, "r")
    dset = fid["DS1"]
    a = read_attribute(dset, "A1")
    @test norm(a - fcmp) < 1.5e-5
    close(fid)

    file = joinpath(test_files, "h5ex_t_float.h5")
    fid = h5open(file, "r")
    d = read(fid, "DS1")
    @test norm(d - fcmp) < 1.5e-5
    close(fid)

    file = joinpath(test_files, "h5ex_t_intatt.h5")
    fid = h5open(file, "r")
    dset = fid["DS1"]
    a = read_attribute(dset, "A1")
    @test a == icmp
    close(fid)

    file = joinpath(test_files, "h5ex_t_int.h5")
    fid = h5open(file, "r")
    d = read(fid, "DS1")
    @test d == icmp
    close(fid)

    if HDF5.API.h5_get_libversion() >= v"1.8.11"
        file = joinpath(test_files, "h5ex_t_enumatt.h5")
        fid = h5open(file, "r")
        dset = fid["DS1"]
        a = read_attribute(dset, "A1")
        @test a == ecmp
        close(fid)

        file = joinpath(test_files, "h5ex_t_enum.h5")
        fid = h5open(file, "r")
        d = read(fid, "DS1")
        @test d == ecmp
        close(fid)
    end

    file = joinpath(test_files, "h5ex_t_objrefatt.h5")
    fid = h5open(file, "r")
    dset = fid["DS1"]
    a = read_attribute(dset, "A1")
    g = fid[a[1]]
    @test isa(g, HDF5.Group)
    ds2 = fid[a[2]]
    ds2v = read(ds2)
    @test isa(ds2v, HDF5.EmptyArray{Int32})
    @test isempty(ds2v)
    close(fid)

    file = joinpath(test_files, "h5ex_t_objref.h5")
    fid = h5open(file, "r")
    d = read(fid, "DS1")
    g = fid[d[1]]
    @test isa(g, HDF5.Group)
    ds2 = fid[d[2]]
    ds2v = read(ds2)
    @test isa(ds2v, HDF5.EmptyArray{Int32})
    @test isempty(ds2v)
    close(fid)

    file = joinpath(test_files, "h5ex_t_stringatt.h5")
    fid = h5open(file, "r")
    dset = fid["DS1"]
    a = read_attribute(dset, "A1")
    @test a == scmp
    close(fid)

    file = joinpath(test_files, "h5ex_t_string.h5")
    fid = h5open(file, "r")
    d = read(fid, "DS1")
    @test d == scmp
    close(fid)

    file = joinpath(test_files, "h5ex_t_vlenatt.h5")
    fid = h5open(file, "r")
    dset = fid["DS1"]
    a = read_attribute(dset, "A1")
    @test a == vicmp
    close(fid)

    file = joinpath(test_files, "h5ex_t_vlen.h5")
    fid = h5open(file, "r")
    d = read(fid, "DS1")
    @test d == vicmp
    close(fid)

    file = joinpath(test_files, "h5ex_t_vlstringatt.h5")
    fid = h5open(file, "r")
    dset = fid["DS1"]
    a = read_attribute(dset, "A1")
    @test a == scmp
    close(fid)

    file = joinpath(test_files, "h5ex_t_vlstring.h5")
    fid = h5open(file, "r")
    d = read(fid, "DS1")
    @test d == scmp
    close(fid)

    file = joinpath(test_files, "h5ex_t_opaqueatt.h5")
    fid = h5open(file, "r")
    dset = fid["DS1"]
    a = read_attribute(dset, "A1")
    @test a.tag == "Character array"
    @test a.data == opq
    close(fid)

    file = joinpath(test_files, "h5ex_t_opaque.h5")
    fid = h5open(file, "r")
    d = read(fid, "DS1")
    @test d.tag == "Character array"
    @test d.data == opq
    close(fid)

    file = joinpath(test_files, "h5ex_t_array.h5")
    fid = h5open(file, "r")
    A = read(fid, "DS1")
    @test A == AA
    close(fid)
end # testset readremote

"""
    isavailable(filter_or_id)

Given a subtype of `Filters.Filter` or the filter ID number as an integer,
return `true` if the filter is available and `false` otherwise.
"""
isavailable(filter_or_id) = API.h5z_filter_avail(filter_or_id)

"""
    isencoderenabled(filter_or_id)

Given a subtype of `Filters.Filter` or the filter ID number as an integer,
return `true` if the filter can encode or compress data.
"""
function isencoderenabled(filter_or_id)
    info = API.h5z_get_filter_info(filter_or_id)
    return info & API.H5Z_FILTER_CONFIG_ENCODE_ENABLED != 0
end

"""
    isdecoderenabled(filter_or_id)

Given a subtype of `Filters.Filter` or the filter ID number as an integer,
return `true` if the filter can decode or decompress data.
"""
function isdecoderenabled(filter_or_id)
    info = API.h5z_get_filter_info(filter_or_id)
    return info & API.H5Z_FILTER_CONFIG_DECODE_ENABLED != 0
end

"""
    HDF5.Filters.Registered

Module containing convenience methods to create `ExternalFilter` instances
of [HDF5 registered filters](https://portal.hdfgroup.org/display/support/Registered+Filter+Plugins).

This module does not implement any filter or guarantee filter availability.
Rather the functions within this module create `ExternalFilter` instances for convenience.
These instances can be used to determine if a filter is available. They can also
be incorporated as part of a filter pipeline.

Examine `REGISTERED_FILTERS`, a `Dict{H5Z_filter_t, Function}`, for a list of
filter functions contained within this module, which are exported.

```jldoctest
julia> println.(values(HDF5.Filters.Registered.REGISTERED_FILTERS));
FCIDECOMPFilter
LZOFilter
BitGroomFilter
SZ3Filter
Delta_RiceFilter
fpzipFilter
LPC_RiceFilter
LZFFilter
FLACFilter
VBZFilter
FAPECFilter
zfpFilter
CBFFilter
JPEG_XRFilter
LZ4Filter
BLOSC2Filter
ZstandardFilter
SZFilter
Granular_BitRoundFilter
JPEGFilter
SnappyFilter
B³DFilter
APAXFilter
BLOSCFilter
SPDPFilter
bitshuffleFilter
MAFISCFilter
BZIP2Filter
CCSDS_123Filter
JPEG_LSFilter
```

"""
module Registered

using HDF5.Filters:
    Filters, Filter, ExternalFilter, EXTERNAL_FILTER_JULIA_PACKAGES, isavailable
using HDF5.API: API, H5Z_filter_t, H5Z_FLAG_MANDATORY

const _REGISTERED_FILTERIDS_DICT = Dict{H5Z_filter_t,Symbol}(
    305 => :LZO,
    307 => :BZIP2,
    32000 => :LZF,
    32001 => :BLOSC,
    32002 => :MAFISC,
    32003 => :Snappy,
    32004 => :LZ4,
    32005 => :APAX,
    32006 => :CBF,
    32007 => :JPEG_XR,
    32008 => :bitshuffle,
    32009 => :SPDP,
    32010 => :LPC_Rice,
    32011 => :CCSDS_123,
    32012 => :JPEG_LS,
    32013 => :zfp,
    32014 => :fpzip,
    32015 => :Zstandard,
    32016 => :B³D,
    32017 => :SZ,
    32018 => :FCIDECOMP,
    32019 => :JPEG,
    32020 => :VBZ,
    32021 => :FAPEC,
    32022 => :BitGroom,
    32023 => :Granular_BitRound,
    32024 => :SZ3,
    32025 => :Delta_Rice,
    32026 => :BLOSC2,
    32027 => :FLAC
)

const REGISTERED_FILTERS = Dict{H5Z_filter_t,Function}()

for (filter_id, filter_name) in _REGISTERED_FILTERIDS_DICT
    fn_string = String(filter_name) * "Filter"
    fn = Symbol(fn_string)
    filter_name_string = replace(String(filter_name), "_" => raw"\_")
    @eval begin
        @doc """
            $($fn_string)(flags=API.H5Z_FLAG_MANDATORY, data::AbstractVector{<: Integer}=Cuint[], config::Cuint=0)
            $($fn_string)(flags=API.H5Z_FLAG_MANDATORY, data::Integer...)

        Create an [`ExternalFilter`](@ref) for $($filter_name_string) with filter id $($filter_id).
        $(haskey(EXTERNAL_FILTER_JULIA_PACKAGES, $filter_id) ?
            "Users are instead encouraged to use the Julia package $(EXTERNAL_FILTER_JULIA_PACKAGES[$filter_id])." :
            "Users should consider defining a subtype of [`Filter`](@ref) to specify the data."
        )

        # Fields / Arguments
        * `flags` -     (optional) bit vector describing general properties of the filter. Defaults to `API.H5Z_FLAG_MANDATORY`
        * `data` -      (optional) auxillary data for the filter. See [`cd_values`](@ref API.h5p_set_filter). Defaults to `Cuint[]`
        * `config` -    (optional) bit vector representing information about the filter regarding whether it is able to encode data, decode data, neither, or both. Defaults to `0`.

        See [`ExternalFilter`](@ref) for valid argument values.
        """ $fn
        export $fn
        $fn(flags, data::AbstractVector{<:Integer}) =
            ExternalFilter($filter_id, flags, Cuint.(data), $filter_name_string, 0)
        $fn(flags, data::Integer...) =
            ExternalFilter($filter_id, flags, Cuint[data...], $filter_name_string, 0)
        $fn(data::AbstractVector{<:Integer}=Cuint[]) = ExternalFilter(
            $filter_id, H5Z_FLAG_MANDATORY, Cuint.(data), $filter_name_string, 0
        )
        $fn(flags, data, config) =
            ExternalFilter($filter_id, flags, data, $filter_name_string, config)
        REGISTERED_FILTERS[$filter_id] = $fn
    end
end

"""
    available_registered_filters()::Dict{H5Z_filter_t, Function}

Return a `Dict{H5Z_filter_t, Function}` listing the available filter ids and
their corresponding convenience function.
"""
function available_registered_filters()
    filter(p -> isavailable(first(p)), REGISTERED_FILTERS)
end

end

using Documenter
using HDF5
using H5Zblosc
using H5Zbzip2
using H5Zlz4
using H5Zzstd
using MPI  # needed to generate docs for parallel HDF5 API

DocMeta.setdocmeta!(HDF5, :DocTestSetup, :(using HDF5); recursive=true)

makedocs(;
    sitename="HDF5.jl",
    modules=[HDF5, H5Zblosc, H5Zbzip2, H5Zlz4, H5Zzstd],
    authors="Mustafa Mohamad <mus-m@outlook.com> and contributors",
    format=Documenter.HTML(;
        prettyurls=get(ENV, "CI", "false") == "true",
        canonical="https://JuliaIO.github.io/HDF5.jl",
        assets=String[],
        sidebar_sitename=false
    ),
    strict=true,
    pages=[
        "Home" => "index.md",
        "Interface" => [
            "interface/configuration.md",
            "interface/files.md",
            "interface/groups.md",
            "interface/dataspaces.md",
            "interface/dataset.md",
            "interface/attributes.md",
            "interface/properties.md",
            "interface/filters.md",
            "interface/objects.md",
        ],
        "mpi.md",
        "Low-level library bindings" => "api_bindings.md",
        "Additional Resources" => "resources.md",
    ]
)

deploydocs(; repo="github.com/JuliaIO/HDF5.jl.git", push_preview=true)

"""
    JuliaFormatterTool

Implements a script that runs a simple loop that runs `JuliaFormatter.format` on
every iteration after the user presses enter.
"""
module JuliaFormatterTool

export run_formatter_loop

using JuliaFormatter

# This tool lives in <repo>/contrib/format/, format <repo> by default
const default_target_dir = joinpath(dirname(dirname(@__DIR__)))

"""
    run_formatter_loop(target_dir = $default_target_dir)

This function runs a simple loop that runs `JuliaFormatter.format` on
every iteration, every time the user presses enter.
"""
function run_formatter_loop(target_dir::AbstractString=default_target_dir)
    printstyled("Welcome to Julia Formatter Tool!\n"; color=:cyan, bold=true)
    printstyled("--------------------------------\n"; color=:cyan, bold=true)
    let running::Bool = true
        while running
            println()
            printstyled(
                "Press enter to format the directory $target_dir or `q[enter]` to quit\n";
                color=:light_cyan
            )
            printstyled("format.jl> "; color=:green, bold=true)
            input = readline()
            running = input != "q" && input != "quit" && !startswith(input, "exit")
            if running
                println("Applying JuliaFormatter...")
                @info "Is the current directory formatted?" target_dir format(target_dir)
            end
        end
        println("Thank you for formatting HDF5.jl. Have a nice day!")
    end
    return nothing
end

end # module JuliaFormatterTool

using HDF5, Test

@testset "h5a_iterate" begin
    filename = tempname()
    f = h5open(filename, "w")

    write_attribute(f, "a", 1)
    write_attribute(f, "b", 2)

    # iterate over attributes
    names = String[]
    @test HDF5.API.h5a_iterate(
        f, HDF5.API.H5_INDEX_NAME, HDF5.API.H5_ITER_INC
    ) do loc, name, info
        push!(names, unsafe_string(name))
        return false
    end == 2
    @test names == ["a", "b"]

    # iterate over attributes in reverse
    names = String[]
    @test HDF5.API.h5a_iterate(
        f, HDF5.API.H5_INDEX_NAME, HDF5.API.H5_ITER_DEC
    ) do loc, name, info
        push!(names, unsafe_string(name))
        return false
    end == 2
    @test names == ["b", "a"]

    # only iterate once
    names = String[]
    @test HDF5.API.h5a_iterate(
        f, HDF5.API.H5_INDEX_NAME, HDF5.API.H5_ITER_INC
    ) do loc, name, info
        push!(names, unsafe_string(name))
        return true
    end == 1
    @test names == ["a"]

    # HDF5 error
    @test_throws HDF5.API.H5Error HDF5.API.h5a_iterate(
        f, HDF5.API.H5_INDEX_NAME, HDF5.API.H5_ITER_INC
    ) do loc, name, info
        return -1
    end

    # Julia error
    @test_throws AssertionError HDF5.API.h5a_iterate(
        f, HDF5.API.H5_INDEX_NAME, HDF5.API.H5_ITER_INC
    ) do loc, name, info
        @assert false
    end
end

@testset "h5l_iterate" begin
    filename = tempname()
    f = h5open(filename, "w")

    create_group(f, "a")
    create_group(f, "b")

    # iterate over groups
    names = String[]
    @test HDF5.API.h5l_iterate(
        f, HDF5.API.H5_INDEX_NAME, HDF5.API.H5_ITER_INC
    ) do loc, name, info
        push!(names, unsafe_string(name))
        return false
    end == 2
    @test names == ["a", "b"]

    # iterate over attributes in reverse
    names = String[]
    @test HDF5.API.h5l_iterate(
        f, HDF5.API.H5_INDEX_NAME, HDF5.API.H5_ITER_DEC
    ) do loc, name, info
        push!(names, unsafe_string(name))
        return false
    end == 2
    @test names == ["b", "a"]

    # only iterate once
    names = String[]
    @test HDF5.API.h5l_iterate(
        f, HDF5.API.H5_INDEX_NAME, HDF5.API.H5_ITER_INC
    ) do loc, name, info
        push!(names, unsafe_string(name))
        return true
    end == 1
    @test names == ["a"]

    # HDF5 error
    @test_throws HDF5.API.H5Error HDF5.API.h5l_iterate(
        f, HDF5.API.H5_INDEX_NAME, HDF5.API.H5_ITER_INC
    ) do loc, name, info
        return -1
    end

    # Julia error
    @test_throws AssertionError HDF5.API.h5l_iterate(
        f, HDF5.API.H5_INDEX_NAME, HDF5.API.H5_ITER_INC
    ) do loc, name, info
        @assert false
    end
end

@testset "h5dchunk_iter" begin
    @test convert(HDF5.API.H5_iter_t, 0) == HDF5.API.H5_ITER_CONT
    @test convert(HDF5.API.H5_iter_t, 1) == HDF5.API.H5_ITER_STOP
    @test convert(HDF5.API.H5_iter_t, -1) == HDF5.API.H5_ITER_ERROR
end

### Generic H5DataStore interface ###

# Common methods that could be applicable to any interface for reading/writing variables from a file, e.g. HDF5, JLD, or MAT files.
# Types inheriting from H5DataStore should have names, read, and write methods.
# Supertype of HDF5.File, HDF5.Group, JldFile, JldGroup, Matlabv5File, and MatlabHDF5File.
abstract type H5DataStore end

"""
    read(parent::H5DataStore)
    read(parent::H5DataStore, names...)

Read a list of variables, read(parent, "A", "B", "x", ...).
If no variables are specified, read every variable in the file.
"""
function Base.read(parent::H5DataStore, name::AbstractString...)
    tuple((read(parent, x) for x in name)...)
end

# Read every variable in the file
function Base.read(f::H5DataStore)
    vars = keys(f)
    vals = Vector{Any}(undef, length(vars))
    for i in 1:length(vars)
        vals[i] = read(f, vars[i])
    end
    Dict(zip(vars, vals))
end

### Base HDF5 structs ###

## HDF5 uses a plain integer to refer to each file, group, or
## dataset. These are wrapped into special types in order to allow
## method dispatch.

# Note re finalizers: we use them to ensure that objects passed back
# to the user will eventually be cleaned up properly. However, since
# finalizers don't run on a predictable schedule, we also call close
# directly on function exit. (This avoids certain problems, like those
# that occur when passing a freshly-created file to some other
# application).

# This defines an "unformatted" HDF5 data file. Formatted files are defined in separate modules.
mutable struct File <: H5DataStore
    id::API.hid_t
    filename::String

    function File(id, filename, toclose::Bool=true)
        f = new(id, filename)
        if toclose
            finalizer(API.try_close_finalizer, f)
        end
        f
    end
end
Base.cconvert(::Type{API.hid_t}, f::File) = f
Base.unsafe_convert(::Type{API.hid_t}, f::File) = f.id

mutable struct Group <: H5DataStore
    id::API.hid_t
    file::File         # the parent file

    function Group(id, file)
        g = new(id, file)
        finalizer(API.try_close_finalizer, g)
        g
    end
end
Base.cconvert(::Type{API.hid_t}, g::Group) = g
Base.unsafe_convert(::Type{API.hid_t}, g::Group) = g.id

"""
    HDF5.Dataset

A mutable wrapper for a HDF5 Dataset `HDF5.API.hid_t`.
"""
mutable struct Dataset
    id::API.hid_t
    file::File
    xfer::DatasetTransferProperties

    function Dataset(id, file, xfer=DatasetTransferProperties())
        dset = new(id, file, xfer)
        finalizer(API.try_close_finalizer, dset)
        dset
    end
end
Base.cconvert(::Type{API.hid_t}, dset::Dataset) = dset
Base.unsafe_convert(::Type{API.hid_t}, dset::Dataset) = dset.id

"""
    HDF5.Datatype(id, toclose = true)

Wrapper for a HDF5 datatype id. If `toclose` is true, the finalizer will close
the datatype.
"""
mutable struct Datatype
    id::API.hid_t
    toclose::Bool
    file::File

    function Datatype(id, toclose::Bool=true)
        nt = new(id, toclose)
        if toclose
            finalizer(API.try_close_finalizer, nt)
        end
        nt
    end
    function Datatype(id, file::File, toclose::Bool=true)
        nt = new(id, toclose, file)
        if toclose
            finalizer(API.try_close_finalizer, nt)
        end
        nt
    end
end
Base.cconvert(::Type{API.hid_t}, dtype::Datatype) = dtype
Base.unsafe_convert(::Type{API.hid_t}, dtype::Datatype) = dtype.id
Base.hash(dtype::Datatype, h::UInt) = hash(dtype.id, hash(Datatype, h))
Base.:(==)(dt1::Datatype, dt2::Datatype) = API.h5t_equal(dt1, dt2)

mutable struct Dataspace
    id::API.hid_t

    function Dataspace(id)
        dspace = new(id)
        finalizer(API.try_close_finalizer, dspace)
        dspace
    end
end
Base.cconvert(::Type{API.hid_t}, dspace::Dataspace) = dspace
Base.unsafe_convert(::Type{API.hid_t}, dspace::Dataspace) = dspace.id

mutable struct Attribute
    id::API.hid_t
    file::File

    function Attribute(id, file)
        dset = new(id, file)
        finalizer(API.try_close_finalizer, dset)
        dset
    end
end
Base.cconvert(::Type{API.hid_t}, attr::Attribute) = attr
Base.unsafe_convert(::Type{API.hid_t}, attr::Attribute) = attr.id

# High-level reference handler
struct Reference
    r::API.hobj_ref_t
end
Base.cconvert(
    ::Type{Ptr{T}}, ref::Reference
) where {T<:Union{Reference,API.hobj_ref_t,Cvoid}} = Ref(ref)

const BitsType = Union{
    Bool,Int8,UInt8,Int16,UInt16,Int32,UInt32,Int64,UInt64,Float32,Float64
}
const ScalarType = Union{BitsType,Reference}

# Define an H5O Object type
const Object = Union{Group,Dataset,Datatype}

idx_type(obj::File) =
    if get_context_property(:file_create).track_order ||
        get_create_properties(obj).track_order
        API.H5_INDEX_CRT_ORDER
    else
        API.H5_INDEX_NAME
    end
idx_type(obj::Group) =
    if get_context_property(:group_create).track_order ||
        get_create_properties(obj).track_order
        API.H5_INDEX_CRT_ORDER
    else
        API.H5_INDEX_NAME
    end
idx_type(obj) = API.H5_INDEX_NAME

# TODO: implement alternative iteration order ?
order(obj) = API.H5_ITER_INC

Reference() = Reference(API.HOBJ_REF_T_NULL) # NULL reference to compare to
Base.:(==)(a::Reference, b::Reference) = a.r == b.r
Base.hash(x::Reference, h::UInt) = hash(x.r, h)

function Reference(parent::Union{File,Group,Dataset}, name::AbstractString)
    ref = Ref{API.hobj_ref_t}()
    API.h5r_create(ref, checkvalid(parent), name, API.H5R_OBJECT, -1)
    return Reference(ref[])
end

# Dereference
function _deref(parent, r::Reference)
    r == Reference() && error("Reference is null")
    obj_id = API.h5r_dereference(checkvalid(parent), API.H5P_DEFAULT, API.H5R_OBJECT, r)
    h5object(obj_id, parent)
end
Base.getindex(parent::Union{File,Group}, r::Reference) = _deref(parent, r)
Base.getindex(parent::Dataset, r::Reference) = _deref(parent, r) # defined separately to resolve ambiguity

using MPI
using HDF5
using Test

@testset "mpio" begin
    HDF5.FileAccessProperties() do fapl
        Drivers.set_driver!(fapl, Drivers.Core())
    end

    MPI.Init()

    comm = MPI.COMM_WORLD

    if !HDF5.has_parallel()
        @test_throws ErrorException(
            "HDF5.jl has no parallel support. Make sure that you're using MPI-enabled HDF5 libraries, and that MPI was loaded before HDF5. See HDF5.jl docs for details."
        ) HDF5.FileAccessProperties(driver=HDF5.Drivers.MPIO(comm))
    else
        nprocs = MPI.Comm_size(comm)
        myrank = MPI.Comm_rank(comm)

        # Check that serial drivers are still there after loading MPI (#928)
        @test Drivers.Core ∈ values(Drivers.DRIVERS)
        @test Drivers.POSIX ∈ values(Drivers.DRIVERS)

        let fileprop = HDF5.FileAccessProperties()
            fileprop.driver = HDF5.Drivers.MPIO(comm)
            driver = fileprop.driver
            h5comm = driver.comm
            h5info = driver.info

            # check that the two communicators point to the same group
            if isdefined(MPI, :Comm_compare)  # requires recent MPI.jl version
                @test MPI.Comm_compare(comm, h5comm) == MPI.CONGRUENT
            end
            HDF5.close(fileprop)
        end

        # open file in parallel and write dataset
        fn = MPI.bcast(tempname(), 0, comm)
        A = [myrank + i for i in 1:10]
        h5open(fn, "w", comm) do f
            @test isopen(f)
            g = create_group(f, "mygroup")
            dset = create_dataset(
                g,
                "B",
                datatype(Int64),
                dataspace(10, nprocs);
                chunk=(10, 1),
                dxpl_mpio=:collective
            )
            dset[:, myrank + 1] = A
        end

        MPI.Barrier(comm)
        h5open(fn, comm) do f  # default: opened in read mode, with default MPI.Info()
            @test isopen(f)
            @test keys(f) == ["mygroup"]

            B = read(f, "mygroup/B"; dxpl_mpio=:collective)
            @test !isempty(B)
            @test A == vec(B[:, myrank + 1])

            B = f["mygroup/B", dxpl_mpio=:collective]
            @test !isempty(B)
            @test A == vec(B[:, myrank + 1])
        end

        MPI.Barrier(comm)

        B = h5read(fn, "mygroup/B"; driver=HDF5.Drivers.MPIO(comm), dxpl_mpio=:collective)
        @test A == vec(B[:, myrank + 1])

        MPI.Barrier(comm)

        B = h5read(
            fn,
            "mygroup/B",
            (:, myrank + 1);
            driver=HDF5.Drivers.MPIO(comm),
            dxpl_mpio=:collective
        )
        @test A == vec(B)
    end

    MPI.Finalize()
end # testset mpio

using HDF5, OrderedCollections, FileIO, Test

@testset "fileio" begin
    fn = tempname() * ".h5"

    hfile = h5open(fn, "w")
    hfile["A"] = 1.0
    hfile["B"] = [1, 2, 3]
    create_group(hfile, "G")
    hfile["G/A"] = collect(-3:4)
    create_group(hfile, "G1/G2")
    hfile["G1/G2/A"] = "hello"
    close(hfile)

    # test loader
    data = Dict("A" => 1.0, "B" => [1, 2, 3], "G/A" => collect(-3:4), "G1/G2/A" => "hello")
    @test load(fn) == data
    @test load(fn, "A") == 1.0
    @test load(fn, "A", "B") == (1.0, [1, 2, 3])
    @test load(fn, "G/A") == collect(-3:4)

    rm(fn)

    # test saver
    save(fn, data)
    @test load(fn) == data
    @test load(fn, "A") == 1.0
    fr = h5open(fn, "r")
    read(fr, "A") == 1.0
    close(fr)

    rm(fn)
end

@testset "track order" begin
    let fn = tempname() * ".h5"
        h5open(fn, "w"; track_order=true) do io
            fcpl = HDF5.get_create_properties(io)
            @test fcpl.track_order
            io["b"] = 1
            io["a"] = 2
            g = create_group(io, "G"; track_order=true)
            gcpl = HDF5.get_create_properties(io["G"])
            @test gcpl.track_order
            write(g, "z", 3)
            write(g, "f", 4)
        end

        dat = load(fn; dict=OrderedDict())  # `track_order` is inferred from `OrderedDict`

        @test all(keys(dat) .== ["b", "a", "G/z", "G/f"])

        # issue #939
        h5open(fn, "r"; track_order=true) do io
            @test HDF5.get_context_property(:file_create).track_order
            @test all(keys(io) .== ["b", "a", "G"])
            @test HDF5.get_context_property(:group_create).track_order
            @test HDF5.get_create_properties(io["G"]).track_order  # inferred from file, created with `track_order=true`
            @test all(keys(io["G"]) .== ["z", "f"])
        end

        h5open(fn, "r"; track_order=false) do io
            @test !HDF5.get_context_property(:file_create).track_order
            @test all(keys(io) .== ["G", "a", "b"])
            @test !HDF5.get_context_property(:group_create).track_order
            @test HDF5.get_create_properties(io["G"]).track_order  # inferred from file
            @test all(keys(io["G"]) .== ["z", "f"])
        end

        h5open(fn, "r") do io
            @test !HDF5.get_create_properties(io).track_order
            @test all(keys(io) .== ["G", "a", "b"])
            @test HDF5.get_create_properties(io["G"]).track_order  # inferred from file
            @test all(keys(io["G"]) .== ["z", "f"])
        end
    end

    let fn = tempname() * ".h5"
        save(fn, OrderedDict("b" => 1, "a" => 2, "G/z" => 3, "G/f" => 4))

        dat = load(fn; dict=OrderedDict())

        @test all(keys(dat) .== ["b", "a", "G/z", "G/f"])
    end
end # @testset track_order

@static if HDF5.API.h5_get_libversion() >= v"1.10.5"
    @testset "h5f_get_dset_no_attrs_hint" begin
        fn = tempname()
        threshold = 300
        h5open(fn, "w"; libver_bounds=:latest, meta_block_size=threshold) do f
            HDF5.API.h5f_set_dset_no_attrs_hint(f, true)
            @test HDF5.API.h5f_get_dset_no_attrs_hint(f)
            f["test"] = 0x1
            # We expect that with the hint, the offset will actually be 300
            @test HDF5.API.h5d_get_offset(f["test"]) == threshold
        end
        @test filesize(fn) == threshold + 1
        h5open(fn, "w"; libver_bounds=:latest, meta_block_size=threshold) do f
            HDF5.API.h5f_set_dset_no_attrs_hint(f, false)
            @test !HDF5.API.h5f_get_dset_no_attrs_hint(f)
            f["test"] = 0x1
            # We expect that with the hint, the offset will be greater than 300
            @test HDF5.API.h5d_get_offset(f["test"]) > threshold
        end
        @test filesize(fn) > threshold + 1
    end
end # @static if HDF5.API.h5_get_libversion() >= v"1.10.5"

# This file is a companion to `src/api.jl` --- it defines the raw ccall wrappers, while
# here small normalizations are made to make the calls more Julian.
# For instance, many property getters return values through pointer output arguments,
# so the methods here handle making the appropriate `Ref`s and return them (as tuples).

const H5F_LIBVER_LATEST = if _libhdf5_build_ver >= v"1.15"
    H5F_LIBVER_V200
elseif _libhdf5_build_ver >= v"1.14"
    H5F_LIBVER_V114
elseif _libhdf5_build_ver >= v"1.12"
    H5F_LIBVER_V112
elseif _libhdf5_build_ver >= v"1.10"
    H5F_LIBVER_V110
else
    H5F_LIBVER_V108
end

###
### HDF5 General library functions
###

function h5_get_libversion()
    majnum, minnum, relnum = Ref{Cuint}(), Ref{Cuint}(), Ref{Cuint}()
    h5_get_libversion(majnum, minnum, relnum)
    VersionNumber(majnum[], minnum[], relnum[])
end

function h5_is_library_threadsafe()
    is_ts = Ref{Cuchar}(0)
    h5_is_library_threadsafe(is_ts)
    return is_ts[] > 0
end

###
### HDF5 File Interface
###
function h5f_get_dset_no_attrs_hint(file_id)::Bool
    minimize = Ref{hbool_t}(false)
    h5f_get_dset_no_attrs_hint(file_id, minimize)
    return minimize[]
end

"""
    h5f_get_file_image(file_id)

Return a `Vector{UInt8}` containing the file image. Does not include the user block.
"""
function h5f_get_file_image(file_id)
    buffer_length = h5f_get_file_image(file_id, C_NULL, 0)
    buffer = Vector{UInt8}(undef, buffer_length)
    h5f_get_file_image(file_id, buffer, buffer_length)
    return buffer
end

"""
    h5f_get_file_image(file_id, buffer::Vector{UInt8})

Store the file image in the provided buffer.
"""
function h5f_get_file_image(file_id, buffer::Vector{UInt8})
    h5f_get_file_image(fild_id, buffer, length(buffer))
end

###
### Attribute Interface
###

function h5a_get_name(attr_id)
    len = h5a_get_name(attr_id, 0, C_NULL)
    buf = StringVector(len)
    h5a_get_name(attr_id, len + 1, buf)
    return String(buf)
end

function h5a_get_name_by_idx(loc_id, obj_name, idx_type, order, idx, lapl_id)
    len = h5a_get_name_by_idx(loc_id, obj_name, idx_type, order, idx, C_NULL, 0, lapl_id)
    buf = StringVector(len)
    h5a_get_name_by_idx(loc_id, obj_name, idx_type, order, idx, buf, len + 1, lapl_id)
    return String(buf)
end

# libhdf5 supports proper closure environments, so we use that support rather than
# emulating it with the less desirable form of creating closure handles directly in
# `@cfunction` with `$f`.
# This helper translates between the two preferred forms for each respective language.
function h5a_iterate_helper(
    loc_id::hid_t, attr_name::Ptr{Cchar}, ainfo::Ptr{H5A_info_t}, @nospecialize(data::Any)
)::herr_t
    f, err_ref = data
    try
        return herr_t(f(loc_id, attr_name, ainfo))
    catch err
        err_ref[] = err
        return herr_t(-1)
    end
end

"""
    h5a_iterate(f, loc_id, idx_type, order, idx = 0) -> hsize_t

Executes [`h5a_iterate`](@ref h5a_iterate(::hid_t, ::Cint, ::Cint,
::Ptr{hsize_t}, ::Ptr{Cvoid}, ::Ptr{Cvoid})) with the user-provided callback
function `f`, returning the index where iteration ends.

The callback function must correspond to the signature
```
f(loc::HDF5.API.hid_t, name::Ptr{Cchar}, info::Ptr{HDF5.API.H5A_info_t}) -> Union{Bool, Integer}
```
where a negative return value halts iteration abnormally (triggering an error),
a `true` or a positive value halts iteration successfully, and `false` or zero
continues iteration.

# Examples
```julia-repl
julia> HDF5.API.h5a_iterate(obj, HDF5.API.H5_INDEX_NAME, HDF5.API.H5_ITER_INC) do loc, name, info
           println(unsafe_string(name))
           return false
       end
```
"""
function h5a_iterate(@nospecialize(f), obj_id, idx_type, order, idx=0)
    err_ref = Ref{Any}(nothing)
    idxref = Ref{hsize_t}(idx)
    fptr = @cfunction(h5a_iterate_helper, herr_t, (hid_t, Ptr{Cchar}, Ptr{H5A_info_t}, Any))
    try
        h5a_iterate(obj_id, idx_type, order, idxref, fptr, (f, err_ref))
    catch h5err
        jlerr = err_ref[]
        if !isnothing(jlerr)
            rethrow(jlerr)
        end
        rethrow(h5err)
    end
    return idxref[]
end

###
### Dataset Interface
###

"""
    h5d_vlen_get_buf_size(dataset_id, type_id, space_id)

Helper method to determines the number of bytes required to store the variable length data from the dataset. Returns a value of type `HDF5.API.hsize_t`.
"""
function h5d_vlen_get_buf_size(dataset_id, type_id, space_id)
    sz = Ref{hsize_t}()
    h5d_vlen_get_buf_size(dataset_id, type_id, space_id, sz)
    return sz[]
end

"""
    h5d_get_chunk_info(dataset_id, fspace_id, index)
    h5d_get_chunk_info(dataset_id, index; fspace_id = HDF5.API.H5S_ALL)

Helper method to retrieve chunk information.

Returns a `NamedTuple{(:offset, :filter_mask, :addr, :size), Tuple{HDF5.API.hsize_t, UInt32, HDF5.API.haddr_t, HDF5.API.hsize_t}}`.
"""
function h5d_get_chunk_info(dataset_id, fspace_id, index)
    offset = Vector{hsize_t}(undef, ndims(dataset_id))
    filter_mask = Ref{UInt32}()
    addr = Ref{haddr_t}()
    size = Ref{hsize_t}()
    h5d_get_chunk_info(dataset_id, fspace_id, index, offset, filter_mask, addr, size)
    return (offset=offset, filter_mask=filter_mask[], addr=addr[], size=size[])
end
h5d_get_chunk_info(dataset_id, index; fspace_id=H5S_ALL) =
    h5d_get_chunk_info(dataset_id, fspace_id, index)

"""
    h5d_get_chunk_info_by_coord(dataset_id, offset)

Helper method to read chunk information by coordinate. Returns a `NamedTuple{(:filter_mask, :addr, :size), Tuple{UInt32, HDF5.API.haddr_t, HDF5.API.hsize_t}}`.
"""
function h5d_get_chunk_info_by_coord(dataset_id, offset)
    filter_mask = Ref{UInt32}()
    addr = Ref{haddr_t}()
    size = Ref{hsize_t}()
    h5d_get_chunk_info_by_coord(dataset_id, offset, filter_mask, addr, size)
    return (filter_mask=filter_mask[], addr=addr[], size=size[])
end

"""
    h5d_get_chunk_storage_size(dataset_id, offset)

Helper method to retrieve the chunk storage size in bytes. Returns an integer of type `HDF5.API.hsize_t`.
"""
function h5d_get_chunk_storage_size(dataset_id, offset)
    chunk_nbytes = Ref{hsize_t}()
    h5d_get_chunk_storage_size(dataset_id, offset, chunk_nbytes)
    return chunk_nbytes[]
end

@static if v"1.10.5" ≤ _libhdf5_build_ver
    """
        h5d_get_num_chunks(dataset_id, fspace_id = H5S_ALL)

    Helper method to retrieve the number of chunks. Returns an integer of type `HDF5.API.hsize_t`.
    """
    function h5d_get_num_chunks(dataset_id, fspace_id=H5S_ALL)
        nchunks = Ref{hsize_t}()
        h5d_get_num_chunks(dataset_id, fspace_id, nchunks)
        return nchunks[]
    end
end

"""
    h5d_chunk_iter(f, dataset, [dxpl_id=H5P_DEFAULT])

Call `f(offset::Ptr{hsize_t}, filter_mask::Cuint, addr::haddr_t, size::hsize_t)` for each chunk.
`dataset` maybe a `HDF5.Dataset` or a dataset id.
`dxpl_id` is the the dataset transfer property list and is optional.

Available only for HDF5 1.10.x series for 1.10.9 and greater or for version HDF5 1.12.3 or greater.
"""
h5d_chunk_iter() = nothing

@static if v"1.12.3" ≤ _libhdf5_build_ver ||
    (_libhdf5_build_ver.minor == 10 && _libhdf5_build_ver.patch >= 10)
    # H5Dchunk_iter is first available in 1.10.10, 1.12.3, and 1.14.0 in the 1.10, 1.12, and 1.14 minor version series, respectively
    function h5d_chunk_iter_helper(
        offset::Ptr{hsize_t},
        filter_mask::Cuint,
        addr::haddr_t,
        size::hsize_t,
        @nospecialize(data::Any)
    )::H5_iter_t
        func, err_ref = data
        try
            return convert(H5_iter_t, func(offset, filter_mask, addr, size))
        catch err
            err_ref[] = err
            return H5_ITER_ERROR
        end
    end
    function h5d_chunk_iter(@nospecialize(f), dset_id, dxpl_id=H5P_DEFAULT)
        err_ref = Ref{Any}(nothing)
        fptr = @cfunction(
            h5d_chunk_iter_helper, H5_iter_t, (Ptr{hsize_t}, Cuint, haddr_t, hsize_t, Any)
        )
        try
            return h5d_chunk_iter(dset_id, dxpl_id, fptr, (f, err_ref))
        catch h5err
            jlerr = err_ref[]
            if !isnothing(jlerr)
                rethrow(jlerr)
            end
            rethrow(h5err)
        end
    end
end

"""
    h5d_get_space_status(dataset_id)

Helper method to retrieve the status of the dataset space.
Returns a `HDF5.API.H5D_space_status_t` (`Cint`) indicating the status, see `HDF5.API.H5D_SPACE_STATUS_`* constants.
"""
function h5d_get_space_status(dataset_id)
    r = Ref{H5D_space_status_t}()
    h5d_get_space_status(dataset_id, r)
    return r[]
end

###
### Error Interface
###

function h5e_get_auto(estack_id)
    func = Ref{Ptr{Cvoid}}()
    client_data = Ref{Ptr{Cvoid}}()
    h5e_get_auto(estack_id, func, client_data)
    return func[], client_data[]
end

"""
    mesg_type, mesg = h5e_get_msg(meshg_id)

"""
function h5e_get_msg(mesg_id)
    mesg_type = Ref{Cint}()
    mesg_len = h5e_get_msg(mesg_id, mesg_type, C_NULL, 0)
    buffer = StringVector(mesg_len)
    h5e_get_msg(mesg_id, mesg_type, buffer, mesg_len + 1)
    resize!(buffer, mesg_len)
    return mesg_type[], String(buffer)
end

# See explanation for h5a_iterate above.
function h5e_walk_helper(
    n::Cuint, err_desc::Ptr{H5E_error2_t}, @nospecialize(data::Any)
)::herr_t
    f, err_ref = data
    try
        return herr_t(f(n, err_desc))
    catch err
        err_ref[] = err
        return herr_t(-1)
    end
end
function h5e_walk(f::Function, stack_id, direction)
    err_ref = Ref{Any}(nothing)
    fptr = @cfunction(h5e_walk_helper, herr_t, (Cuint, Ptr{H5E_error2_t}, Any))
    try
        h5e_walk(stack_id, direction, fptr, (f, err_ref))
    catch h5err
        jlerr = err_ref[]
        if !isnothing(jlerr)
            rethrow(jlerr)
        end
        rethrow(h5err)
    end
end

###
### File Interface
###

function h5f_get_intent(file_id)
    intent = Ref{Cuint}()
    h5f_get_intent(file_id, intent)
    return intent[]
end

function h5f_get_name(loc_id)
    len = h5f_get_name(loc_id, C_NULL, 0)
    buf = StringVector(len)
    h5f_get_name(loc_id, buf, len + 1)
    return String(buf)
end

function h5f_get_obj_ids(file_id, types)
    sz = h5f_get_obj_count(file_id, types)
    hids = Vector{hid_t}(undef, sz)
    sz2 = h5f_get_obj_ids(file_id, types, sz, hids)
    sz2 != sz && resize!(hids, sz2)
    return hids
end

function h5f_get_vfd_handle(file_id, fapl)
    file_handle = Ref{Ptr{Cvoid}}()
    h5f_get_vfd_handle(file_id, fapl, file_handle)
    return file_handle[]
end

"""
    h5f_get_free_sections(file_id, type, [sect_info::AbstractVector{H5F_sect_info_t}])::AbstractVector{H5F_sect_info_t}

Return an `AbstractVector` of the free section information. If `sect_info` is not provided a new `Vector` will be allocated and returned.
If `sect_info` is provided, a view, a `SubArray`, will be returned.
"""
function h5f_get_free_sections(file_id, type)
    nsects = h5f_get_free_sections(file_id, type, 0, C_NULL)
    sect_info = Vector{H5F_sect_info_t}(undef, nsects)
    if nsects > 0
        h5f_get_free_sections(file_id, type, nsects, sect_info)
    end
    return sect_info
end

function h5f_get_free_sections(file_id, type, sect_info::AbstractVector{H5F_sect_info_t})
    nsects = length(sect_info)
    nsects = h5f_get_free_sections(file_id, type, nsects, sect_info)
    return @view(sect_info[1:nsects])
end

function h5p_get_file_locking(fapl)
    use_file_locking = Ref{API.hbool_t}(0)
    ignore_when_disabled = Ref{API.hbool_t}(0)
    h5p_get_file_locking(fapl, use_file_locking, ignore_when_disabled)
    return (
        use_file_locking     = Bool(use_file_locking[]),
        ignore_when_disabled = Bool(ignore_when_disabled[])
    )
end

# Check to see if h5p_set_file_locking should exist
const _has_h5p_set_file_locking = _has_symbol(:H5Pset_file_locking)
function has_h5p_set_file_locking()
    return _has_h5p_set_file_locking
    #=
    h5_version = h5_get_libversion()
    if (h5_version >= v"1.10" && h5_version < v"1.10.7") ||
       (h5_version >= v"1.12" && h5_version < v"1.12.1") ||
       (h5_version < v"1.10")
       return false
    else
       return true
    end
    =#
end

function h5p_get_file_space_strategy(plist_id)
    strategy = Ref{H5F_fspace_strategy_t}()
    persist = Ref{hbool_t}(0)
    threshold = Ref{hsize_t}()
    h5p_get_file_space_strategy(plist_id, strategy, persist, threshold)
    return (strategy=strategy[], persist=persist[], threshold=threshold[])
end

function h5p_get_file_space_page_size(plist_id)
    fsp_size = Ref{hsize_t}()
    h5p_get_file_space_page_size(plist_id, fsp_size)
    return fsp_size[]
end

function h5p_set_file_space_strategy(
    plist_id; strategy=nothing, persist=nothing, threshold=nothing
)
    current = h5p_get_file_space_strategy(plist_id)
    strategy = isnothing(strategy) ? current[:strategy] : strategy
    persist = isnothing(persist) ? current[:persist] : persist
    threshold = isnothing(threshold) ? current[:threshold] : threshold
    return h5p_set_file_space_strategy(plist_id, strategy, persist, threshold)
end

###
### Group Interface
###

function h5g_get_info(loc_id)
    ginfo = Ref{H5G_info_t}()
    h5g_get_info(loc_id, ginfo)
    return ginfo[]
end

function h5g_get_num_objs(loc_id)
    num_objs = Ref{hsize_t}()
    h5g_get_num_objs(loc_id, num_objs)
    return num_objs[]
end

###
### Identifier Interface
###

function h5i_get_name(loc_id)
    len = h5i_get_name(loc_id, C_NULL, 0)
    buf = StringVector(len)
    h5i_get_name(loc_id, buf, len + 1)
    return String(buf)
end

###
### Link Interface
###

function h5l_get_info(link_loc_id, link_name, lapl_id)
    info = Ref{H5L_info_t}()
    h5l_get_info(link_loc_id, link_name, info, lapl_id)
    return info[]
end

function h5l_get_name_by_idx(loc_id, group_name, idx_type, order, idx, lapl_id)
    len = h5l_get_name_by_idx(loc_id, group_name, idx_type, order, idx, C_NULL, 0, lapl_id)
    buf = StringVector(len)
    h5l_get_name_by_idx(loc_id, group_name, idx_type, order, idx, buf, len + 1, lapl_id)
    return String(buf)
end

# See explanation for h5a_iterate above.
function h5l_iterate_helper(
    group::hid_t, name::Ptr{Cchar}, info::Ptr{H5L_info_t}, @nospecialize(data::Any)
)::herr_t
    f, err_ref = data
    try
        return herr_t(f(group, name, info))
    catch err
        err_ref[] = err
        return herr_t(-1)
    end
end
"""
    h5l_iterate(f, group_id, idx_type, order, idx = 0) -> hsize_t

Executes [`h5l_iterate`](@ref h5l_iterate(::hid_t, ::Cint, ::Cint,
::Ptr{hsize_t}, ::Ptr{Cvoid}, ::Ptr{Cvoid})) with the user-provided callback
function `f`, returning the index where iteration ends.

The callback function must correspond to the signature
```
f(group::HDF5.API.hid_t, name::Ptr{Cchar}, info::Ptr{HDF5.API.H5L_info_t}) -> Union{Bool, Integer}
```
where a negative return value halts iteration abnormally, `true` or a positive
value halts iteration successfully, and `false` or zero continues iteration.

# Examples
```julia-repl
julia> HDF5.API.h5l_iterate(hfile, HDF5.API.H5_INDEX_NAME, HDF5.API.H5_ITER_INC) do group, name, info
           println(unsafe_string(name))
           return HDF5.API.herr_t(0)
       end
```
"""
function h5l_iterate(@nospecialize(f), group_id, idx_type, order, idx=0)
    err_ref = Ref{Any}(nothing)
    idxref = Ref{hsize_t}(idx)
    fptr = @cfunction(h5l_iterate_helper, herr_t, (hid_t, Ptr{Cchar}, Ptr{H5L_info_t}, Any))
    try
        h5l_iterate(group_id, idx_type, order, idxref, fptr, (f, err_ref))
    catch h5err
        jlerr = err_ref[]
        if !isnothing(jlerr)
            rethrow(jlerr)
        end
        rethrow(h5err)
    end
    return idxref[]
end

###
### Object Interface
###

@static if _libhdf5_build_ver < v"1.10.3"

    # H5Oget_info1
    function h5o_get_info(loc_id)
        oinfo = Ref{H5O_info1_t}()
        h5o_get_info(loc_id, oinfo)
        return oinfo[]
    end

    # H5Oget_info_by_name1
    function h5o_get_info_by_name(loc_id, name, lapl=H5P_DEFAULT)
        oinfo = Ref{H5O_info1_t}()
        h5o_get_info_by_name(loc_id, name, oinfo, lapl)
        return oinfo[]
    end

    # H5Oget_info_by_idx1
    function h5o_get_info_by_idx(loc_id, group_name, idx_type, order, n, lapl=H5P_DEFAULT)
        oinfo = Ref{H5O_info1_t}()
        h5o_get_info_by_idx(loc_id, group_name, idx_type, order, n, oinfo, lapl)
        return oinfo[]
    end

elseif _libhdf5_build_ver >= v"1.10.3" && _libhdf5_build_ver < v"1.12.0"

    # H5Oget_info2
    function h5o_get_info(loc_id, fields=H5O_INFO_ALL)
        oinfo = Ref{H5O_info1_t}()
        h5o_get_info(loc_id, oinfo, fields)
        return oinfo[]
    end

    # H5Oget_info_by_name2
    function h5o_get_info_by_name(loc_id, name, fields=H5O_INFO_ALL, lapl=H5P_DEFAULT)
        oinfo = Ref{H5O_info1_t}()
        h5o_get_info_by_name(loc_id, name, oinfo, fields, lapl)
        return oinfo[]
    end

    # H5Oget_info_by_idx2
    function h5o_get_info_by_idx(
        loc_id, group_name, idx_type, order, n, fields=H5O_INFO_ALL, lapl=H5P_DEFAULT
    )
        oinfo = Ref{H5O_info1_t}()
        h5o_get_info_by_idx(loc_id, group_name, idx_type, order, n, oinfo, fields, lapl)
        return oinfo[]
    end

else # _libhdf5_build_ver >= v"1.12.0"

    # H5Oget_info3
    function h5o_get_info(loc_id, fields=H5O_INFO_ALL)
        oinfo = Ref{H5O_info2_t}()
        h5o_get_info(loc_id, oinfo, fields)
        return oinfo[]
    end

    # H5Oget_info_by_name3
    function h5o_get_info_by_name(loc_id, name, fields=H5O_INFO_ALL, lapl=H5P_DEFAULT)
        oinfo = Ref{H5O_info2_t}()
        h5o_get_info_by_name(loc_id, name, oinfo, fields, lapl)
        return oinfo[]
    end

    # H5Oget_info_by_idx3
    function h5o_get_info_by_idx(
        loc_id, group_name, idx_type, order, n, fields=H5O_INFO_ALL, lapl=H5P_DEFAULT
    )
        oinfo = Ref{H5O_info2_t}()
        h5o_get_info_by_idx(loc_id, group_name, idx_type, order, n, oinfo, fields, lapl)
        return oinfo[]
    end

    function h5o_get_native_info(loc_id, fields=H5O_NATIVE_INFO_ALL)
        oinfo = Ref{H5O_native_info_t}()
        h5o_get_native_info(loc_id, oinfo, fields)
        return oinfo[]
    end

    function h5o_get_native_info_by_idx(
        loc_id, group_name, idx_type, order, n, fields=H5O_NATIVE_INFO_ALL, lapl=H5P_DEFAULT
    )
        oinfo = Ref{H5O_native_info_t}()
        h5o_get_native_info_by_idx(
            loc_id, group_name, idx_type, order, n, oinfo, fields, lapl
        )
        return oinfo[]
    end

    function h5o_get_native_info_by_name(
        loc_id, name, fields=H5O_NATIVE_INFO_ALL, lapl=H5P_DEFAULT
    )
        oinfo = Ref{H5O_native_info_t}()
        h5o_get_native_info_by_name(loc_id, name, oinfo, fields, lapl)
        return oinfo[]
    end
end # @static if _libhdf5_build_ver < v"1.12.0"

# Add a default link access property list if not specified
function h5o_exists_by_name(loc_id, name)
    return h5o_exists_by_name(loc_id, name, H5P_DEFAULT)
end

# Legacy h5o_get_info1 interface, for compat with pre-1.12.0
# Used by deprecated object_info function
"""
    h5o_get_info1(object_id, [buf])

Deprecated HDF5 function. Use [`h5o_get_info`](@ref) or [`h5o_get_native_info`](@ref) if possible.

See `libhdf5` documentation for [`H5Oget_info1`](https://portal.hdfgroup.org/display/HDF5/H5O_GET_INFO1).
"""
function h5o_get_info1(object_id, buf)
    var"#status#" = ccall(
        (:H5Oget_info1, libhdf5), herr_t, (hid_t, Ptr{H5O_info_t}), object_id, buf
    )
    var"#status#" < 0 && @h5error("Error getting object info")
    return nothing
end
function h5o_get_info1(loc_id)
    oinfo = Ref{H5O_info1_t}()
    h5o_get_info1(loc_id, oinfo)
    return oinfo[]
end

###
### Property Interface
###

function h5p_get_alignment(fapl_id)
    threshold = Ref{hsize_t}()
    alignment = Ref{hsize_t}()
    h5p_get_alignment(fapl_id, threshold, alignment)
    return threshold[], alignment[]
end

function h5p_get_alloc_time(plist_id)
    alloc_time = Ref{Cint}()
    h5p_get_alloc_time(plist_id, alloc_time)
    return alloc_time[]
end

function h5p_get_char_encoding(plist_id)
    encoding = Ref{Cint}()
    h5p_get_char_encoding(plist_id, encoding)
    return encoding[]
end

function h5p_get_chunk(plist_id)
    ndims = h5p_get_chunk(plist_id, 0, C_NULL)
    dims = Vector{hsize_t}(undef, ndims)
    h5p_get_chunk(plist_id, ndims, dims)
    return dims, ndims
end

function h5p_get_chunk_cache(dapl_id)
    nslots = Ref{Csize_t}()
    nbytes = Ref{Csize_t}()
    w0 = Ref{Cdouble}()
    h5p_get_chunk_cache(dapl_id, nslots, nbytes, w0)
    return (nslots=nslots[], nbytes=nbytes[], w0=w0[])
end

function h5p_get_create_intermediate_group(plist_id)
    cig = Ref{Cuint}()
    h5p_get_create_intermediate_group(plist_id, cig)
    return cig[]
end

function h5p_get_dxpl_mpio(dxpl_id)
    xfer_mode = Ref{Cint}()
    h5p_get_dxpl_mpio(dxpl_id, xfer_mode)
    return xfer_mode[]
end

function h5p_get_efile_prefix(plist)
    efile_len = h5p_get_efile_prefix(plist, C_NULL, 0)
    buffer = StringVector(efile_len)
    prefix_size = h5p_get_efile_prefix(plist, buffer, efile_len + 1)
    return String(buffer)
end

function h5p_set_efile_prefix(plist, sym::Symbol)
    if sym === :origin
        h5p_set_efile_prefix(plist, raw"$ORIGIN")
    else
        throw(
            ArgumentError(
                "The only valid `Symbol` argument for `h5p_set_efile_prefix` is `:origin`. Got `$sym`."
            )
        )
    end
end

function h5p_get_external(plist, idx=0)
    Offset_t = @static if v"2.0" ≤ _libhdf5_build_ver
        H5Doff_t
    else
        off_t
    end
    offset = Ref{Offset_t}(0)
    sz = Ref{hsize_t}(0)
    name_size = 64
    name = Base.StringVector(name_size)
    while true
        h5p_get_external(plist, idx, name_size, name, offset, sz)
        null_id = findfirst(==(0x00), name)
        if isnothing(null_id)
            name_size *= 2
            resize!(name, name_size)
        else
            resize!(name, null_id - 1)
            break
        end
    end
    return (name=String(name), offset=offset[], size=sz[])
end

function h5p_get_fclose_degree(fapl_id)
    out = Ref{Cint}()
    h5p_get_fclose_degree(fapl_id, out)
    return out[]
end

function h5p_get_fill_time(plist_id)
    out = Ref{H5D_fill_time_t}()
    h5p_get_fill_time(plist_id, out)
    return out[]
end

function h5p_get_libver_bounds(plist_id)
    low = Ref{Cint}()
    high = Ref{Cint}()
    h5p_get_libver_bounds(plist_id, low, high)
    return low[], high[]
end

function h5p_get_local_heap_size_hint(plist_id)
    size_hint = Ref{Csize_t}()
    h5p_get_local_heap_size_hint(plist_id, size_hint)
    return size_hint[]
end

function h5p_get_meta_block_size(fapl_id)
    sz = Ref{hsize_t}(0)
    h5p_get_meta_block_size(fapl_id, sz)
    return sz[]
end

function h5p_get_obj_track_times(plist_id)
    track_times = Ref{UInt8}()
    h5p_get_obj_track_times(plist_id, track_times)
    return track_times[] != 0x0
end

function h5p_get_userblock(plist_id)
    len = Ref{hsize_t}()
    h5p_get_userblock(plist_id, len)
    return len[]
end

function h5p_get_virtual_count(dcpl_id)
    count = Ref{Csize_t}()
    h5p_get_virtual_count(dcpl_id, count)
    return count[]
end

function h5p_get_virtual_dsetname(dcpl_id, index)
    len = h5p_get_virtual_dsetname(dcpl_id, index, C_NULL, 0)
    buffer = StringVector(len)
    h5p_get_virtual_dsetname(dcpl_id, index, buffer, len + 1)
    return String(buffer)
end
function h5p_get_virtual_filename(dcpl_id, index)
    len = h5p_get_virtual_filename(dcpl_id, index, C_NULL, 0)
    buffer = StringVector(len)
    h5p_get_virtual_filename(dcpl_id, index, buffer, len + 1)
    return String(buffer)
end

function h5p_get_virtual_prefix(dapl_id)
    virtual_file_len = h5p_get_virtual_prefix(dapl_id, C_NULL, 0)
    buffer = StringVector(virtual_file_len)
    prefix_size = h5p_get_virtual_prefix(dapl_id, buffer, virtual_file_len + 1)
    return String(buffer)
end

function h5p_get_virtual_printf_gap(dapl_id)
    gap = Ref{hsize_t}()
    h5p_get_virtual_printf_gap(dapl_id, gap)
    return gap[]
end

function h5p_get_virtual_view(dapl_id)
    view = Ref{H5D_vds_view_t}()
    h5p_get_virtual_view(dapl_id, view)
    return view[]
end

"""
    h5p_get_file_image(fapl_id)::Vector{UInt8}

Retrieve a file image of the appropriate size in a `Vector{UInt8}`.
"""
function h5p_get_file_image(fapl_id)::Vector{UInt8}
    cb = h5p_get_file_image_callbacks(fapl_id)
    if cb.image_free != C_NULL
        # The user has configured their own memory deallocation routines.
        # The user should use a lower level call to properly handle deallocation
        error(
            "File image callback image_free is not C_NULL. Use the three argument method of h5p_get_file_image when setting file image callbacks."
        )
    end
    buf_ptr_ref = Ref{Ptr{Nothing}}()
    buf_len_ref = Ref{Csize_t}(0)
    h5p_get_file_image(fapl_id, buf_ptr_ref, buf_len_ref)
    image = unsafe_wrap(Array{UInt8}, Ptr{UInt8}(buf_ptr_ref[]), buf_len_ref[]; own=false)
    finalizer(image) do image
        # Use h5_free_memory to ensure we are using the correct free
        h5_free_memory(image)
    end
    return image
end

"""
    h5p_set_file_image(fapl_id, image::Vector{UInt8})

Set the file image from a `Vector{UInt8}`.
"""
function h5p_set_file_image(fapl_id, image::Vector{UInt8})
    h5p_set_file_image(fapl_id, image, length(image))
end

"""
    h5p_get_file_image_callbacks(fapl_id)

Retrieve the file image callbacks for memory operations
"""
function h5p_get_file_image_callbacks(fapl_id)
    cb = H5FD_file_image_callbacks_t(C_NULL, C_NULL, C_NULL, C_NULL, C_NULL, C_NULL, C_NULL)
    r = Ref(cb)
    h5p_get_file_image_callbacks(fapl_id, r)
    return r[]
end

# Note: The following function(s) implement direct ccalls because the binding generator
# cannot (yet) do the string wrapping and memory freeing.

"""
    h5p_get_class_name(pcid::hid_t) -> String

See `libhdf5` documentation for [`H5P_GET_CLASS_NAME`](https://portal.hdfgroup.org/display/HDF5/H5P_GET_CLASS_NAME).
"""
function h5p_get_class_name(pcid)
    pc = ccall((:H5Pget_class_name, libhdf5), Ptr{UInt8}, (hid_t,), pcid)
    if pc == C_NULL
        @h5error("Error getting class name")
    end
    s = unsafe_string(pc)
    h5_free_memory(pc)
    return s
end

function h5p_get_attr_creation_order(p)
    attr = Ref{UInt32}()
    h5p_get_attr_creation_order(p, attr)
    return attr[]
end

function h5p_get_link_creation_order(p)
    link = Ref{UInt32}()
    h5p_get_link_creation_order(p, link)
    return link[]
end

function h5p_get_dset_no_attrs_hint(dcpl)::hbool_t
    minimize = Ref{hbool_t}(false)
    h5p_get_dset_no_attrs_hint(dcpl, minimize)
    return minimize[] > 0
end

###
### Plugin Interface
###

function h5pl_get_loading_state()
    plugin_control_mask = Ref{Cuint}()
    h5pl_get_loading_state(plugin_control_mask)
    plugin_control_mask[]
end

function h5pl_get(index=0)
    buf_size = Csize_t(1024)
    path_buf = Vector{Cchar}(undef, buf_size)
    h5pl_get(index, path_buf, buf_size)
    unsafe_string(pointer(path_buf))
end

function h5pl_size()
    num_paths = Ref{Cuint}()
    h5pl_size(num_paths)
    num_paths[]
end

###
### Reference Interface
###

###
### Dataspace Interface
###

function h5s_get_regular_hyperslab(space_id)
    n      = h5s_get_simple_extent_ndims(space_id)
    start  = Vector{hsize_t}(undef, n)
    stride = Vector{hsize_t}(undef, n)
    count  = Vector{hsize_t}(undef, n)
    block  = Vector{hsize_t}(undef, n)
    h5s_get_regular_hyperslab(space_id, start, stride, count, block)
    return start, stride, count, block
end

function h5s_get_simple_extent_dims(space_id)
    n = h5s_get_simple_extent_ndims(space_id)
    dims = Vector{hsize_t}(undef, n)
    maxdims = Vector{hsize_t}(undef, n)
    h5s_get_simple_extent_dims(space_id, dims, maxdims)
    return dims, maxdims
end
function h5s_get_simple_extent_dims(space_id, ::Nothing)
    n = h5s_get_simple_extent_ndims(space_id)
    dims = Vector{hsize_t}(undef, n)
    h5s_get_simple_extent_dims(space_id, dims, C_NULL)
    return dims
end

###
### Datatype Interface
###

function h5t_get_array_dims(type_id)
    nd = h5t_get_array_ndims(type_id)
    dims = Vector{hsize_t}(undef, nd)
    h5t_get_array_dims(type_id, dims)
    return dims
end

function h5t_get_fields(type_id)
    spos = Ref{Csize_t}()
    epos = Ref{Csize_t}()
    esize = Ref{Csize_t}()
    mpos = Ref{Csize_t}()
    msize = Ref{Csize_t}()
    h5t_get_fields(type_id, spos, epos, esize, mpos, msize)
    return (spos[], epos[], esize[], mpos[], msize[])
end

# Note: The following two functions implement direct ccalls because the binding generator
# cannot (yet) do the string wrapping and memory freeing.
"""
    h5t_get_member_name(type_id::hid_t, index::Cuint) -> String

See `libhdf5` documentation for [`H5Oopen`](https://portal.hdfgroup.org/display/HDF5/H5T_GET_MEMBER_NAME).
"""
function h5t_get_member_name(type_id, index)
    pn = ccall((:H5Tget_member_name, libhdf5), Ptr{UInt8}, (hid_t, Cuint), type_id, index)
    if pn == C_NULL
        @h5error("Error getting name of compound datatype member #$index")
    end
    s = unsafe_string(pn)
    h5_free_memory(pn)
    return s
end

"""
    h5t_get_tag(type_id::hid_t) -> String

See `libhdf5` documentation for [`H5Oopen`](https://portal.hdfgroup.org/display/HDF5/H5T_GET_TAG).
"""
function h5t_get_tag(type_id)
    pc = ccall((:H5Tget_tag, libhdf5), Ptr{UInt8}, (hid_t,), type_id)
    if pc == C_NULL
        @h5error("Error getting opaque tag")
    end
    s = unsafe_string(pc)
    h5_free_memory(pc)
    return s
end

h5t_get_native_type(type_id) = h5t_get_native_type(type_id, H5T_DIR_ASCEND)

###
### Optimized Functions Interface
###

###
### HDF5 Lite Interface
###

function h5lt_dtype_to_text(dtype_id)
    len = Ref{Csize_t}()
    h5lt_dtype_to_text(dtype_id, C_NULL, 0, len)
    buf = StringVector(len[] - 1)
    h5lt_dtype_to_text(dtype_id, buf, 0, len)
    return String(buf)
end

###
### Table Interface
###

function h5tb_get_table_info(loc_id, table_name)
    nfields = Ref{hsize_t}()
    nrecords = Ref{hsize_t}()
    h5tb_get_table_info(loc_id, table_name, nfields, nrecords)
    return nfields[], nrecords[]
end

function h5tb_get_field_info(loc_id, table_name)
    nfields, = h5tb_get_table_info(loc_id, table_name)
    field_sizes = Vector{Csize_t}(undef, nfields)
    field_offsets = Vector{Csize_t}(undef, nfields)
    type_size = Ref{Csize_t}()
    # pass C_NULL to field_names argument since libhdf5 does not provide a way to determine if the
    # allocated buffer is the correct length, which is thus susceptible to a buffer overflow if
    # an incorrect buffer length is passed. Instead, we manually compute the column names using the
    # same calls that h5tb_get_field_info internally uses.
    h5tb_get_field_info(loc_id, table_name, C_NULL, field_sizes, field_offsets, type_size)
    did = h5d_open(loc_id, table_name, H5P_DEFAULT)
    tid = h5d_get_type(did)
    h5d_close(did)
    field_names = [h5t_get_member_name(tid, i - 1) for i in 1:nfields]
    h5t_close(tid)
    return field_names, field_sizes, field_offsets, type_size[]
end

###
### Filter Interface
###

function h5z_get_filter_info(filter)
    ref = Ref{Cuint}()
    h5z_get_filter_info(filter, ref)
    ref[]
end

###
### MPIO
###

# define these stubs, but can't define the methods as the types aren't
# known until MPI.jl is loaded.

"""
    h5p_get_fapl_mpio(fapl_id::hid_t, comm::Ptr{MPI.MPI_Comm}, info::Ptr{MPI.MPI_Info})

See `libhdf5` documentation for [`H5Pget_fapl_mpio`](https://portal.hdfgroup.org/display/HDF5/H5P_GET_FAPL_MPIO32).
"""
function h5p_get_fapl_mpio end

"""
    h5p_set_fapl_mpio(fapl_id::hid_t, comm::MPI.MPI_Comm, info::MPI.MPI_Info)

See `libhdf5` documentation for [`H5Pset_fapl_mpio`](https://portal.hdfgroup.org/display/HDF5/H5P_SET_FAPL_MPIO32).
"""
function h5p_set_fapl_mpio end

using Random, Test, HDF5

@testset "reference" begin
    data = rand(100)

    fn = tempname()

    f = h5open(fn, "w")
    f["data"] = data
    f["group_data"] = data
    f["attr_data"] = data
    # reference attached to file
    f["file_ref"] = HDF5.Reference(f, "data")
    # reference attached to group
    g = create_group(f, "sub")
    g["group_ref"] = HDF5.Reference(f, "group_data")
    # reference attached to dataset
    f["data"]["attr_ref"] = HDF5.Reference(f, "attr_data")

    close(f)

    f = h5open(fn, "r")
    # read back file-attached reference
    ref = read(f["file_ref"])
    @test ref isa HDF5.Reference
    @test data == read(f[ref])
    # read back group-attached reference
    gref = read(f["sub"]["group_ref"])
    @test gref isa HDF5.Reference
    @test data == read(f["sub"][gref])
    # read back dataset-attached reference
    aref = read(f["data"]["attr_ref"])
    @test aref isa HDF5.Reference
    @test data == read(f["data"][aref])

    close(f)
    rm(fn)
end

# This file defines midlevel api wrappers. We include name normalization for methods that are
# applicable to different hdf5 api-layers. We still try to adhere close proximity to the underlying
# method name in the hdf5-library.

"""
    HDF5.set_extent_dims(dset::HDF5.Dataset, new_dims::Dims)

Change the current dimensions of a dataset to `new_dims`, limited by
`max_dims = get_extent_dims(dset)[2]`. Reduction is possible and leads to loss of truncated data.
"""
function set_extent_dims(dset::Dataset, size::Dims)
    checkvalid(dset)
    API.h5d_set_extent(dset, API.hsize_t[reverse(size)...])
end

"""
    HDF5.set_extent_dims(dspace::HDF5.Dataspace, new_dims::Dims, max_dims::Union{Dims,Nothing} = nothing)

Change the dimensions of a dataspace `dspace` to `new_dims`, optionally with the maximum possible
dimensions `max_dims` different from the active size `new_dims`. If not given, `max_dims` is set equal
to `new_dims`.
"""
function set_extent_dims(
    dspace::Dataspace, size::Dims, max_dims::Union{Dims,Nothing}=nothing
)
    checkvalid(dspace)
    rank = length(size)
    current_size = API.hsize_t[reverse(size)...]
    maximum_size = isnothing(max_dims) ? C_NULL : [reverse(max_dims .% API.hsize_t)...]
    API.h5s_set_extent_simple(dspace, rank, current_size, maximum_size)
    return nothing
end

"""
    HDF5.get_extent_dims(obj::Union{HDF5.Dataspace, HDF5.Dataset, HDF5.Attribute}) -> dims, maxdims

Get the array dimensions from a dataspace, dataset, or attribute and return a tuple of `dims` and `maxdims`.
"""
function get_extent_dims(obj::Union{Dataspace,Dataset,Attribute})
    dspace = obj isa Dataspace ? checkvalid(obj) : dataspace(obj)
    h5_dims, h5_maxdims = API.h5s_get_simple_extent_dims(dspace)
    # reverse dimensions since hdf5 uses C-style order
    N = length(h5_dims)
    dims = ntuple(i -> @inbounds(Int(h5_dims[N - i + 1])), N)
    maxdims = ntuple(i -> @inbounds(h5_maxdims[N - i + 1]) % Int, N) # allows max_dims to be specified as -1 without triggering an overflow
    obj isa Dataspace || close(dspace)
    return dims, maxdims
end

"""
    HDF5.get_chunk_offset(dataset_id, index)

Get 0-based offset of chunk from 0-based `index`. The offsets are returned in Julia's column-major order rather than hdf5 row-major order.
For a 1-based API, see `HDF5.ChunkStorage`.
"""
function get_chunk_offset(dataset_id, index)
    extent = size(dataset_id)
    chunk = get_chunk(dataset_id)
    chunk_indices = CartesianIndices(
        ntuple(i -> 0:(cld(extent[i], chunk[i]) - 1), length(extent))
    )
    offset = API.hsize_t.(chunk_indices[index + 1].I .* chunk)
    return offset
end

"""
    HDF5.get_chunk_index(dataset_id, offset)

Get 0-based index of chunk from 0-based `offset` returned in Julia's column-major order.
For a 1-based API, see `HDF5.ChunkStorage`.
"""
function get_chunk_index(dataset_id, offset)
    extent = size(dataset_id)
    chunk = get_chunk(dataset_id)
    chunk_indices = LinearIndices(
        ntuple(i -> 0:(cld(extent[i], chunk[i]) - 1), length(extent))
    )
    chunk_indices[(fld.(offset, chunk) .+ 1)...] - 1
end

"""
    HDF5.get_num_chunks_per_dim(dataset_id)

Get the number of chunks in each dimension in Julia's column-major order.
"""
function get_num_chunks_per_dim(dataset_id)
    extent = size(dataset_id)
    chunk = get_chunk(dataset_id)
    return cld.(extent, chunk)
end

"""
    HDF5.get_num_chunks(dataset_id)

Returns the number of chunks in a dataset. Equivalent to `API.h5d_get_num_chunks(dataset_id, HDF5.H5S_ALL)`.
"""
function get_num_chunks(dataset_id)
    @static if v"1.10.5" ≤ API._libhdf5_build_ver
        API.h5d_get_num_chunks(dataset_id)
    else
        prod(get_num_chunks_per_dim(dataset_id))
    end
end

"""
    HDF5.get_chunk_length(dataset_id)

Retrieves the chunk size in bytes. Equivalent to `API.h5d_get_chunk_info(dataset_id, index)[:size]`.
"""
function get_chunk_length(dataset_id)
    type = API.h5d_get_type(dataset_id)
    chunk = get_chunk(dataset_id)
    return Int(API.h5t_get_size(type) * prod(chunk))
end

vlen_get_buf_size(dset::Dataset, dtype::Datatype, dspace::Dataspace) =
    API.h5d_vlen_get_buf_size(dset, dtype, dspace)
function vlen_get_buf_size(dataset_id)
    type = API.h5d_get_type(dataset_id)
    space = API.h5d_get_space(dataset_id)
    API.h5d_vlen_get_buf_size(dataset_id, type, space)
end

"""
    HDF5.read_chunk(dataset_id, offset, [buf]; dxpl_id = HDF5.API.H5P_DEFAULT, filters = Ref{UInt32}())

Helper method to read chunks via 0-based offsets in a `Tuple`.

Argument `buf` is optional and defaults to a `Vector{UInt8}` of length determined by `HDF5.get_chunk_length`.
Argument `dxpl_id` can be supplied a keyword and defaults to `HDF5.API.H5P_DEFAULT`.
Argument `filters` can be retrieved by supplying a `Ref{UInt32}` value via a keyword argument.

This method returns `Vector{UInt8}`.
"""
function read_chunk(
    dataset_id,
    offset,
    buf::Vector{UInt8}=Vector{UInt8}(undef, get_chunk_length(dataset_id));
    dxpl_id=API.H5P_DEFAULT,
    filters=Ref{UInt32}()
)
    API.h5d_read_chunk(dataset_id, dxpl_id, offset, filters, buf)
    return buf
end

"""
    HDF5.read_chunk(dataset_id, index::Integer, [buf]; dxpl_id = HDF5.API.H5P_DEFAULT, filters = Ref{UInt32}())

Helper method to read chunks via 0-based integer `index`.

Argument `buf` is optional and defaults to a `Vector{UInt8}` of length determined by `HDF5.API.h5d_get_chunk_info`.
Argument `dxpl_id` can be supplied a keyword and defaults to `HDF5.API.H5P_DEFAULT`.
Argument `filters` can be retrieved by supplying a `Ref{UInt32}` value via a keyword argument.

This method returns `Vector{UInt8}`.
"""
function read_chunk(
    dataset_id,
    index::Integer,
    buf::Vector{UInt8}=Vector{UInt8}(undef, get_chunk_length(dataset_id));
    dxpl_id=API.H5P_DEFAULT,
    filters=Ref{UInt32}()
)
    offset = [reverse(get_chunk_offset(dataset_id, index))...]
    read_chunk(dataset_id, offset, buf; dxpl_id=dxpl_id, filters=filters)
end

"""
    HDF5.write_chunk(dataset_id, offset, buf::AbstractArray; dxpl_id = HDF5.API.H5P_DEFAULT, filter_mask = 0)

Helper method to write chunks via 0-based offsets `offset` as a `Tuple`.
"""
function write_chunk(
    dataset_id, offset, buf::AbstractArray; dxpl_id=API.H5P_DEFAULT, filter_mask=0
)
    # Borrowed from write_dataset stride detection
    stride(buf, 1) == 1 ||
        throw(ArgumentError("Cannot write arrays with a different stride than `Array`"))
    API.h5d_write_chunk(dataset_id, dxpl_id, filter_mask, offset, sizeof(buf), buf)
end

function write_chunk(
    dataset_id,
    offset,
    buf::Union{DenseArray,Base.FastContiguousSubArray};
    dxpl_id=API.H5P_DEFAULT,
    filter_mask=0
)
    # We can bypass the need to check stride with Array and FastContiguousSubArray
    API.h5d_write_chunk(dataset_id, dxpl_id, filter_mask, offset, sizeof(buf), buf)
end

"""
    HDF5.write_chunk(dataset_id, index::Integer, buf::AbstractArray; dxpl_id = API.H5P_DEFAULT, filter_mask = 0)

Helper method to write chunks via 0-based integer `index`.
"""
function write_chunk(
    dataset_id, index::Integer, buf::AbstractArray; dxpl_id=API.H5P_DEFAULT, filter_mask=0
)
    offset = [reverse(get_chunk_offset(dataset_id, index))...]
    write_chunk(dataset_id, offset, buf; dxpl_id=dxpl_id, filter_mask=filter_mask)
end

# Avoid ambiguous method with offset based versions
function write_chunk(
    dataset_id,
    index::Integer,
    buf::Union{DenseArray,Base.FastContiguousSubArray};
    dxpl_id=API.H5P_DEFAULT,
    filter_mask=0
)
    # We can bypass the need to check stride with Array and FastContiguousSubArray
    offset = [reverse(get_chunk_offset(dataset_id, index))...]
    write_chunk(dataset_id, offset, buf; dxpl_id=dxpl_id, filter_mask=filter_mask)
end

function get_fill_value(plist_id, ::Type{T}) where {T}
    value = Ref{T}()
    API.h5p_get_fill_value(plist_id, datatype(T), value)
    return value[]
end

get_fill_value(plist_id) = get_fill_value(plist_id, Float64)

function set_fill_value!(plist_id, value)
    ref_value = Ref(value)
    API.h5p_set_fill_value(plist_id, datatype(value), ref_value)
    return plist_id
end

using Base.Meta: isexpr, quot

# Some names don't follow the automatic conversion rules, so define how to make some
# of the translations explicitly.
const bind_exceptions = Dict{Symbol,Symbol}()

# Load URLs for HDF Group Doxygen
const urldict = Dict{String,String}([
    func_urls[1] => func_urls[2] for
    func_urls in split.(readlines("DoxygenTagParser/hdf5_func_urls.tsv"))
])
# have numbers at the end
bind_exceptions[:h5p_set_fletcher32] = :H5Pset_fletcher32
bind_exceptions[:h5p_set_fapl_sec2]  = :H5Pset_fapl_sec2
bind_exceptions[:h5p_get_fapl_ros3]  = :H5Pget_fapl_ros3
bind_exceptions[:h5p_set_fapl_ros3]  = :H5Pset_fapl_ros3
# underscore separator not removed
bind_exceptions[:h5fd_core_init]   = :H5FD_core_init
bind_exceptions[:h5fd_family_init] = :H5FD_family_init
bind_exceptions[:h5fd_log_init]    = :H5FD_log_init
bind_exceptions[:h5fd_mpio_init]   = :H5FD_mpio_init
bind_exceptions[:h5fd_multi_init]  = :H5FD_multi_init
bind_exceptions[:h5fd_sec2_init]   = :H5FD_sec2_init
bind_exceptions[:h5fd_stdio_init]  = :H5FD_stdio_init

# An expression which is injected at the beginning of the API defitions to aid in doing
# (pre)compile-time conditional compilation based on the libhdf5 version.
_libhdf5_build_ver_expr = quote
    _libhdf5_build_ver = let
        majnum, minnum, relnum = Ref{Cuint}(), Ref{Cuint}(), Ref{Cuint}()
        r = ccall(
            (:H5get_libversion, libhdf5),
            herr_t,
            (Ref{Cuint}, Ref{Cuint}, Ref{Cuint}),
            majnum,
            minnum,
            relnum
        )
        r < 0 && error("Error getting HDF5 library version")
        VersionNumber(majnum[], minnum[], relnum[])
    end
end

# We'll also use this processing pass to automatically generate documentation that simply
# lists all of the bound API functions.
const bound_api = Dict{String,Vector{String}}()

"""
    @bind h5_function(arg1::Arg1Type, ...)::ReturnType [ErrorStringOrExpression] [(lb,ub)]

A binding generator for translating `@ccall`-like declarations of HDF5 library functions
to error-checked `ccall` expressions.

The provided function name is used to define the Julia function with any trailing version
number removed (such as `h5t_open2` -> `h5t_open`). The corresponding C function name is
auto-generated by uppercasing the first few letters (up to the first `_`), the first `_` is
removed. Explicit name mappings can be made by inserting a `:jlname => :h5name` pair into
the `bind_exceptions` dictionary.

The optional `ErrorStringOrExpression` can be either a string literal or an expression
which evaluates to a string. This string is used as the message in `h5error(msg)`
call. Note that the expression may refer to any arguments by name.

The optional Tuple `(lb,ub)` is a tuple of version literals (e.g. v"1.10.5") or `nothing`
defining an inclusive lower bound (lb) and exclusive upper bound (ub) such that
the binding is only defined if `lb ≤ _libhdf5_build_ver < ub`. If either bound is `nothing`
then that bound is ignored and the version is unbounded on that side.

The declared return type in the function-like signature must be the return type of the C
function, and the Julia return type is inferred as one of the following possibilities:

1. If `ReturnType === :herr_t`, the Julia function returns `nothing` and the C return is
   used only in error checking.

2. If `ReturnType === :htri_t`, the Julia function returns a boolean indicating whether
   the return value of the C function was zero (`false`) or positive (`true`).

3. Otherwise, the C function return value is returned from the Julia function, with the
   following exceptions:

   - If the return type is an C integer type compatible with Int, the return type is
     converted to an Int.

Furthermore, the C return value is interpreted to automatically generate error checks:

1. If `ReturnType === :herr_t` or `ReturnType === :htri_t`, an error is raised when the return
   value is negative.

2. If `ReturnType === :haddr_t` or `ReturnType === :hsize_t`, an error is raised when the
   return value is equivalent to `-1 % haddr_t` and `-1 % hsize_t`, respectively.

3. If `ReturnType` is a `Ptr` expression, an error is raised when the return value is
   equal to `C_NULL`.

4. If `ReturnType` is a `Csize_t` expression, an error is raised when the return value is
   equal to `0`. Note that at least in the case of `h5t_get_member_offset`, `0` is also a
   valid return value, so it is necessary for `h5error()` to check the error stack to
   determine whether or not an error should be thrown.

5. For all other return types, it is assumed a negative value indicates error.

It is assumed that the HDF library names are given in global constants named `libhdf5`
and `libhdf5_hl`. The former is used for all `ccall`s, except if the C library name begins
with "H5DO" or "H5TB" then the latter library is used.
"""
macro bind(sig::Expr, err::Union{String,Expr}, vers::Union{Expr,Nothing}=nothing)
    expr = _bind(__module__, __source__, sig, err)
    isnothing(vers) && return esc(expr)

    isexpr(vers, :tuple) || error("Expected 2-tuple of version bounds, got ", vers)
    length(vers.args) == 2 || error("Expected 2-tuple of version bounds, got ", vers)
    lb = vers.args[1]
    ub = vers.args[2]

    if lb !== :nothing && !(isexpr(lb, :macrocall) && lb.args[1] == Symbol("@v_str"))
        error("Lower version bound must be `nothing` or version number literal, got ", lb)
    end
    if ub !== :nothing && !(isexpr(ub, :macrocall) && ub.args[1] == Symbol("@v_str"))
        error("Upper version bound must be `nothing` or version number literal, got ", ub)
    end

    if lb === :nothing && ub !== :nothing
        conditional = :(_libhdf5_build_ver < $(ub))
    elseif lb !== :nothing && ub === :nothing
        conditional = :($(lb) ≤ _libhdf5_build_ver)
    else
        conditional = :($(lb) ≤ _libhdf5_build_ver < $(ub))
    end
    conditional = Expr(:if, conditional, expr)
    return esc(Expr(:macrocall, Symbol("@static"), nothing, conditional))
end

function _bind(__module__, __source__, sig::Expr, err::Union{String,Expr,Nothing})
    sig.head === :(::) || error("return type required on function signature")

    # Pull apart return-type and rest of function declaration
    rettype = sig.args[2]::Union{Symbol,Expr}
    funcsig = sig.args[1]
    isexpr(funcsig, :call) ||
        error("expected function-like expression, found `", funcsig, "`")
    funcsig = funcsig::Expr

    # Extract function name and argument list
    jlfuncname = funcsig.args[1]::Symbol
    funcargs = funcsig.args[2:end]

    # Pull apart argument names and types
    args = Vector{Symbol}()
    argt = Vector{Union{Expr,Symbol}}()
    for ii in 1:length(funcargs)
        argex = funcargs[ii]
        if !isexpr(argex, :(::)) || !(argex.args[1] isa Symbol)
            error(
                "expected `name::type` expression in argument ", ii, ", got ", funcargs[ii]
            )
        end
        push!(args, argex.args[1])
        push!(argt, argex.args[2])
    end

    prefix, rest = split(string(jlfuncname), "_"; limit=2)
    # Translate the C function name to a local equivalent
    if haskey(bind_exceptions, jlfuncname)
        cfuncname = bind_exceptions[jlfuncname]
    else
        # turn e.g. h5f_close into H5Fclose
        cfuncname = Symbol(uppercase(prefix), rest)
        # Remove the version number if present (excluding match to literal "hdf5" suffix)
        if occursin(r"\d(?<!hdf5)$", String(jlfuncname))
            jlfuncname = Symbol(chop(String(jlfuncname); tail=1))
        end
    end

    # Store the function prototype in HDF5-module specific lists:
    funclist = get!(bound_api, uppercase(prefix), Vector{String}(undef, 0))
    string(jlfuncname) in funclist || push!(funclist, string(jlfuncname))
    # Also start building the matching doc string.
    docfunc = copy(funcsig)
    docfunc.args[1] = jlfuncname
    docstr = "    $docfunc"

    # Determine the underlying C library to call
    lib = startswith(string(cfuncname), r"H5(DO|DS|LT|TB)") ? :libhdf5_hl : :libhdf5

    # Now start building up the full expression:
    statsym = Symbol("#status#") # not using gensym() to have stable naming

    # The ccall(...) itself
    cfunclib = Expr(:tuple, quot(cfuncname), lib)
    ccallexpr = :(ccall($cfunclib, $rettype, ($(argt...),), $(args...)))

    # The error condition expression
    #  errexpr = :(@hdf5error($err))
    # avoid generating line numbers in macrocall
    errexpr = Expr(:macrocall, Symbol("@h5error"), nothing, err)
    if rettype === :Csize_t
        :($statsym == 0 % $rettype && $errexpr)
        # pass through
    elseif rettype === :haddr_t || rettype === :hsize_t
        # Error typically indicated by negative values, but some return types are unsigned
        # integers. From `H5public.h`:
        #   ADDR_UNDEF => (haddr_t)(-1)
        #   HSIZE_UNDEF => (hsize_t)(-1)
        # which are both just `-1 % $type` in Julia
        errexpr = :($statsym == -1 % $rettype && $errexpr)
    elseif isexpr(rettype, :curly) && rettype.args[1] === :Ptr
        errexpr = :($statsym == C_NULL && $errexpr)
    else
        errexpr = :($statsym < $rettype(0) && $errexpr)
    end

    # Three cases for handling the return type
    if rettype === :htri_t
        # Returns a Boolean on non-error
        returnexpr = :(return $statsym > 0)
        docstr *= " -> Bool"
    elseif rettype === :herr_t
        # Only used to indicate error status
        returnexpr = :(return nothing)
    elseif rettype === :Cint
        # Convert to Int type
        returnexpr = :(return Int($statsym))
        docstr *= " -> Int"
    else
        # Returns a value
        returnexpr = :(return $statsym)
        docstr *= " -> $rettype"
    end

    if prefix == "h5fd" && endswith(rest, "_init")
        # remove trailing _init
        drivername = rest[1:(end - 5)]
        docstr *=
            "\n\nThis function is exposed in `libhdf5` as the macro `H5FD_$(uppercase(drivername))`. " *
            "See `libhdf5` documentation for [`H5Pget_driver`]" *
            "(" *
            urldict["H5Pget_driver"] *
            ").\n"
    else
        docstr *=
            "\n\nSee `libhdf5` documentation for [`$cfuncname`]" *
            "(" *
            get(urldict, string(cfuncname), "https://docs.hdfgroup.org/hdf5/v1_14/") *
            ").\n"
    end
    # Then assemble the pieces. Doing it through explicit Expr() objects
    # avoids inserting the line number nodes for the macro --- the call site
    # is instead explicitly injected into the function body via __source__.
    jlfuncsig = Expr(:call, jlfuncname, args...)
    jlfuncbody = Expr(
        :block, __source__, :(lock(liblock)), :($statsym = try
            $ccallexpr
        finally
            unlock(liblock)
        end)
    )
    if errexpr !== nothing
        push!(jlfuncbody.args, errexpr)
    end
    push!(jlfuncbody.args, returnexpr)
    jlfuncexpr = Expr(:function, jlfuncsig, jlfuncbody)
    jlfuncexpr = Expr(:macrocall, Symbol("@doc"), nothing, docstr, jlfuncexpr)
    return jlfuncexpr
end

using HDF5
using Test

"""
    Test Set create_dataset

Test the combination of arguments to create_dataset.
"""

@testset "create_dataset" begin
    mktemp() do fn, io
        h5open(fn, "w") do h5f
            h5g = create_group(h5f, "test_group")

            # Arguments
            #  Test file and group
            parents = (h5f, h5g)
            # Test anonymous dattaset, String, and SubString
            names = (nothing, "test_dataset", @view("test_dataset"[1:4]))
            # Test primitive, HDF5.Datatype, non-primitive, non-primitive HDF5.Datatype
            types = (UInt8, datatype(UInt8), Complex{Float32}, datatype(Complex{Float32}))
            # Test Tuple, HDF5.Dataspace, two tuples (extendible), extendible HDF5.Dataspace
            spaces = (
                (3, 4),
                dataspace((16, 16)),
                ((4, 4), (8, 8)),
                dataspace((16, 16); max_dims=(32, 32))
            )
            # TODO: test keywords

            # Create argument cross product
            p = Iterators.product(parents, names, types, spaces)

            for (parent, name, type, space) in p
                try
                    # create a chunked dataset since contiguous datasets are not extendible
                    ds = create_dataset(parent, name, type, space; chunk=(2, 2))
                    @test datatype(ds) == datatype(type)
                    @test dataspace(ds) == dataspace(space)
                    @test isvalid(ds)
                    close(ds)
                    if !isnothing(name)
                        # if it is not an anonymous dataset, try to open it
                        ds2 = open_dataset(parent, name)
                        @test isvalid(ds2)
                        close(ds2)
                        delete_object(parent, name)
                    end
                catch err
                    throw(ArgumentError("""
                        Error occured with (
                            $parent :: $(typeof(parent)),
                            $name :: $(typeof(name)),
                            $type :: $(typeof(type)),
                            $space :: $(typeof(space)))
                    """))
                end
            end
        end
    end
end

using Test, HDF5

@testset "virtual dataset" begin
    dirname = mktempdir()

    filename = joinpath(dirname, "main.hdf5")

    h5open(filename, "w") do f
        sub0 = joinpath(dirname, "sub-0.hdf5")
        f0 = h5open(sub0, "w")
        f0["x"] = fill(1.0, 3)
        close(f0)

        sub1 = joinpath(dirname, "sub-1.hdf5")
        f1 = h5open(sub1, "w")
        f1["x"] = fill(2.0, 3)
        close(f1)

        srcspace = dataspace((3,))
        vspace = dataspace((3, 2); max_dims=(3, -1))
        HDF5.select_hyperslab!(vspace, (1:3, HDF5.BlockRange(1; count=-1)))

        d = create_dataset(
            f,
            "x",
            datatype(Float64),
            vspace;
            virtual=[HDF5.VirtualMapping(vspace, "./sub-%b.hdf5", "x", srcspace)]
        )

        @test size(d) == (3, 2)
        @test read(d) == hcat(fill(1.0, 3), fill(2.0, 3))

        dcpl = HDF5.get_create_properties(d)

        @test dcpl.virtual isa HDF5.VirtualLayout
        @test length(dcpl.virtual) == 1
        @test dcpl.virtual[1] isa HDF5.VirtualMapping
    end
end

# The context API is under active development. This is an internal API and may change.

"""
    HDF5Context

*Internal API*

An `HDF5Context` is a collection of HDF5 property lists. It is meant to be used
as a `Task` local mechanism to store state and change the default property lists
for new objects.

Use the function `get_context_property(name::Symbol)` to access a property
list within the local context.

The context in `task_local_storage()[:hdf5_context]` will be checked first.
A common global HDF5Context is stored in the constant `HDF5.CONTEXT` and
serves as the default context if the current task does not have a
`:hdf5_context`.

# Fields

* attribute_access
* attribute_create
* dataset_access
* dataset_create
* dataset_tranfer
* datatype_access
* datatype_create
* file_access
* file_create
* file_mount
* group_access
* group_create
* link_access
* link_create
* object_copy
* object_create
* string_create
"""
struct HDF5Context
    attribute_access :: AttributeAccessProperties
    attribute_create :: AttributeCreateProperties
    dataset_access   :: DatasetAccessProperties
    dataset_create   :: DatasetCreateProperties
    dataset_transfer :: DatasetTransferProperties
    datatype_access  :: DatatypeAccessProperties
    datatype_create  :: DatatypeCreateProperties
    file_access      :: FileAccessProperties
    file_create      :: FileCreateProperties
    file_mount       :: FileMountProperties
    group_access     :: GroupAccessProperties
    group_create     :: GroupCreateProperties
    link_access      :: LinkAccessProperties
    link_create      :: LinkCreateProperties
    object_copy      :: ObjectCopyProperties
    object_create    :: ObjectCreateProperties
    string_create    :: StringCreateProperties
end

Base.copy(ctx::HDF5Context) =
    HDF5Context(map(n -> copy(getfield(ctx, n)), fieldnames(HDF5Context))...)

Base.close(ctx::HDF5Context) =
    foreach(n -> close(getfield(ctx, n)), fieldnames(HDF5Context))

function HDF5Context()
    HDF5Context(
        AttributeAccessProperties(),
        AttributeCreateProperties(),
        DatasetAccessProperties(),
        DatasetCreateProperties(),
        DatasetTransferProperties(),
        DatatypeAccessProperties(),
        DatatypeCreateProperties(),
        FileAccessProperties(),
        FileCreateProperties(),
        FileMountProperties(),
        GroupAccessProperties(),
        GroupCreateProperties(),
        LinkAccessProperties(),
        LinkCreateProperties(),
        ObjectCopyProperties(),
        ObjectCreateProperties(),
        StringCreateProperties(),
    )
end

"""
    HDF5.CONTEXT

*Internal API*

Default `HDF5Context`.
"""
const CONTEXT = HDF5Context()

"""
    get_context_property(name::Symbol)

*Internal API*

Retrieve a property list from the task local context, defaulting to
`HDF5.CONTEXT` if `task_local_storage()[:hdf5_context]` does not
exist.
"""
get_context_property(name::Symbol) =
    getfield(get(task_local_storage(), :hdf5_context, CONTEXT), name)

module API

using Libdl: dlopen, dlclose, dlpath, dlsym, RTLD_LAZY, RTLD_NODELETE
using Base: StringVector
using Preferences: @load_preference, delete_preferences!, set_preferences!
using UUIDs: UUID

const _PREFERENCE_LIBHDF5 = @load_preference("libhdf5", nothing)
const _PREFERENCE_LIBHDF5_HL = @load_preference("libhdf5_hl", nothing)
if _PREFERENCE_LIBHDF5 === nothing && _PREFERENCE_LIBHDF5_HL === nothing
    using HDF5_jll
elseif _PREFERENCE_LIBHDF5 !== nothing && _PREFERENCE_LIBHDF5_HL === nothing
    error("You have only set a preference for the path of libhdf5, but not of libhdf5_hl.")
elseif _PREFERENCE_LIBHDF5 === nothing && _PREFERENCE_LIBHDF5_HL !== nothing
    error("You have only set a preference for the path of libhdf5_hl, but not of libhdf5.")
else
    libhdf5 = _PREFERENCE_LIBHDF5
    libhdf5_hl = _PREFERENCE_LIBHDF5_HL
    # Check whether we can open the libraries
    flags = RTLD_LAZY | RTLD_NODELETE
    dlopen(libhdf5, flags; throw_error=true)
    dlopen(libhdf5_hl, flags; throw_error=true)
    libhdf5_size = filesize(dlpath(libhdf5))
end

const HDF5_JL_UUID = UUID("f67ccb44-e63f-5c2f-98bd-6dc0ccc4ba2f")
const HDF5_JLL_JL_UUID = UUID("0234f1f7-429e-5d53-9886-15a909be8d59")

"""
    set_libraries!(libhdf5 = nothing, libhdf5_hl = nothing; force = true)

Convenience function to set the preferences for a system-provided HDF5 library.
Pass the paths pointing to the libraries `libhdf5` and `libhdf5_hl` as strings
to set the preference. If `libhdf5` and `libhdf5_hl` are `nothing` use the default,
i.e. the binaries provided by HDF5_jll.jl.
"""
function set_libraries!(libhdf5=nothing, libhdf5_hl=nothing; force=true)
    if isnothing(libhdf5) && isnothing(libhdf5_hl)
        delete_preferences!(HDF5_JL_UUID, "libhdf5"; force)
        delete_preferences!(HDF5_JL_UUID, "libhdf5_hl"; force)
        delete_preferences!(HDF5_JLL_JL_UUID, "libhdf5_path", "libhdf5_hl_path"; force)
        @info "The libraries from HDF5_jll will be used."
    elseif isnothing(libhdf5) || isnothing(libhdf5_hl)
        throw(
            ArgumentError(
                "Specify either no positional arguments or both positional arguments."
            )
        )
    else
        isfile(libhdf5) || throw(ArgumentError("$libhdf5 is not a file that exists."))
        isfile(libhdf5_hl) || throw(ArgumentError("$libhdf5_hl is not a file that exists."))
        set_preferences!(HDF5_JL_UUID, "libhdf5" => libhdf5; force)
        set_preferences!(HDF5_JL_UUID, "libhdf5_hl" => libhdf5_hl; force)
        # Also set the HDF5_jll override settings in case some other package tries to use HDF5_jll
        set_preferences!(
            HDF5_JLL_JL_UUID, "libhdf5_path" => libhdf5, "libhdf5_hl_path" => libhdf5_hl
        )
    end
    @info "Please restart Julia and reload HDF5.jl for the library changes to take effect"
end

include("lock.jl")
include("types.jl")
include("error.jl")
include("functions.jl") # core API ccall wrappers
include("helpers.jl")

function __init__()
    # HDF5.API.__init__() is run before HDF5.__init__()

    # Ensure this is reinitialized on using
    libhdf5handle[] = dlopen(libhdf5)

    # Warn if the environment is set and does not agree with Preferences.jl 
    if haskey(ENV, "JULIA_HDF5_PATH")
        if _PREFERENCE_LIBHDF5 === nothing
            @warn "The environment variable JULIA_HDF5_PATH is deprecated and ignored. Use Preferences.jl as detailed in the documentation." ENV["JULIA_HDF5_PATH"] _PREFERENCE_LIBHDF5
        elseif !startswith(_PREFERENCE_LIBHDF5, ENV["JULIA_HDF5_PATH"])
            @warn "The environment variable JULIA_HDF5_PATH is deprecated and does not agree with the Preferences.jl setting." ENV["JULIA_HDF5_PATH"] _PREFERENCE_LIBHDF5
        else
            @debug "The environment variable JULIA_HDF5_PATH is set and agrees with the Preferences.jl setting." ENV["JULIA_HDF5_PATH"] _PREFERENCE_LIBHDF5
        end
    end
    # Disable file locking as that can cause problems with mmap'ing.
    # File locking is disabled in HDF5.init!(::FileAccessPropertyList)
    # or here if h5p_set_file_locking is not available
    @static if !has_h5p_set_file_locking() && !haskey(ENV, "HDF5_USE_FILE_LOCKING")
        ENV["HDF5_USE_FILE_LOCKING"] = "FALSE"
    end

    # use our own error handling machinery (i.e. turn off automatic error printing)
    h5e_set_auto(API.H5E_DEFAULT, C_NULL, C_NULL)
end

end # module API

# Configuration

```@meta
CurrentModule = HDF5
```

```@docs
has_parallel
has_ros3
```

## Display

```@docs
SHOW_TREE_ICONS
SHOW_TREE_MAX_CHILDREN
SHOW_TREE_MAX_DEPTH
```

## Internals

```@docs
get_context_property
CONTEXT
HDF5Context
```

## System Libraries

```@docs
API.set_libraries!
```

```@meta
CurrentModule = HDF5
DocTestSetup = quote
    using HDF5
end
```

# HDF5.jl

## Overview

[HDF5](https://www.hdfgroup.org/solutions/hdf5/) stands for Hierarchical Data Format v5 and is closely modeled on file systems. In HDF5, a "group" is analogous to a directory, a "dataset" is like a file. HDF5 also uses "attributes" to associate metadata with a particular group or dataset. HDF5 uses ASCII names for these different objects, and objects can be accessed by Unix-like pathnames, e.g., "/sample1/tempsensor/firsttrial" for a top-level group "sample1", a subgroup "tempsensor", and a dataset "firsttrial".

For simple types (scalars, strings, and arrays), HDF5 provides sufficient metadata to know how each item is to be interpreted. For example, HDF5 encodes that a given block of bytes is to be interpreted as an array of `Int64`, and represents them in a way that is compatible across different computing architectures.

However, to preserve Julia objects, one generally needs additional type information to be supplied,
which is easy to provide using attributes. This is handled for you automatically in the [JLD](https://github.com/JuliaIO/JLD.jl)/[JLD2](https://github.com/JuliaIO/JLD2.jl). These specific formats (conventions) provide "extra" functionality, but they are still both regular
HDF5 files and are therefore compatible with any HDF5 reader or writer.

Language wrappers for HDF5 are often described as either "low level" or "high level." This package contains both flavors: at the low level, it directly wraps HDF5's functions, thus copying their API and making them available from within Julia. At the high level, it provides a set of functions built on the low-level wrap which may make the usage of this library more convenient.

## Installation

```julia
julia>]
pkg> add HDF5
```

Starting from Julia 1.3, the HDF5 binaries are by default downloaded using the `HDF5_jll` package.

### Using custom or system provided HDF5 binaries

!!! note "Migration from HDF5.jl v0.16 and earlier"
    How to use a system-provided HDF5 library has been changed in HDF5.jl v0.17. Previously,
    the library path was set by the environment variable `JULIA_HDF5_PATH`, which required to
    rebuild HDF5.jl afterwards. The environment variable has been removed and no longer has an
    effect (for backward compatibility it is still recommended to **also** set the environment
    variable). Instead, proceed as described below.

To use system-provided HDF5 binaries instead, set the preferences `libhdf5` and `libhdf5_hl`, see also [Preferences.jl](https://github.com/JuliaPackaging/Preferences.jl). These need to point to the local paths of the libraries `libhdf5` and `libhdf5_hl`.

For example, to use HDF5 (`libhdf5-mpich-dev`) with MPI using system libraries on Ubuntu 20.04, you would run

```sh
$ sudo apt install mpich libhdf5-mpich-dev
```

If your system HDF5 library is compiled with MPI, you need to tell MPI.jl to use the same locally installed MPI implementation. This can be done in Julia by running:

```julia
using MPIPreferences
MPIPreferences.use_system_binary()
```

to set the MPI preferences, see the [documentation of MPI.jl](https://juliaparallel.org/MPI.jl/stable/configuration/). You can set the path to the system library using [Preferences.jl](https://github.com/JuliaPackaging/Preferences.jl) by:

```julia
using Preferences, HDF5

set_preferences!(
    HDF5,
    "libhdf5" => "/usr/lib/x86_64-linux-gnu/hdf5/mpich/libhdf5.so",
    "libhdf5_hl" => "/usr/lib/x86_64-linux-gnu/hdf5/mpich/libhdf5_hl.so", force = true)
```

Alternatively, HDF5.jl provides a convenience function [`HDF5.API.set_libraries!`](@ref) that can be used as follows:
```julia
using HDF5

HDF5.API.set_libraries!("/usr/lib/x86_64-linux-gnu/hdf5/mpich/libhdf5.so", "/usr/lib/x86_64-linux-gnu/hdf5/mpich/libhdf5_hl.so")
```
Going back to the default, i.e. deleting the preferences again, can be done by calling `HDF5.API.set_libraries!()`.
If HDF5 cannot be loaded, it may be useful to use the UUID to change these settings:

```julia
using Preferences, UUIDs

set_preferences!(
    UUID("f67ccb44-e63f-5c2f-98bd-6dc0ccc4ba2f"), # UUID of HDF5.jl
    "libhdf5" => "/usr/lib/x86_64-linux-gnu/hdf5/mpich/libhdf5.so",
    "libhdf5_hl" => "/usr/lib/x86_64-linux-gnu/hdf5/mpich/libhdf5_hl.so", force = true)
```

Also see the file `test/configure_packages.jl` for an example.

Both, the MPI preferences and the preferences for HDF5.jl write to a file called LocalPreferences.toml in the project directory. After performing the described steps this file could look like the following:

```toml
[MPIPreferences]
_format = "1.0"
abi = "MPICH"
binary = "system"
libmpi = "/software/mpi/lib/libmpi.so"
mpiexec = "/software/mpi/bin/mpiexec"

[HDF5]
libhdf5 = "/usr/lib/x86_64-linux-gnu/hdf5/mpich/libhdf5.so"
libhdf5_hl = "/usr/lib/x86_64-linux-gnu/hdf5/mpich/libhdf5_hl.so"
```

If you want to switch to another HDF5 library or the library moved, you can call the `set_preferences!` commands again (or manually edit LocalPreferences.toml) to set the new paths. Using the default implementation provided by HDF5_jll can be done by simply manually deleting the LocalPreferences.toml file.

## Opening and closing files

"Plain" (i.e., with no extra formatting conventions) HDF5 files are created and/or opened with the `h5open` command:

```julia
fid = h5open(filename, mode)
```

The mode can be any one of the following:

| mode | Meaning                                                             |
| :--- | :------------------------------------------------------------------ |
| "r"  | read-only                                                           |
| "r+" | read-write, preserving any existing contents                        |
| "cw" | read-write, create file if not existing, preserve existing contents |
| "w"  | read-write, destroying any existing contents (if any)               |

For example

```@repl main
using HDF5
fname = tempname(); # temporary file
fid = h5open(fname, "w")
```

This produces an object of type `HDF5File`, a subtype of the abstract type `DataFile`. This file will have no elements (groups, datasets, or attributes) that are not explicitly created by the user.

When you're finished with a file, you should close it:

```julia
close(fid)
```

Closing a file also closes any other open objects (e.g., datasets, groups) in that file. In general, you need to close an HDF5 file to "release" it for use by other applications.

## Creating a group or dataset

Groups can be created via the function [`create_group`](@ref)

```@repl main
create_group(fid, "mygroup")
```

We can write the `"mydataset"` by indexing into `fid`. This also happens to write data to the dataset.

```@repl main
fid["mydataset"] = rand()
```

Alternatively, we can call [`create_dataset`](@ref), which does not write data to the dataset. It merely creates the dataset.

```@repl main
create_dataset(fid, "myvector", Int, (10,))
```

Creating a dataset within a group is as simple as indexing into the group with the name of the dataset or calling [`create_dataset`](@ref) with the group as the first argument.

```@repl main
g = fid["mygroup"]
g["mydataset"] = "Hello World!"
create_dataset(g, "myvector", Int, (10,))
```

The `do` syntax is also supported. The file, group, and dataset handles will automatically be closed after the `do` block terminates.

```@repl main
h5open("example2.h5", "w") do fid
    g = create_group(fid, "mygroup")
    dset = create_dataset(g, "myvector", Float64, (10,))
    write(dset,rand(10))
end
```

## Opening and closing objects

If you have a file object `fid`, and this has a group or dataset called `"mygroup"` at the top level of a file, you can open it in the following way:

```@repl main
obj = fid["mygroup"]
```

This does not read any data or attributes associated with the object, it's simply a handle for further manipulations. For example:

```@repl main
g = fid["mygroup"]
dset = g["mydataset"]
```

or simply

```@repl main
dset = fid["mygroup/mydataset"]
```

When you're done with an object, you can close it using `close(obj)`. If you forget to do this, it will be closed for you anyway when the file is closed, or if `obj` goes out of scope and gets garbage collected.

## Reading and writing data

Suppose you have a group `g` which contains a dataset with path `"mydataset"`, and that you've also opened this dataset as `dset = g["mydataset"]`.
You can read information in this dataset in any of the following ways:

```julia
A = read(dset)
A = read(g, "mydataset")
Asub = dset[2:3, 1:3]
```

The last syntax reads just a subset of the data array (assuming that `dset` is an array of sufficient size).
libhdf5 has internal mechanisms for slicing arrays, and consequently if you need only a small piece of a large array, it can be faster to read just what you need rather than reading the entire array and discarding most of it.

Datasets can be created with either

```julia
g["mydataset"] = rand(3,5)
write(g, "mydataset", rand(3,5))
```

One can use the high level interface `load` and `save` from `FileIO`, where an optional `OrderedDict` can be passed (`track_order` inferred). Note that using `track_order=true` or passing an `OrderedDict` is a promise that the read file has been created with the appropriate ordering flags.

```julia
julia> using OrderedCollections, FileIO
julia> save("track_order.h5", OrderedDict("z"=>1, "a"=>2, "g/f"=>3, "g/b"=>4))
julia> load("track_order.h5"; dict=OrderedDict())
OrderedDict{Any, Any} with 4 entries:
  "z"   => 1
  "a"   => 2
  "g/f" => 3
  "g/b" => 4
```

## Passing parameters

It is often required to pass parameters to specific routines, which are collected
in so-called property lists in HDF5. There are different property lists for
different tasks, e.g. for the access/creation of files, datasets, groups.
In this high level framework multiple parameters can be simply applied by
appending them at the end of function calls as keyword arguments.

```julia
g["A"] = A  # basic
g["A", chunk=(5,5)] = A # add chunks

B = h5read(fn,"mygroup/B", # two parameters
  fapl_mpio=(ccomm,cinfo), # if parameter requires multiple args use tuples
  dxpl_mpio=HDF5.H5FD_MPIO_COLLECTIVE )
```

This will automatically create the correct property lists, add the properties,
and apply the property list while reading/writing the data.
The naming of the properties generally follows that of HDF5, i.e. the key
`fapl_mpio` returns the HDF5 functions `h5pget/set_fapl_mpio` and their
corresponding property list type `H5P_FILE_ACCESS`.
The complete list if routines and their interfaces is available at the
[H5P: Property List Interface](https://portal.hdfgroup.org/display/HDF5/Property+Lists)
documentation. Note that not all properties are available. When searching
for a property check whether the corresponding `h5pget/set` functions are
available.

## Chunking and compression

You can also optionally "chunk" and/or compress your data. For example,

```julia
A = rand(100,100)
g["A", chunk=(5,5)] = A
```

stores the matrix `A` in 5-by-5 chunks. Chunking improves efficiency if you
write or extract small segments or slices of an array, if these are not stored
contiguously.

```julia
A = rand(100,100)
g1["A", chunk=(5,5), compress=3] = A
g2["A", chunk=(5,5), shuffle=(), deflate=3] = A
using H5Zblosc # load in Blosc
g3["A", chunk=(5,5), blosc=3] = A
```

Standard compression in HDF5 (`"compress"`) corresponds to (`"deflate"`) and
uses the [deflate/zlib](http://en.wikipedia.org/wiki/DEFLATE) algorithm. The
deflate algorithm is often more efficient if prefixed by a `"shuffle"` filter.
Blosc is generally much faster than deflate -- however, reading Blosc-compressed
HDF5 files require Blosc to be installed. This is the case for Julia, but often
not for vanilla HDF5 distributions that may be used outside Julia. (In this
case, the structure of the HDF5 file is still accessible, but compressed
datasets cannot be read.) Compression requires chunking, and heuristic chunking
is automatically used if you specify compression but don't specify chunking.

It is also possible to write to subsets of an on-disk HDF5 dataset. This is
useful to incrementally save to very large datasets you don't want to keep in
memory. For example,

```julia
dset = create_dataset(g, "B", datatype(Float64), dataspace(1000,100,10), chunk=(100,100,1))
dset[:,1,1] = rand(1000)
```

creates a Float64 dataset in the file or group `g`, with dimensions 1000x100x10, and then
writes to just the first 1000 element slice.
If you know the typical size of subset reasons you'll be reading/writing, it can be beneficial to set the chunk dimensions appropriately.

For fine-grained control of filter and compression pipelines, please use the [`filters`](@ref Filters) keyword to define a filter pipeline. For example, this can be used to include external filter packages. This enables the use of Blosc, Bzip2, LZ4, ZStandard, or custom filter plugins.

## Memory mapping

If you will frequently be accessing individual elements or small regions of array datasets, it can be substantially more efficient to bypass HDF5 routines and use direct [memory mapping](https://en.wikipedia.org/wiki/Memory-mapped_file).
This is possible only under particular conditions: when the dataset is an array of standard "bits" types (e.g., `Float64` or `Int32`) and no chunking/compression is being used.
You can use the `ismmappable` function to test whether this is possible; for example,

```julia
dset = g["x"]
if HDF5.ismmappable(dset)
    dset = HDF5.readmmap(dset)
end
val = dset[15]
```

Note that `readmmap` returns an `Array` rather than an HDF5 object.

**Note**: if you use `readmmap` on a dataset and subsequently close the file, the array data are still available---and file continues to be in use---until all of the arrays are garbage-collected.
This is in contrast to standard HDF5 datasets, where closing the file prevents further access to any of the datasets, but the file is also detached and can safely be rewritten immediately.

Under the default
[allocation-time policy](https://portal.hdfgroup.org/display/HDF5/H5P_SET_ALLOC_TIME),
a newly added `ismmappable` dataset can only be memory mapped after it has been written
to.
The following fails:

```julia
vec_dset = create_dataset(g, "v", datatype(Float64), dataspace(10_000,1))
HDF5.ismmappable(vec_dset)    # == true
vec = HDF5.readmmap(vec_dset) # throws ErrorException("Error mmapping array")
```

because although the dataset description has been added, the space within the HDF5 file
has not yet actually been allocated (so the file region cannot be memory mapped by the OS).
The storage can be allocated by making at least one write:

```julia
vec_dset[1,1] = 0.0      # force allocation of /g/v within the file
vec = HDF5.readmmap(vec_dset) # and now the memory mapping can succeed
```

Alternatively, the policy can be set so that the space is allocated immediately upon
creation of the data set with the `alloc_time` keyword:

```julia
mtx_dset = create_dataset(g, "M", datatype(Float64), dataspace(100, 1000),
                    alloc_time = HDF5.H5D_ALLOC_TIME_EARLY)
mtx = HDF5.readmmap(mtx_dset) # succeeds immediately
```

## In-memory HDF5 files

It is possible to use HDF5 files without writing or reading from disk. This is useful when receiving or sending data over the network. Typically, when sending data, one might want to
1) Create a new file in memory. This can be achieved by passing `Drivers.Core(; backing_store=false)` to `h5open(...)`
2) Add data to the `HDF5.File` object
3) Get a representation of the file as a byte vector. This can be achieved by calling `Vector{UInt8}(...)` on the file object.

This is illustrated on the example below
```julia
using HDF5

# Creates a new file object without storing to disk by setting `backing_store=false`
file_as_bytes = h5open("AnyName_InMemory", "w"; driver=Drivers.Core(; backing_store=false)) do fid
   fid["MyData"] = randn(5, 5) # add some data
   return Vector{UInt8}(fid) # get a byte vector to send, e.g., using HTTP, MQTT or similar.
end
```

The same way, when receiving data as a vector of bytes that represent a HDF5 file, one can use `h5open(...)` with the byte vector as first argument to get a file object.
Creating a file object from a byte vector will also by default open the file in memory, without saving a copy on disk.
 ```julia
using HDF5

...
h5open(file_as_bytes, "r"; name = "in_memory.h5") do fid
... # Do things with the data
end
...
```

## Supported data types

`HDF5.jl` knows how to store values of the following types: signed and unsigned integers of 8, 16, 32, and 64 bits, `Float32`, `Float64`; `Complex` versions of these numeric types; `Array`s of these numeric types (including complex versions); `String`; and `Array`s of `String`.
`Array`s of strings are supported using HDF5's variable-length-strings facility.
By default `Complex` numbers are stored as compound types with `r` and `i` fields following the `h5py` convention.
When reading data, compound types with matching field names will be loaded as the corresponding `Complex` Julia type.
These field names are configurable with the `HDF5.set_complex_field_names(real::AbstractString, imag::AbstractString)` function and complex support can be completely enabled/disabled with `HDF5.enable/disable_complex_support()`.

As of HDF5.jl version 0.16.13, support was added to map Julia structs to compound HDF5 datatypes.

```jldoctest
julia> struct Point3{T}
           x::T
           y::T
           z::T
       end

julia> datatype(Point3{Float64})
HDF5.Datatype: H5T_COMPOUND {
      H5T_IEEE_F64LE "x" : 0;
      H5T_IEEE_F64LE "y" : 8;
      H5T_IEEE_F64LE "z" : 16;
   }
```

For `Array`s, note that the array dimensionality is preserved, including 0-length
dimensions:

```julia
fid["zero_vector"] = zeros(0)
fid["zero_matrix"] = zeros(0, 0)
size(fid["zero_vector"]) # == (0,)
size(fid["zero_matrix"]) # == (0, 0)
```

An _exception_ to this rule is Julia's 0-dimensional `Array`, which is stored as an HDF5
scalar because there is a value to be preserved:

```julia
fid["zero_dim_value"] = fill(1.0π)
read(fid["zero_dim_value"]) # == 3.141592653589793, != [3.141592653589793]
```

HDF5 also has the concept of a null array which contains a type but has neither size nor
contents, which is represented by the type `HDF5.EmptyArray`:

```julia
fid["empty_array"] = HDF5.EmptyArray{Float32}()
HDF5.isnull(fid["empty_array"]) # == true
size(fid["empty_array"]) # == ()
eltype(fid["empty_array"]) # == Float32
```

This module also supports HDF5's VLEN, OPAQUE, and REFERENCE types, which can be used to encode more complex types. In general, you need to specify how you want to combine these more advanced facilities to represent more complex data types. For many of the data types in Julia, the JLD module implements support. You can likewise define your own file format if, for example, you need to interact with some external program that has explicit formatting requirements.

## Creating groups and attributes

Create a new group in the following way:

```julia
g = create_group(parent, name)
```

The named group will be created as a child of the parent.

Attributes can be created using

```julia
attributes(parent)[name] = value
```

where `attributes` simply indicates that the object referenced by `name` (a string) is an attribute, not another group or dataset. (Datasets cannot have child datasets, but groups can have either.) `value` must be a simple type: `BitsKind`s, strings, and arrays of either of these. The HDF5 standard recommends against storing large objects as attributes.

The value stored in an attribute can be retrieved like
```julia
read_attribute(parent, name)
```
You can also access the value of an attribute by indexing, like so:
```julia
julia> attr = attributes(parent)[name];
julia> attr[]
```

## Getting information

```julia
HDF5.name(obj)
```

will return the full HDF5 pathname of object `obj`.

```julia
keys(g)
```

returns a string array containing all objects inside group `g`. These relative pathnames, not absolute pathnames.

You can iterate over the objects in a group, i.e.,

```julia
for obj in g
  data = read(obj)
  println(data)
end
```

This gives you a straightforward way of recursively exploring an entire HDF5 file.

If you need to know whether group `g` has a dataset named `mydata`, you can test that with

```julia
if haskey(g, "mydata")
   ...
end
tf = haskey(g, "mydata")
```

If instead you want to know whether `g` has an attribute named `myattribute`, do it this way:

```julia
tf = haskey(attributes(g), "myattribute")
```

If you have an HDF5 object, and you want to know where it fits in the hierarchy of the file, the following can be useful:

```julia
p = parent(obj)     # p is the parent object (usually a group)
fn = HDF5.filename(obj)  # fn is a string
g = HDF5.root(obj)       # g is the group "/"
```

For array objects (datasets and attributes) the following methods work:

```
dims = size(dset)
nd = ndims(dset)
len = length(dset)
```

Objects can be created with properties, and you can query those
properties in the following way:

```
p = HDF5.get_create_properties(dset)
chunksz = HDF5.get_chunk(p)
```

The simpler syntax `chunksz = HDF5.get_chunk(dset)` is also available.

Finally, sometimes you need to be able to conveniently test whether a file is an HDF5 file:

```julia
tf = HDF5.ishdf5(filename)
```

## Mid-level routines

Sometimes you might want more fine-grained control, which can be achieved using a different set of routines. For example,

```julia
g = open_group(parent, name)
dset = open_dataset(parent, name[, apl])
attr = open_attribute(parent, name)
t = open_datatype(parent, name)
```

These open the named group, dataset, attribute, and committed datatype, respectively. For datasets, `apl` stands for "access parameter list" and provides opportunities for more sophisticated control (see the [HDF5](https://www.hdfgroup.org/solutions/hdf5/) documentation).

New objects can be created in the following ways:

```julia
g = create_group(parent, name[, lcpl, gcpl]; properties...)
dset = create_dataset(parent, name, data; properties...)
attr = create_attribute(parent, name, data)
```

creates groups, datasets, and attributes without writing any data to them. You can then use `write(obj, data)` to store the data. The optional properties and property lists allow even more fine-grained control. This syntax uses `data` to infer the object's "HDF5.datatype" and "HDF5.dataspace"; for the most explicit control, `data` can be replaced with `dtype, dspace`, where `dtype` is an `HDF5.Datatype` and `dspace` is an `HDF5.Dataspace`.

Analogously, to create committed data types, use

```julia
t = commit_datatype(parent, name, dtype[, lcpl, tcpl, tapl])
```

You can create and write data in one step,

```julia
write_dataset(parent, name, data; properties...)
write_attribute(parent, name, data)
```

You can use extendible dimensions,

```julia
d = create_dataset(parent, name, dtype, (dims, max_dims), chunk=(chunk_dims))
HDF5.set_extent_dims(d, new_dims)
```

where dims is a tuple of integers. For example

```julia
b = create_dataset(fid, "b", Int, ((1000,),(-1,)), chunk=(100,)) #-1 is equivalent to typemax(hsize_t)
HDF5.set_extent_dims(b, (10000,))
b[1:10000] = collect(1:10000)
```

when dimensions are reduced, the truncated data is lost. A maximum dimension of -1 is often referred to as unlimited dimensions, though it is limited by the maximum size of an unsigned integer.

You can copy data from one file to another:

```julia
copy_object(source, data_name, target, name)
copy_object(source[data_name], target, name)
```

Finally, it's possible to delete objects:

```julia
delete_object(parent, name)   # for groups, datasets, and datatypes
delete_attribute(parent, name)   # for attributes
```

## Low-level routines

Many of the most commonly-used libhdf5 functions have been wrapped in a submodule `API`. The library follows a consistent convention: for example, libhdf5's `H5Adelete` is wrapped with a Julia function called `h5a_delete`. The arguments are exactly as specified in the [HDF5](https://www.hdfgroup.org/solutions/hdf5/) reference manual. Note that the functions in the `API` submodule are not exported, so unless you import them specifically, you need to preface them with `HDF5.API` to use them: for example, `HDF5.API.h5a_delete`.

HDF5 is a large library, and the low-level wrap is not complete. However, many of the most-commonly used functions are wrapped, and in general wrapping a new function takes only a single line of code. Users who need additional functionality are encouraged to contribute it.

Note that Julia's HDF5 directly uses the "2" interfaces, e.g., `H5Dcreate2`, so you need to have version 1.8 of the HDF5 library or later.


## Language interoperability with row- and column-major order arrays

There are two main methods for storing multidimensional arrays in linear storage [row-major order and column-major order](https://en.wikipedia.org/wiki/Row-_and_column-major_order). Julia, like Fortran and MATLAB, stores multidimensional arrays in column-major order, while other languages, including C and Python (NumPy), use row-major order. Therefore when reading an array in Julia from row-major order language the dimensions may be inverted.

To read a multidimensional array into the original shape from an HDF5 file written by Python (`numpy` and `h5py`) or C/C++/Objective-C, simply reverse the dimensions. For example, one may add the following line after reading the dataset `dset`:
```julia
dset = permutedims(dset, reverse(1:ndims(dset)))
```

Note that some languages or libraries use both methods, so please check the datset's description for details. For example, NumPy arrays are row-major by default, but NumPy can use either row-major or column-major ordered arrays.

## Credits

- Konrad Hinsen initiated Julia's support for HDF5

- Tim Holy and Simon Kornblith (primary authors)

- Tom Short contributed code and ideas to the dictionary-like
  interface

- Blake Johnson made several improvements, such as support for
  iterating over attributes

- Isaiah Norton and Elliot Saba improved installation on Windows and OSX

- Steve Johnson contributed the `do` syntax and Blosc compression

- Mike Nolta and Jameson Nash contributed code or suggestions for
  improving the handling of HDF5's constants

- Thanks also to the users who have reported bugs and tested fixes

```@raw html
<!-- This file is auto-generated and should not be manually editted. To update, run the
gen/gen_wrappers.jl script -->
```
```@meta
CurrentModule = HDF5.API
```

# Low-level library bindings

At the lowest level, `HDF5.jl` operates by calling the public API of the HDF5 shared
library through a set of `ccall` wrapper functions.
This page documents the function names and nominal C argument types of the API which
have bindings in this package.
Note that in many cases, high-level data types are valid arguments through automatic
`ccall` conversions.
For instance, `HDF5.Datatype` objects will be automatically converted to their `hid_t` ID
by Julia's `cconvert`+`unsafe_convert` `ccall` rules.

There are additional helper wrappers (often for out-argument functions) which are not
documented here.

---

## [[`H5`](https://docs.hdfgroup.org/hdf5/v1_14/group___h5.html) — General Library Functions](@id H5)
- [`h5_close`](@ref h5_close)
- [`h5_dont_atexit`](@ref h5_dont_atexit)
- [`h5_free_memory`](@ref h5_free_memory)
- [`h5_garbage_collect`](@ref h5_garbage_collect)
- [`h5_get_libversion`](@ref h5_get_libversion)
- [`h5_is_library_threadsafe`](@ref h5_is_library_threadsafe)
- [`h5_open`](@ref h5_open)
- [`h5_set_free_list_limits`](@ref h5_set_free_list_limits)
```@docs
h5_close
h5_dont_atexit
h5_free_memory
h5_garbage_collect
h5_get_libversion
h5_is_library_threadsafe
h5_open
h5_set_free_list_limits
```

---

## [[`H5A`](https://docs.hdfgroup.org/hdf5/v1_14/group___h5_a.html) — Attribute Interface](@id H5A)
- [`h5a_close`](@ref h5a_close)
- [`h5a_create`](@ref h5a_create)
- [`h5a_create_by_name`](@ref h5a_create_by_name)
- [`h5a_delete`](@ref h5a_delete)
- [`h5a_delete_by_idx`](@ref h5a_delete_by_idx)
- [`h5a_delete_by_name`](@ref h5a_delete_by_name)
- [`h5a_exists`](@ref h5a_exists)
- [`h5a_exists_by_name`](@ref h5a_exists_by_name)
- [`h5a_get_create_plist`](@ref h5a_get_create_plist)
- [`h5a_get_name`](@ref h5a_get_name)
- [`h5a_get_name_by_idx`](@ref h5a_get_name_by_idx)
- [`h5a_get_space`](@ref h5a_get_space)
- [`h5a_get_type`](@ref h5a_get_type)
- [`h5a_iterate`](@ref h5a_iterate)
- [`h5a_open`](@ref h5a_open)
- [`h5a_open_by_idx`](@ref h5a_open_by_idx)
- [`h5a_read`](@ref h5a_read)
- [`h5a_rename`](@ref h5a_rename)
- [`h5a_write`](@ref h5a_write)
```@docs
h5a_close
h5a_create
h5a_create_by_name
h5a_delete
h5a_delete_by_idx
h5a_delete_by_name
h5a_exists
h5a_exists_by_name
h5a_get_create_plist
h5a_get_name
h5a_get_name_by_idx
h5a_get_space
h5a_get_type
h5a_iterate
h5a_open
h5a_open_by_idx
h5a_read
h5a_rename
h5a_write
```

---

## [[`H5D`](https://docs.hdfgroup.org/hdf5/v1_14/group___h5_d.html) — Dataset Interface](@id H5D)
- [`h5d_chunk_iter`](@ref h5d_chunk_iter)
- [`h5d_close`](@ref h5d_close)
- [`h5d_create`](@ref h5d_create)
- [`h5d_create_anon`](@ref h5d_create_anon)
- [`h5d_extend`](@ref h5d_extend)
- [`h5d_fill`](@ref h5d_fill)
- [`h5d_flush`](@ref h5d_flush)
- [`h5d_gather`](@ref h5d_gather)
- [`h5d_get_access_plist`](@ref h5d_get_access_plist)
- [`h5d_get_chunk_info`](@ref h5d_get_chunk_info)
- [`h5d_get_chunk_info_by_coord`](@ref h5d_get_chunk_info_by_coord)
- [`h5d_get_chunk_storage_size`](@ref h5d_get_chunk_storage_size)
- [`h5d_get_create_plist`](@ref h5d_get_create_plist)
- [`h5d_get_num_chunks`](@ref h5d_get_num_chunks)
- [`h5d_get_offset`](@ref h5d_get_offset)
- [`h5d_get_space`](@ref h5d_get_space)
- [`h5d_get_space_status`](@ref h5d_get_space_status)
- [`h5d_get_storage_size`](@ref h5d_get_storage_size)
- [`h5d_get_type`](@ref h5d_get_type)
- [`h5d_iterate`](@ref h5d_iterate)
- [`h5d_open`](@ref h5d_open)
- [`h5d_read`](@ref h5d_read)
- [`h5d_read_chunk`](@ref h5d_read_chunk)
- [`h5d_refresh`](@ref h5d_refresh)
- [`h5d_scatter`](@ref h5d_scatter)
- [`h5d_set_extent`](@ref h5d_set_extent)
- [`h5d_vlen_get_buf_size`](@ref h5d_vlen_get_buf_size)
- [`h5d_vlen_reclaim`](@ref h5d_vlen_reclaim)
- [`h5d_write`](@ref h5d_write)
- [`h5d_write_chunk`](@ref h5d_write_chunk)
```@docs
h5d_chunk_iter
h5d_close
h5d_create
h5d_create_anon
h5d_extend
h5d_fill
h5d_flush
h5d_gather
h5d_get_access_plist
h5d_get_chunk_info
h5d_get_chunk_info_by_coord
h5d_get_chunk_storage_size
h5d_get_create_plist
h5d_get_num_chunks
h5d_get_offset
h5d_get_space
h5d_get_space_status
h5d_get_storage_size
h5d_get_type
h5d_iterate
h5d_open
h5d_read
h5d_read_chunk
h5d_refresh
h5d_scatter
h5d_set_extent
h5d_vlen_get_buf_size
h5d_vlen_reclaim
h5d_write
h5d_write_chunk
```

---

## [[`H5E`](https://docs.hdfgroup.org/hdf5/v1_14/group___h5_e.html) — Error Interface](@id H5E)
- [`h5e_close_stack`](@ref h5e_close_stack)
- [`h5e_get_auto`](@ref h5e_get_auto)
- [`h5e_get_current_stack`](@ref h5e_get_current_stack)
- [`h5e_get_msg`](@ref h5e_get_msg)
- [`h5e_get_num`](@ref h5e_get_num)
- [`h5e_set_auto`](@ref h5e_set_auto)
- [`h5e_walk`](@ref h5e_walk)
```@docs
h5e_close_stack
h5e_get_auto
h5e_get_current_stack
h5e_get_msg
h5e_get_num
h5e_set_auto
h5e_walk
```

---

## [[`H5F`](https://docs.hdfgroup.org/hdf5/v1_14/group___h5_f.html) — File Interface](@id H5F)
- [`h5f_clear_elink_file_cache`](@ref h5f_clear_elink_file_cache)
- [`h5f_close`](@ref h5f_close)
- [`h5f_create`](@ref h5f_create)
- [`h5f_delete`](@ref h5f_delete)
- [`h5f_flush`](@ref h5f_flush)
- [`h5f_format_convert`](@ref h5f_format_convert)
- [`h5f_get_access_plist`](@ref h5f_get_access_plist)
- [`h5f_get_create_plist`](@ref h5f_get_create_plist)
- [`h5f_get_dset_no_attrs_hint`](@ref h5f_get_dset_no_attrs_hint)
- [`h5f_get_eoa`](@ref h5f_get_eoa)
- [`h5f_get_file_image`](@ref h5f_get_file_image)
- [`h5f_get_fileno`](@ref h5f_get_fileno)
- [`h5f_get_filesize`](@ref h5f_get_filesize)
- [`h5f_get_free_sections`](@ref h5f_get_free_sections)
- [`h5f_get_freespace`](@ref h5f_get_freespace)
- [`h5f_get_info`](@ref h5f_get_info)
- [`h5f_get_intent`](@ref h5f_get_intent)
- [`h5f_get_mdc_config`](@ref h5f_get_mdc_config)
- [`h5f_get_mdc_hit_rate`](@ref h5f_get_mdc_hit_rate)
- [`h5f_get_mdc_image_info`](@ref h5f_get_mdc_image_info)
- [`h5f_get_mdc_logging_status`](@ref h5f_get_mdc_logging_status)
- [`h5f_get_mdc_size`](@ref h5f_get_mdc_size)
- [`h5f_get_metadata_read_retry_info`](@ref h5f_get_metadata_read_retry_info)
- [`h5f_get_mpi_atomicity`](@ref h5f_get_mpi_atomicity)
- [`h5f_get_name`](@ref h5f_get_name)
- [`h5f_get_obj_count`](@ref h5f_get_obj_count)
- [`h5f_get_obj_ids`](@ref h5f_get_obj_ids)
- [`h5f_get_page_buffering_stats`](@ref h5f_get_page_buffering_stats)
- [`h5f_get_vfd_handle`](@ref h5f_get_vfd_handle)
- [`h5f_increment_filesize`](@ref h5f_increment_filesize)
- [`h5f_is_accessible`](@ref h5f_is_accessible)
- [`h5f_is_hdf5`](@ref h5f_is_hdf5)
- [`h5f_mount`](@ref h5f_mount)
- [`h5f_open`](@ref h5f_open)
- [`h5f_reopen`](@ref h5f_reopen)
- [`h5f_reset_mdc_hit_rate_stats`](@ref h5f_reset_mdc_hit_rate_stats)
- [`h5f_reset_page_buffering_stats`](@ref h5f_reset_page_buffering_stats)
- [`h5f_set_dset_no_attrs_hint`](@ref h5f_set_dset_no_attrs_hint)
- [`h5f_set_libver_bounds`](@ref h5f_set_libver_bounds)
- [`h5f_set_mdc_config`](@ref h5f_set_mdc_config)
- [`h5f_set_mpi_atomicity`](@ref h5f_set_mpi_atomicity)
- [`h5f_start_mdc_logging`](@ref h5f_start_mdc_logging)
- [`h5f_start_swmr_write`](@ref h5f_start_swmr_write)
- [`h5f_stop_mdc_logging`](@ref h5f_stop_mdc_logging)
- [`h5f_unmount`](@ref h5f_unmount)
```@docs
h5f_clear_elink_file_cache
h5f_close
h5f_create
h5f_delete
h5f_flush
h5f_format_convert
h5f_get_access_plist
h5f_get_create_plist
h5f_get_dset_no_attrs_hint
h5f_get_eoa
h5f_get_file_image
h5f_get_fileno
h5f_get_filesize
h5f_get_free_sections
h5f_get_freespace
h5f_get_info
h5f_get_intent
h5f_get_mdc_config
h5f_get_mdc_hit_rate
h5f_get_mdc_image_info
h5f_get_mdc_logging_status
h5f_get_mdc_size
h5f_get_metadata_read_retry_info
h5f_get_mpi_atomicity
h5f_get_name
h5f_get_obj_count
h5f_get_obj_ids
h5f_get_page_buffering_stats
h5f_get_vfd_handle
h5f_increment_filesize
h5f_is_accessible
h5f_is_hdf5
h5f_mount
h5f_open
h5f_reopen
h5f_reset_mdc_hit_rate_stats
h5f_reset_page_buffering_stats
h5f_set_dset_no_attrs_hint
h5f_set_libver_bounds
h5f_set_mdc_config
h5f_set_mpi_atomicity
h5f_start_mdc_logging
h5f_start_swmr_write
h5f_stop_mdc_logging
h5f_unmount
```

---

## [[`H5G`](https://docs.hdfgroup.org/hdf5/v1_14/group___h5_g.html) — Group Interface](@id H5G)
- [`h5g_close`](@ref h5g_close)
- [`h5g_create`](@ref h5g_create)
- [`h5g_get_create_plist`](@ref h5g_get_create_plist)
- [`h5g_get_info`](@ref h5g_get_info)
- [`h5g_get_num_objs`](@ref h5g_get_num_objs)
- [`h5g_get_objname_by_idx`](@ref h5g_get_objname_by_idx)
- [`h5g_open`](@ref h5g_open)
```@docs
h5g_close
h5g_create
h5g_get_create_plist
h5g_get_info
h5g_get_num_objs
h5g_get_objname_by_idx
h5g_open
```

---

## [[`H5I`](https://docs.hdfgroup.org/hdf5/v1_14/group___h5_i.html) — Identifier Interface](@id H5I)
- [`h5i_dec_ref`](@ref h5i_dec_ref)
- [`h5i_get_file_id`](@ref h5i_get_file_id)
- [`h5i_get_name`](@ref h5i_get_name)
- [`h5i_get_ref`](@ref h5i_get_ref)
- [`h5i_get_type`](@ref h5i_get_type)
- [`h5i_inc_ref`](@ref h5i_inc_ref)
- [`h5i_is_valid`](@ref h5i_is_valid)
```@docs
h5i_dec_ref
h5i_get_file_id
h5i_get_name
h5i_get_ref
h5i_get_type
h5i_inc_ref
h5i_is_valid
```

---

## [[`H5L`](https://docs.hdfgroup.org/hdf5/v1_14/group___h5_l.html) — Link Interface](@id H5L)
- [`h5l_create_external`](@ref h5l_create_external)
- [`h5l_create_hard`](@ref h5l_create_hard)
- [`h5l_create_soft`](@ref h5l_create_soft)
- [`h5l_delete`](@ref h5l_delete)
- [`h5l_exists`](@ref h5l_exists)
- [`h5l_get_info`](@ref h5l_get_info)
- [`h5l_get_name_by_idx`](@ref h5l_get_name_by_idx)
- [`h5l_iterate`](@ref h5l_iterate)
- [`h5l_move`](@ref h5l_move)
```@docs
h5l_create_external
h5l_create_hard
h5l_create_soft
h5l_delete
h5l_exists
h5l_get_info
h5l_get_name_by_idx
h5l_iterate
h5l_move
```

---

## [[`H5O`](https://docs.hdfgroup.org/hdf5/v1_14/group___h5_o.html) — Object Interface](@id H5O)
- [`h5o_are_mdc_flushes_disabled`](@ref h5o_are_mdc_flushes_disabled)
- [`h5o_close`](@ref h5o_close)
- [`h5o_copy`](@ref h5o_copy)
- [`h5o_decr_refcount`](@ref h5o_decr_refcount)
- [`h5o_disable_mdc_flushes`](@ref h5o_disable_mdc_flushes)
- [`h5o_enable_mdc_flushes`](@ref h5o_enable_mdc_flushes)
- [`h5o_exists_by_name`](@ref h5o_exists_by_name)
- [`h5o_flush`](@ref h5o_flush)
- [`h5o_get_comment`](@ref h5o_get_comment)
- [`h5o_get_comment_by_name`](@ref h5o_get_comment_by_name)
- [`h5o_get_info`](@ref h5o_get_info)
- [`h5o_get_info1`](@ref h5o_get_info1)
- [`h5o_get_info_by_idx`](@ref h5o_get_info_by_idx)
- [`h5o_get_info_by_name`](@ref h5o_get_info_by_name)
- [`h5o_get_native_info`](@ref h5o_get_native_info)
- [`h5o_get_native_info_by_idx`](@ref h5o_get_native_info_by_idx)
- [`h5o_get_native_info_by_name`](@ref h5o_get_native_info_by_name)
- [`h5o_incr_refcount`](@ref h5o_incr_refcount)
- [`h5o_link`](@ref h5o_link)
- [`h5o_open`](@ref h5o_open)
- [`h5o_open_by_addr`](@ref h5o_open_by_addr)
- [`h5o_open_by_idx`](@ref h5o_open_by_idx)
- [`h5o_refresh`](@ref h5o_refresh)
- [`h5o_set_comment`](@ref h5o_set_comment)
- [`h5o_set_comment_by_name`](@ref h5o_set_comment_by_name)
- [`h5o_token_cmp`](@ref h5o_token_cmp)
- [`h5o_token_from_str`](@ref h5o_token_from_str)
- [`h5o_token_to_str`](@ref h5o_token_to_str)
- [`h5o_visit`](@ref h5o_visit)
- [`h5o_visit_by_name`](@ref h5o_visit_by_name)
```@docs
h5o_are_mdc_flushes_disabled
h5o_close
h5o_copy
h5o_decr_refcount
h5o_disable_mdc_flushes
h5o_enable_mdc_flushes
h5o_exists_by_name
h5o_flush
h5o_get_comment
h5o_get_comment_by_name
h5o_get_info
h5o_get_info1
h5o_get_info_by_idx
h5o_get_info_by_name
h5o_get_native_info
h5o_get_native_info_by_idx
h5o_get_native_info_by_name
h5o_incr_refcount
h5o_link
h5o_open
h5o_open_by_addr
h5o_open_by_idx
h5o_refresh
h5o_set_comment
h5o_set_comment_by_name
h5o_token_cmp
h5o_token_from_str
h5o_token_to_str
h5o_visit
h5o_visit_by_name
```

---

## [[`H5PL`](https://docs.hdfgroup.org/hdf5/v1_14/group___h5_p_l.html) — Plugin Interface](@id H5PL)
- [`h5pl_append`](@ref h5pl_append)
- [`h5pl_get`](@ref h5pl_get)
- [`h5pl_get_loading_state`](@ref h5pl_get_loading_state)
- [`h5pl_insert`](@ref h5pl_insert)
- [`h5pl_prepend`](@ref h5pl_prepend)
- [`h5pl_remove`](@ref h5pl_remove)
- [`h5pl_replace`](@ref h5pl_replace)
- [`h5pl_set_loading_state`](@ref h5pl_set_loading_state)
- [`h5pl_size`](@ref h5pl_size)
```@docs
h5pl_append
h5pl_get
h5pl_get_loading_state
h5pl_insert
h5pl_prepend
h5pl_remove
h5pl_replace
h5pl_set_loading_state
h5pl_size
```

---

## [[`H5P`](https://docs.hdfgroup.org/hdf5/v1_14/group___h5_p.html) — Property Interface](@id H5P)
- [`h5p_add_merge_committed_dtype_path`](@ref h5p_add_merge_committed_dtype_path)
- [`h5p_all_filters_avail`](@ref h5p_all_filters_avail)
- [`h5p_close`](@ref h5p_close)
- [`h5p_close_class`](@ref h5p_close_class)
- [`h5p_copy`](@ref h5p_copy)
- [`h5p_copy_prop`](@ref h5p_copy_prop)
- [`h5p_create`](@ref h5p_create)
- [`h5p_create_class`](@ref h5p_create_class)
- [`h5p_decode`](@ref h5p_decode)
- [`h5p_encode`](@ref h5p_encode)
- [`h5p_equal`](@ref h5p_equal)
- [`h5p_exist`](@ref h5p_exist)
- [`h5p_fill_value_defined`](@ref h5p_fill_value_defined)
- [`h5p_free_merge_committed_dtype_paths`](@ref h5p_free_merge_committed_dtype_paths)
- [`h5p_get`](@ref h5p_get)
- [`h5p_get_alignment`](@ref h5p_get_alignment)
- [`h5p_get_alloc_time`](@ref h5p_get_alloc_time)
- [`h5p_get_append_flush`](@ref h5p_get_append_flush)
- [`h5p_get_attr_creation_order`](@ref h5p_get_attr_creation_order)
- [`h5p_get_attr_phase_change`](@ref h5p_get_attr_phase_change)
- [`h5p_get_btree_ratios`](@ref h5p_get_btree_ratios)
- [`h5p_get_buffer`](@ref h5p_get_buffer)
- [`h5p_get_cache`](@ref h5p_get_cache)
- [`h5p_get_char_encoding`](@ref h5p_get_char_encoding)
- [`h5p_get_chunk`](@ref h5p_get_chunk)
- [`h5p_get_chunk_cache`](@ref h5p_get_chunk_cache)
- [`h5p_get_chunk_opts`](@ref h5p_get_chunk_opts)
- [`h5p_get_class`](@ref h5p_get_class)
- [`h5p_get_class_name`](@ref h5p_get_class_name)
- [`h5p_get_class_parent`](@ref h5p_get_class_parent)
- [`h5p_get_copy_object`](@ref h5p_get_copy_object)
- [`h5p_get_core_write_tracking`](@ref h5p_get_core_write_tracking)
- [`h5p_get_create_intermediate_group`](@ref h5p_get_create_intermediate_group)
- [`h5p_get_data_transform`](@ref h5p_get_data_transform)
- [`h5p_get_driver`](@ref h5p_get_driver)
- [`h5p_get_driver_info`](@ref h5p_get_driver_info)
- [`h5p_get_dset_no_attrs_hint`](@ref h5p_get_dset_no_attrs_hint)
- [`h5p_get_dxpl_mpio`](@ref h5p_get_dxpl_mpio)
- [`h5p_get_edc_check`](@ref h5p_get_edc_check)
- [`h5p_get_efile_prefix`](@ref h5p_get_efile_prefix)
- [`h5p_get_elink_acc_flags`](@ref h5p_get_elink_acc_flags)
- [`h5p_get_elink_cb`](@ref h5p_get_elink_cb)
- [`h5p_get_elink_fapl`](@ref h5p_get_elink_fapl)
- [`h5p_get_elink_file_cache_size`](@ref h5p_get_elink_file_cache_size)
- [`h5p_get_elink_prefix`](@ref h5p_get_elink_prefix)
- [`h5p_get_est_link_info`](@ref h5p_get_est_link_info)
- [`h5p_get_evict_on_close`](@ref h5p_get_evict_on_close)
- [`h5p_get_external`](@ref h5p_get_external)
- [`h5p_get_external_count`](@ref h5p_get_external_count)
- [`h5p_get_family_offset`](@ref h5p_get_family_offset)
- [`h5p_get_fapl_core`](@ref h5p_get_fapl_core)
- [`h5p_get_fapl_family`](@ref h5p_get_fapl_family)
- [`h5p_get_fapl_hdfs`](@ref h5p_get_fapl_hdfs)
- [`h5p_get_fapl_mpio`](@ref h5p_get_fapl_mpio)
- [`h5p_get_fapl_multi`](@ref h5p_get_fapl_multi)
- [`h5p_get_fapl_ros3`](@ref h5p_get_fapl_ros3)
- [`h5p_get_fapl_splitter`](@ref h5p_get_fapl_splitter)
- [`h5p_get_fclose_degree`](@ref h5p_get_fclose_degree)
- [`h5p_get_file_image`](@ref h5p_get_file_image)
- [`h5p_get_file_image_callbacks`](@ref h5p_get_file_image_callbacks)
- [`h5p_get_file_locking`](@ref h5p_get_file_locking)
- [`h5p_get_file_space`](@ref h5p_get_file_space)
- [`h5p_get_file_space_page_size`](@ref h5p_get_file_space_page_size)
- [`h5p_get_file_space_strategy`](@ref h5p_get_file_space_strategy)
- [`h5p_get_fill_time`](@ref h5p_get_fill_time)
- [`h5p_get_fill_value`](@ref h5p_get_fill_value)
- [`h5p_get_filter`](@ref h5p_get_filter)
- [`h5p_get_filter_by_id`](@ref h5p_get_filter_by_id)
- [`h5p_get_gc_references`](@ref h5p_get_gc_references)
- [`h5p_get_hyper_vector_size`](@ref h5p_get_hyper_vector_size)
- [`h5p_get_istore_k`](@ref h5p_get_istore_k)
- [`h5p_get_layout`](@ref h5p_get_layout)
- [`h5p_get_libver_bounds`](@ref h5p_get_libver_bounds)
- [`h5p_get_link_creation_order`](@ref h5p_get_link_creation_order)
- [`h5p_get_link_phase_change`](@ref h5p_get_link_phase_change)
- [`h5p_get_local_heap_size_hint`](@ref h5p_get_local_heap_size_hint)
- [`h5p_get_mcdt_search_cb`](@ref h5p_get_mcdt_search_cb)
- [`h5p_get_mdc_config`](@ref h5p_get_mdc_config)
- [`h5p_get_mdc_image_config`](@ref h5p_get_mdc_image_config)
- [`h5p_get_mdc_log_options`](@ref h5p_get_mdc_log_options)
- [`h5p_get_meta_block_size`](@ref h5p_get_meta_block_size)
- [`h5p_get_metadata_read_attempts`](@ref h5p_get_metadata_read_attempts)
- [`h5p_get_multi_type`](@ref h5p_get_multi_type)
- [`h5p_get_nfilters`](@ref h5p_get_nfilters)
- [`h5p_get_nlinks`](@ref h5p_get_nlinks)
- [`h5p_get_nprops`](@ref h5p_get_nprops)
- [`h5p_get_obj_track_times`](@ref h5p_get_obj_track_times)
- [`h5p_get_object_flush_cb`](@ref h5p_get_object_flush_cb)
- [`h5p_get_page_buffer_size`](@ref h5p_get_page_buffer_size)
- [`h5p_get_preserve`](@ref h5p_get_preserve)
- [`h5p_get_shared_mesg_index`](@ref h5p_get_shared_mesg_index)
- [`h5p_get_shared_mesg_nindexes`](@ref h5p_get_shared_mesg_nindexes)
- [`h5p_get_shared_mesg_phase_change`](@ref h5p_get_shared_mesg_phase_change)
- [`h5p_get_sieve_buf_size`](@ref h5p_get_sieve_buf_size)
- [`h5p_get_size`](@ref h5p_get_size)
- [`h5p_get_sizes`](@ref h5p_get_sizes)
- [`h5p_get_small_data_block_size`](@ref h5p_get_small_data_block_size)
- [`h5p_get_sym_k`](@ref h5p_get_sym_k)
- [`h5p_get_type_conv_cb`](@ref h5p_get_type_conv_cb)
- [`h5p_get_userblock`](@ref h5p_get_userblock)
- [`h5p_get_version`](@ref h5p_get_version)
- [`h5p_get_virtual_count`](@ref h5p_get_virtual_count)
- [`h5p_get_virtual_dsetname`](@ref h5p_get_virtual_dsetname)
- [`h5p_get_virtual_filename`](@ref h5p_get_virtual_filename)
- [`h5p_get_virtual_prefix`](@ref h5p_get_virtual_prefix)
- [`h5p_get_virtual_printf_gap`](@ref h5p_get_virtual_printf_gap)
- [`h5p_get_virtual_srcspace`](@ref h5p_get_virtual_srcspace)
- [`h5p_get_virtual_view`](@ref h5p_get_virtual_view)
- [`h5p_get_virtual_vspace`](@ref h5p_get_virtual_vspace)
- [`h5p_get_vlen_mem_manager`](@ref h5p_get_vlen_mem_manager)
- [`h5p_get_vol_id`](@ref h5p_get_vol_id)
- [`h5p_get_vol_info`](@ref h5p_get_vol_info)
- [`h5p_insert`](@ref h5p_insert)
- [`h5p_isa_class`](@ref h5p_isa_class)
- [`h5p_iterate`](@ref h5p_iterate)
- [`h5p_modify_filter`](@ref h5p_modify_filter)
- [`h5p_register`](@ref h5p_register)
- [`h5p_remove`](@ref h5p_remove)
- [`h5p_remove_filter`](@ref h5p_remove_filter)
- [`h5p_set`](@ref h5p_set)
- [`h5p_set_alignment`](@ref h5p_set_alignment)
- [`h5p_set_alloc_time`](@ref h5p_set_alloc_time)
- [`h5p_set_append_flush`](@ref h5p_set_append_flush)
- [`h5p_set_attr_creation_order`](@ref h5p_set_attr_creation_order)
- [`h5p_set_attr_phase_change`](@ref h5p_set_attr_phase_change)
- [`h5p_set_btree_ratios`](@ref h5p_set_btree_ratios)
- [`h5p_set_buffer`](@ref h5p_set_buffer)
- [`h5p_set_cache`](@ref h5p_set_cache)
- [`h5p_set_char_encoding`](@ref h5p_set_char_encoding)
- [`h5p_set_chunk`](@ref h5p_set_chunk)
- [`h5p_set_chunk_cache`](@ref h5p_set_chunk_cache)
- [`h5p_set_chunk_opts`](@ref h5p_set_chunk_opts)
- [`h5p_set_copy_object`](@ref h5p_set_copy_object)
- [`h5p_set_core_write_tracking`](@ref h5p_set_core_write_tracking)
- [`h5p_set_create_intermediate_group`](@ref h5p_set_create_intermediate_group)
- [`h5p_set_data_transform`](@ref h5p_set_data_transform)
- [`h5p_set_deflate`](@ref h5p_set_deflate)
- [`h5p_set_driver`](@ref h5p_set_driver)
- [`h5p_set_dset_no_attrs_hint`](@ref h5p_set_dset_no_attrs_hint)
- [`h5p_set_dxpl_mpio`](@ref h5p_set_dxpl_mpio)
- [`h5p_set_edc_check`](@ref h5p_set_edc_check)
- [`h5p_set_efile_prefix`](@ref h5p_set_efile_prefix)
- [`h5p_set_elink_acc_flags`](@ref h5p_set_elink_acc_flags)
- [`h5p_set_elink_cb`](@ref h5p_set_elink_cb)
- [`h5p_set_elink_fapl`](@ref h5p_set_elink_fapl)
- [`h5p_set_elink_file_cache_size`](@ref h5p_set_elink_file_cache_size)
- [`h5p_set_elink_prefix`](@ref h5p_set_elink_prefix)
- [`h5p_set_est_link_info`](@ref h5p_set_est_link_info)
- [`h5p_set_evict_on_close`](@ref h5p_set_evict_on_close)
- [`h5p_set_external`](@ref h5p_set_external)
- [`h5p_set_family_offset`](@ref h5p_set_family_offset)
- [`h5p_set_fapl_core`](@ref h5p_set_fapl_core)
- [`h5p_set_fapl_family`](@ref h5p_set_fapl_family)
- [`h5p_set_fapl_hdfs`](@ref h5p_set_fapl_hdfs)
- [`h5p_set_fapl_log`](@ref h5p_set_fapl_log)
- [`h5p_set_fapl_mpio`](@ref h5p_set_fapl_mpio)
- [`h5p_set_fapl_multi`](@ref h5p_set_fapl_multi)
- [`h5p_set_fapl_ros3`](@ref h5p_set_fapl_ros3)
- [`h5p_set_fapl_sec2`](@ref h5p_set_fapl_sec2)
- [`h5p_set_fapl_split`](@ref h5p_set_fapl_split)
- [`h5p_set_fapl_splitter`](@ref h5p_set_fapl_splitter)
- [`h5p_set_fapl_stdio`](@ref h5p_set_fapl_stdio)
- [`h5p_set_fapl_windows`](@ref h5p_set_fapl_windows)
- [`h5p_set_fclose_degree`](@ref h5p_set_fclose_degree)
- [`h5p_set_file_image`](@ref h5p_set_file_image)
- [`h5p_set_file_image_callbacks`](@ref h5p_set_file_image_callbacks)
- [`h5p_set_file_locking`](@ref h5p_set_file_locking)
- [`h5p_set_file_space`](@ref h5p_set_file_space)
- [`h5p_set_file_space_page_size`](@ref h5p_set_file_space_page_size)
- [`h5p_set_file_space_strategy`](@ref h5p_set_file_space_strategy)
- [`h5p_set_fill_time`](@ref h5p_set_fill_time)
- [`h5p_set_fill_value`](@ref h5p_set_fill_value)
- [`h5p_set_filter`](@ref h5p_set_filter)
- [`h5p_set_filter_callback`](@ref h5p_set_filter_callback)
- [`h5p_set_fletcher32`](@ref h5p_set_fletcher32)
- [`h5p_set_gc_references`](@ref h5p_set_gc_references)
- [`h5p_set_hyper_vector_size`](@ref h5p_set_hyper_vector_size)
- [`h5p_set_istore_k`](@ref h5p_set_istore_k)
- [`h5p_set_layout`](@ref h5p_set_layout)
- [`h5p_set_libver_bounds`](@ref h5p_set_libver_bounds)
- [`h5p_set_link_creation_order`](@ref h5p_set_link_creation_order)
- [`h5p_set_link_phase_change`](@ref h5p_set_link_phase_change)
- [`h5p_set_local_heap_size_hint`](@ref h5p_set_local_heap_size_hint)
- [`h5p_set_mcdt_search_cb`](@ref h5p_set_mcdt_search_cb)
- [`h5p_set_mdc_config`](@ref h5p_set_mdc_config)
- [`h5p_set_mdc_image_config`](@ref h5p_set_mdc_image_config)
- [`h5p_set_mdc_log_options`](@ref h5p_set_mdc_log_options)
- [`h5p_set_meta_block_size`](@ref h5p_set_meta_block_size)
- [`h5p_set_metadata_read_attempts`](@ref h5p_set_metadata_read_attempts)
- [`h5p_set_multi_type`](@ref h5p_set_multi_type)
- [`h5p_set_nbit`](@ref h5p_set_nbit)
- [`h5p_set_nlinks`](@ref h5p_set_nlinks)
- [`h5p_set_obj_track_times`](@ref h5p_set_obj_track_times)
- [`h5p_set_object_flush_cb`](@ref h5p_set_object_flush_cb)
- [`h5p_set_page_buffer_size`](@ref h5p_set_page_buffer_size)
- [`h5p_set_preserve`](@ref h5p_set_preserve)
- [`h5p_set_scaleoffset`](@ref h5p_set_scaleoffset)
- [`h5p_set_shared_mesg_index`](@ref h5p_set_shared_mesg_index)
- [`h5p_set_shared_mesg_nindexes`](@ref h5p_set_shared_mesg_nindexes)
- [`h5p_set_shared_mesg_phase_change`](@ref h5p_set_shared_mesg_phase_change)
- [`h5p_set_shuffle`](@ref h5p_set_shuffle)
- [`h5p_set_sieve_buf_size`](@ref h5p_set_sieve_buf_size)
- [`h5p_set_sizes`](@ref h5p_set_sizes)
- [`h5p_set_small_data_block_size`](@ref h5p_set_small_data_block_size)
- [`h5p_set_sym_k`](@ref h5p_set_sym_k)
- [`h5p_set_szip`](@ref h5p_set_szip)
- [`h5p_set_type_conv_cb`](@ref h5p_set_type_conv_cb)
- [`h5p_set_userblock`](@ref h5p_set_userblock)
- [`h5p_set_virtual`](@ref h5p_set_virtual)
- [`h5p_set_virtual_prefix`](@ref h5p_set_virtual_prefix)
- [`h5p_set_virtual_printf_gap`](@ref h5p_set_virtual_printf_gap)
- [`h5p_set_virtual_view`](@ref h5p_set_virtual_view)
- [`h5p_set_vlen_mem_manager`](@ref h5p_set_vlen_mem_manager)
- [`h5p_set_vol`](@ref h5p_set_vol)
- [`h5p_unregister`](@ref h5p_unregister)
```@docs
h5p_add_merge_committed_dtype_path
h5p_all_filters_avail
h5p_close
h5p_close_class
h5p_copy
h5p_copy_prop
h5p_create
h5p_create_class
h5p_decode
h5p_encode
h5p_equal
h5p_exist
h5p_fill_value_defined
h5p_free_merge_committed_dtype_paths
h5p_get
h5p_get_alignment
h5p_get_alloc_time
h5p_get_append_flush
h5p_get_attr_creation_order
h5p_get_attr_phase_change
h5p_get_btree_ratios
h5p_get_buffer
h5p_get_cache
h5p_get_char_encoding
h5p_get_chunk
h5p_get_chunk_cache
h5p_get_chunk_opts
h5p_get_class
h5p_get_class_name
h5p_get_class_parent
h5p_get_copy_object
h5p_get_core_write_tracking
h5p_get_create_intermediate_group
h5p_get_data_transform
h5p_get_driver
h5p_get_driver_info
h5p_get_dset_no_attrs_hint
h5p_get_dxpl_mpio
h5p_get_edc_check
h5p_get_efile_prefix
h5p_get_elink_acc_flags
h5p_get_elink_cb
h5p_get_elink_fapl
h5p_get_elink_file_cache_size
h5p_get_elink_prefix
h5p_get_est_link_info
h5p_get_evict_on_close
h5p_get_external
h5p_get_external_count
h5p_get_family_offset
h5p_get_fapl_core
h5p_get_fapl_family
h5p_get_fapl_hdfs
h5p_get_fapl_mpio
h5p_get_fapl_multi
h5p_get_fapl_ros3
h5p_get_fapl_splitter
h5p_get_fclose_degree
h5p_get_file_image
h5p_get_file_image_callbacks
h5p_get_file_locking
h5p_get_file_space
h5p_get_file_space_page_size
h5p_get_file_space_strategy
h5p_get_fill_time
h5p_get_fill_value
h5p_get_filter
h5p_get_filter_by_id
h5p_get_gc_references
h5p_get_hyper_vector_size
h5p_get_istore_k
h5p_get_layout
h5p_get_libver_bounds
h5p_get_link_creation_order
h5p_get_link_phase_change
h5p_get_local_heap_size_hint
h5p_get_mcdt_search_cb
h5p_get_mdc_config
h5p_get_mdc_image_config
h5p_get_mdc_log_options
h5p_get_meta_block_size
h5p_get_metadata_read_attempts
h5p_get_multi_type
h5p_get_nfilters
h5p_get_nlinks
h5p_get_nprops
h5p_get_obj_track_times
h5p_get_object_flush_cb
h5p_get_page_buffer_size
h5p_get_preserve
h5p_get_shared_mesg_index
h5p_get_shared_mesg_nindexes
h5p_get_shared_mesg_phase_change
h5p_get_sieve_buf_size
h5p_get_size
h5p_get_sizes
h5p_get_small_data_block_size
h5p_get_sym_k
h5p_get_type_conv_cb
h5p_get_userblock
h5p_get_version
h5p_get_virtual_count
h5p_get_virtual_dsetname
h5p_get_virtual_filename
h5p_get_virtual_prefix
h5p_get_virtual_printf_gap
h5p_get_virtual_srcspace
h5p_get_virtual_view
h5p_get_virtual_vspace
h5p_get_vlen_mem_manager
h5p_get_vol_id
h5p_get_vol_info
h5p_insert
h5p_isa_class
h5p_iterate
h5p_modify_filter
h5p_register
h5p_remove
h5p_remove_filter
h5p_set
h5p_set_alignment
h5p_set_alloc_time
h5p_set_append_flush
h5p_set_attr_creation_order
h5p_set_attr_phase_change
h5p_set_btree_ratios
h5p_set_buffer
h5p_set_cache
h5p_set_char_encoding
h5p_set_chunk
h5p_set_chunk_cache
h5p_set_chunk_opts
h5p_set_copy_object
h5p_set_core_write_tracking
h5p_set_create_intermediate_group
h5p_set_data_transform
h5p_set_deflate
h5p_set_driver
h5p_set_dset_no_attrs_hint
h5p_set_dxpl_mpio
h5p_set_edc_check
h5p_set_efile_prefix
h5p_set_elink_acc_flags
h5p_set_elink_cb
h5p_set_elink_fapl
h5p_set_elink_file_cache_size
h5p_set_elink_prefix
h5p_set_est_link_info
h5p_set_evict_on_close
h5p_set_external
h5p_set_family_offset
h5p_set_fapl_core
h5p_set_fapl_family
h5p_set_fapl_hdfs
h5p_set_fapl_log
h5p_set_fapl_mpio
h5p_set_fapl_multi
h5p_set_fapl_ros3
h5p_set_fapl_sec2
h5p_set_fapl_split
h5p_set_fapl_splitter
h5p_set_fapl_stdio
h5p_set_fapl_windows
h5p_set_fclose_degree
h5p_set_file_image
h5p_set_file_image_callbacks
h5p_set_file_locking
h5p_set_file_space
h5p_set_file_space_page_size
h5p_set_file_space_strategy
h5p_set_fill_time
h5p_set_fill_value
h5p_set_filter
h5p_set_filter_callback
h5p_set_fletcher32
h5p_set_gc_references
h5p_set_hyper_vector_size
h5p_set_istore_k
h5p_set_layout
h5p_set_libver_bounds
h5p_set_link_creation_order
h5p_set_link_phase_change
h5p_set_local_heap_size_hint
h5p_set_mcdt_search_cb
h5p_set_mdc_config
h5p_set_mdc_image_config
h5p_set_mdc_log_options
h5p_set_meta_block_size
h5p_set_metadata_read_attempts
h5p_set_multi_type
h5p_set_nbit
h5p_set_nlinks
h5p_set_obj_track_times
h5p_set_object_flush_cb
h5p_set_page_buffer_size
h5p_set_preserve
h5p_set_scaleoffset
h5p_set_shared_mesg_index
h5p_set_shared_mesg_nindexes
h5p_set_shared_mesg_phase_change
h5p_set_shuffle
h5p_set_sieve_buf_size
h5p_set_sizes
h5p_set_small_data_block_size
h5p_set_sym_k
h5p_set_szip
h5p_set_type_conv_cb
h5p_set_userblock
h5p_set_virtual
h5p_set_virtual_prefix
h5p_set_virtual_printf_gap
h5p_set_virtual_view
h5p_set_vlen_mem_manager
h5p_set_vol
h5p_unregister
```

---

## [[`H5R`](https://docs.hdfgroup.org/hdf5/v1_14/group___h5_r.html) — Reference Interface](@id H5R)
- [`h5r_create`](@ref h5r_create)
- [`h5r_dereference`](@ref h5r_dereference)
- [`h5r_get_obj_type`](@ref h5r_get_obj_type)
- [`h5r_get_region`](@ref h5r_get_region)
```@docs
h5r_create
h5r_dereference
h5r_get_obj_type
h5r_get_region
```

---

## [[`H5S`](https://docs.hdfgroup.org/hdf5/v1_14/group___h5_s.html) — Dataspace Interface](@id H5S)
- [`h5s_close`](@ref h5s_close)
- [`h5s_combine_hyperslab`](@ref h5s_combine_hyperslab)
- [`h5s_combine_select`](@ref h5s_combine_select)
- [`h5s_copy`](@ref h5s_copy)
- [`h5s_create`](@ref h5s_create)
- [`h5s_create_simple`](@ref h5s_create_simple)
- [`h5s_extent_copy`](@ref h5s_extent_copy)
- [`h5s_extent_equal`](@ref h5s_extent_equal)
- [`h5s_get_regular_hyperslab`](@ref h5s_get_regular_hyperslab)
- [`h5s_get_select_bounds`](@ref h5s_get_select_bounds)
- [`h5s_get_select_elem_npoints`](@ref h5s_get_select_elem_npoints)
- [`h5s_get_select_elem_pointlist`](@ref h5s_get_select_elem_pointlist)
- [`h5s_get_select_hyper_blocklist`](@ref h5s_get_select_hyper_blocklist)
- [`h5s_get_select_hyper_nblocks`](@ref h5s_get_select_hyper_nblocks)
- [`h5s_get_select_npoints`](@ref h5s_get_select_npoints)
- [`h5s_get_select_type`](@ref h5s_get_select_type)
- [`h5s_get_simple_extent_dims`](@ref h5s_get_simple_extent_dims)
- [`h5s_get_simple_extent_ndims`](@ref h5s_get_simple_extent_ndims)
- [`h5s_get_simple_extent_type`](@ref h5s_get_simple_extent_type)
- [`h5s_is_regular_hyperslab`](@ref h5s_is_regular_hyperslab)
- [`h5s_is_simple`](@ref h5s_is_simple)
- [`h5s_modify_select`](@ref h5s_modify_select)
- [`h5s_offset_simple`](@ref h5s_offset_simple)
- [`h5s_select_adjust`](@ref h5s_select_adjust)
- [`h5s_select_all`](@ref h5s_select_all)
- [`h5s_select_copy`](@ref h5s_select_copy)
- [`h5s_select_elements`](@ref h5s_select_elements)
- [`h5s_select_hyperslab`](@ref h5s_select_hyperslab)
- [`h5s_select_intersect_block`](@ref h5s_select_intersect_block)
- [`h5s_select_shape_same`](@ref h5s_select_shape_same)
- [`h5s_select_valid`](@ref h5s_select_valid)
- [`h5s_set_extent_none`](@ref h5s_set_extent_none)
- [`h5s_set_extent_simple`](@ref h5s_set_extent_simple)
```@docs
h5s_close
h5s_combine_hyperslab
h5s_combine_select
h5s_copy
h5s_create
h5s_create_simple
h5s_extent_copy
h5s_extent_equal
h5s_get_regular_hyperslab
h5s_get_select_bounds
h5s_get_select_elem_npoints
h5s_get_select_elem_pointlist
h5s_get_select_hyper_blocklist
h5s_get_select_hyper_nblocks
h5s_get_select_npoints
h5s_get_select_type
h5s_get_simple_extent_dims
h5s_get_simple_extent_ndims
h5s_get_simple_extent_type
h5s_is_regular_hyperslab
h5s_is_simple
h5s_modify_select
h5s_offset_simple
h5s_select_adjust
h5s_select_all
h5s_select_copy
h5s_select_elements
h5s_select_hyperslab
h5s_select_intersect_block
h5s_select_shape_same
h5s_select_valid
h5s_set_extent_none
h5s_set_extent_simple
```

---

## [[`H5T`](https://docs.hdfgroup.org/hdf5/v1_14/group___h5_t.html) — Datatype Interface](@id H5T)
- [`h5t_array_create`](@ref h5t_array_create)
- [`h5t_close`](@ref h5t_close)
- [`h5t_commit`](@ref h5t_commit)
- [`h5t_committed`](@ref h5t_committed)
- [`h5t_copy`](@ref h5t_copy)
- [`h5t_create`](@ref h5t_create)
- [`h5t_enum_insert`](@ref h5t_enum_insert)
- [`h5t_equal`](@ref h5t_equal)
- [`h5t_get_array_dims`](@ref h5t_get_array_dims)
- [`h5t_get_array_ndims`](@ref h5t_get_array_ndims)
- [`h5t_get_class`](@ref h5t_get_class)
- [`h5t_get_cset`](@ref h5t_get_cset)
- [`h5t_get_ebias`](@ref h5t_get_ebias)
- [`h5t_get_fields`](@ref h5t_get_fields)
- [`h5t_get_member_class`](@ref h5t_get_member_class)
- [`h5t_get_member_index`](@ref h5t_get_member_index)
- [`h5t_get_member_name`](@ref h5t_get_member_name)
- [`h5t_get_member_offset`](@ref h5t_get_member_offset)
- [`h5t_get_member_type`](@ref h5t_get_member_type)
- [`h5t_get_native_type`](@ref h5t_get_native_type)
- [`h5t_get_nmembers`](@ref h5t_get_nmembers)
- [`h5t_get_offset`](@ref h5t_get_offset)
- [`h5t_get_order`](@ref h5t_get_order)
- [`h5t_get_precision`](@ref h5t_get_precision)
- [`h5t_get_sign`](@ref h5t_get_sign)
- [`h5t_get_size`](@ref h5t_get_size)
- [`h5t_get_strpad`](@ref h5t_get_strpad)
- [`h5t_get_super`](@ref h5t_get_super)
- [`h5t_get_tag`](@ref h5t_get_tag)
- [`h5t_insert`](@ref h5t_insert)
- [`h5t_is_variable_str`](@ref h5t_is_variable_str)
- [`h5t_lock`](@ref h5t_lock)
- [`h5t_open`](@ref h5t_open)
- [`h5t_set_cset`](@ref h5t_set_cset)
- [`h5t_set_ebias`](@ref h5t_set_ebias)
- [`h5t_set_fields`](@ref h5t_set_fields)
- [`h5t_set_offset`](@ref h5t_set_offset)
- [`h5t_set_order`](@ref h5t_set_order)
- [`h5t_set_precision`](@ref h5t_set_precision)
- [`h5t_set_size`](@ref h5t_set_size)
- [`h5t_set_strpad`](@ref h5t_set_strpad)
- [`h5t_set_tag`](@ref h5t_set_tag)
- [`h5t_vlen_create`](@ref h5t_vlen_create)
```@docs
h5t_array_create
h5t_close
h5t_commit
h5t_committed
h5t_copy
h5t_create
h5t_enum_insert
h5t_equal
h5t_get_array_dims
h5t_get_array_ndims
h5t_get_class
h5t_get_cset
h5t_get_ebias
h5t_get_fields
h5t_get_member_class
h5t_get_member_index
h5t_get_member_name
h5t_get_member_offset
h5t_get_member_type
h5t_get_native_type
h5t_get_nmembers
h5t_get_offset
h5t_get_order
h5t_get_precision
h5t_get_sign
h5t_get_size
h5t_get_strpad
h5t_get_super
h5t_get_tag
h5t_insert
h5t_is_variable_str
h5t_lock
h5t_open
h5t_set_cset
h5t_set_ebias
h5t_set_fields
h5t_set_offset
h5t_set_order
h5t_set_precision
h5t_set_size
h5t_set_strpad
h5t_set_tag
h5t_vlen_create
```

---

## [[`H5Z`](https://docs.hdfgroup.org/hdf5/v1_14/group___h5_z.html) — Filter Interface](@id H5Z)
- [`h5z_filter_avail`](@ref h5z_filter_avail)
- [`h5z_get_filter_info`](@ref h5z_get_filter_info)
- [`h5z_register`](@ref h5z_register)
- [`h5z_unregister`](@ref h5z_unregister)
```@docs
h5z_filter_avail
h5z_get_filter_info
h5z_register
h5z_unregister
```

---

## [[`H5FD`](https://docs.hdfgroup.org/hdf5/v1_14/_v_f_l.html) — File Drivers](@id H5FD)
- [`h5fd_core_init`](@ref h5fd_core_init)
- [`h5fd_family_init`](@ref h5fd_family_init)
- [`h5fd_log_init`](@ref h5fd_log_init)
- [`h5fd_mpio_init`](@ref h5fd_mpio_init)
- [`h5fd_multi_init`](@ref h5fd_multi_init)
- [`h5fd_sec2_init`](@ref h5fd_sec2_init)
- [`h5fd_stdio_init`](@ref h5fd_stdio_init)
```@docs
h5fd_core_init
h5fd_family_init
h5fd_log_init
h5fd_mpio_init
h5fd_multi_init
h5fd_sec2_init
h5fd_stdio_init
```

---

## [[`H5DO`](https://docs.hdfgroup.org/hdf5/v1_14/group___h5_d_o.html) — Optimized Functions Interface](@id H5DO)
- [`h5do_append`](@ref h5do_append)
- [`h5do_write_chunk`](@ref h5do_write_chunk)
```@docs
h5do_append
h5do_write_chunk
```

---

## [[`H5DS`](https://docs.hdfgroup.org/hdf5/v1_14/group___h5_d_s.html) — Dimension Scale Interface](@id H5DS)
- [`h5ds_attach_scale`](@ref h5ds_attach_scale)
- [`h5ds_detach_scale`](@ref h5ds_detach_scale)
- [`h5ds_get_label`](@ref h5ds_get_label)
- [`h5ds_get_num_scales`](@ref h5ds_get_num_scales)
- [`h5ds_get_scale_name`](@ref h5ds_get_scale_name)
- [`h5ds_is_attached`](@ref h5ds_is_attached)
- [`h5ds_is_scale`](@ref h5ds_is_scale)
- [`h5ds_set_label`](@ref h5ds_set_label)
- [`h5ds_set_scale`](@ref h5ds_set_scale)
```@docs
h5ds_attach_scale
h5ds_detach_scale
h5ds_get_label
h5ds_get_num_scales
h5ds_get_scale_name
h5ds_is_attached
h5ds_is_scale
h5ds_set_label
h5ds_set_scale
```

---

## [[`H5LT`](https://docs.hdfgroup.org/hdf5/v1_14/group___h5_l_t.html) — Lite Interface](@id H5LT)
- [`h5lt_dtype_to_text`](@ref h5lt_dtype_to_text)
```@docs
h5lt_dtype_to_text
```

---

## [[`H5TB`](https://docs.hdfgroup.org/hdf5/v1_14/group___h5_t_b.html) — Table Interface](@id H5TB)
- [`h5tb_append_records`](@ref h5tb_append_records)
- [`h5tb_get_field_info`](@ref h5tb_get_field_info)
- [`h5tb_get_table_info`](@ref h5tb_get_table_info)
- [`h5tb_make_table`](@ref h5tb_make_table)
- [`h5tb_read_records`](@ref h5tb_read_records)
- [`h5tb_read_table`](@ref h5tb_read_table)
- [`h5tb_write_records`](@ref h5tb_write_records)
```@docs
h5tb_append_records
h5tb_get_field_info
h5tb_get_table_info
h5tb_make_table
h5tb_read_records
h5tb_read_table
h5tb_write_records
```

# Filters

HDF5 supports filters for compression and validation: these are applied sequentially to
each chunk of a dataset when writing data, and in reverse order when reading data.

```@meta
CurrentModule = HDF5
```

These can be set by passing a filter or vector of filters as a `filters` property to
[`DatasetCreateProperties`](@ref) or via the `filters` keyword argument of [`create_dataset`](@ref).

```@meta
CurrentModule = HDF5.Filters
```

## Example

```@docs
Filters
```

## Built-in Filters


```@docs
Deflate
Shuffle
Fletcher32
Szip
NBit
ScaleOffset
ExternalFilter
```

## External Filter Packages

Several external Julia packages implement HDF5 filter plugins in Julia.
As they are independent of HDF5.jl, they must be installed in order to use their plugins.

The
[H5Zblosc.jl](https://github.com/JuliaIO/HDF5.jl/tree/master/filters/H5Zblosc),
[H5Zbzip2.jl](https://github.com/JuliaIO/HDF5.jl/tree/master/filters/H5Zbzip2),
[H5Zlz4.jl](https://github.com/JuliaIO/HDF5.jl/tree/master/filters/H5Zlz4), and
[H5Zzstd.jl](https://github.com/JuliaIO/HDF5.jl/tree/master/filters/H5Zzstd) packages are maintained as
independent subdirectory packages within the HDF5.jl repository.

### H5Zblosc.jl

```@meta
CurrentModule = H5Zblosc
```

```@docs
BloscFilter
```

### H5Zbzip2.jl

```@meta
CurrentModule = H5Zbzip2
```

```@docs
Bzip2Filter
```

### H5Zlz4.jl

```@meta
CurrentModule = H5Zlz4
```

```@docs
Lz4Filter
```

### H5Zzstd.jl

```@meta
CurrentModule = H5Zzstd
```

```@docs
ZstdFilter
```

## Other External Filters

Additional filters can be dynamically loaded by the HDF5 library. See [External Links](@ref) below for more information.

### Using an ExternalFilter

```@meta
CurrentModule = HDF5.Filters
```

[`ExternalFilter`](@ref) can be used to insert a dynamically loaded filter into the [`FilterPipeline`](@ref) in an ad-hoc fashion.

#### Example for `bitshuffle`

If we do not have a defined subtype of [`Filter`](@ref) for the [bitshuffle filter](https://github.com/kiyo-masui/bitshuffle/blob/master/src/bshuf_h5filter.h)
we can create an `ExternalFilter`. From the header file or list of registered plugins, we see that the bitshuffle filter has an id of `32008`.

Furthermore, the header describes two options:
1. `block_size` (optional). Default is `0`.
2. `compression` - This can be `0` or `BSHUF_H5_COMPRESS_LZ4` (`2` as defined in the C header)

```julia
using HDF5.Filters

bitshuf = ExternalFilter(32008, Cuint[0, 0])
bitshuf_comp = ExternalFilter(32008, Cuint[0, 2])

data_A = rand(0:31, 1024)
data_B = rand(32:63, 1024)

filename, _ = mktemp()
h5open(filename, "w") do h5f
    # Indexing style
    h5f["ex_data_A", chunk=(32,), filters=bitshuf] = data_A
    # Procedural style
    d, dt = create_dataset(h5f, "ex_data_B", data_B, chunk=(32,), filters=[bitshuf_comp])
    write(d, data_B)
end
```

### Registered Filter Helpers

The HDF Group maintains a list of registered filters which have been assigned a filter ID number.
The module [`Filters.Registered`](@ref) contains information about registered filters including functions
to create an `ExternalFilter` for each registered filter.

### Creating a new Filter type

Examining the [bitshuffle filter source code](https://github.com/kiyo-masui/bitshuffle/blob/0aee87e142c71407aa097c660727f2621c71c493/src/bshuf_h5filter.c#L47-L64) we see that three additional data components get prepended to the options. These are
1. The major version
2. The minor version
3. The element size in bytes of the type via `H5Tget_size`.

```julia
import HDF5.Filters: FILTERS, Filter, FilterPipeline, filterid
using HDF5.API

const H5Z_BSHUF_ID = API.H5Z_filter_t(32008)
struct BitShuffleFilter <: HDF5.Filters.Filter
    major::Cuint
    minor::Cuint
    elem_size::Cuint
    block_size::Cuint
    compression::Cuint
    BitShuffleFilter(block_size, compression) = new(0, 0, 0, block_size, compression)
end
# filterid is the only required method of the filter interface
# since we are using an externally registered filter
filterid(::Type{BitShuffleFilter}) = H5Z_BSHUF_ID
FILTERS[H5Z_BSHUF_ID] = BitShuffleFilter

function Base.push!(p::FilterPipeline, f::BitShuffleFilter)
    ref = Ref(f)
    GC.@preserve ref begin
        API.h5p_set_filter(p.plist, H5Z_BSHUF_ID, API.H5Z_FLAG_OPTIONAL, 2, pointer_from_objref(ref) + sizeof(Cuint)*3)
    end
    return p
end
```

Because the first three elements are not provided directly via `h5p_set_filter`, we also needed to implement a custom `Base.push!` into the `FilterPipeline`.

## Filter Interface

```@meta
CurrentModule = HDF5.Filters
```

The filter interface is used to describe filters and obtain information on them.

```@docs
Filter
FilterPipeline
UnknownFilter
FILTERS
EXTERNAL_FILTER_JULIA_PACKAGES
filterid
isavailable
isdecoderenabled
isencoderenabled
decoder_present
encoder_present
ensure_filters_available
filtername
can_apply_func
can_apply_cfunc
set_local_func
set_local_cfunc
filter_func
filter_cfunc
register_filter
```

## Registered Filters

```@autodocs
Modules = [Registered]
```

## External Links

* A [list of registered filter plugins](https://portal.hdfgroup.org/display/support/Registered+Filter+Plugins) can be found on the HDF Group website.
* [See the HDF5 Documentation of HDF5 Filter Plugins for details.](https://portal.hdfgroup.org/display/support/HDF5+Filter+Plugins)
* The source code for many external plugins have been collected in the [HDFGroup hdf5_plugins repository](https://github.com/HDFGroup/hdf5_plugins).
* [Compiled binaries of dynamically downloaded plugins](https://portal.hdfgroup.org/display/support/Downloads) by downloaded from HDF5 Group.

# Dataset

```@meta
CurrentModule = HDF5
```

Many dataset operations are available through the indexing interface, which is aliased to the functional interface. Below describes the functional interface.

```@docs
Dataset
create_dataset
Base.copyto!
Base.similar
create_external_dataset
get_datasets
open_dataset
write_dataset
read_dataset
```

## Chunks

```@docs
do_read_chunk
do_write_chunk
get_chunk_index
get_chunk_info_all
get_chunk_length
get_chunk_offset
get_num_chunks
get_num_chunks_per_dim
read_chunk
write_chunk
```

### Private Implementation

These functions select private implementations of the public high-level API.
They should be used for diagnostic purposes only.

```@docs
_get_chunk_info_all_by_index
_get_chunk_info_all_by_iter
```

# Parallel HDF5

It is possible to read and write [parallel
HDF5](https://portal.hdfgroup.org/display/HDF5/Parallel+HDF5) files using MPI.
For this, the HDF5 binaries loaded by HDF5.jl must have been compiled with
parallel support, and linked to the specific MPI implementation that will be used for parallel I/O.

Parallel-enabled HDF5 libraries are usually included in computing clusters and
linked to the available MPI implementations.
They are also available via the package manager of a number of Linux
distributions.

Finally, note that the MPI.jl package is lazy-loaded by HDF5.jl
using [Requires](https://github.com/JuliaPackaging/Requires.jl).
In practice, this means that in Julia code, `MPI` must be imported _before_
`HDF5` for parallel functionality to be available.

## Setting-up Parallel HDF5

The following step-by-step guide assumes one already has access to
parallel-enabled HDF5 libraries linked to an existent MPI installation.

### [1. Using system-provided MPI libraries](@id using_system_MPI)

Using a system-provided MPI library can be done with MPIPreferences.jl.
After installing MPIPreferences.jl and running
`julia --project -e 'using MPIPreferences; MPIPreferences.use_system_binary()'`
MPIPreferences.jl identifies any available MPI implementation and stores the information
in a file LocalPreferences.toml.
See the [MPI.jl
docs](https://juliaparallel.org/MPI.jl/stable/configuration/#Using-a-system-provided-MPI-backend)
for details.

### [2. Using parallel HDF5 libraries](@id using_parallel_HDF5)

!!! note "Migration from HDF5.jl v0.16 and earlier"
    How to use a system-provided HDF5 library has been changed in HDF5.jl v0.17. Previously,
    the library path was set by the environment variable `JULIA_HDF5_PATH`, which required to
    rebuild HDF5.jl afterwards. The environment variable has been removed and no longer has an
    effect (for backward compatibility it is still recommended to **also** set the environment
    variable). Instead, proceed as described below.

As detailed in [Using custom or system provided HDF5 binaries](@ref), set the
preferences `libhdf5` and `libhdf5_hl` to the full path, where the parallel HDF5 binaries are located.
This can be done by:

```julia
julia> using HDF5

julia> HDF5.API.set_libraries!("/path/to/your/libhdf5.so", "/path/to/your/libhdf5_hl.so")
```

### 3. Loading MPI-enabled HDF5

In Julia code, MPI.jl must be loaded _before_ HDF5.jl for MPI functionality to
be available:

```julia
using MPI
using HDF5

@assert HDF5.has_parallel()
```

### Notes to HPC cluster administrators

More information for a setup at an HPC cluster can be found in the [docs of MPI.jl](https://juliaparallel.org/MPI.jl/stable/configuration/#Notes-to-HPC-cluster-administrators).
After performing the steps [1.](@ref using_system_MPI) and [2.](@ref using_parallel_HDF5) the
LocalPreferences.toml file could look something like the following:

```toml
[MPIPreferences]
_format = "1.0"
abi = "OpenMPI"
binary = "system"
libmpi = "/software/mpi/lib/libmpi.so"
mpiexec = "/software/mpi/bin/mpiexec"

[HDF5]
libhdf5 = "/path/to/your/libhdf5.so"
libhdf5_hl = "/path/to/your/libhdf5_hl.so"
```

### Reading and writing data in parallel

A parallel HDF5 file may be opened by passing a `MPI.Comm` (and optionally a
`MPI.Info`) object to [`h5open`](@ref).
For instance:

```julia
comm = MPI.COMM_WORLD
info = MPI.Info()
ff = h5open(filename, "w", comm, info)
```

MPI-distributed data is typically written by first creating a dataset
describing the global dimensions of the data.
The following example writes a `10 × Nproc` array distributed over `Nproc` MPI
processes.

```julia
Nproc = MPI.Comm_size(comm)
myrank = MPI.Comm_rank(comm)
M = 10
A = fill(myrank, M)  # local data
dims = (M, Nproc)    # dimensions of global data

# Create dataset
dset = create_dataset(ff, "/data", datatype(eltype(A)), dataspace(dims))

# Write local data
dset[:, myrank + 1] = A
```

Note that metadata operations, such as `create_dataset`, must be called _collectively_ (on all processes at the same time, with the same arguments), but the actual writing to the dataset may be done independently. See [Collective Calling Requirements in Parallel HDF5 Applications](https://portal.hdfgroup.org/display/HDF5/Collective+Calling+Requirements+in+Parallel+HDF5+Applications) for the exact requirements.

Sometimes, it may be more efficient to write data in chunks, so that each
process writes to a separate chunk of the file.
This is especially the case when data is uniformly distributed among MPI
processes.
In this example, this can be achieved by passing `chunk=(M, 1)` to `create_dataset`.

For better performance, it is sometimes preferable to perform [collective
I/O](https://portal.hdfgroup.org/display/HDF5/Introduction+to+Parallel+HDF5)
when reading and writing datasets in parallel.
This is achieved by passing `dxpl_mpio=:collective` to `create_dataset`.
See also the [HDF5 docs](https://portal.hdfgroup.org/display/HDF5/H5P_SET_DXPL_MPIO).

A few more examples are available in [`test/mpio.jl`](https://github.com/JuliaIO/HDF5.jl/blob/master/test/mpio.jl).

# Additional Resources

## JuliaCon 2023 Presentation

During JuliaCon 2023, Mark Kittisopikul and Simon Byrne presented "HDF5.jl: Hierarchial Data Storage for Julia" with assistance from Mustafa Mohamad. A recording of the talk is available on YouTube below.

```@raw html
<iframe width="560" height="315" src="https://www.youtube.com/embed/YNDDB8uR26Q?si=V5ArUwOkG6s7VesL" title="YouTube video player" frameborder="0" allow="accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture; web-share" allowfullscreen></iframe>
```

The slides for the JuliaCon 2023 presentation are also available [download](https://github.com/JuliaIO/HDF5.jl/blob/master/docs/juliacon_2023/juliacon_2023_presentation.pdf).

## Community Help Channels

* The Julia Discourse forum has a [hdf5 tag](https://discourse.julialang.org/tag/hdf5)
* The [Julia Community](https://julialang.org/community/) also has a number of chat options. See the [#data](https://julialang.slack.com/archives/C674VR0HH) or [#helpdesk](https://julialang.slack.com/archives/C6A044SQH) chat channels.

---
marp: true
---

# HDF5.jl: Hierarchical Data Storage for Julia

Mark Kittisopikul (HHMI), Simon Byrne (Caltech), Mustafa Mohamad (UCalgary)

---

# What is HDF5?

HDF5 stands for Hierarchial Data Format version 5 and is maintained by The HDF Group, formerly part of the National Center for Supercomputing Appplications (NCSA).

* HDF5 is a file format with an open specification.
* HDF5 is a C Library and API.
* HDF5 is a data model.

---

# When to use HDF5

* Store numeric array and attributes in nested groups.
* Use it when you want to compactly store binary data.

## When not to use HDF5
* You have arrays of variable-length strings. Used fixed lengths strings instead.
* You have tables of heterogeneous data. Consider using columnar layouts. Other formats are more optimized for tables.

---

# Related formats

HDF5 is used as a base for other formats
* NetCDF - Network Common Data Form v4 (Unidata, UCAR)
* MAT - MATLAB data files v7.3+
* PyTables - Pandas
* JLD/JLD2 - Julia Data Format

---

# HDF5 Specification

The HDF5 specification is open and freely available.

![width:600px](images/specification_toc.png)

https://docs.hdfgroup.org/hdf5/v1_14/_f_m_t3.html

---

# What is HDF5.jl?

HDF5.jl is a wrapper around the HDF5 C Library.

It consists of
* A low level interface, a direct mapping to the C API
* A mid level interface, lightweight helpers
* A high level interface, a Julia API
<!-- give examples ? -->

---

# Related Julia Packages

* HDF5_jll.jl, C Library from HDF Group (dependency of HDF5.jl)
* MAT.jl, MATLAB files (depends on HDF5.jl)
* JLD.jl, Julia Data Format (depends on HDF5.jl)
* JLD2.jl, Julia Data Format 2: pure Julia implementation of a subset of HDF5
* NetCDF.jl & NCDatasets.jl: wrappers for the NetCDF C library, which incorporates HDF5

---

# HDF5.jl Early and Recent Contributors

* There are many contributors
* Konrad Hisen initiated Julia's support for HDF5
* Tim Holy and Simon Kornblith were the initial primary authors
* Tom Short, Blake Johnson, Isaih Norton, Elliot Saba, Steven Johnson, Mike Nolta, Jameson Nash
* Justin Willmert improved many aspects C to Julia API interface
* Other recent contributors: t-bltg, Hendrik Ranocha, Nathan Zimmerberg, Joshua Lampert, Tamas Gal, David MacMahon, Juan Ignacio Polanco, Michael Schlottke-Lakemper, linwaytin, Dmitri Iouchtchenko, Lorenzo Van Munoz, Jared Wahlstrand, Julian Samaroo, machakann, James Hester, Ralph Kube, Kristoffer Carlsson

---

# HDF5.jl Current Developers

* Mustafa Mohamad, Mark Kittisopikul, and Simon Byrne are the current maintainers
* Mark Kittisopikul has been expanding API coverage, especially with chunking
* Simon Byrne has been working on package organization, filter interface, virtual datasets, and parallelization

## Special mention
- Erik Schnetter for building HDF5 in Yggdrasil

---

# What advantages does Julia bring to HDF5.jl?

<!--reorder-->

* HDF5.jl dynamically create types to match the stored HDF5 types.
* HDF5.jl can use Julia's reflection capabilities to create corresponding HDF5 types.
* HDF5.jl is easily extensible using multiple dispatch.
* HDF5.jl can create callbacks for C for efficient iteration.
* HDF5.jl wraps the C library directly in Julia via `@ccall`.
    * This is partially automated via Clang.jl and https://github.com/mkitti/LibHDF5.jl .

---

# Basic HDF5.jl Usage

```julia
using HDF5

# Write a HDF5 file
h5open("mydata.h5", "w") do h5f
    # Store an array
    h5f["group_A/group_B/array_C"] = rand(1024,1024)
    # Store an attribute
    attrs(h5f["group_A"])["access_date"] = "2023_07_21"
end

# Read a HDF5 file
C = h5open("mydata.h5") do h5f
    # Access an attribute
    println(attrs(h5f["group_A"])["access_date"])
    # Load an array and return it as C
    h5f["group_A/group_B/array_C"][:,:]
end
```

---

# Exploring a HDF5 file with HDF5.jl

```julia
julia> h5f = h5open("mydata.h5")
🗂️ HDF5.File: (read-only) mydata.h5
└─ 📂 group_A
   ├─ 🏷️ access_date
   └─ 📂 group_B
      └─ 🔢 array_C

julia> C  = h5f["group_A"]["group_B"]["array_C"][1:16,1:16]
16×16 Matrix{Float64}:
...

julia> close(h5f)
```

---

# Structs and HDF5 Types

```julia
julia> struct Foo
           x::Int64
           y::Float64
       end

julia> HDF5.datatype(Foo)
HDF5.Datatype: H5T_COMPOUND {
      H5T_STD_I64LE "x" : 0;
      H5T_IEEE_F64LE "y" : 8;
   }
```

---

# Reading and writing structs

```julia
julia> h5open("mystruct.h5", "w") do h5f
           h5f["Foo"] = [Foo(1, 3.0)]
       end
1-element Vector{Foo}:
 Foo(1, 3.0)

julia> h5open("mystruct.h5", "r") do h5f
           h5f["Foo"][]
       end
1-element Vector{NamedTuple{(:x, :y), Tuple{Int64, Float64}}}:
 (x = 1, y = 3.0)

julia> h5open("mystruct.h5", "r") do h5f
           read(h5f["Foo"], Foo)
       end
1-element Vector{Foo}:
 Foo(1, 3.0)
```

---

# Chunking and Built-in Gzip Compression Usage

In HDF5.jl version 0.16 we introduced a new general filter keyword allowing for the definition of filter pipelines.
```julia
using HDF5

h5open("simple_chunked.h5", "w", libver_bounds=v"1.12") do h5f
    h5ds = create_dataset(h5f, "gzipped_data", UInt8, (16,16),
        chunk=(4,4),
        filters=[HDF5.Filters.Deflate()],
        alloc_time = :early
    )
end
```

---

# Compression Filter Plugin Packages

<!--During the talk explain what these do and when/why you would want to use them-->

Glue code written in Julia.

* H5Zblosc.jl - Blosc.jl (Thank you, Steven G. Johnson)
* H5Zzstd.jl - CodecZstd.jl
* H5Zlz4.jl - CodecLZ4.jl
* H5Zbzip2.jl - CodecBzip2.jl
* H5Zbitshuffle.jl

Future: Let's figure out how to share these with JLD2.jl!

---

# Chunking and Filter Plugin Usage

```julia
using HDF5, H5Zzstd

h5open("zstd_chunked.h5", "w", libver_bounds=v"1.12") do h5f
    h5ds = create_dataset(h5f, "zstd_data", UInt8, (16,16),
        chunk=(4,4),
        filters=[ZstdFilter(3)]
    )
end
```

TODO: Use a package extension loading mechanism when CodecZstd.jl is present.

---

# Using External Native Plugin Filters

The HDF5 C library has a filter plugin mechanism. Plugins are shared libraries located in `/usr/local/hdf5/lib/plugin` or as specified by `$HDF5_PLUGIN_DIR`.

```julia
using HDF5.Filters

bitshuf = ExternalFilter(32008, Cuint[0, 0])
bitshuf_comp = ExternalFilter(32008, Cuint[0, 2])

data_A = rand(0:31, 1024)
data_B = rand(32:63, 1024)

filename, _ = mktemp()
h5open(filename, "w") do h5f
    # Indexing style
    h5f["ex_data_A", chunk=(32,), filters=bitshuf] = data_A
    # Procedural style
    d, dt = create_dataset(h5f, "ex_data_B", data_B, chunk=(32,), filters=[bitshuf_comp])
    write(d, data_B)
end
```
---

# New with HDF5 1.12.3 and 1.14.0: Efficient Chunk Based Iteration

Where are the compressed chunks and can we decompress them in parallel? 

| N Chunks | H5Dchunk_iter | H5Dget_chunk_info | Ratio |
|---|---|---|---|
| 64 | 2e-4 s | 5e-4 s | 2.4 |
| 256 | 7e-4 s | 5e-3 s | 6 |
| 1024 | 3e-3 s | 5e-2 s | 16 |
| 4096 | 1e-2 s | 7e-1 s | 57 |
| 16384 | 6e-2 s | 1e2 s | 208 |

---

# The HDF5 C API does not allow for multithreaded concurrency

* The HDF5 C library is not directly compatible with multithreading for parallel I/O. The preferred parallelization is via MPI.
* There is a `H5_HAVE_THREADSAFE` compile time option that uses a recursive lock.
* In HDF5.jl we have applied a `ReentrantLock` on all API calls.
  * It is now safe to use HDF5.jl with multithreading, but you may not see much of an improvement.

---

# Virtual datasets

- Maps multiple datasets into a single dataset
  - Can be same or different files
  - Supports patterns for sequentially numbered files/datasets

- e.g. consider a dataset made up of 100&times;10 blocks, across 4 files
  - `data00.h5`, `data01.h5`, etc.

```julia
space = dataspace((100,40))
create_dataset(h5f, "dataset", datatype, space;
    virtual=[HDF5.VirtualMapping(
        HDF5.hyperslab(space, (1:100, HDF5.BlockRange(1:10; count = -1))), # block pattern
        "./data0%b.h5",       # filenames (%b block pattern)
        "data",               # path to source dataset in file
        dataspace((100,10))   # view into source dataset
    )]
)
```

---

# Parallelization via MPI

- Message Passing Interface (MPI) is an interface for single-program, multiple-data (SPMD) parallelism.
  - Launch multiple processes running the same program
    ```sh
     mpiexec -n <nprocs> program ...
     ```
  - Programs determine what they should do based on their identifier (_rank_).
  - Each process determines what communication operations it should do (messages)
   - Multiple implementations (Open MPI, MPICH, vendor-specific)
   - Widely used in HPC for large-scale distributed parallelism.
- MPI.jl provides Julia bindings

---
## Using MPI + HDF5

Load and initialize MPI
```julia
using MPI, HDF5
MPI.Init()
```

Pass MPI communicator to `h5open`, e.g.
```julia
h5 = h5open("data.h5", "w", MPI.COMM_WORLD)
```
- Needs to be _collective_ (all processes at the same time), with the same arguments.
- File needs to be on accessible from all processes (e.g. on a shared file system if distributed).

---

Usage otherwise same as normal:
- metadata operatrions(`create_dataset`, writing attributes) should be done collectively, with the same arguments.
- reading/writing data can be independently per-process.
  - try to align chunks with processes
  - if collective, use `dxpl_mpio=:collective` option with `create_dataset`/`open_dataset`
- some limitations (e.g no datasets with variable-length strings).

---

# Configuring HDF5 (in upcoming 0.17 release)

- May want to use specific HDF5 library
  - interoperability with other languages (e.g. h5py)
  - linked against custom MPI binary
  - specific hardware features (burst buffers)

- Preferences.jl to specify custom HDF5 binary
```julia
using Preferences, HDF5
set_preferences!(HDF5,
        "libhdf5" => "/path/to/your/libhdf5.so",
        "libhdf5_hl" => "/path/to/your/libhdf5_hl.so",
        force = true)
```

---

# Applications

* CliMa
* Plots.jl backend
* JLD.jl (dependency) and JLD2.jl (interop reference)
* Checkpointing.jl

---

# Summary

* HDF5 is a format, C library, and data model for storing hierarchical information.
* HDF5.jl is a wrapper providing high and low level access to the HDF5 library.
* HDF5.jl now allows for multithreaded capability through locks and may expand capabilities beyond that of HDF5 C library
* HDF5.jl works with MPI.jl to allow for distributed multiprocessing

---

# Questions?

---

# Extra Slides and Advanced Topics
* HDF5 Specification: Superblock and Hex Dump
* Iteration

---

# HDF5 Specification: Superblock

HDF5 structures are variably sized and use Bob Jenkin's Lookup3 checksum for metadata integrity.

![width:800px](images/superblock.png)

https://docs.hdfgroup.org/hdf5/v1_14/_f_m_t3.html#Superblock

---

# A HDF5 Hex Dump

<!--Move to the end-->

```
00000000  89 48 44 46 0d 0a 1a 0a  03 08 08 00 00 00 00 00  |.HDF............|
00000010  00 00 00 00 ff ff ff ff  ff ff ff ff 82 08 01 00  |................|
00000020  00 00 00 00 30 00 00 00  00 00 00 00 92 3c c0 2c  |....0........<.,|
00000030  4f 48 44 52 02 20 a3 5c  ae 64 a3 5c ae 64 a3 5c  |OHDR. .\.d.\.d.\|
00000040  ae 64 a3 5c ae 64 78 02  12 00 00 00 00 ff ff ff  |.d.\.dx.........|
00000050  ff ff ff ff ff ff ff ff  ff ff ff ff ff 0a 02 00  |................|
00000060  01 00 00 06 14 00 00 01  00 09 7a 61 72 72 73 68  |..........zarrsh|
00000070  61 72 64 c3 00 00 00 00  00 00 00 00 40 00 00 00  |ard.........@...|
00000080  00 00 00 00 00 00 00 00  00 00 00 00 00 00 00 00  |................|
```

![](images/format_signature.png)

---

# Iteration

<!--move to end-->

For accessing data has two kinds of interfaces for accessing enumerated data:
1. `h5a_get_name_by_idx(loc_id, obj_name, index_type, order, idx, name, size, lapl_id)`
2. `h5a_iterate(obj_id::hid_t, idx_type::Cint, order::Cint, n::Ptr{hsize_t}, op::Ptr{Cvoid}, op_data::Any)`, `op` is function pointer

The `_by_idx` calls are easy to use via a simple `for` loop but are very inefficient for iterating over many items.

The `_iterate` calls require a C callback, `op`, and can be challenging to use but are efficient.

Based on `h5a_iterate` we have created a new `attrs` API replacing the former `attributes` API.

---

# Concurrency with Direct I/O

* The HDF5 C library provides byte offsets for continguous and chunked datasets
* Currently, HDF5.jl allows contiguous datasets to be memory mapped into arrays allowing for multithreaded reads.
* With efficient chunk iteration, could we perform parallel decompression in HDF5.jl by reading compressed chunks directly?

# Third Party Licenses

HDF5.jl contains several derivative works of open source software.

In particular, the following submodules are licensed as derivative works from third-parties.
Original and derivative code in HDF5.jl is licensed according to [LICENSE.txt](LICENSE.txt)
as permitted by licenses for the original software from which they may be derived.
See the files indicated below for the copyright notices and the licenses of the original
software from which individual submodules are derived.

## Filter Plugins
* [H5Zbzip2](filters/H5Zbzip2/src/H5Zbzip2.jl): See [filters/H5Zbzip2/THIRDPARTY.txt](filters/H5Zbzip2/THIRDPARTY.txt)
* [H5Zlz4](filters/H5Zlz4/src/H5Zlz4.jl): See [filters/H5Zlz4/THIRDPARTY.txt](filters/H5Zlz4/THIRDPARTY.txt)
* [H5Zzstd](filters/H5Zzstd/src/H5Zzstd.jl): See [filters/H5Zzstd/THIRDPARTY.txt](filters/H5Zzstd/THIRDPARTY.txt)

# Properties

```@meta
CurrentModule = HDF5
```

HDF5 property lists are collections of name-value pairs which can be passed to other HDF5
functions to control features that are typically unimportant or whose default values are
usually used. In HDF5.jl, these options are typically handled by keyword arguments to such
functions, which will internally create the appropriate `Properties` objects, and
so users will not usually be required to construct them manually.

Not all properties defined by the HDF5 library are currently available in HDF5.jl. If you
require additional properties, please open an issue or pull request.

## Common functions

```@docs
setproperties!
```

## `Properties` types

```@docs
AttributeCreateProperties
FileAccessProperties
FileCreateProperties
GroupAccessProperties
GroupCreateProperties
DatasetCreateProperties
DatasetAccessProperties
DatatypeAccessProperties
DatasetTransferProperties
LinkCreateProperties
ObjectCreateProperties
StringCreateProperties
DatatypeCreateProperties
```

## Virtual Datasets

```@docs
VirtualMapping
VirtualLayout
```

## Drivers

```@meta
CurrentModule = HDF5
```

File drivers determine how the HDF5 is accessed. These can be set as the `driver` property in [`FileAccessProperties`](@ref).

```@meta
CurrentModule = HDF5.Drivers
```

```@docs
Core
POSIX
ROS3
MPIO
```

## Internals

```@meta
CurrentModule = HDF5
```

The following macros are used for defining new properties and property getters/setters.

```@docs
@propertyclass
@bool_property
@enum_property
@tuple_property
```

# Attributes

```@meta
CurrentModule = HDF5
```

## Dictionary interface

```@docs
attrs
attributes
```

## Mid-level Interface

```@docs
Attribute
open_attribute
create_attribute
read_attribute
write_attribute
delete_attribute
rename_attribute
```

## Convenience interface

```@docs
h5readattr
h5writeattr
num_attrs
```
